/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2024, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "access/tableam.h"
#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_am.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "gramparse.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static PartitionStrategy parsePartitionStrategy(char *strategy);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 294 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSENT = 276,
    ABSOLUTE_P = 277,
    ACCESS = 278,
    ACTION = 279,
    ADD_P = 280,
    ADMIN = 281,
    AFTER = 282,
    AGGREGATE = 283,
    ALL = 284,
    ALSO = 285,
    ALTER = 286,
    ALWAYS = 287,
    ANALYSE = 288,
    ANALYZE = 289,
    AND = 290,
    ANY = 291,
    ARRAY = 292,
    AS = 293,
    ASC = 294,
    ASENSITIVE = 295,
    ASSERTION = 296,
    ASSIGNMENT = 297,
    ASYMMETRIC = 298,
    ATOMIC = 299,
    AT = 300,
    ATTACH = 301,
    ATTRIBUTE = 302,
    AUTHORIZATION = 303,
    BACKWARD = 304,
    BEFORE = 305,
    BEGIN_P = 306,
    BETWEEN = 307,
    BIGINT = 308,
    BINARY = 309,
    BIT = 310,
    BOOLEAN_P = 311,
    BOTH = 312,
    BREADTH = 313,
    BY = 314,
    CACHE = 315,
    CALL = 316,
    CALLED = 317,
    CASCADE = 318,
    CASCADED = 319,
    CASE = 320,
    CAST = 321,
    CATALOG_P = 322,
    CHAIN = 323,
    CHAR_P = 324,
    CHARACTER = 325,
    CHARACTERISTICS = 326,
    CHECK = 327,
    CHECKPOINT = 328,
    CLASS = 329,
    CLOSE = 330,
    CLUSTER = 331,
    COALESCE = 332,
    COLLATE = 333,
    COLLATION = 334,
    COLUMN = 335,
    COLUMNS = 336,
    COMMENT = 337,
    COMMENTS = 338,
    COMMIT = 339,
    COMMITTED = 340,
    COMPRESSION = 341,
    CONCURRENTLY = 342,
    CONFIGURATION = 343,
    CONFLICT = 344,
    CONNECTION = 345,
    CONSTRAINT = 346,
    CONSTRAINTS = 347,
    CONTENT_P = 348,
    CONTINUE_P = 349,
    CONVERSION_P = 350,
    COPY = 351,
    COST = 352,
    CREATE = 353,
    CROSS = 354,
    CSV = 355,
    CUBE = 356,
    CURRENT_P = 357,
    CURRENT_CATALOG = 358,
    CURRENT_DATE = 359,
    CURRENT_ROLE = 360,
    CURRENT_SCHEMA = 361,
    CURRENT_TIME = 362,
    CURRENT_TIMESTAMP = 363,
    CURRENT_USER = 364,
    CURSOR = 365,
    CYCLE = 366,
    DATA_P = 367,
    DATABASE = 368,
    DAY_P = 369,
    DEALLOCATE = 370,
    DEC = 371,
    DECIMAL_P = 372,
    DECLARE = 373,
    DEFAULT = 374,
    DEFAULTS = 375,
    DEFERRABLE = 376,
    DEFERRED = 377,
    DEFINER = 378,
    DELETE_P = 379,
    DELIMITER = 380,
    DELIMITERS = 381,
    DEPENDS = 382,
    DEPTH = 383,
    DESC = 384,
    DETACH = 385,
    DICTIONARY = 386,
    DISABLE_P = 387,
    DISCARD = 388,
    DISTINCT = 389,
    DO = 390,
    DOCUMENT_P = 391,
    DOMAIN_P = 392,
    DOUBLE_P = 393,
    DROP = 394,
    EACH = 395,
    ELSE = 396,
    ENABLE_P = 397,
    ENCODING = 398,
    ENCRYPTED = 399,
    END_P = 400,
    ENUM_P = 401,
    ESCAPE = 402,
    EVENT = 403,
    EXCEPT = 404,
    EXCLUDE = 405,
    EXCLUDING = 406,
    EXCLUSIVE = 407,
    EXECUTE = 408,
    EXISTS = 409,
    EXPLAIN = 410,
    EXPRESSION = 411,
    EXTENSION = 412,
    EXTERNAL = 413,
    EXTRACT = 414,
    FALSE_P = 415,
    FAMILY = 416,
    FETCH = 417,
    FILTER = 418,
    FINALIZE = 419,
    FIRST_P = 420,
    FLOAT_P = 421,
    FOLLOWING = 422,
    FOR = 423,
    FORCE = 424,
    FOREIGN = 425,
    FORMAT = 426,
    FORWARD = 427,
    FREEZE = 428,
    FROM = 429,
    FULL = 430,
    FUNCTION = 431,
    FUNCTIONS = 432,
    GENERATED = 433,
    GLOBAL = 434,
    GRANT = 435,
    GRANTED = 436,
    GREATEST = 437,
    GROUP_P = 438,
    GROUPING = 439,
    GROUPS = 440,
    HANDLER = 441,
    HAVING = 442,
    HEADER_P = 443,
    HOLD = 444,
    HOUR_P = 445,
    IDENTITY_P = 446,
    IF_P = 447,
    ILIKE = 448,
    IMMEDIATE = 449,
    IMMUTABLE = 450,
    IMPLICIT_P = 451,
    IMPORT_P = 452,
    IN_P = 453,
    INCLUDE = 454,
    INCLUDING = 455,
    INCREMENT = 456,
    INDENT = 457,
    INDEX = 458,
    INDEXES = 459,
    INHERIT = 460,
    INHERITS = 461,
    INITIALLY = 462,
    INLINE_P = 463,
    INNER_P = 464,
    INOUT = 465,
    INPUT_P = 466,
    INSENSITIVE = 467,
    INSERT = 468,
    INSTEAD = 469,
    INT_P = 470,
    INTEGER = 471,
    INTERSECT = 472,
    INTERVAL = 473,
    INTO = 474,
    INVOKER = 475,
    IS = 476,
    ISNULL = 477,
    ISOLATION = 478,
    JOIN = 479,
    JSON = 480,
    JSON_ARRAY = 481,
    JSON_ARRAYAGG = 482,
    JSON_OBJECT = 483,
    JSON_OBJECTAGG = 484,
    JSON_SCALAR = 485,
    JSON_SERIALIZE = 486,
    KEY = 487,
    KEYS = 488,
    LABEL = 489,
    LANGUAGE = 490,
    LARGE_P = 491,
    LAST_P = 492,
    LATERAL_P = 493,
    LEADING = 494,
    LEAKPROOF = 495,
    LEAST = 496,
    LEFT = 497,
    LEVEL = 498,
    LIKE = 499,
    LIMIT = 500,
    LISTEN = 501,
    LOAD = 502,
    LOCAL = 503,
    LOCALTIME = 504,
    LOCALTIMESTAMP = 505,
    LOCATION = 506,
    LOCK_P = 507,
    LOCKED = 508,
    LOGGED = 509,
    MAPPING = 510,
    MATCH = 511,
    MATCHED = 512,
    MATERIALIZED = 513,
    MAXVALUE = 514,
    MERGE = 515,
    METHOD = 516,
    MINUTE_P = 517,
    MINVALUE = 518,
    MODE = 519,
    MONTH_P = 520,
    MOVE = 521,
    NAME_P = 522,
    NAMES = 523,
    NATIONAL = 524,
    NATURAL = 525,
    NCHAR = 526,
    NEW = 527,
    NEXT = 528,
    NFC = 529,
    NFD = 530,
    NFKC = 531,
    NFKD = 532,
    NO = 533,
    NONE = 534,
    NORMALIZE = 535,
    NORMALIZED = 536,
    NOT = 537,
    NOTHING = 538,
    NOTIFY = 539,
    NOTNULL = 540,
    NOWAIT = 541,
    NULL_P = 542,
    NULLIF = 543,
    NULLS_P = 544,
    NUMERIC = 545,
    OBJECT_P = 546,
    OF = 547,
    OFF = 548,
    OFFSET = 549,
    OIDS = 550,
    OLD = 551,
    ON = 552,
    ONLY = 553,
    OPERATOR = 554,
    OPTION = 555,
    OPTIONS = 556,
    OR = 557,
    ORDER = 558,
    ORDINALITY = 559,
    OTHERS = 560,
    OUT_P = 561,
    OUTER_P = 562,
    OVER = 563,
    OVERLAPS = 564,
    OVERLAY = 565,
    OVERRIDING = 566,
    OWNED = 567,
    OWNER = 568,
    PARALLEL = 569,
    PARAMETER = 570,
    PARSER = 571,
    PARTIAL = 572,
    PARTITION = 573,
    PASSING = 574,
    PASSWORD = 575,
    PLACING = 576,
    PLANS = 577,
    POLICY = 578,
    POSITION = 579,
    PRECEDING = 580,
    PRECISION = 581,
    PRESERVE = 582,
    PREPARE = 583,
    PREPARED = 584,
    PRIMARY = 585,
    PRIOR = 586,
    PRIVILEGES = 587,
    PROCEDURAL = 588,
    PROCEDURE = 589,
    PROCEDURES = 590,
    PROGRAM = 591,
    PUBLICATION = 592,
    QUOTE = 593,
    RANGE = 594,
    READ = 595,
    REAL = 596,
    REASSIGN = 597,
    RECHECK = 598,
    RECURSIVE = 599,
    REF_P = 600,
    REFERENCES = 601,
    REFERENCING = 602,
    REFRESH = 603,
    REINDEX = 604,
    RELATIVE_P = 605,
    RELEASE = 606,
    RENAME = 607,
    REPEATABLE = 608,
    REPLACE = 609,
    REPLICA = 610,
    RESET = 611,
    RESTART = 612,
    RESTRICT = 613,
    RETURN = 614,
    RETURNING = 615,
    RETURNS = 616,
    REVOKE = 617,
    RIGHT = 618,
    ROLE = 619,
    ROLLBACK = 620,
    ROLLUP = 621,
    ROUTINE = 622,
    ROUTINES = 623,
    ROW = 624,
    ROWS = 625,
    RULE = 626,
    SAVEPOINT = 627,
    SCALAR = 628,
    SCHEMA = 629,
    SCHEMAS = 630,
    SCROLL = 631,
    SEARCH = 632,
    SECOND_P = 633,
    SECURITY = 634,
    SELECT = 635,
    SEQUENCE = 636,
    SEQUENCES = 637,
    SERIALIZABLE = 638,
    SERVER = 639,
    SESSION = 640,
    SESSION_USER = 641,
    SET = 642,
    SETS = 643,
    SETOF = 644,
    SHARE = 645,
    SHOW = 646,
    SIMILAR = 647,
    SIMPLE = 648,
    SKIP = 649,
    SMALLINT = 650,
    SNAPSHOT = 651,
    SOME = 652,
    SQL_P = 653,
    STABLE = 654,
    STANDALONE_P = 655,
    START = 656,
    STATEMENT = 657,
    STATISTICS = 658,
    STDIN = 659,
    STDOUT = 660,
    STORAGE = 661,
    STORED = 662,
    STRICT_P = 663,
    STRIP_P = 664,
    SUBSCRIPTION = 665,
    SUBSTRING = 666,
    SUPPORT = 667,
    SYMMETRIC = 668,
    SYSID = 669,
    SYSTEM_P = 670,
    SYSTEM_USER = 671,
    TABLE = 672,
    TABLES = 673,
    TABLESAMPLE = 674,
    TABLESPACE = 675,
    TEMP = 676,
    TEMPLATE = 677,
    TEMPORARY = 678,
    TEXT_P = 679,
    THEN = 680,
    TIES = 681,
    TIME = 682,
    TIMESTAMP = 683,
    TO = 684,
    TRAILING = 685,
    TRANSACTION = 686,
    TRANSFORM = 687,
    TREAT = 688,
    TRIGGER = 689,
    TRIM = 690,
    TRUE_P = 691,
    TRUNCATE = 692,
    TRUSTED = 693,
    TYPE_P = 694,
    TYPES_P = 695,
    UESCAPE = 696,
    UNBOUNDED = 697,
    UNCOMMITTED = 698,
    UNENCRYPTED = 699,
    UNION = 700,
    UNIQUE = 701,
    UNKNOWN = 702,
    UNLISTEN = 703,
    UNLOGGED = 704,
    UNTIL = 705,
    UPDATE = 706,
    USER = 707,
    USING = 708,
    VACUUM = 709,
    VALID = 710,
    VALIDATE = 711,
    VALIDATOR = 712,
    VALUE_P = 713,
    VALUES = 714,
    VARCHAR = 715,
    VARIADIC = 716,
    VARYING = 717,
    VERBOSE = 718,
    VERSION_P = 719,
    VIEW = 720,
    VIEWS = 721,
    VOLATILE = 722,
    WHEN = 723,
    WHERE = 724,
    WHITESPACE_P = 725,
    WINDOW = 726,
    WITH = 727,
    WITHIN = 728,
    WITHOUT = 729,
    WORK = 730,
    WRAPPER = 731,
    WRITE = 732,
    XML_P = 733,
    XMLATTRIBUTES = 734,
    XMLCONCAT = 735,
    XMLELEMENT = 736,
    XMLEXISTS = 737,
    XMLFOREST = 738,
    XMLNAMESPACES = 739,
    XMLPARSE = 740,
    XMLPI = 741,
    XMLROOT = 742,
    XMLSERIALIZE = 743,
    XMLTABLE = 744,
    YEAR_P = 745,
    YES_P = 746,
    ZONE = 747,
    FORMAT_LA = 748,
    NOT_LA = 749,
    NULLS_LA = 750,
    WITH_LA = 751,
    WITHOUT_LA = 752,
    MODE_TYPE_NAME = 753,
    MODE_PLPGSQL_EXPR = 754,
    MODE_PLPGSQL_ASSIGN1 = 755,
    MODE_PLPGSQL_ASSIGN2 = 756,
    MODE_PLPGSQL_ASSIGN3 = 757,
    UMINUS = 758
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 232 "gram.y" /* yacc.c:355  */

	core_YYSTYPE core_yystype;
	/* these fields must match core_YYSTYPE: */
	int			ival;
	char	   *str;
	const char *keyword;

	char		chr;
	bool		boolean;
	JoinType	jtype;
	DropBehavior dbehavior;
	OnCommitAction oncommit;
	List	   *list;
	Node	   *node;
	ObjectType	objtype;
	TypeName   *typnam;
	FunctionParameter *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs *objwithargs;
	DefElem	   *defelt;
	SortBy	   *sortby;
	WindowDef  *windef;
	JoinExpr   *jexpr;
	IndexElem  *ielem;
	StatsElem  *selem;
	Alias	   *alias;
	RangeVar   *range;
	IntoClause *into;
	WithClause *with;
	InferClause	*infer;
	OnConflictClause *onconflict;
	A_Indices  *aind;
	ResTarget  *target;
	struct PrivTarget *privtarget;
	AccessPriv *accesspriv;
	struct ImportQual *importqual;
	InsertStmt *istmt;
	VariableSetStmt *vsetstmt;
	PartitionElem *partelem;
	PartitionSpec *partspec;
	PartitionBoundSpec *partboundspec;
	RoleSpec   *rolespec;
	PublicationObjSpec *publicationobjectspec;
	struct SelectLimit *selectlimit;
	SetQuantifier setquantifier;
	struct GroupClause *groupclause;
	MergeWhenClause *mergewhen;
	struct KeyActions *keyactions;
	struct KeyAction *keyaction;

#line 889 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 919 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  910
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   116632

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  521
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  709
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3305
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6266

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   758

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   510,     2,     2,
     515,   516,   508,   506,   519,   507,   517,   509,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   520,   518,
     503,   505,   504,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   513,     2,   514,   511,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   512
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   901,   901,   906,   910,   915,   923,   931,   951,   963,
     977,   978,   982,   983,   984,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,  1104,  1105,  1107,  1114,  1115,  1119,
    1120,  1124,  1125,  1129,  1130,  1131,  1140,  1156,  1168,  1169,
    1170,  1179,  1180,  1184,  1185,  1189,  1194,  1198,  1208,  1216,
    1220,  1224,  1229,  1233,  1281,  1283,  1287,  1291,  1295,  1299,
    1313,  1332,  1341,  1353,  1354,  1358,  1367,  1376,  1385,  1407,
    1415,  1423,  1431,  1439,  1447,  1465,  1484,  1496,  1497,  1508,
    1519,  1530,  1546,  1565,  1572,  1580,  1581,  1582,  1583,  1584,
    1585,  1599,  1606,  1613,  1623,  1632,  1641,  1645,  1654,  1663,
    1671,  1682,  1683,  1692,  1704,  1712,  1721,  1733,  1742,  1751,
    1759,  1769,  1780,  1781,  1785,  1786,  1789,  1791,  1795,  1796,
    1797,  1798,  1802,  1803,  1804,  1810,  1822,  1826,  1830,  1847,
    1855,  1856,  1857,  1861,  1862,  1863,  1867,  1868,  1872,  1876,
    1877,  1885,  1893,  1904,  1912,  1923,  1924,  1929,  1930,  1935,
    1942,  1949,  1956,  1963,  1974,  1985,  1986,  1990,  1991,  1999,
    2015,  2022,  2029,  2036,  2043,  2063,  2073,  2083,  2093,  2103,
    2115,  2127,  2137,  2147,  2157,  2169,  2181,  2191,  2201,  2211,
    2221,  2231,  2241,  2253,  2265,  2275,  2288,  2289,  2294,  2308,
    2321,  2337,  2354,  2364,  2374,  2384,  2394,  2404,  2413,  2422,
    2432,  2441,  2451,  2461,  2477,  2487,  2497,  2507,  2517,  2534,
    2544,  2554,  2564,  2575,  2589,  2605,  2615,  2624,  2640,  2649,
    2660,  2671,  2679,  2688,  2697,  2705,  2713,  2722,  2731,  2740,
    2748,  2756,  2765,  2773,  2781,  2790,  2799,  2808,  2817,  2826,
    2835,  2846,  2854,  2863,  2872,  2881,  2890,  2899,  2908,  2916,
    2924,  2932,  2939,  2950,  2951,  2955,  2964,  2968,  2969,  2973,
    2981,  2989,  2997,  3008,  3011,  3012,  3016,  3017,  3022,  3026,
    3030,  3035,  3042,  3044,  3049,  3053,  3057,  3068,  3075,  3076,
    3081,  3134,  3147,  3161,  3173,  3180,  3184,  3198,  3211,  3212,
    3217,  3227,  3238,  3249,  3276,  3283,  3317,  3353,  3376,  3377,
    3381,  3382,  3391,  3392,  3393,  3396,  3397,  3402,  3403,  3407,
    3411,  3415,  3419,  3423,  3427,  3431,  3435,  3439,  3443,  3447,
    3451,  3455,  3459,  3463,  3472,  3476,  3480,  3484,  3488,  3489,
    3494,  3498,  3505,  3512,  3513,  3514,  3515,  3516,  3520,  3524,
    3532,  3543,  3563,  3583,  3604,  3625,  3646,  3680,  3681,  3682,
    3683,  3684,  3691,  3698,  3699,  3703,  3704,  3708,  3709,  3713,
    3717,  3724,  3728,  3735,  3736,  3737,  3741,  3742,  3745,  3769,
    3788,  3810,  3811,  3815,  3816,  3820,  3821,  3825,  3826,  3830,
    3831,  3835,  3843,  3844,  3845,  3877,  3888,  3896,  3909,  3921,
    3934,  3944,  3954,  3978,  3998,  3999,  4000,  4004,  4005,  4024,
    4032,  4040,  4048,  4060,  4072,  4073,  4074,  4078,  4079,  4080,
    4081,  4082,  4083,  4084,  4085,  4086,  4087,  4096,  4104,  4108,
    4122,  4136,  4155,  4171,  4189,  4205,  4225,  4248,  4249,  4253,
    4254,  4258,  4259,  4263,  4264,  4267,  4273,  4274,  4277,  4281,
    4289,  4294,  4300,  4301,  4305,  4310,  4317,  4318,  4322,  4332,
    4342,  4350,  4359,  4372,  4384,  4391,  4399,  4407,  4415,  4423,
    4433,  4434,  4438,  4439,  4442,  4454,  4455,  4458,  4469,  4480,
    4494,  4495,  4500,  4501,  4502,  4505,  4506,  4507,  4508,  4511,
    4512,  4515,  4516,  4519,  4539,  4552,  4574,  4575,  4578,  4584,
    4590,  4607,  4616,  4638,  4652,  4669,  4685,  4686,  4687,  4699,
    4713,  4730,  4744,  4745,  4757,  4778,  4789,  4803,  4812,  4824,
    4825,  4828,  4829,  4832,  4833,  4836,  4840,  4844,  4848,  4852,
    4856,  4860,  4864,  4868,  4872,  4876,  4881,  4885,  4889,  4895,
    4896,  4900,  4901,  4902,  4909,  4912,  4913,  4925,  4941,  4957,
    4958,  4966,  4967,  4971,  4972,  4976,  4977,  4981,  4982,  4986,
    4987,  4997,  5009,  5010,  5023,  5031,  5049,  5058,  5070,  5073,
    5077,  5081,  5085,  5092,  5104,  5115,  5118,  5122,  5135,  5145,
    5155,  5165,  5175,  5185,  5195,  5205,  5215,  5225,  5235,  5245,
    5255,  5274,  5286,  5287,  5288,  5289,  5293,  5294,  5298,  5299,
    5309,  5318,  5331,  5332,  5336,  5340,  5348,  5352,  5356,  5363,
    5367,  5372,  5377,  5384,  5391,  5396,  5406,  5419,  5435,  5436,
    5441,  5442,  5446,  5447,  5457,  5467,  5476,  5494,  5515,  5536,
    5558,  5592,  5608,  5609,  5613,  5622,  5637,  5647,  5660,  5661,
    5673,  5682,  5700,  5725,  5743,  5758,  5759,  5763,  5764,  5768,
    5769,  5773,  5774,  5778,  5792,  5796,  5797,  5801,  5802,  5803,
    5804,  5805,  5815,  5827,  5828,  5839,  5862,  5894,  5895,  5896,
    5900,  5902,  5924,  5926,  5928,  5930,  5932,  5937,  5938,  5942,
    5943,  5947,  5959,  5960,  5964,  5973,  5977,  5981,  5986,  5996,
    5997,  6001,  6002,  6006,  6007,  6011,  6012,  6016,  6017,  6018,
    6022,  6026,  6027,  6028,  6032,  6033,  6038,  6039,  6066,  6067,
    6068,  6069,  6070,  6071,  6084,  6095,  6110,  6112,  6117,  6122,
    6124,  6129,  6140,  6141,  6142,  6143,  6154,  6173,  6185,  6198,
    6209,  6220,  6232,  6241,  6249,  6257,  6267,  6277,  6287,  6297,
    6307,  6318,  6328,  6341,  6344,  6345,  6348,  6352,  6359,  6360,
    6361,  6362,  6363,  6364,  6367,  6370,  6371,  6379,  6386,  6387,
    6390,  6392,  6403,  6415,  6427,  6439,  6451,  6480,  6481,  6497,
    6513,  6514,  6518,  6531,  6542,  6551,  6561,  6571,  6572,  6575,
    6576,  6579,  6580,  6581,  6584,  6598,  6603,  6614,  6624,  6637,
    6638,  6642,  6651,  6664,  6675,  6689,  6700,  6723,  6734,  6753,
    6764,  6775,  6786,  6797,  6808,  6819,  6830,  6841,  6852,  6863,
    6874,  6889,  6890,  6891,  6892,  6893,  6894,  6895,  6896,  6897,
    6898,  6899,  6900,  6901,  6911,  6912,  6913,  6914,  6915,  6919,
    6920,  6921,  6922,  6923,  6924,  6925,  6926,  6931,  6932,  6933,
    6937,  6938,  6941,  6942,  6945,  6947,  6952,  6953,  6964,  6976,
    6977,  6978,  6988,  6997,  7006,  7015,  7024,  7033,  7042,  7051,
    7060,  7069,  7083,  7092,  7101,  7110,  7119,  7128,  7137,  7146,
    7158,  7159,  7173,  7184,  7195,  7206,  7217,  7228,  7239,  7250,
    7261,  7272,  7285,  7286,  7289,  7290,  7300,  7307,  7316,  7325,
    7334,  7343,  7352,  7361,  7370,  7379,  7388,  7397,  7406,  7415,
    7424,  7433,  7442,  7451,  7462,  7463,  7466,  7467,  7477,  7495,
    7511,  7539,  7541,  7543,  7545,  7553,  7563,  7564,  7567,  7575,
    7583,  7591,  7598,  7609,  7613,  7620,  7624,  7635,  7644,  7653,
    7662,  7671,  7680,  7689,  7698,  7707,  7716,  7725,  7734,  7743,
    7751,  7760,  7769,  7778,  7787,  7796,  7805,  7814,  7827,  7828,
    7832,  7833,  7838,  7839,  7849,  7860,  7874,  7886,  7904,  7905,
    7909,  7916,  7917,  7918,  7921,  7922,  7932,  7943,  7944,  7948,
    7952,  7956,  7967,  7981,  7996,  8014,  8015,  8016,  8017,  8018,
    8019,  8031,  8063,  8098,  8099,  8103,  8104,  8107,  8108,  8113,
    8125,  8144,  8149,  8154,  8161,  8162,  8165,  8166,  8169,  8170,
    8174,  8175,  8176,  8179,  8180,  8181,  8197,  8211,  8226,  8240,
    8257,  8258,  8261,  8262,  8266,  8267,  8271,  8272,  8277,  8291,
    8299,  8307,  8323,  8324,  8328,  8329,  8344,  8354,  8364,  8374,
    8384,  8397,  8398,  8399,  8400,  8401,  8407,  8411,  8426,  8427,
    8433,  8443,  8447,  8452,  8460,  8502,  8506,  8510,  8514,  8522,
    8523,  8527,  8539,  8540,  8545,  8546,  8551,  8552,  8559,  8563,
    8567,  8571,  8575,  8579,  8583,  8587,  8591,  8595,  8599,  8603,
    8607,  8611,  8615,  8619,  8624,  8631,  8635,  8639,  8643,  8647,
    8653,  8654,  8660,  8670,  8674,  8685,  8691,  8700,  8706,  8707,
    8711,  8712,  8716,  8717,  8720,  8733,  8737,  8752,  8761,  8770,
    8783,  8784,  8789,  8790,  8807,  8818,  8829,  8840,  8851,  8862,
    8876,  8887,  8901,  8912,  8926,  8934,  8936,  8938,  8943,  8945,
    8950,  8951,  8956,  8975,  8985,  8986,  8990,  8994,  9006,  9018,
    9030,  9044,  9045,  9046,  9050,  9063,  9064,  9074,  9087,  9091,
    9095,  9099,  9106,  9128,  9141,  9154,  9169,  9170,  9173,  9174,
    9177,  9178,  9188,  9198,  9216,  9226,  9236,  9246,  9256,  9266,
    9276,  9286,  9296,  9306,  9316,  9326,  9336,  9347,  9358,  9368,
    9378,  9388,  9398,  9408,  9418,  9429,  9440,  9451,  9462,  9473,
    9484,  9495,  9506,  9517,  9528,  9539,  9550,  9562,  9574,  9586,
    9598,  9610,  9622,  9633,  9644,  9656,  9668,  9679,  9690,  9699,
    9709,  9719,  9729,  9739,  9749,  9759,  9769,  9779,  9789,  9804,
    9805,  9808,  9809,  9819,  9829,  9839,  9849,  9860,  9870,  9882,
    9883,  9893,  9903,  9913,  9923,  9933,  9943,  9953,  9963,  9973,
    9983,  9993, 10003, 10013, 10023, 10033, 10043, 10053, 10063, 10073,
   10083, 10093, 10103, 10113, 10123, 10133, 10143, 10153, 10172, 10182,
   10183, 10186, 10188, 10190, 10196, 10197, 10198, 10199, 10200, 10212,
   10228, 10237, 10246, 10255, 10264, 10273, 10282, 10291, 10300, 10309,
   10318, 10327, 10336, 10345, 10354, 10363, 10372, 10381, 10390, 10399,
   10408, 10417, 10426, 10435, 10463, 10471, 10480, 10506, 10515, 10522,
   10528, 10555, 10566, 10575, 10583, 10585, 10607, 10615, 10625, 10635,
   10654, 10673, 10683, 10693, 10703, 10714, 10725, 10736, 10747, 10758,
   10776, 10785, 10802, 10820, 10821, 10822, 10827, 10833, 10842, 10843,
   10844, 10845, 10846, 10850, 10851, 10854, 10855, 10856, 10857, 10861,
   10862, 10863, 10875, 10886, 10887, 10890, 10900, 10907, 10927, 10937,
   10946, 10956, 10966, 10975, 10984, 10993, 11002, 11011, 11020, 11029,
   11041, 11050, 11062, 11063, 11064, 11068, 11071, 11074, 11077, 11080,
   11087, 11089, 11091, 11096, 11098, 11102, 11103, 11104, 11116, 11130,
   11144, 11163, 11185, 11186, 11187, 11188, 11198, 11215, 11226, 11227,
   11231, 11232, 11236, 11240, 11244, 11262, 11263, 11264, 11265, 11266,
   11267, 11268, 11275, 11276, 11287, 11295, 11303, 11312, 11322, 11340,
   11349, 11358, 11367, 11379, 11383, 11394, 11406, 11424, 11431, 11448,
   11462, 11472, 11481, 11490, 11500, 11512, 11524, 11535, 11536, 11547,
   11558, 11570, 11582, 11594, 11606, 11616, 11629, 11630, 11644, 11668,
   11677, 11687, 11699, 11711, 11725, 11726, 11738, 11759, 11770, 11782,
   11794, 11798, 11805, 11806, 11810, 11817, 11818, 11819, 11823, 11824,
   11825, 11829, 11830, 11834, 11835, 11838, 11839, 11842, 11843, 11847,
   11848, 11852, 11859, 11861, 11866, 11867, 11880, 11888, 11899, 11907,
   11918, 11919, 11920, 11921, 11922, 11923, 11924, 11925, 11926, 11927,
   11937, 11948, 11949, 11953, 11954, 11955, 11956, 11957, 11967, 11975,
   11993, 12013, 12014, 12024, 12033, 12042, 12051, 12070, 12088, 12092,
   12100, 12106, 12113, 12119, 12126, 12135, 12136, 12140, 12142, 12147,
   12158, 12168, 12178, 12184, 12193, 12202, 12208, 12209, 12220, 12235,
   12236, 12247, 12258, 12259, 12262, 12263, 12264, 12265, 12266, 12267,
   12268, 12269, 12272, 12273, 12277, 12278, 12279, 12290, 12309, 12310,
   12314, 12319, 12343, 12354, 12355, 12367, 12385, 12386, 12390, 12397,
   12404, 12411, 12421, 12434, 12435, 12439, 12452, 12465, 12474, 12483,
   12492, 12501, 12513, 12525, 12537, 12540, 12541, 12542, 12543, 12544,
   12545, 12548, 12549, 12550, 12598, 12599, 12603, 12604, 12619, 12620,
   12627, 12635, 12643, 12651, 12659, 12667, 12678, 12679, 12711, 12727,
   12744, 12745, 12764, 12768, 12772, 12787, 12794, 12801, 12811, 12812,
   12815, 12831, 12832, 12833, 12837, 12847, 12858, 12864, 12876, 12889,
   12895, 12896, 12900, 12912, 12920, 12925, 12930, 12935, 12940, 12948,
   12956, 12961, 12966, 12973, 12974, 12978, 12979, 12980, 12987, 12988,
   12992, 12993, 12997, 12998, 13002, 13003, 13007, 13011, 13012, 13015,
   13024, 13037, 13042, 13047, 13051, 13063, 13064, 13068, 13077, 13093,
   13102, 13111, 13120, 13132, 13135, 13140, 13141, 13149, 13169, 13170,
   13172, 13177, 13178, 13182, 13183, 13186, 13187, 13212, 13221, 13231,
   13232, 13236, 13237, 13238, 13239, 13240, 13244, 13257, 13264, 13271,
   13278, 13279, 13283, 13284, 13288, 13289, 13293, 13294, 13298, 13310,
   13311, 13312, 13313, 13317, 13318, 13328, 13335, 13354, 13355, 13359,
   13360, 13366, 13371, 13380, 13388, 13397, 13404, 13412, 13421, 13430,
   13434, 13460, 13464, 13478, 13499, 13521, 13534, 13551, 13557, 13562,
   13568, 13575, 13576, 13586, 13592, 13600, 13604, 13608, 13615, 13623,
   13628, 13629, 13630, 13631, 13635, 13636, 13651, 13655, 13663, 13670,
   13677, 13684, 13691, 13702, 13703, 13716, 13720, 13728, 13742, 13756,
   13757, 13772, 13783, 13796, 13801, 13802, 13805, 13806, 13809, 13810,
   13815, 13816, 13821, 13822, 13831, 13836, 13837, 13841, 13845, 13851,
   13876, 13887, 13901, 13902, 13906, 13920, 13977, 13991, 13993, 13998,
   14000, 14002, 14004, 14009, 14011, 14016, 14024, 14044, 14049, 14056,
   14061, 14067, 14072, 14081, 14083, 14086, 14090, 14091, 14092, 14093,
   14094, 14095, 14100, 14106, 14121, 14122, 14123, 14124, 14125, 14136,
   14142, 14150, 14151, 14157, 14162, 14167, 14172, 14177, 14182, 14187,
   14192, 14198, 14204, 14210, 14217, 14239, 14248, 14252, 14260, 14264,
   14272, 14284, 14305, 14309, 14315, 14319, 14332, 14340, 14350, 14352,
   14354, 14356, 14358, 14360, 14365, 14366, 14373, 14382, 14390, 14399,
   14410, 14418, 14419, 14420, 14424, 14426, 14428, 14430, 14432, 14434,
   14436, 14441, 14446, 14452, 14460, 14465, 14472, 14479, 14483, 14487,
   14495, 14530, 14531, 14533, 14542, 14549, 14565, 14567, 14569, 14571,
   14573, 14575, 14577, 14579, 14581, 14583, 14585, 14587, 14589, 14591,
   14594, 14596, 14599, 14601, 14603, 14605, 14608, 14613, 14622, 14627,
   14636, 14641, 14650, 14655, 14665, 14674, 14683, 14692, 14711, 14720,
   14729, 14738, 14747, 14764, 14773, 14782, 14791, 14800, 14809, 14818,
   14822, 14826, 14834, 14842, 14850, 14858, 14879, 14902, 14914, 14921,
   14937, 14942, 14948, 14955, 14962, 14970, 14978, 14995, 15014, 15040,
   15042, 15044, 15046, 15048, 15050, 15052, 15054, 15056, 15058, 15060,
   15062, 15064, 15066, 15068, 15070, 15072, 15074, 15076, 15080, 15084,
   15089, 15105, 15106, 15107, 15124, 15137, 15139, 15141, 15153, 15178,
   15190, 15202, 15210, 15221, 15232, 15242, 15248, 15257, 15267, 15277,
   15290, 15300, 15331, 15367, 15377, 15388, 15389, 15390, 15397, 15404,
   15408, 15412, 15416, 15420, 15424, 15428, 15432, 15436, 15440, 15444,
   15448, 15452, 15459, 15463, 15467, 15471, 15473, 15480, 15487, 15494,
   15501, 15512, 15526, 15536, 15547, 15563, 15573, 15580, 15587, 15594,
   15598, 15606, 15615, 15624, 15628, 15632, 15636, 15640, 15644, 15653,
   15657, 15667, 15671, 15675, 15680, 15691, 15697, 15711, 15722, 15736,
   15752, 15764, 15774, 15783, 15798, 15800, 15804, 15806, 15808, 15811,
   15814, 15817, 15818, 15821, 15829, 15839, 15840, 15843, 15844, 15845,
   15848, 15849, 15850, 15855, 15859, 15863, 15867, 15874, 15875, 15883,
   15884, 15888, 15889, 15897, 15898, 15902, 15903, 15908, 15917, 15919,
   15934, 15937, 15965, 15966, 15969, 15970, 15978, 15986, 15994, 16003,
   16013, 16031, 16077, 16086, 16095, 16104, 16113, 16125, 16126, 16127,
   16128, 16129, 16143, 16144, 16145, 16148, 16149, 16152, 16155, 16156,
   16157, 16160, 16161, 16164, 16165, 16166, 16167, 16168, 16169, 16170,
   16171, 16172, 16173, 16174, 16175, 16178, 16180, 16185, 16187, 16192,
   16194, 16196, 16198, 16200, 16202, 16214, 16218, 16225, 16229, 16235,
   16239, 16249, 16261, 16262, 16265, 16266, 16269, 16273, 16277, 16283,
   16284, 16289, 16299, 16300, 16301, 16302, 16303, 16304, 16305, 16306,
   16310, 16311, 16312, 16313, 16318, 16323, 16332, 16353, 16357, 16362,
   16373, 16390, 16396, 16397, 16398, 16401, 16409, 16419, 16434, 16435,
   16439, 16451, 16452, 16455, 16456, 16459, 16463, 16470, 16474, 16478,
   16487, 16499, 16500, 16504, 16505, 16509, 16510, 16513, 16514, 16519,
   16528, 16545, 16552, 16557, 16563, 16572, 16586, 16587, 16588, 16589,
   16590, 16599, 16600, 16601, 16602, 16603, 16607, 16609, 16619, 16622,
   16628, 16629, 16630, 16634, 16635, 16636, 16640, 16641, 16645, 16663,
   16683, 16684, 16693, 16694, 16698, 16699, 16702, 16710, 16718, 16726,
   16749, 16750, 16761, 16765, 16771, 16773, 16778, 16780, 16782, 16792,
   16794, 16805, 16809, 16813, 16817, 16821, 16830, 16838, 16870, 16874,
   16881, 16889, 16893, 16897, 16903, 16904, 16906, 16907, 16908, 16912,
   16953, 16981, 16985, 16989, 16995, 16997, 17011, 17047, 17060, 17061,
   17064, 17065, 17082, 17083, 17084, 17089, 17090, 17091, 17096, 17097,
   17098, 17099, 17105, 17106, 17107, 17108, 17109, 17115, 17116, 17136,
   17137, 17138, 17139, 17140, 17141, 17142, 17143, 17144, 17145, 17146,
   17147, 17148, 17149, 17150, 17151, 17152, 17153, 17154, 17155, 17156,
   17157, 17158, 17159, 17160, 17161, 17162, 17163, 17164, 17165, 17166,
   17167, 17168, 17169, 17170, 17171, 17172, 17173, 17174, 17175, 17176,
   17177, 17178, 17179, 17180, 17181, 17182, 17183, 17184, 17185, 17186,
   17187, 17188, 17189, 17190, 17191, 17192, 17193, 17194, 17195, 17196,
   17197, 17198, 17199, 17200, 17201, 17202, 17203, 17204, 17205, 17206,
   17207, 17208, 17209, 17210, 17211, 17212, 17213, 17214, 17215, 17216,
   17217, 17218, 17219, 17220, 17221, 17222, 17223, 17224, 17225, 17226,
   17227, 17228, 17229, 17230, 17231, 17232, 17233, 17234, 17235, 17236,
   17237, 17238, 17239, 17240, 17241, 17242, 17243, 17244, 17245, 17246,
   17247, 17248, 17249, 17250, 17251, 17252, 17253, 17254, 17255, 17256,
   17257, 17258, 17259, 17260, 17261, 17262, 17263, 17264, 17265, 17266,
   17267, 17268, 17269, 17270, 17271, 17272, 17273, 17274, 17275, 17276,
   17277, 17278, 17279, 17280, 17281, 17282, 17283, 17284, 17285, 17286,
   17287, 17288, 17289, 17290, 17291, 17292, 17293, 17294, 17295, 17296,
   17297, 17298, 17299, 17300, 17301, 17302, 17303, 17304, 17305, 17306,
   17307, 17308, 17309, 17310, 17311, 17312, 17313, 17314, 17315, 17316,
   17317, 17318, 17319, 17320, 17321, 17322, 17323, 17324, 17325, 17326,
   17327, 17328, 17329, 17330, 17331, 17332, 17333, 17334, 17335, 17336,
   17337, 17338, 17339, 17340, 17341, 17342, 17343, 17344, 17345, 17346,
   17347, 17348, 17349, 17350, 17351, 17352, 17353, 17354, 17355, 17356,
   17357, 17358, 17359, 17360, 17361, 17362, 17363, 17364, 17365, 17366,
   17367, 17368, 17369, 17370, 17371, 17372, 17373, 17374, 17375, 17376,
   17377, 17378, 17379, 17380, 17381, 17382, 17383, 17384, 17385, 17386,
   17387, 17388, 17389, 17390, 17391, 17392, 17393, 17394, 17395, 17396,
   17397, 17398, 17399, 17400, 17401, 17402, 17403, 17404, 17405, 17406,
   17407, 17408, 17409, 17410, 17411, 17412, 17413, 17414, 17415, 17416,
   17417, 17418, 17419, 17420, 17421, 17422, 17423, 17424, 17425, 17426,
   17427, 17428, 17429, 17430, 17431, 17432, 17433, 17434, 17435, 17436,
   17437, 17438, 17439, 17440, 17441, 17442, 17443, 17444, 17445, 17446,
   17447, 17448, 17449, 17463, 17464, 17465, 17466, 17467, 17468, 17469,
   17470, 17471, 17472, 17473, 17474, 17475, 17476, 17477, 17478, 17479,
   17480, 17481, 17482, 17483, 17484, 17485, 17486, 17487, 17488, 17489,
   17490, 17491, 17492, 17493, 17494, 17495, 17496, 17497, 17498, 17499,
   17500, 17501, 17502, 17503, 17504, 17505, 17506, 17507, 17508, 17509,
   17510, 17511, 17512, 17513, 17514, 17515, 17516, 17517, 17518, 17519,
   17520, 17534, 17535, 17536, 17537, 17538, 17539, 17540, 17541, 17542,
   17543, 17544, 17545, 17546, 17547, 17548, 17549, 17550, 17551, 17552,
   17553, 17554, 17555, 17556, 17566, 17567, 17568, 17569, 17570, 17571,
   17572, 17573, 17574, 17575, 17576, 17577, 17578, 17579, 17580, 17581,
   17582, 17583, 17584, 17585, 17586, 17587, 17588, 17589, 17590, 17591,
   17592, 17593, 17594, 17595, 17596, 17597, 17598, 17599, 17600, 17601,
   17602, 17603, 17604, 17605, 17606, 17607, 17608, 17609, 17610, 17611,
   17612, 17613, 17614, 17615, 17616, 17617, 17618, 17619, 17620, 17621,
   17622, 17623, 17624, 17625, 17626, 17627, 17628, 17629, 17630, 17631,
   17632, 17633, 17634, 17635, 17636, 17637, 17638, 17639, 17640, 17641,
   17642, 17643, 17656, 17657, 17658, 17659, 17660, 17661, 17662, 17663,
   17664, 17665, 17666, 17667, 17668, 17669, 17670, 17671, 17672, 17673,
   17674, 17675, 17676, 17677, 17678, 17679, 17680, 17681, 17682, 17683,
   17684, 17685, 17686, 17687, 17688, 17689, 17690, 17691, 17692, 17693,
   17694, 17695, 17696, 17697, 17698, 17699, 17700, 17701, 17702, 17703,
   17704, 17705, 17706, 17707, 17708, 17709, 17710, 17711, 17712, 17713,
   17714, 17715, 17716, 17717, 17718, 17719, 17720, 17721, 17722, 17723,
   17724, 17725, 17726, 17727, 17728, 17729, 17730, 17731, 17732, 17733,
   17734, 17735, 17736, 17737, 17738, 17739, 17740, 17741, 17742, 17743,
   17744, 17745, 17746, 17747, 17748, 17749, 17750, 17751, 17752, 17753,
   17754, 17755, 17756, 17757, 17758, 17759, 17760, 17761, 17762, 17763,
   17764, 17765, 17766, 17767, 17768, 17769, 17770, 17771, 17772, 17773,
   17774, 17775, 17776, 17777, 17778, 17779, 17780, 17781, 17782, 17783,
   17784, 17785, 17786, 17787, 17788, 17789, 17790, 17791, 17792, 17793,
   17794, 17795, 17796, 17797, 17798, 17799, 17800, 17801, 17802, 17803,
   17804, 17805, 17806, 17807, 17808, 17809, 17810, 17811, 17812, 17813,
   17814, 17815, 17816, 17817, 17818, 17819, 17820, 17821, 17822, 17823,
   17824, 17825, 17826, 17827, 17828, 17829, 17830, 17831, 17832, 17833,
   17834, 17835, 17836, 17837, 17838, 17839, 17840, 17841, 17842, 17843,
   17844, 17845, 17846, 17847, 17848, 17849, 17850, 17851, 17852, 17853,
   17854, 17855, 17856, 17857, 17858, 17859, 17860, 17861, 17862, 17863,
   17864, 17865, 17866, 17867, 17868, 17869, 17870, 17871, 17872, 17873,
   17874, 17875, 17876, 17877, 17878, 17879, 17880, 17881, 17882, 17883,
   17884, 17885, 17886, 17887, 17888, 17889, 17890, 17891, 17892, 17893,
   17894, 17895, 17896, 17897, 17898, 17899, 17900, 17901, 17902, 17903,
   17904, 17905, 17906, 17907, 17908, 17909, 17910, 17911, 17912, 17913,
   17914, 17915, 17916, 17917, 17918, 17919, 17920, 17921, 17922, 17923,
   17924, 17925, 17926, 17927, 17928, 17929, 17930, 17931, 17932, 17933,
   17934, 17935, 17936, 17937, 17938, 17939, 17940, 17941, 17942, 17943,
   17944, 17945, 17946, 17947, 17948, 17949, 17950, 17951, 17952, 17953,
   17954, 17955, 17956, 17957, 17958, 17959, 17960, 17961, 17962, 17963,
   17964, 17965, 17966, 17967, 17968, 17969, 17970, 17971, 17972, 17973,
   17974, 17975, 17976, 17977, 17978, 17979, 17980, 17981, 17982, 17983,
   17984, 17985, 17986, 17987, 17988, 17989, 17990, 17991, 17992, 17993,
   17994, 17995, 17996, 17997, 17998, 17999, 18000, 18001, 18002, 18003,
   18004, 18005, 18006, 18007, 18008, 18009, 18010, 18011, 18012, 18013,
   18014, 18015, 18016, 18017, 18018, 18019, 18020, 18021, 18022, 18023,
   18024, 18025, 18026, 18027, 18028, 18029, 18030, 18031, 18032, 18033,
   18034, 18035, 18036, 18037, 18038, 18039, 18040, 18041, 18042, 18043,
   18044, 18045, 18046, 18047, 18048, 18049, 18050, 18051, 18052, 18053,
   18054, 18055, 18056, 18057, 18058, 18059, 18060, 18061, 18062, 18063,
   18064, 18065, 18066, 18067, 18068, 18069, 18070, 18071, 18072, 18073,
   18074, 18075, 18076, 18077, 18078, 18079, 18080, 18081, 18082, 18083,
   18084, 18085, 18086, 18087, 18088, 18089
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT", "ABSOLUTE_P",
  "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL",
  "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY",
  "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC",
  "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD",
  "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P",
  "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED", "CASCADE",
  "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION", "CONCURRENTLY",
  "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS",
  "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE",
  "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DEPENDS", "DEPTH", "DESC", "DETACH", "DICTIONARY",
  "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P",
  "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED",
  "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXPRESSION", "EXTENSION",
  "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER",
  "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN",
  "FORMAT", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT", "INDENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "JSON", "JSON_ARRAY", "JSON_ARRAYAGG",
  "JSON_OBJECT", "JSON_OBJECTAGG", "JSON_SCALAR", "JSON_SERIALIZE", "KEY",
  "KEYS", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LEADING",
  "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD",
  "LOCAL", "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED",
  "LOGGED", "MAPPING", "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE",
  "MERGE", "METHOD", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE",
  "NAME_P", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NFC",
  "NFD", "NFKC", "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "ON",
  "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY",
  "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY",
  "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARAMETER", "PARSER",
  "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS",
  "POLICY", "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE",
  "PREPARED", "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROCEDURES", "PROGRAM", "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL",
  "REASSIGN", "RECHECK", "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING",
  "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP",
  "ROUTINE", "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR",
  "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STORED", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING",
  "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P", "SYSTEM_USER", "TABLE",
  "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIES", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UESCAPE", "UNBOUNDED",
  "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN",
  "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC",
  "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN",
  "WHERE", "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK",
  "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI",
  "XMLROOT", "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE",
  "FORMAT_LA", "NOT_LA", "NULLS_LA", "WITH_LA", "WITHOUT_LA",
  "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR", "MODE_PLPGSQL_ASSIGN1",
  "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3", "'<'", "'>'", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('",
  "')'", "'.'", "';'", "','", "':'", "$accept", "parse_toplevel",
  "stmtmulti", "toplevel_stmt", "stmt", "opt_single_name",
  "opt_qualified_name", "opt_concurrently", "opt_drop_behavior",
  "CallStmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "DropRoleStmt", "CreateGroupStmt", "AlterGroupStmt", "add_drop",
  "CreateSchemaStmt", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_collate_clause", "alter_using", "replica_identity", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem",
  "alter_identity_column_option_list", "alter_identity_column_option",
  "set_statistics_value", "PartitionBoundSpec", "hash_partbound_elem",
  "hash_partbound", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "opt_program", "copy_file_name", "copy_options", "copy_opt_list",
  "copy_opt_item", "opt_binary", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "column_compression", "opt_column_compression", "column_storage",
  "opt_column_storage", "ColQualList", "ColConstraint",
  "ColConstraintElem", "opt_unique_null_treatment", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_without_overlaps", "opt_column_list", "columnList", "columnElem",
  "opt_c_include", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "OptWhereClause", "key_actions", "key_update",
  "key_delete", "key_action", "OptInherit", "OptPartitionSpec",
  "PartitionSpec", "part_params", "part_elem",
  "table_access_method_clause", "OptWith", "OnCommitOption",
  "OptTableSpace", "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "stats_params", "stats_param", "AlterStatsStmt", "CreateAsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "grant_role_opt_list", "grant_role_opt",
  "grant_role_opt_value", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_relation", "reindex_target_all",
  "opt_reindex_option_list", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "opt_no",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterTypeStmt",
  "AlterOwnerStmt", "CreatePublicationStmt", "PublicationObjSpec",
  "pub_obj_list", "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "MergeStmt", "merge_when_list",
  "merge_when_clause", "opt_merge_when_condition", "merge_update",
  "merge_delete", "merge_insert", "merge_values_clause",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "JsonType", "a_expr", "b_expr", "c_expr", "func_application",
  "func_expr", "func_expr_windowless", "func_expr_common_subexpr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_indent_option", "xml_whitespace_option", "xmlexists_argument",
  "xml_passing_mech", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "opt_window_exclusion_clause", "row", "explicit_row",
  "implicit_row", "sub_type", "all_Op", "MathOp", "qual_Op", "qual_all_Op",
  "subquery_Op", "expr_list", "func_arg_list", "func_arg_expr",
  "func_arg_list_opt", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "position_list", "substr_list", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "opt_slice_bound", "indirection",
  "opt_indirection", "opt_asymmetric", "json_value_expr",
  "json_format_clause", "json_format_clause_opt",
  "json_returning_clause_opt", "json_predicate_type_constraint",
  "json_key_uniqueness_constraint_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor_null_clause_opt", "json_value_expr_list",
  "json_aggregate_func", "json_array_aggregate_order_by_clause_opt",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "attr_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "SignedIconst", "RoleId",
  "RoleSpec", "role_list", "PLpgSQL_Expr", "PLAssignStmt",
  "plassign_target", "plassign_equals", "ColId", "type_function_name",
  "NonReservedWord", "ColLabel", "BareColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,    60,    62,    61,    43,    45,    42,    47,
      37,    94,   758,    91,    93,    40,    41,    46,    59,    44,
      58
};
# endif

#define YYPACT_NINF -5708

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5708)))

#define YYTABLE_NINF -2903

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2903)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    7123,  1351, 20719, -5708, -5708,  1351, 69730, -5708, 79040,     0,
     192,  1250,   194,  8859, 79530, 89330,   803,   368, 20310,  1351,
   89330,  2386, 60419, 75120,  1086, 89330,   495,   686, 60419, 89330,
   89820,  1065,   940,   984, 90310, 80020, 74140,  1384, 89330,  1287,
     414, 90800, 80510,  1167, 81000,   686, 55530,   210,  1251, 91290,
   89330,113760,   414, 81490, 81490, 81490,  2276,  1632,  1281, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708,  1318, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708,  1961, -5708,  1121,
    2069,  1570,   933,  1348, -5708, -5708,  2047, 69730, 89330, 89330,
   89330,  1793, 89330,  1737, 89330,   207, 69730, 66300, 81980,  1911,
    1759, 51494, 91780, -5708, 69730, 89330, 63850, 69730, 89330, 89330,
   92270, 89330, 92760, 89330,  1161, 77570, 89330,  1863, 89330, 89330,
   64340, 93250,  2077,   248,   258, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708,  1808,  1796, -5708,   284, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, 60909, 89330, 20694,   495,  2047, -5708,
    2276, 89330,  2137, 89330,  1815, 93740, 89330, -5708, 89330,  1930,
   94230,   900,   696, 66300,  2124, 52003,  2019, 89330, 89330, 66300,
   94720, 95210, 95700, 89330, 89330, -5708, -5708,  2044, 89330, -5708,
    2125, 66790,  1891,  2155,  2335,  2245,  1095, -5708, 82470, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, 69240,   368, -5708,
   -5708,  2207, 70220,  2285, -5708, -5708, 96190,114236,  2119, -5708,
     912, 70710, 67280,  2395,  2068, 52512,  2520, -5708, 71200, -5708,
   67770, 71690, -5708, -5708, -5708, -5708, -5708, 96680, -5708, 97170,
    2220,  2285, -5708,114712, 68260, -5708,  2383, 97660, 98150, 98640,
    2047,  2117,  1282,  1159, 45996, -5708, -5708, -5708,  2179, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,   334,  2006,
     243,   233,   310, -5708, -5708,   239,   241,   249,   334,  2636,
    2636, -5708, 89330, -5708, -5708,  2006,    69,  2264,  2240,  2240,
    2240,  2397,    17, -5708,  2240,  2278, -5708, -5708, -5708, -5708,
   81000, -5708,  2166,   495,  2287,  2662,  2241, 60909,  1108, 89330,
   -5708, -5708,  2642,  2284,  2618,  2329, -5708, -5708, -5708,  2429,
    2580,   120,    87,   495,   232, -5708,  2695, -5708,  2581, 31390,
   31390,   495, 82960, 99130,   230, 69240,   495, 83450,  2378,  1397,
    2585, -5708, -5708, -5708,   876, -5708,  2844,  2404,  2679,  2329,
     248, 47980, -5708, -5708,  2402,  1796, 81000, -5708, -5708, -5708,
   60909,  2732, 34438, 89330,  2392, -5708,  2407,  2392, -5708, -5708,
    2474, -5708,  2474,  2474,  2413,  2413,  2611,  2435, -5708, -5708,
   -5708, -5708,  1864,  2474,  2413, -5708,115664, -5708,  1814,  1893,
   -5708, -5708,  2905, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708,  2457, -5708,   987, -5708,  1982, -5708, -5708, -5708, 31390,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708,  2442,  2477,  1570,
   -5708, 11680, 60909, 89330,   439,   439,  2940,   439,  1931,  1989,
   -5708,  2799, -5708,  2826,  2793,  2798, 81000,  2503,   968, -5708,
    1749,  2518,  1787,  2509,  1834,  2531, -5708,   971, 89330,   238,
    2565, 83940,  5555,  2533,  1796,  2545, -5708, -5708, -5708, -5708,
    2715,  1550, -5708, -5708, -5708, -5708,  2893,  2954,  6602,   329,
   84430, -5708, -5708, -5708, -5708, 89330, 89330, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708,  2597,  1452, -5708, -5708,
    2596,  2965,  2828,  6300,   333,  2943,  2796,  1374,  7297,  2852,
    1715,  2999,  6574,  1619,  3011,  1947,  2194, 84920, 89330,  2969,
    3014,  4783,  1549,   874,  2872,  1560,  2943,  3004,  2821,  1374,
    3020,  6860, 89330, -5708,  2932,  3055,   104, -5708,   836, -5708,
   24333, 34438, 55040, -5708,  1796, -5708,  1496, -5708, -5708, 59929,
   -5708,  2725,  2883,   730, 69730,  2666, 89330, 89330, -5708,113760,
   69730, -5708,  2897, 53021, 69730, -5708, 69730, -5708, -5708,  3016,
  113760, 89330, 89330, -5708, 89330, -5708, -5708,  2673, -5708, -5708,
   -5708, -5708, -5708,  2240, 89330,  3126,113760,  2917,   300,    11,
    3163, 89330,  2920,    11,  2727, 99620, -5708, -5708,    11, -5708,
   -5708, -5708, 89330, 89330,  2692,  1528,  2911,   861,    11,  2927,
    3165,  3168,  2929,  2778,  2936,  2407, -5708,  3129,  2908,  1124,
     209,  2113,    11,  2757,100110,100600, 89330,  2758, 89330,  3138,
   69730,  2792, 69730, 69730, 89330,  3061, 89330, -5708,  2898, -5708,
   -5708,  1424, -5708, -5708, -5708, -5708, -5708,  3076, -5708,   214,
    3078,  2718,  3080,  1872,  3081,   332, -5708, -5708,  2761, -5708,
    3086,   346, -5708,  3088, -5708,  2724,101090, -5708,101580,102070,
    3091,   349, -5708, 66300,  3093,   346,  3094,  2724,  3095,   346,
    3096,   967,  3097, -5708,  1128,  3085,  3100,   332,  3104,  2135,
    2724, -5708,  3105,   358, -5708,  3107,   372, -5708,  3110,  2968,
   -5708, 34438, -5708,  2849, -5708,  1251,  1987,  1159,  2006, -5708,
   89330,  2006, 89330,  2006, 89330,  2006, 89330,  2006, 89330, 89330,
   89330,  2006, -5708, -5708, -5708, 89330,  2759, 89330, -5708, 89330,
   -5708, -5708, -5708, 76100, 66300, 76590, -5708, 89330, -5708,   761,
     495, -5708, -5708,113760,  3235, 66300,  3138,  2033, -5708, -5708,
    3138, -5708, -5708,  3138,  3138, -5708, -5708, -5708,  3032, 89330,
    3112, 76100, 66300,  3113, -5708,102560, -5708, 69240,  2985,  2775,
   -5708, -5708, -5708, -5708, -5708,  1997,  3285,   255,  3286, 34438,
    2780,   255,   255,  2781,  3125, -5708, -5708, -5708,   291,  2783,
    2784, -5708,   253,   253, -5708,  2788,  2789, -5708,   262,  2791,
    2794,  3301,  3302,   273,   278,  2795,  2800,  2801,  2804,  2806,
    2809,  2812,  2814,  2816,  1864,   255,  2817, 34438, -5708,  2819,
     253,  2820,  2822,  2823,  3305,  2824, -5708,  3307,  2827, -5708,
     225,   245,  2831,  2833, -5708,  3025, -5708,   296,  2835,  2837,
    2839,  2843,  2846,  2847,  2853,  2854, 34438, 34438, 34438, -5708,
   28845,  1796,   495, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708,   305, -5708, 50985, -5708,  2863, -5708, -5708,  3034, -5708,
   -5708, 34438, -5708, -5708,  3178,   857, -5708,   306, -5708, -5708,
   -5708,  1796,  3140,  2845, -5708, -5708,   337,  2848, -5708,  1804,
   -5708, -5708, -5708, -5708, -5708, -5708, 68750,  3333, -5708,   341,
     495,   836,  1948,  3270, 58459, 58949, -5708, -5708,  3141, -5708,
   89330, -5708, -5708,  1796,   168,  2064, -5708,  2179, 19640,  2076,
    2392, 89330, 89330,  3345, -5708,  2870, -5708, -5708, 34438, -5708,
   -5708, -5708,  2636, -5708,  2474,  2474, -5708, -5708,  3350,  2961,
    2962,  2636, -5708,  2636, -5708,  2878,  2880,  2636,  2966,  2967,
    2970, -5708,  2879,  2971,  2636, -5708, -5708, 61890,  2123, -5708,
    3223,   326, -5708, -5708, -5708,  2089, -5708,  2884, -5708,  2407,
   -5708, -5708,  1570,  1570, 34438,  1570,  1590,  1215, 31898, 34946,
    3240,  3108,   869,  1698,  3242, -5708,  3121,  1931,  1989, 81000,
   89330, 81000,103050,  3027, 34438, -5708,  3348,  2989,  2990,  3047,
   57490, -5708,  2994,  2964,  2996,  3056,  2912,  3003,  3005,  3059,
   -5708,  3191, -5708, -5708,  3008,  3361,  3015,103540, -5708, -5708,
     931, -5708, -5708, -5708,   931, -5708,  2941,  1530,  1044,  1018,
    3018,   489,   929,  3354, -5708,  1359, -5708, -5708,  3075, -5708,
   11012, 89330,  3297,  7141,  3155,   329,  3074, -5708, -5708, -5708,
    3214,  3026, 89330,  3028,  3171,   329,  1585,104030, -5708, -5708,
   89330, -5708, -5708, -5708, -5708,  4811,  3334, 27383, -5708,  1985,
    3031,  3010,  3043, 89330, 72670,  2036,  3147,  3170,  1885,  2150,
     624,  3099, 89330,  1750,  3180, 89330,  2955,  3044,  3048,  3289,
    2972,   434,  3394,  2975, -5708, -5708, -5708,  3363, -5708,  2228,
    2364,  3175, -5708,  3293,  3341,  7819,  3045,  3051,112332, -5708,
    3071,    34, 53530, 89330, 89330,  3077,  3079,104520,  4811,  3378,
   77080, 77080,  3082,  3087, 47484,  3397,  1222,  3090, -5708, -5708,
   -5708,  1222,  3101,  3102,105010,  4811,  3388, 89330,  3111,  3116,
   89330,115664,   329, -5708,  3461,   329,   329,  2273,  3464,  3118,
     247,  3258,   886,    11,  2975,  2169, -5708,  3119,  3120,   357,
   -5708,  3225, 89330,  3122,  3123,  1490,  3196,   495, -5708,  3199,
   -5708,  3124,  3204,  3128,   698,  2692, -5708, -5708,  1455,  3134,
   81000,  3210,  3243,  1750,   257,  1039,  2975, -5708,  3131,  3135,
    2972,  2972, 89330, 89330, 89330, 89330, 89330,   304,  3511,   339,
    3136,   271,    37,  3050, -5708,  1222, 64830,  3137, -5708,  1222,
   89330,   471,  1077,  2975,  1847,   137, -5708, -5708, -5708,   248,
   -5708, 34438, 34438, 34438,  3054, -5708,  2286, 19640,   847, -5708,
     308, 16375,  3058, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   89330, 60909, -5708, -5708, -5708, -5708, -5708, -5708, -5708, 89330,
   -5708, 89330,  3342,113760,  3346,  3274,  3353,  3358,   329, 89330,
   89330,  3359,  3362,  3364,113760,  3365,  3369,  3371,  3298,  3153,
     179,  3157,  3083,  3561,  3446, 89330, 61890, -5708,   931, -5708,
  113760,  3304,  3453, -5708, 89330,  3328,    72, -5708,  3493,  3160,
   -5708, -5708,    75, 89330, 75610,  2692, -5708, -5708,  3462, 66300,
     378,  3463,   495,  3154,  3466,  3322,   495, 66300,  3372, 89330,
   89330, 89330, 89330,   152, -5708, 64830,  3349, -5708, 89330,  3351,
    2169,  3352,  3586,  1217,  2240,105500,  3459, -5708,105990,  3115,
   89330,  3117,  3117,  3590,113760,  1423,  3401, -5708, -5708,  2112,
   -5708,  3263, -5708, 69730, -5708, -5708, 69730, -5708, -5708,113760,
   89330,  3127,113760,113760, -5708, -5708, 69730, 69730, -5708, 66300,
   66300,  3487,   358,  3490,  3192,  3495,  3194, 53530, 53530, -5708,
     379, 69730, -5708, 66300, 69730, -5708, 89330, -5708, 89330, -5708,
   -5708, -5708, -5708,113760,113760, -5708, 66300, 64830,  3496, 89330,
   89330, -5708, 89330, 89330, -5708, 89330, 89330,  2100,106480,  1159,
   -5708, 89330, -5708, 89330, -5708, 89330, -5708, 89330, -5708, 89330,
   -5708, -5708, -5708, 89330, -5708, 89330,  2106, -5708, -5708,  2138,
     178, 89330, 89330,   882, 69730, 89330,  3360, 89330, 69730, 69730,
   89330, 89330, 89330, 89330, 89330,  3227,  2848,   173, -5708,   302,
     873, 81000,  3366, -5708, -5708,  2147,  2276,    20, 89330, -5708,
   89330, 89330, 89330, -5708, -5708, 75120,  3480,   157, 76590, 89330,
   -5708, -5708,  6307, 34438,  1796, 30877, -5708, -5708, 19640,  3189,
   34438, 34438,  3144,  2636,  2636, -5708,   386, 34438, 34438, 34438,
   28337, 34438, 32406, 34438, 34438, 34438, 34438,  2636,  2636, 34438,
    9424, 34438, 53530, 34438, 40026, 25361, 34438, 34438, 29353,   293,
    2788, 34438,  3393, 41036, 34438,  1948,  3395, 34438,  1948,  9424,
    3648,  3648,  2083,  8575,  3148,  1796, -5708,  2636,   191, -5708,
     456,113760, 34438, 34438, 34438, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   34438, -5708, 61890, -5708, -5708, -5708, -5708, -5708, -5708,   158,
   -5708, -5708, -5708, -5708, -5708, -5708,  3224, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   89330, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, 29861, -5708, -5708, -5708, -5708,  3156,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
    4485, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, 30369, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708,  3158, -5708, -5708, 34438, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
    3239, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708,   965, 34438, 34438, 34438, 34438, 34438, 34438, 34438,
   34438, 34438, -5708, 34438,   466, -5708, -5708,  3491,  3178,    56,
     465,  3166,  3355, 85410, 31390,  3223, 24333, -5708,   272,  3223,
   -5708, -5708, -5708, 89330,  3333, -5708, -5708,  3244, -5708, -5708,
   -5708, -5708, -5708,   309, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708,  3159, -5708, -5708, -5708, -5708,  3159, -5708,  3164,  3492,
    3494,   967, 89330,  2452, 34438,   158,   252, 89330, 34438,  3156,
    4485, 34438,  3158, 34438,  3239, -5708, 34438, -5708,  2149,  2049,
   34438,  2164,  3172, -5708, -5708,  3169,  2880,  3197,  3200,  3182,
    3183,  2636,   212,  3184,   213,   781,  3313,  2636,  3436,  3186,
   -5708, 61890, -5708, 43020,  3236, -5708, -5708, -5708,   414, 89330,
   89330, -5708,  3486, -5708,  3185, -5708, 16542,  3486, -5708, -5708,
   40531,  3316,  3475,  3410, -5708, -5708, -5708,  3190, 19640, 35454,
   35454, -5708,  2121, 19640,  2199, -5708, -5708, -5708, -5708, -5708,
   -5708,  1389, -5708, 89330,  1523,  3240,  1698,  3257,  1115,  3673,
    3259, 89330, -5708, 48476,  2168, -5708, 66300, 89330, 89330,  3407,
   -5708,  3655, -5708,115664, -5708,  3202, -5708,115188,111380, -5708,
   -5708,    67, -5708,   970, 66300, -5708, 89330, 89330, 66300, 89330,
   89330, -5708, 66300,  3251, 89330, 89330, -5708, -5708, -5708, -5708,
   -5708, 59439,   109, 75120,  3347, 74630, -5708, -5708,  3201, 89330,
    3266,  3488,  3435,  3498,   110, -5708, -5708,106970, -5708,  3437,
   66300, 89330, 89330, 34438,  3439, 89330, 89330, -5708,   920,  3299,
    3303, -5708, 89330,  3306, 69730,  3212,113760, 69730, 54039, 69730,
   69730,  3563,113760, 89330, 89330,  1611, 81000,   473,  1150,  2975,
    3449, -5708,  1624, -5708, 66300, -5708, 89330,  3440, -5708, -5708,
   -5708, 85900,  3685,  3343, -5708, -5708, -5708,107460, -5708, -5708,
    3441, -5708,  2170, -5708, 66300, 66300, 89330,  7994,107950,  1007,
    3467, -5708, -5708,113760, -5708, 89330, 86390, 89330, 89330,  3501,
   89330, 78060,108440,108930,   715,  1451,  3502, 89330, 78550,  3503,
   -5708,  3381, 89330, -5708, -5708, 62380, 66300, 89330,   954, 61890,
   -5708,  3499, -5708, 89330, -5708,   317, -5708, 89330,  3221,  3444,
   -5708, -5708,  3318,  3331, 89330,   475,  1168,  2975,  3625, 89330,
   89330,  3237,  2188, 66300, 89330, 61890, -5708,  3456,   759, 66300,
   89330, 85900, -5708,  3457, -5708, 81000,  3557, -5708,  3238,  2240,
    2402,  2122,  3238, 66300, 89330, -5708,  3238, 89330, 99130, -5708,
   66300,  1364, -5708, 66300, 89330, 85900, -5708,  3468,  3409, 66300,
   89330, 14070, -5708, -5708, -5708,   329, -5708, -5708, -5708, -5708,
   -5708, 89330, 89330,   329, 89330, 89330,   329,  1685, -5708, 66300,
   89330, -5708, -5708, -5708,  3375, 66300, 89330, 89330,   334, 89330,
   -5708, 89330, 66300,  3287, 89330, 89330, -5708, -5708, 89330,  5597,
   89330, 89330, 89330, 89330, 89330, 89330, 66300, 89330, -5708, -5708,
    1633,    92,  1722,  1772,  1604, 89330,  3574, 89330,109420,   495,
   66300, 89330, 89330,   495, 89330, 61890,  1849, -5708, -5708,  3384,
   -5708, 66300,  1364, -5708,  9275, 89330, 89330, 89330,  3344,  3356,
     313,  3430, -5708, -5708, -5708,   878,   878,  3471, -5708, 34438,
   34438, 32914,  3255, -5708, -5708, 34438,  2725, -5708, -5708, -5708,
    1031,  3737,  1031,109910,  1031,  1031,  3556,  3335,  3336,  1031,
    1031,  1031,  3551,  1031,  1031,  1031, 89330,  3451, -5708, -5708,
    3451,   175, 34438,113760, 89330, -5708,  2192, -5708,  3288, -5708,
   -5708, 61890, 89330,   890,   870,  3636,  3504, 73160,  2607,  3623,
   89330,  3330, 89330,  3759,  3380,   615, -5708,  2607, 89330, -5708,
    2114, 75120, -5708, -5708, -5708, -5708, -5708, -5708, -5708, 89330,
   -5708, -5708,  3630, 89330, 43516,  3472, -5708,   495,  2692,  2692,
    2692,  2692,  3300,  2692, 89330,  3417,  3649,  2607,  3308,  3650,
   -5708,  2169,  3654,  1339, 89330,  3510, 73160,  3367,  3340,  3532,
    3778,  2240,   495,  3535,  3521, -5708, 57969, -5708,  2692,  3792,
   27860,  6159,  7166,  3524,  3587, -5708, -5708,  3533,  1094, 89330,
    3635,  3638,  3661, -5708,   214, -5708,  3793,  1872,  3664,   332,
   -5708,   346, -5708,  2724, -5708, 89330, -5708, 89330, 89330, 89330,
   89330,   349, -5708, -5708,   346,  2724,   346,   967, -5708,  3595,
     332,  2724,  3450,  3667,   358, -5708,   372, -5708,  3539,   967,
   -5708,  3555,  2240, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
    2204, -5708, 89330, -5708,  3642,  3643,  3644,  3651,  3652,  3337,
    3338,  3376, 89330,  3339,  3337,   329,  3357,  3368, -5708,  3339,
    3339,  3337,  2848,  2848,  3337,  3338, 65320,  3794, 61890, -5708,
   -5708,  3425,  3373,  3686,   219, -5708,   221,    86,  3598, -5708,
   -5708, -5708, -5708,113760, -5708, 66300,  3387, -5708, -5708, -5708,
    3566,  3379, 65320,   967,   130, -5708, 69730, 89330,113760, 69730,
    3573, 69730, 69730,113760, 89330, 89330,  2206, -5708,   -16, -5708,
    1755, 34438,   486, -5708, 10714,  2212, 34438,  3383,  3385, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708,  3389,  3692, -5708,  2214,
    2237, 17474,  2177,113760,  2888,  3374, -5708,  3390,   217,  3565,
    7247,  3412,  2238,  3391,   236, -5708,  7247,   336,  8985,  3513,
    2243,  3392,  3396,  8138,  7727,  3398, 17630,  3400,  3399,  3404,
    3377, 40026, 40026, 28845,  1053, -5708, 40026,  3405,  3562,  2244,
   16731,  3408,  3413, 18208, 33422, 34438, 33422, 33422, 18275,  3411,
    3415, -5708,  3741, -5708,  2249, 61890,  3558, 18595,  2254, -5708,
   34438, 61890,  8299, 34438, -5708, 34438,  3418, -5708, -5708,  2871,
    2871,  2871,  9424, -5708, -5708,  3386, -5708, 40026, 40026, -5708,
    3273, 28845, -5708, -5708,  3706, -5708, -5708,   244, -5708, -5708,
   -5708, -5708, -5708,  2290, -5708, -5708, -5708,  3600,  2177,  3601,
   53530,  7881, 34438,   270, 34438,  3156, 34438,  3454,  2871,  2871,
    2871,   351,   351,   322,   322,   322,  1968,   465, -5708, -5708,
   -5708,  3382,  3402,  3355,  3420, 34438, -5708,  3434, 48972, -5708,
    2246,  2326, 89330,  1332,  4946,  6080, -5708, -5708, -5708,  3236,
     847,  3236, -5708,   248,  2636,   191, 59929, -5708, -5708, -5708,
   -5708, -5708, -5708, 89330, 19640, -5708, -5708,  3624,  3421,  2255,
   -5708, -5708,  2636, -5708, -5708,  2061,  2061,  3414, -5708,  3424,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708,  3423, -5708, -5708,
   -5708,  3426, 44012,  3713,  3427, 42524, 86880,  3433,  2191, -5708,
   86880, 87370, 86880, -5708,  3447, -5708, -5708,  1796, 34438,  3711,
   -5708, -5708, -5708, 34438, -5708, -5708,   661,  3416,    62,  1213,
    2396,  2396,  2121,  1240, -5708, -5708,  3458, -5708, 34438,  2234,
   -5708,  2257, -5708, -5708, -5708, -5708,  2848, -5708,  3657, -5708,
   -5708, -5708, 43020,  3476,  3445,  1538, 46988,  3616, -5708, 89330,
   43020, -5708, 89330,   259, -5708,  3448, -5708, -5708, -5708, -5708,
   -5708, -5708,111380,  1982, -5708,115188, -5708,115188, -5708,  1982,
    3857, -5708,111380,  1908, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, 66300, 66300,  3626,
   89330,  3640,  3629, 34438,  1271, 89330,  3431,  3442, 89330,  1075,
    3751,  3469, -5708,  3801,   967, -5708, -5708,  3530, -5708, 19640,
   -5708, -5708, -5708, -5708, -5708, 66300, 89330, -5708, 69240, -5708,
   -5708,113760, -5708, -5708, 89330, 89330, -5708, -5708, -5708,113760,
   -5708, -5708, -5708, 89330,  1015,  3534,  3536, 89330, -5708,  1400,
    3225,  9564, 89330, 89330, 89330,  3750, -5708, -5708, -5708, -5708,
    3675, -5708,  3807, -5708,111380, -5708,  2724,   740,  3537,  2975,
    3695, -5708,  3824,  3576, -5708,  3592,  1058, -5708, -5708,  3604,
   -5708, -5708, -5708, -5708,  3826,   967,  3831,   967, 89330, 89330,
   89330, 89330,  3607, -5708, -5708, -5708, -5708,  3608,  3745, -5708,
   61890, 61890, 61890,  2261, -5708, -5708,   495, -5708, -5708, -5708,
   -5708, -5708, -5708,  3787, -5708,  2269, -5708,   -23, 89330, -5708,
   -5708, -5708, -5708, -5708,  3834, 66300, 89330,  9683, 89330, 89330,
   89330,  3697,  1966,   915,113760, -5708,112808, -5708, -5708,  2280,
   -5708,  3500, 89330,  3567, 66300,  3542, -5708, -5708, -5708,  3835,
    2240,  3627, 77080,  3529,  3529,  2133, -5708, -5708, -5708, -5708,
   -5708,  3754,  3683, -5708,  1074,  3684, 66300,  3559, -5708, -5708,
   -5708, -5708,  3850,  3579, -5708, -5708,  3581,  1242,  2975,  2169,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,  3609,
   -5708, -5708, -5708, -5708,  1450,  1450, -5708, -5708, -5708,  1450,
     809,   354,  1313,  2975, -5708,   343,  1028,  3585, -5708,  3588,
   -5708, -5708, -5708,  3760,  3761,  3763,  3593,  3594,  3647,  3599,
    3602,  3658, -5708,  3610,  3662,  3612,  3669,  3615,  3892,   967,
  113760,  3764,   495,  3660,  3900,   967, -5708, -5708,  3637, -5708,
    3639, -5708,  2281,  4008,  4020, -5708, 89330, -5708,   476,  1340,
    2975, -5708,  3646, -5708, 66300, 89330, -5708, -5708, -5708, 34438,
    3560,  3564,  3569, 19640, 19640, 34438, -5708, -5708, 19640,  3568,
   -5708, -5708, -5708, -5708,113760, -5708, 89330,  3851, -5708, -5708,
    1031, 89330, 89330, -5708, -5708, -5708, 89330, -5708, -5708, -5708,
    3856, -5708,   265,   265, -5708, -5708,  3895,  9375,  3571,   340,
   -5708, 61890, 49967,  4124,   808,    11, -5708, 69240, 89330, 69240,
   -5708,   870,  3788, 89330, 89330, 89330,  3575,  3578, -5708, -5708,
   -5708, -5708, 66300,   237, 66300,  2636, -5708, -5708,  3659, -5708,
   89330,  2240,  4087,  3926,  3287, -5708,  4052,  3168,   378,  2048,
     234,  2778,  3990,  2407, 34438,   338, -5708, -5708,  1796, 89330,
    3340, -5708, -5708, -5708, -5708,   495, -5708,  3597,  3584, -5708,
   89330,  3936, 89330, 89330, 89330, 89330,  3387,  3591, 89330,  3606,
  113760, 89330,  2318,  2972,  4076,  3962,  2276,  3367,  3689,  3969,
   81000,  3622,  2282, -5708, -5708,  1094, -5708,  2306,   167, -5708,
     495, 69240,111856,  3960, -5708,   960,  7166, -5708, -5708,   960,
     917, 89330, -5708, -5708, -5708, -5708,  3837,  1995, -5708,  3947,
   -5708, -5708,  2276, -5708,113760,  3634, -5708,  2307, -5708, -5708,
   -5708,   358,  3687,   967,  3688,   967, -5708, -5708, -5708, -5708,
   89330, -5708, 89330, 64830, -5708, -5708, 89330, -5708,  3984, -5708,
   -5708,  3768,  3776,  3783,  3784,  3785, 89330,  3337, -5708,  3641,
   89330, 89330, 66300,  1623, -5708, -5708, 66300,   384, -5708,  1080,
   -5708, 81000,  3782, -5708, -5708, -5708, -5708,  4018,  4022, -5708,
   -5708, -5708,  1391, -5708, 76100,   409, -5708, 66300,  3951,  3954,
    3955,  3957,   329,  3959,  3961,  3964,  3968,  3970, -5708, -5708,
   -5708,  3668, 18030, 34438, -5708,  4045,113760, -5708,  9507, -5708,
   -5708, -5708, 34438, -5708, -5708,  3967, -5708, -5708,  3748,  3752,
    3681,  3374,  3513, -5708,  3902,  3903, 34438,  3513,  4142,  1057,
   34438, 34438, -5708, -5708,  3907,  3908, 34438,  2177,  2177, -5708,
    3690, -5708, -5708, -5708, -5708,  2299, 34438, -5708, 34438, -5708,
   -5708, 25875,  4194,  4194,  3693,113760, 40026, 40026, 40026, 40026,
    1614,  2820, 40026, 40026, 40026, 40026, 40026, 40026, 40026, 40026,
   40026, 40026,   474, -5708,  3899, 34438, 34438, 33930, -5708, -5708,
  113760,  3698,  3411,  3700,  3701, 34438, -5708, -5708, -5708,  2312,
   41532,  3702, 61890, -5708, 34438, 14911,  2336,  3747, 18690,  1796,
   10071,   495, 34438,  1143,  1658, 34438,  2337, 34438, -5708, -5708,
   -5708, -5708,  4039, -5708, -5708, -5708, -5708, -5708, -5708,  3939,
    2177, -5708, -5708, 34438,  3705,  3645, 40026, 40026,  4158, -5708,
    4429, 34438, 28845, -5708,  3471, -5708, 26389,  3703, 34438,110890,
   -5708, -5708,   686,   686,   686,   686, -5708, 89330, 89330, 89330,
    3711,  3707,  3711,   836,  3708, -5708, -5708, -5708, -5708,  2276,
   -5708,  3714, -5708, -5708, -5708, -5708, -5708, 86880, 87370, 86880,
    3710, 42028, 26886,  2191,  3715, 89330, -5708, -5708,  3712, 43020,
    4005,  3923, -5708, 43020,  3923,  1464,  3923,  4009,  3815, 49468,
   -5708, -5708,  3720, -5708,  3934, -5708,  1985, 19640,  4180,  4053,
   -5708,  3726, -5708,  3416,  1667, -5708, -5708, -5708,  1267, -5708,
    3816, -5708, -5708, -5708,  3433, 35962,  3886, -5708, -5708, -5708,
    3791,  2346, -5708, -5708,  4161,  3886, -5708,  2082, -5708,  2355,
   48476,  3476, 34438,  1796,  2356,  1952, -5708, -5708,111380, -5708,
    3812,  2724,  2724,  1403,  3337,  4084,  1403, 10362, -5708, -5708,
   44508, 89330, -5708, 89330, -5708, 89330, 89330,  1502, 89330, -5708,
   89330, -5708, -5708, -5708,  4215,  3804,  3805,  4019, -5708,  2509,
   -5708, -5708, 66300, 89330, -5708, -5708, -5708,   482,  1368,  2975,
   -5708,  3830, -5708, -5708,  4049, 89330, -5708,  4202,  3842, 89330,
    4109, 89330, 87860, -5708,  4178,  1502,  3862,  4091,  2103,  2972,
     247,  4217, -5708,  1860, -5708, -5708,  3832, -5708, 89330, -5708,
   89330, -5708, -5708, -5708, -5708, -5708, -5708, -5708,  3891, -5708,
   -5708, -5708, -5708, 62380, -5708, -5708, 89330, -5708, 61890, 49967,
   61890, -5708, 89330, -5708,  1111,   502,  1416,  2975, -5708,  3844,
   -5708,  4117,  3846,  3847,  3904,   963,   246,  3854,  3855,  3906,
    3769,  3771,  3773, -5708, 61890, 50476,  3938, 89330,  2724,  3780,
    3819, 89330,  3529, 88350, -5708,  3781, -5708, -5708,  3529,   334,
     495, -5708, -5708,   495,  2724,   495, 89330, 89330, 89330, 89330,
     334, -5708, -5708, -5708,  4238,  3884, 89330, 89330, 89330, 89330,
   -5708,  3841, -5708, -5708, -5708, 89330, 89330,  4139,  1042,  2175,
   66300, 89330, 89330, 66300, 89330, 89330, 89330, 89330, 89330, 89330,
   89330,  4012, -5708,  4233,  4159,  2193,  4200,  3875, 89330, -5708,
   89330,   495, -5708,  3225, 89330, 89330, 89330, 89330, -5708, -5708,
   -5708, -5708, -5708,  3471, -5708,  3802,  4100,  1031, -5708,  4104,
    4105,  4111,  1031, -5708, -5708,    11, -5708,   511, 89330, -5708,
    2334, 89330, -5708, -5708, -5708,  3726,  2228,  2364, -5708, -5708,
   -5708, -5708, -5708, -5708,  3818, 89330, 89330, 40026, -5708,  2226,
    1729,  1482, -5708,  4098, 89330,  3025, -5708, -5708, -5708,  1304,
   89330, -5708, -5708, -5708, -5708,  3820, -5708,   684,  3591, -5708,
    4128, 73160,  2724, 66300, 66300,  2724, -5708,113760,  3822,  3340,
   -5708,   267,  3909, -5708, 66300,   378,110400,  3154,  3864,  4044,
   11596, 43020, 43516,  1450, -5708,  3838,  3827, -5708, -5708, 89330,
    3788, 64830,  2375,  2169,  4309,  1279,  2117, -5708, 73650,  4035,
    3591,  4128, -5708,  2972,  4060,  4061, -5708,  2276, 89330,  3387,
    3340,   495, 89330,  3266, 49967, -5708,  4356,  2120, -5708,111380,
   34438, 34438, -5708,  3843, -5708,  3845,  7166, -5708,  3922,  3848,
    4319, 34438, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
    3935,  3860, 89330, 89330,  1094, 89330, -5708,  3849,  3664, -5708,
    3664, -5708, 89330, -5708, 89330, -5708,   967, -5708,  3982,   967,
   89330, 89330, 89330, 89330, 89330, 89330,  3337,   329,  3368, -5708,
   -5708,  4189, 65320,  4190, -5708, 61890, -5708, -5708, -5708, -5708,
   -5708,  2384, 89330, -5708, -5708, -5708,  4258,  4198,   967,   157,
    1099,  1099,  1099,  1099,  4155,  1099,  1099,  1099,  1099,  1099,
   -5708, 34438, 19640, -5708,  3863, -5708, 19640,  4235,  4147,  4148,
   -5708, -5708,  3866,  4097,  4106, -5708,  3869, 34438,  3513, -5708,
   -5708,  4112,  4113, -5708,  3513,  3513, -5708,  3876, 12156, 18779,
   -5708,  2388, 34438, -5708,   587,   587,   587,  3465,  4222, -5708,
    2650,   587,   587,   587,   371,   371,   323,   323,   323,  4194,
     474, 18850, 19257, 19362,  3882, -5708, -5708, -5708,  3411, -5708,
   36470,  1355,  4344, 41036, -5708, -5708, -5708,  3937,  3940,  3888,
   -5708, 34438, 36978,  3890,115664,  4096, -5708,  1708, 34438, 34438,
    3880, -5708, 10516, 34438, -5708, -5708,  3880,   492, 34438,  1949,
    2470, 34438, 34438,  4456, 12192,  3897, -5708,  2393, 34438, 12241,
    4101, -5708, 89330, 89330, 89330, 89330, -5708, -5708, -5708,  4053,
     495,  4053,   495,  3898, -5708, -5708, -5708, -5708, 62870,  3910,
    3558, 86880,  3911, 89330,  2191, 43020, -5708, -5708,  2167, -5708,
   43020,  4191, -5708, 43020, 69730, -5708, 89330,  3913, 89330, -5708,
     439, 34438,  3950, 53530, -5708, -5708, -5708, -5708,  3996, -5708,
    4132, 19640, 31390, -5708,  2276,  2575, 89330,  1796,   825, -5708,
   34438,  3925, 89330, -5708,  3886, 19640, -5708,  3992,  2405, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708,  4004, 75120,  4260, -5708,
   34438,  2410, -5708,  3965,  4358,   231,  2414,  1502,   -10,  1502,
   -5708,   -10, -5708,  1780,  4236,   187, -5708,   967, -5708,113760,
   89330, 89330, 89330,  2912, -5708, -5708, 89330, 89330, 89330, 89330,
   -5708, -5708, 66300, 89330, -5708, 89330, -5708, -5708, -5708, 88840,
   -5708,  3788,   331,  2226,  4246,  4248,  4156, -5708,   329, -5708,
    4406,  2226,  4163,   331, -5708, -5708, -5708, -5708,  3234, -5708,
  113760,   967,   967, -5708, -5708, -5708, -5708, -5708,  3941, -5708,
    4386,  4028, 89330, 89330, 89330, 89330, 89330, 66300, 89330, 89330,
    2636,  2636,113760,  3932, -5708,  2636,  2636,  3933, -5708, 66300,
   89330, 89330, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708,  4024, -5708, 34438,  4383, -5708, -5708, -5708,
   -5708, -5708, 34438, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, 66300, 89330,  4027, -5708,  4029, -5708,   934,
   -5708, -5708, 89330, 89330, 89330, 89330,  4305, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,  4303, 89330,
   -5708, -5708,   495,   495,113760,   967,   967, -5708, -5708, -5708,
    4033, -5708, -5708,  3948,  4247,  1031, -5708,  1031,  1031,  1031,
   -5708,  3956, -5708,    11,  4346, -5708,  1502,   289,  4297, -5708,
   34438, -5708,   948,  3465, -5708,  4359,  4437, -5708, -5708, -5708,
    4199,  3287,  2240,  3287, -5708, -5708, 69730,   389, -5708,  4281,
     890, 61890,  4192, 73160,   343,   318,  3971,  4099, -5708,  2724,
    2724,  4032, 89330,  4444, -5708, -5708, -5708, -5708, -5708, -5708,
   66300,  3542, -5708,  4207,  1316,  4320, 89330, 43516, -5708,  3433,
   -5708, -5708, -5708,   495, -5708, -5708,  4108,  3340, -5708,  1449,
   89330,  4201, 73160,  3387,  2416, -5708, -5708, -5708,  4025,  4435,
    3367, -5708,   343,  4035, -5708, -5708,  4412,  4080,  4030,  4465,
   -5708,  4080,  4330,  4212,  3995, -5708,  3622, -5708, 89330, -5708,
   19640, 19640,   495,116140,   960,113760,  4343, -5708, 19640, 89330,
     910,  3993,  4166, -5708,  4306,   967,  2422, -5708,   967,   967,
   -5708, 89330, -5708,  3337,  3337,  3337,  3337,  3337, -5708,  4216,
   -5708, -5708, -5708, -5708,  4298, -5708, 65320, -5708,   967, -5708,
   -5708, -5708, -5708, -5708, -5708,  1099, -5708, -5708, -5708, -5708,
   -5708, 19640, -5708, 89330, -5708, -5708, -5708, -5708, -5708, -5708,
    3185,  4002, -5708, -5708,  4014,  4015, -5708, -5708, 34438, -5708,
   12575, 40026,  4354, -5708, 34438, 34438, 34438, -5708,  4017,  2427,
    2428, -5708, -5708,  1355, -5708,  4344, -5708, -5708, -5708, 12904,
    4075, 19640,  4135,  4021,   879,  3880,  3880, 10516,  3880, 34438,
   34438,  3880,  3880, 34438, -5708, -5708, -5708, 12942, -5708,  4477,
    3471, -5708, -5708, -5708, -5708,  3950, -5708,  3950, -5708,  4162,
   -5708,  2443,  4502, 39010,  4460, -5708, 89330,  2466, -5708, 34438,
    4031, -5708, -5708, 43020,  2167,  4034,  2467, 89330,  2468,113760,
   37486, 19640, 89330,  3471,  4036, -5708, 89330,  2845, -5708,  1538,
   -5708, -5708,  4462, 44508,  4416, 19392, 34438, -5708, -5708, -5708,
   -5708, 65320,  4250, 65320,  1502, 13305,  4355, 44508, 54548, 89330,
   -5708, 89330, -5708,  4210,  4249,  4041,  4043, -5708, -5708, -5708,
   -5708, -5708, -5708,  4048, -5708, -5708, -5708, -5708,  4131, -5708,
   -5708,    45,  3366, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
    4523,  4411,  4414, -5708, -5708,  4051, -5708, -5708, -5708,  4233,
   -5708, -5708, 49967, 66300, 89330, -5708,  4140, -5708, -5708, -5708,
   -5708, -5708, -5708, 46492, 53530, -5708,   963,  4056,  4057,   246,
   -5708, -5708, -5708, 89330, 13341,  4062, 13466,  1256,  3366, 89330,
   89330,  4063,  4064,  4065,  1731,  1399,  1886,  3337,  4407, 89330,
   -5708, -5708, -5708,  4233, -5708, -5708, 89330, -5708,  1031, -5708,
   -5708, -5708, -5708, 61890, -5708,  2707,  3956,   495, 69730,  4543,
    4543, 14153,  4295, -5708, -5708,   125,  4378, -5708,  4134,  4328,
    4134,  4073, 89330,  1304,  4074,  2472, -5708, 89330,  4077,  4206,
    1795,  1795, 89330, 89330, 89330,  2479,  2276,  2724,  3819,   378,
    4438, 73160,  4479,  3788,   352, -5708, 89330,  4557, 89330,  3387,
    3591, 89330,  4081, -5708, -5708, 73650,  4299,  4124, 89330,  2318,
    4035,  3367,  1076, 89330, -5708,  1472, -5708,  2276, -5708, 89330,
   81000, 44508,  4427, -5708,115188, -5708,  2485, -5708, -5708, -5708,
    4165, 20140,  3236,  4204,  4208,  4089,  2099,  4439, 89330,   926,
   -5708, -5708, -5708, -5708, -5708, -5708, 89330,   409, -5708, -5708,
   -5708, -5708, -5708, -5708, 19500, -5708,  4016, 40026, 19640, 19640,
   19640, 34438, -5708, 34438, -5708, -5708, -5708, -5708,   711, -5708,
   -5708,  4408,  4092,  3880,  3880,  3880, -5708, 34438,  1388, -5708,
   -5708,  1055,  4498,  3447, 62870,  4102, -5708, 40026,  2506, -5708,
    1705, 89330,  2511, -5708, 19640, 89330, -5708, -5708, 34438, -5708,
    2512, -5708,  4114,    26,  4115, 24847,  4093, -5708, -5708, -5708,
   -5708, -5708, 19640,  4095, -5708,  4573,  1698, -5708, -5708,  4157,
   89330,  2516, -5708,  1117,  2039,  4160, -5708, 19640,  1623,  1403,
     491,  4358,  4116,  3287, -5708,  4119, -5708, -5708,   415,  2972,
   89330, -5708,  4355,  4355, -5708, 89330,  4196, -5708,  4124,  4433,
   -5708, -5708, 34438,  4173, -5708,  1372,  3366, 89330,113760, -5708,
     135,  4467, -5708,113760,113760, -5708, -5708, -5708, 34438, -5708,
    4220, -5708, -5708, -5708, 34438, 34438, 72180, -5708, -5708, 89330,
   89330, 89330, 89330, 89330, -5708,   967, -5708, -5708,  2523, -5708,
   45500, -5708, -5708,  3163,   495,  3163,  1890, -5708, -5708,  3163,
    3163, -5708,  3236, -5708,  4543,   374, -5708, -5708,  4199,  4121,
   34438, -5708,  4440, -5708,   200,  4345, -5708,  4137, -5708, 69730,
    4638, -5708, 61890,  3591,  4128, 89330, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -5708,  2524,  3788,
    4486,  3340,  4030, -5708, 89330,  4172, -5708, 43020,  3788,  2276,
    2117, -5708,  4035,  3591,  4128, -5708, -5708,  4136,  4061,  3367,
    2318,  4285, -5708,  4287, -5708,  4586,  4360,  4587,  3387, -5708,
    3266,  2530, 89330, -5708, -5708,  7166,116140,113760, -5708, -5708,
   -5708,  4143,  4527,  4203,  4205, -5708, -5708, -5708,  2099, -5708,
    1606,  4530,  4195, -5708,  4214, 89330, -5708, -5708,  3788,   967,
   34438,  4016,  2536,  2538,  4218, -5708, -5708, -5708,  3411, 37994,
   37994, 37994,  4164,  4507,  4509, 89330, -5708, -5708, -5708, 89330,
    3465,  4167, 39010, 61890,  2542, -5708,113284, -5708,  2556,  2557,
   -5708, 34438,  4168, 34438, -5708, 37486, 89330,  4170,  3240,  2276,
   -5708,  3236, 44508, -5708,  4291,  4644,  4424, -5708, -5708,  4508,
   -5708, -5708, 89330,  4134, 53530,  3416,   415,  2240,  3287,  3287,
   -5708, 89330,  4121, 14209, 34438, -5708,  4268, -5708, -5708,  2561,
    1565,  4347,  4347,  2562,  2566, 14542, 89330,  2567,  2573, -5708,
    2582,  2636,  3338,  1886,  3338, -5708,  3337, -5708, -5708, 61890,
   -5708, 65810, -5708, -5708, -5708,   495, -5708,   495,  4402, 56020,
   56510,   495,   495, -5708, -5708, -5708, -5708, -5708,  2169, -5708,
   14841,  4271, -5708, -5708, -5708,   504, -5708,  4395,  4396, -5708,
    4179, -5708,  2584, -5708,   343,  4313,  3788, -5708, -5708, 89330,
    4661,  4663, -5708,  1322, 89330,  3433, -5708,  4030,  3387,  3367,
     343,  4035,  4124, 45004,  4080,  2318,  4061, -5708, -5708,  4404,
   -5708,  4405, -5708,  4193,  4512, -5708,  1874,   960, -5708, -5708,
   -5708,  1419,  4537,  4538, -5708, -5708, -5708,  3163, -5708,   772,
    4209,  4553, -5708, -5708, -5708, -5708, 19640, -5708, -5708, -5708,
   39518,  4348,  1338, 17259,  4568, -5708,  4568,  4568, -5708,  4660,
    4662,  1380,  2588, 41036, -5708, -5708, -5708, 89330,  4419,  1481,
    4682,  4373,  2590, 37486,  2598, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708, 48476, 34438,  4302,  4644, 65320,  2602,  3529,  4213,
   -5708,  3416,  4328,  4134,  4134,  3366, -5708, -5708, 19640, 89330,
   69730,  4671, -5708, -5708, -5708, -5708, -5708, -5708, -5708,  3366,
    4304, -5708, -5708, 72180, -5708, 89330, -5708, -5708,  2604, -5708,
   -5708, -5708, 57000, -5708,  3993, -5708,  3993, -5708, -5708,  2115,
    4324, 89330,  1070,  1070,  4610, -5708,  4284, -5708,  4221, -5708,
    4730,  4361, 89330, -5708, -5708,   963,  2276, 73160,  3788, -5708,
   -5708,  2318,  4035,  3367, 34438,  2608, -5708,  4358,   231, -5708,
    4061,  4080, -5708, -5708, 44508,  4223,  3025,  4599, -5708, -5708,
   -5708,  1979, 69730, 69730, 89330, -5708, -5708, -5708, 34438,  1304,
    4708, -5708, -5708, -5708, -5708, -5708,  1078, -5708, -5708, -5708,
   89330, 89330, 89330, -5708,  3558, -5708, -5708, 40026, 40026,  4457,
   -5708,  1481, -5708, 89330, -5708,  4231, -5708, -5708,  2613, -5708,
      -3, 19640,   944,  4322,   491, -5708, -5708, -5708, -5708,  4345,
   -5708, -5708, -5708,  3366, -5708, 89330, -5708,  4237, -5708, -5708,
   -5708, 65810, -5708,  3993, -5708, -5708, -5708, -5708,  4726, -5708,
    1319, -5708, -5708, -5708, -5708, 89330,  3788,  3932,  4030, -5708,
    4061,  3367,  2318, 15754, -5708, 45004, 89330, 89330,  4080, -5708,
    2619, 44508,  3340,  4382, -5708,  1977, -5708, -5708, -5708, -5708,
   -5708, -5708, -5708,   864,  4234,  4244, -5708, -5708, 15794, 69730,
   38502,  4399, -5708,  4464, -5708,  1433,  1460,  1951,  4689,  3465,
    3465, -5708, -5708, -5708, 34438, -5708, -5708, -5708,  4488,  4387,
   -5708, -5708,  1301, -5708,  1502, -5708,  1502,  1502, -5708, -5708,
   34438, -5708, -5708,  2240,  2240,  3788, -5708, -5708,  4080,  2318,
    4061,  4358, -5708, -5708, -5708, -5708,  4512, -5708,  2620,  4080,
    4195,  2311, -5708, -5708,  2324,  2477,  4349,  4601, -5708,  4262,
   -5708, -5708, -5708, 89330, 89330, 63360, 89330, 89330, 16197, -5708,
   48476,  4490,   182, -5708,  1502,  2621, -5708, -5708, -5708, -5708,
    4061,  4080, 89330,  3025, -5708, 44508,  3236,  4626, -5708,  1977,
    4384,  4385, 61400, -5708, -5708,  4774,   314,  4667, -5708,  2627,
   -5708,  4272, -5708,  4333,  1538,  4266, 89330, -5708, -5708,  4080,
   -5708, -5708,  3340, -5708, -5708,  1304, -5708,  4315,  4325, -5708,
    2631, -5708, -5708, -5708, -5708, 34438, 63360, -5708, -5708,  4336,
   34438,  2639, -5708,  4080, 69730,  4622,  4623, -5708, 61400,   878,
    4350,  4341,  2645,   107,  3236,  4290, 69730, 69730, -5708,  4286,
   89330, -5708, -5708,  1538, -5708, -5708, 61400, -5708, -5708,   495,
   -5708,  4351,  2647,  4341, -5708, -5708
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1711,  1454,   660,  1543,  1542,  1454,     0,   269,     0,  1554,
       0,  1454,   435,  1111,     0,     0,     0,     0,   660,  1454,
       0,  1711,     0,     0,     0,     0,     0,  1724,     0,     0,
       0,     0,     0,  1251,     0,     0,     0,  1454,     0,     0,
    1731,     0,     0,     0,     0,  1724,     0,  1556,     0,     0,
       0,     0,  1731,     0,     0,     0,     0,     0,     2,     9,
      10,    45,    80,    81,    38,    37,    98,    63,    24,    71,
     133,   132,   134,    50,    46,    88,    33,    35,    47,    51,
      73,    75,    40,    53,    64,   110,    72,    31,    70,    76,
      96,    58,    19,    20,    59,    21,    60,    22,    61,   106,
      82,    99,    43,    69,    30,    52,    78,    79,    12,    54,
      86,    18,    65,    66,    68,    91,    92,    93,   116,    94,
     128,    49,   125,   103,   104,   122,   105,   123,    16,   107,
      62,    23,   119,   118,   120,    89,    55,    90,    77,    97,
     117,    34,   121,    25,    26,    28,    29,    27,    67,    36,
      74,    39,    95,   124,   114,   109,   129,   127,    11,   135,
     111,    83,    14,    15,   100,    13,    32,    57,    17,    42,
      41,    56,    48,   131,    44,  1554,   102,   115,   101,    84,
     108,    87,   112,   130,   113,    85,   126,  1675,  1674,  1735,
    1678,  1710,     0,  1690,  1453,  1452,  1467,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   659,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1464,  2382,  2399,  2400,  2401,  2402,  2403,
    2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,
    2415,  2414,  2416,  2417,  2771,  2418,  2419,  2420,  2713,  2714,
    2772,  2715,  2716,  2421,  2422,  2423,  2424,  2425,  2426,  2427,
    2428,  2429,  2717,  2718,  2430,  2431,  2432,  2433,  2434,  2719,
    2773,  2435,  2436,  2437,  2438,  2439,  2440,  2774,  2441,  2442,
    2443,  2444,  2445,  2446,  2447,  2448,  2449,  2775,  2450,  2451,
    2452,  2776,  2453,  2454,  2455,  2456,  2457,  2458,  2720,  2721,
    2459,  2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,  2481,  2482,  2483,  2484,  2485,  2486,  2722,  2487,
    2488,  2489,  2490,  2723,  2491,  2492,  2493,  2494,  2724,  2495,
    2496,  2497,  2498,  2777,  2778,  2499,  2500,  2501,  2502,  2503,
    2725,  2726,  2504,  2505,  2506,  2507,  2508,  2509,  2510,  2779,
    2511,  2512,  2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,
    2521,  2522,  2523,  2780,  2727,  2524,  2525,  2526,  2527,  2728,
    2729,  2730,  2528,  2781,  2782,  2529,  2783,  2731,  2732,  2733,
    2734,  2735,  2736,  2737,  2530,  2531,  2532,  2533,  2534,  2535,
    2536,  2738,  2784,  2537,  2785,  2538,  2539,  2540,  2541,  2542,
    2543,  2544,  2545,  2546,  2547,  2548,  2549,  2550,  2551,  2552,
    2553,  2554,  2555,  2556,  2557,  2558,  2739,  2786,  2740,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2741,  2742,  2566,  2567,
    2568,  2787,  2569,  2743,  2570,  2744,  2571,  2572,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2745,  2788,  2581,  2789,
    2746,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2747,  2594,  2748,  2597,  2595,  2596,  2598,
    2599,  2600,  2601,  2602,  2603,  2604,  2605,  2606,  2607,  2749,
    2608,  2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,  2617,
    2618,  2619,  2620,  2621,  2622,  2623,  2624,  2625,  2626,  2790,
    2627,  2628,  2629,  2630,  2631,  2750,  2632,  2633,  2634,  2635,
    2636,  2637,  2638,  2639,  2640,  2641,  2642,  2643,  2644,  2645,
    2646,  2647,  2648,  2751,  2649,  2650,  2791,  2651,  2652,  2752,
    2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,  2661,  2662,
    2663,  2664,  2665,  2666,  2753,  2667,  2668,  2669,  2670,  2792,
    2671,  2672,  2673,  2674,  2675,  2676,  2754,  2755,  2677,  2678,
    2756,  2679,  2757,  2680,  2681,  2682,  2683,  2684,  2685,  2686,
    2687,  2688,  2689,  2690,  2691,  2692,  2693,  2694,  2695,  2696,
    2697,  2758,  2759,  2698,  2793,  2699,  2700,  2701,  2702,  2703,
    2704,  2705,  2706,  2707,  2708,  2709,  2760,  2761,  2762,  2763,
    2764,  2765,  2766,  2767,  2768,  2769,  2770,  2710,  2711,  2712,
     146,     0,     0,  2349,  2383,  2384,  2387,  2382,   405,   404,
    1664,  2346,  2383,  1553,     0,  1532,   660,     0,  1467,   434,
    1711,     0,     0,     0,     0,     0,     0,   877,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     138,     0,   140,     0,     0,   458,   457,     0,     0,  1083,
     463,     0,     0,     0,     0,     0,   650,  1595,  2595,  1593,
    1665,   270,   273,   274,   271,   272,  2365,     0,  1223,  1224,
    1226,     0,     0,  1236,   917,   918,     0,     0,     0,   931,
       0,     0,     0,   915,     0,     0,     0,   937,     0,   934,
       0,     0,   938,   935,   912,   936,   919,     0,   911,     0,
       0,  1236,   939,     0,     0,   913,     0,     0,     0,     0,
    1467,  1592,   464,  1711,     0,  1576,  1577,  1578,  1554,  1566,
    1579,  1571,  1573,  1572,  1574,  1575,  1570,  2364,  2401,  1007,
    1007,  1007,  1007,  1004,  1005,  1007,  1007,  1007,  2615,     0,
       0,   986,     0,   988,  2366,  1007,  1012,  2409,   542,   542,
     542,     0,  1011,  1016,   542,     0,  1435,  1476,  2348,  1723,
       0,   987,  1434,  2677,  1582,     0,     0,     0,     0,  2634,
    1444,   254,  2646,  2754,  2677,   253,   248,   249,   222,     0,
       0,  1011,   542,     0,  1467,  1442,   983,  1730,  1728,     0,
    2333,  2428,  2444,  2540,   245,  2627,  2636,  2646,  2754,  2677,
    2709,   201,   211,   206,     0,   263,  2646,  2754,  2677,   259,
    1464,     0,  1691,  1839,  1838,  2342,     0,  1437,  1436,  1555,
       0,  1558,     0,  2610,  1695,  1698,  1560,  1696,  2385,  1916,
    1945,  1923,  1945,  1945,  1912,  1912,  2474,  1925,  1913,  1914,
    1950,  1970,     0,  1945,  1912,  1917,     0,  1915,  1953,  1953,
    1940,     3,  1895,  1896,  1897,  1898,  1926,  1927,  1899,  1932,
    1933,  1937,  1900,  1967,  1903,  1912,  2386,  1732,  1733,  2333,
       4,  2379,     5,  2295,  2378,     6,     7,  1687,     0,     0,
       1,  1711,     0,  1565,  1727,  1727,     0,  1727,     0,  1679,
    1687,  1682,  1686,     0,     0,     0,     0,     0,     0,  1438,
       0,     0,     0,   942,     0,  1479,  1068,     0,     0,     0,
       0,     0,  1320,     0,  1120,  1119,  2388,  2371,  2372,  2373,
       0,  2369,  2370,  2389,  2390,  2391,     0,  2510,  1320,     0,
       0,  2211,  2222,  2223,  2224,  2432,  2491,  2219,  2220,  2221,
    2213,  2214,  2215,  2216,  2217,  2218,     0,     0,  1218,  2212,
       0,  2510,     0,  1320,     0,   173,     0,   150,  1320,     0,
       0,  2510,     0,     0,  2510,     0,     0,     0,     0,     0,
    2510,     0,     0,     0,     0,     0,   173,  2545,     0,   150,
    2510,     0,     0,  1458,     0,     0,     0,  1460,  1463,  1450,
       0,  2292,     0,  2293,  2350,  1547,     0,  1546,  1540,  1550,
    1545,  1535,     0,  2342,     0,     0,     0,     0,   925,     0,
       0,   915,     0,     0,     0,   926,     0,   927,   928,     0,
       0,     0,     0,   924,     0,  1448,  1440,     0,  1584,  1586,
    1585,  1587,  1583,   542,     0,     0,     0,  2510,     0,   150,
    1518,     0,  2510,   150,     0,     0,   462,   461,   150,  2369,
     460,   459,  2432,  2491,     0,  1110,     0,  1193,   150,  2510,
       0,   194,  2510,   719,  2510,  1560,   139,     0,   663,     0,
     831,  2545,   150,     0,     0,     0,     0,     0,     0,   142,
       0,     0,     0,     0,     0,     0,     0,   649,   660,  1596,
    1594,     0,  1227,   247,   246,  1225,   929,  2510,  1152,   145,
       0,     0,  2510,  1499,  2510,   145,   946,   930,     0,   916,
    2510,   145,  1116,  2510,  2374,   183,     0,   914,  2432,  2491,
    2510,   145,  1220,     0,  2510,   145,  2510,   179,  2510,   145,
    2510,   145,  2510,   664,     0,     0,  2510,   145,  2510,  2545,
     181,   933,  2510,   145,   940,  2510,   145,  2344,  2510,     0,
    1451,     0,  1588,     0,  1568,  2758,     0,  1711,  1007,  1006,
       0,  1007,     0,  1007,     0,  1007,     0,  1007,     0,     0,
       0,  1007,  2367,  2368,   989,     0,  1013,     0,  1021,     0,
    1020,  1019,  1018,     0,     0,     0,  1022,     0,  1843,  1623,
       0,  1432,  1447,     0,     0,     0,   142,     0,  1249,  1246,
     142,  1248,  1247,   142,   142,  1443,   252,   250,     0,     0,
       0,     0,     0,     0,  1449,     0,  1441,     0,     0,     0,
    2352,  2354,  2355,  2225,  2295,     0,  2714,  2715,  2716,  2284,
       0,  2717,  2718,  2719,  2773,  2103,  2089,  2098,  2104,  2090,
    2092,  2099,  2720,  2721,  2038,  2722,  2723,  2362,  2724,  2725,
    2726,  2728,  2729,  2730,  2731,  2732,  2733,  2734,  2735,  2736,
    2737,  2738,  2094,  2096,  2739,  2740,  2742,     0,  2363,  2743,
    2744,  2576,  2746,  2747,  2749,  2750,  2100,  2752,  2753,  2101,
    2754,  2755,  2756,  2757,  2361,   506,  2102,  2759,  2761,  2762,
    2763,  2764,  2766,  2767,  2768,  2769,     0,     0,     0,  2339,
       0,  2067,     0,  1904,  1905,  1928,  1929,  1906,  1934,  1935,
    1907,     0,  1908,  2338,  1971,  2170,  2066,  2084,     0,  2072,
    2073,     0,  2065,  2061,  2172,  1713,  2334,     0,  2062,  2351,
    2353,  2285,  1713,  2332,   214,   265,     0,   266,  2340,  2646,
     202,   244,   216,   243,   217,   215,     0,  2430,   203,     0,
       0,   204,     0,     0,     0,     0,   262,   260,     0,  1439,
       0,  1841,  1840,  2343,   951,     0,  1557,  1554,  2235,     0,
    1697,     0,     0,     0,  1944,  1931,  1939,  1938,     0,  1921,
    1920,  1919,     0,  1918,  1945,  1945,  1943,  1922,  1895,     0,
       0,     0,  1949,     0,  1947,  1891,  1887,     0,  1956,  1957,
    1958,  1955,  1968,  1954,     0,  1901,  1959,     0,  1912,  1909,
    1798,     0,  1677,  1676,     8,     0,  1562,  1564,  1538,  1560,
    1725,  1726,     0,     0,     0,     0,     0,     0,     0,     0,
    1785,  1743,  1744,  1746,  1782,  1786,  1794,     0,  1683,     0,
       0,     0,  1845,     0,     0,  1465,     0,     0,     0,     0,
       0,  1151,     0,     0,     0,     0,   943,     0,     0,     0,
    1485,     0,  1487,  1488,  1489,     0,     0,     0,  1490,  1491,
    1479,   256,  1498,  1495,  1478,  1480,  1493,     0,     0,     0,
       0,     0,     0,     0,  1510,     0,   187,   188,     0,   676,
     660,     0,  2510,     0,     0,     0,     0,  1161,  1168,  1319,
       0,     0,     0,     0,     0,     0,     0,     0,  1162,  1160,
       0,  1163,   258,  1173,  1200,  1203,     0,     0,  1118,  1121,
       0,     0,     0,     0,     0,  1310,     0,     0,     0,  1310,
       0,     0,     0,  1319,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   281,   283,   296,   362,     0,   641,     0,
       0,     0,   644,     0,  2510,  1320,     0,     0,     0,  1222,
       0,     0,     0,     0,     0,     0,     0,     0,  1203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   148,   149,
     154,     0,     0,     0,     0,  1203,     0,     0,     0,     0,
       0,     0,     0,   627,   640,     0,     0,     0,     0,     0,
     637,     0,     0,   150,   286,   617,   623,     0,     0,     0,
     726,   725,     0,     0,     0,     0,     0,     0,  1408,     0,
    1407,     0,     0,     0,     0,     0,  1508,  1507,     0,     0,
       0,     0,     0,     0,  1310,     0,   275,   277,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   397,   398,     0,     0,     0,   154,     0,
       0,  1310,     0,   288,     0,     0,  1459,  1456,  1457,     0,
    1462,     0,     0,     0,     0,  2075,     0,  2239,  1735,  2237,
    1136,  2291,     0,  2392,  2794,  2795,  2796,  2797,  2798,  2799,
    2800,  2801,  2802,  2803,  2804,  2805,  2806,  2807,  2808,  2809,
    2810,  2811,  2812,  2813,  2814,  2815,  2816,  2817,  2818,  2819,
    2820,  2821,  2822,  2823,  2824,  2825,  2826,  2827,  2828,  2829,
    2830,  2831,  2832,  2833,  2834,  2835,  2836,  2837,  2838,  2839,
    2840,  2841,  2842,  2843,  2844,  2845,  2846,  2847,  2848,  2849,
    2850,  2851,  2852,  2853,  2854,  2855,  2856,  2857,  2858,  2859,
    2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,  2868,  2869,
    2870,  2871,  2288,  2287,  2347,  2393,  2394,  2395,  2396,  2294,
    1530,     0,   233,   234,   232,  1548,   235,  1549,  1544,     0,
    1531,     0,     0,     0,     0,     0,     0,     0,     0,  2432,
    2491,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   839,  1479,  1517,
       0,     0,     0,   669,     0,  2510,     0,   152,   878,     0,
     829,   463,     0,     0,     0,     0,  1384,   152,     0,     0,
     190,     0,     0,   723,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   830,     0,     0,   152,     0,  2510,
     620,  2510,     0,   542,   542,     0,     0,   141,   138,     0,
       0,     0,     0,     0,     0,     0,     0,  1669,  1668,  1671,
    1670,     0,  1667,     0,   143,   144,     0,  1210,  1235,     0,
       0,     0,     0,     0,   907,   932,     0,     0,  1204,     0,
       0,  2510,   145,  2510,     0,  2510,     0,     0,     0,  1212,
     145,     0,  1206,     0,     0,  1208,     0,  1410,     0,   923,
     921,   920,   922,     0,     0,   905,     0,     0,     0,     0,
       0,   900,     0,     0,   902,     0,     0,     0,     0,  1711,
    1567,     0,   997,     0,  1001,     0,   992,     0,   998,     0,
     993,   990,   991,     0,   996,     0,     0,   543,   545,     0,
       0,  2456,  2473,     0,  2499,  2533,  2534,  2586,  2601,  2630,
    2636,  2642,     0,  2671,  2682,     0,  1027,  1065,  1017,   735,
       0,     0,  1633,  1433,  2244,     0,  1711,     0,     0,  1250,
       0,     0,   138,   251,   223,     0,     0,  1065,     0,  2634,
    1446,   982,   660,     0,  2063,     0,  2070,  2071,  2283,     0,
       0,     0,     0,     0,     0,  2069,     0,     0,     0,     0,
    2305,     0,  2305,     0,     0,     0,     0,     0,     0,     0,
    1994,     0,     0,  2243,     0,     0,  2243,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1995,
    1976,  1977,  2067,  2235,     0,  2068,  2358,     0,  1967,  2397,
    2225,     0,  2222,  2223,  2224,  2872,  2873,  2874,  2875,  2876,
    2877,  2878,  2879,  2880,  2881,  2882,  2883,  2884,  2885,  2886,
    2887,  2888,     0,  2889,  2890,  2891,  2892,  2893,  2895,  2894,
    2896,  2897,  2898,  2899,  2900,  2901,  2298,  2903,  2904,  2905,
    2906,  2907,  2908,  2909,  2910,  2911,  2912,  2913,  2914,  2915,
    2916,  2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,
    2926,  2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,  2935,
    2936,  2937,  2938,  2939,  2940,  2941,  2942,  2943,  2944,  2945,
    2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,
    2956,  2957,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2965,
    2966,  2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,
    2976,  2977,  2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,
    2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,
    2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,
    3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,  3025,
    3026,  3027,  3028,  3029,  3030,  3031,  3032,  3033,  3034,  3035,
    3036,  3037,  3038,  3039,  3040,  3041,  3042,  3043,  3044,  3045,
    3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,  3054,  3055,
    3056,  2009,  3057,  3058,  3059,  3060,  3061,  3062,  3063,  3064,
    3065,  3066,  3067,  3068,  3069,  3070,  3071,  3072,  3073,  3074,
    3075,  3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,
    3085,  3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,  3094,
    3095,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,  3104,
    3105,  3106,  3107,  3108,  3109,  3110,  3111,  3112,  3113,  3114,
    3115,  2011,  3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,
    3124,  3125,  3126,  3127,  3128,  3129,  3130,  3131,  3132,  3133,
    3134,  3135,  3136,  3137,  3138,  3139,  3140,  3141,  3142,  3143,
    3144,  3145,  3146,  3147,  3148,  3149,  3150,  3153,  3151,  3152,
    3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
    3184,  3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,  3193,
    3194,  3195,  3196,  3197,  3198,  3199,  3200,  3201,  3202,  3203,
    3204,  3205,  3206,  3207,  3208,  3209,  3211,  3210,  3212,  3213,
    3214,  3215,  3216,  3217,  3218,  3219,  3220,  3221,  3222,  3223,
    3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,  3232,  3233,
    3234,  3235,  3236,  3237,  3238,  3239,  3240,  3241,  3242,  3243,
    3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,  3252,  3253,
    3254,  3255,  3256,  3257,  3258,  3259,  3260,  3261,  3262,  3263,
    3264,  3265,  3266,  3267,  3268,  3269,  3270,  3271,  3272,  3273,
    3274,  3275,  3276,  3277,  3278,  3279,  3280,  3281,  3282,  3283,
    3284,  3285,  3286,  3287,  3288,  3289,  3290,  3291,  3292,  3293,
    3294,  3295,  3296,  3297,  3298,  3299,  3300,  3301,  3302,  3303,
    3304,  3305,     0,  2219,  2220,  2221,  2213,  2214,  2215,  2216,
    2217,  2218,  2229,     0,     0,  2337,  2398,     0,  2172,     0,
    1991,     0,  2180,     0,     0,  1798,     0,  2356,  2286,  1798,
     267,   268,   264,     0,     0,   219,   218,     0,   237,   241,
     242,   213,   240,     0,   236,   221,  2156,  2155,   220,   212,
     209,   207,   224,   226,   227,   210,   208,   261,     0,     0,
       0,   145,  1565,  1552,     0,     0,  2298,     0,  2233,     0,
       0,  2231,     0,     0,     0,  1795,     0,  1699,     0,  1703,
       0,     0,     0,  1942,  1941,  1892,  1888,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     944,     0,  1910,     0,  1861,  2380,  2381,  2296,  1731,  1565,
       0,  1561,  1694,  1693,  1736,  1737,  1102,  1692,  1765,  1766,
       0,     0,     0,     0,  1791,  1789,  1756,  1747,  1755,     0,
       0,  1753,     0,  1757,  1971,  1784,  1681,  1741,  1742,  1745,
    1680,     0,  1787,     0,  1636,  1785,  1746,  1620,     0,  1598,
       0,     0,  1846,     0,     0,  1466,     0,     0,     0,  1131,
    1133,     0,  1132,     0,  1135,     0,  1144,     0,     0,  1130,
    1149,     0,  1138,  1136,     0,  1506,     0,     0,     0,     0,
       0,  1486,     0,     0,     0,  2671,   255,  1489,  1494,  1481,
    1492,     0,     0,     0,     0,     0,  1067,  1066,     0,     0,
    1086,     0,     0,     0,   506,  1513,   528,     0,   364,     0,
       0,     0,     0,     0,     0,     0,     0,   825,   822,     0,
       0,   821,     0,   674,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   699,     0,  1310,     0,   294,
       0,  1170,     0,  1169,     0,  1174,     0,     0,  1171,  1166,
    1167,  2636,  2646,  2677,   257,  1172,  1202,     0,  1201,  1197,
       0,  1113,     0,  1114,     0,     0,     0,     0,     0,  2483,
    2510,   302,   326,     0,  1309,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     348,     0,     0,   351,   350,     0,     0,     0,     0,     0,
     356,     0,   334,     0,   335,     0,   355,     0,     0,     0,
     642,   643,     0,     0,     0,  1310,     0,   290,     0,     0,
       0,     0,     0,     0,     0,     0,  1219,     0,   752,     0,
       0,  2636,  1198,     0,  1393,     0,  2670,  1394,  1397,   542,
       0,   542,  1399,     0,     0,  1396,  1398,     0,     0,   176,
       0,   171,   175,     0,     0,  2636,  1199,     0,     0,     0,
       0,     0,   625,   626,   639,     0,   630,   631,   628,   632,
     633,     0,     0,     0,     0,     0,     0,     0,   624,     0,
       0,   721,   720,   724,     0,     0,     0,     0,     0,     0,
    1402,     0,     0,  1193,     0,     0,  1401,  1409,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1253,  1252,
       0,     0,     0,     0,  1320,     0,   868,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   178,   739,     0,
     738,     0,   172,   177,     0,     0,     0,     0,     0,     0,
       0,     0,   231,  1455,  1461,  1735,  1735,  1735,  2081,     0,
       0,     0,     0,  1734,  2289,  2292,  1535,  1541,  1534,  1533,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   411,   408,   409,
     411,     0,     0,     0,     0,   841,     0,   844,   847,  1477,
     490,     0,     0,   666,   699,     0,     0,   466,   185,     0,
       0,     0,     0,   754,     0,  1193,  1192,   147,   138,   194,
     464,     0,   193,   195,   197,   198,   199,   196,   200,     0,
     718,   722,     0,     0,     0,     0,   662,     0,     0,     0,
       0,     0,     0,     0,  1866,     0,     0,   170,     0,     0,
     615,   619,     0,     0,     0,     0,   466,   581,   375,  2510,
       0,   542,     0,  2510,     0,   137,     0,   828,     0,     0,
       0,  1155,  1155,     0,     0,   768,   767,     0,     0,     0,
       0,     0,     0,  1666,   145,  1153,     0,  1500,     0,   145,
     947,   145,  1117,   184,  2375,     0,   909,     0,     0,     0,
       0,   145,  1221,   897,   145,   180,   145,   145,   665,     0,
     145,   182,     0,     0,   145,   941,   145,  2345,     0,   145,
    1591,  2510,   542,  1569,   994,  1003,  1002,  1000,   999,   995,
       0,  1014,     0,   541,     0,     0,     0,     0,     0,  1035,
    1036,     0,     0,  1032,  1037,     0,  1039,  1023,  1025,  1033,
    1034,  1040,  1029,  1028,  1041,  1042,     0,     0,     0,  1054,
     733,     0,     0,     0,     0,  1630,     0,  1628,     0,  1844,
    1632,  1621,  1581,     0,  1580,     0,   608,  1244,  1243,  1245,
       0,  1011,     0,   145,     0,  1445,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2248,     0,  2249,
       0,     0,  2282,  2278,     0,     0,     0,     0,     0,  2252,
    2255,  2256,  2257,  2254,  2258,  2253,     0,     0,  2259,     0,
       0,  2303,  2315,     0,  2067,  2303,  2326,     0,  2325,  2331,
    2239,  1971,     0,     0,  2322,  2316,     0,  2322,     0,  2305,
       0,     0,     0,     0,     0,     0,  2239,  2242,     0,     0,
    2750,     0,     0,     0,     0,  2039,     0,     0,  2206,     0,
    2239,     0,     0,     0,     0,     0,     0,     0,  2235,  2274,
       0,   504,     0,  2029,     0,     0,     0,  2154,     0,  2151,
       0,     0,     0,     0,  2295,     0,     0,  2359,  1972,  1987,
    1988,  1989,  1992,  2336,  1975,     0,  2297,     0,     0,  1973,
    2000,     0,  2275,  2025,     0,  2030,  2015,  2306,  2260,  2261,
    2262,  2263,  2032,     0,  2008,  2013,  2017,     0,  2315,  1996,
       0,  1993,     0,  2298,  2234,     0,  2232,     0,  1984,  1985,
    1986,  1978,  1979,  1980,  1981,  1982,  1983,  1990,  2210,  2208,
    2209,     0,     0,  2180,     0,     0,  2012,     0,     0,  2083,
    2502,  2540,     0,  1724,  1724,  1724,  1712,  1722,  2335,  1861,
    1735,  1861,  2341,     0,     0,  1967,     0,  1842,   949,   950,
     948,  1537,  1551,  1565,  2236,  1559,  1701,     0,     0,     0,
    1911,  1924,     0,  1951,  1952,  1953,  1953,     0,  1893,     0,
    1936,  1961,  1962,  1963,  1964,  1965,  1966,     0,  1960,  1902,
     945,  2731,     0,  2632,  2770,     0,  1822,  1797,  1799,  1809,
    1822,  1829,  1822,  2085,  1859,  2086,  2087,  2342,     0,  1768,
    2377,  1539,  1563,     0,  1100,  1101,     0,  1105,  2750,  2632,
       0,     0,     0,     0,  1758,  1792,     0,  1783,     0,  2352,
    1759,  2351,  1760,  1763,  1764,  1754,  1793,  1634,     0,  1788,
    1685,  1684,     0,  1864,     0,     0,     0,  1612,  1600,     0,
       0,  1847,     0,  1798,  1638,     0,  2295,  1796,  1360,  1254,
    1321,  1134,     0,  1912,  1145,     0,  1129,     0,  1128,  1912,
       0,  1146,     0,  1912,  1361,  1255,  1322,  1362,  1256,  1323,
    1363,  1497,  1257,  1496,  1484,  1483,  1482,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   806,  2510,   145,  1511,  1364,     0,  1258,   363,
    1512,  1324,  1516,   824,   823,     0,     0,  1325,     0,   675,
     680,     0,   682,   683,  2432,  2491,   684,   687,   688,     0,
     690,   679,   678,     0,     0,     0,     0,     0,   696,   701,
       0,     0,     0,     0,     0,     0,  1164,  1165,  1365,  1261,
       0,  1326,     0,  1112,     0,  1262,   186,     0,     0,   282,
    2510,   304,     0,   488,   806,     0,  1312,   301,   332,     0,
     347,   342,   343,   341,  2510,   145,  2510,   145,     0,     0,
       0,     0,     0,   344,   339,   340,   336,     0,     0,   349,
    2404,  2475,  2647,     0,   707,   709,     0,   714,   352,  1282,
     371,   370,   369,     0,   357,     0,   376,   379,     0,   354,
     333,   331,   328,   297,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1214,     0,  1368,  1327,     0,
    1349,  1353,     0,     0,     0,   746,  1371,  1268,  1330,     0,
     542,     0,     0,   557,   557,   542,  1382,  1269,   174,  1299,
     163,     0,     0,   159,     0,     0,     0,     0,   153,  1372,
    1270,  1331,     0,     0,  1373,  1271,     0,     0,   287,   618,
     629,   634,  1276,   638,   635,  1339,   636,  1380,  1272,     0,
    1376,  1302,  1334,   601,  1193,  1193,  1383,  1403,  1273,  1193,
       0,  1310,     0,   276,   278,     0,   142,     0,  1274,     0,
    1332,  1375,  1301,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1519,     0,     0,     0,     0,     0,     0,   145,
       0,     0,     0,  1312,  2510,   145,   866,  1374,     0,  1307,
       0,  1347,     0,     0,     0,   399,     0,  1300,  1310,     0,
     289,  1278,     0,  1341,     0,     0,   229,   228,   230,     0,
       0,     0,     0,  2240,  2241,     0,  2238,  2076,  2291,     0,
    1529,   971,   957,   970,     0,   953,  2473,     0,   956,   958,
       0,     0,     0,   959,   963,   964,     0,   955,   952,   954,
       0,   410,     0,     0,   763,   764,     0,     0,     0,     0,
     843,     0,     0,  1509,     0,   150,   673,     0,     0,     0,
     668,   698,   703,     0,     0,     0,     0,   465,   469,   473,
     474,   475,     0,     0,     0,     0,   164,   151,     0,   886,
       0,   542,     0,   756,  1193,  1386,     0,   194,   189,     0,
       0,   719,     0,  1560,     0,     0,   596,   599,   598,     0,
     375,   838,   836,   835,   837,   859,   834,     0,  1865,  1867,
       0,     0,     0,     0,     0,     0,   608,   468,     0,     0,
     545,     0,   584,     0,     0,     0,     0,   581,     0,     0,
       0,  2385,     0,   855,   827,     0,  1123,     0,  1141,  1124,
       0,     0,     0,     0,  1178,  1185,  1154,  1179,  1156,  1185,
       0,     0,   769,   773,   772,   776,   774,     0,   770,   647,
    1672,  1673,     0,  1211,     0,     0,  1505,     0,  1503,   908,
    1205,   145,     0,   145,     0,   145,  1213,  1207,  1209,  1411,
       0,   906,     0,     0,   899,   901,     0,   903,     0,  1015,
     544,     0,     0,     0,     0,     0,     0,  1031,   645,  1038,
       0,     0,     0,  1053,  1048,  1050,     0,  1065,  1059,     0,
     732,     0,     0,  1631,  1624,  1626,  1625,     0,     0,  1622,
    2245,   898,     0,   614,     0,  1065,  1056,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1729,  2246,
    2247,     0,     0,     0,  2279,     0,     0,  2120,     0,  2091,
    2093,  2106,     0,  2121,  2074,     0,  2302,  2299,     0,     0,
       0,  2303,  2305,  2140,     0,     0,     0,  2305,     0,  2325,
       0,     0,  2135,  2137,     0,     0,     0,  2315,  2315,  2142,
       0,  2122,  2095,  2097,  2107,     0,     0,  2226,     0,  2110,
    2109,     0,  2041,  2042,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2056,  2111,  2205,     0,     0,     0,  2113,  2112,
       0,     0,  2273,     0,     0,     0,  2118,   505,  2123,     0,
       0,     0,     0,  2129,     0,  2162,     0,     0,     0,  2064,
    2236,     0,     0,     0,     0,     0,     0,     0,  2308,  2309,
    2310,  2307,     0,  2031,  2016,  2034,  2010,  2014,  2018,     0,
    2315,  2033,  2036,     0,     0,  2004,     0,     0,  2002,  2026,
    1998,     0,     0,  2027,     0,  2082,     0,     0,     0,  2183,
    2178,  2179,  1724,  1724,  1724,  1724,  1721,     0,     0,     0,
    1768,     0,  1768,   205,     0,   238,   225,  1536,  1702,  1711,
    1930,     0,  1948,  1946,  1889,  1894,  1969,  1822,  1829,  1822,
       0,     0,  1687,     0,  1809,     0,  1821,  1807,  1820,     0,
       0,  1835,  1833,     0,  1835,     0,  1835,     0,  1801,     0,
    1825,  1803,  1820,  1805,     0,  1851,  2343,  1860,     0,  1781,
    1738,     0,  2227,  1105,     0,  1740,  1762,  1761,     0,  1751,
       0,  1790,  1748,  1635,  1619,     0,  1617,  1604,  1606,  1605,
       0,     0,  1607,  2295,     0,  1617,  1599,     0,  1643,     0,
       0,  1864,     0,  1642,     0,  1912,  1126,  1127,     0,  1150,
       0,  1070,  1071,     0,  1069,     0,     0,     0,   527,  1085,
       0,     0,   806,     0,   806,     0,     0,   532,     0,  1514,
       0,  1381,  1298,   677,     0,     0,     0,     0,   692,   651,
     693,   695,     0,     0,   694,   697,   700,  1310,     0,   295,
    1284,     0,  1345,  1158,     0,     0,  1115,     0,     0,     0,
       0,     0,     0,   487,   484,   327,     0,     0,     0,     0,
     384,     0,   306,   319,   382,   325,     0,   359,     0,   330,
       0,   323,   345,   337,   346,   338,   358,   360,     0,   711,
     712,   710,   706,     0,   713,   715,     0,   373,     0,     0,
       0,   353,     0,  1367,     0,  1310,     0,   291,  1280,     0,
    1343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1348,     0,     0,     0,     0,   751,     0,
     748,     0,   557,     0,  1395,     0,  1392,  1390,   557,     0,
       0,   156,   155,     0,   162,     0,     0,     0,     0,     0,
       0,  1404,  1405,  1406,     0,     0,     0,     0,     0,     0,
     393,     0,   298,   300,   299,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   400,   366,     0,   862,     0,     0,     0,   402,
       0,     0,  1359,     0,     0,     0,     0,     0,  1366,  1263,
    2079,  2080,  2077,  1735,  2290,     0,     0,     0,   968,     0,
       0,     0,     0,   413,   414,   150,   412,   437,     0,   806,
       0,     0,   840,   845,   853,  2576,  2213,  2214,   851,   846,
     848,   850,   852,   849,     0,     0,     0,     0,   509,     0,
       0,     0,   496,     0,     0,   506,   489,   492,   493,     0,
       0,   669,   672,   670,   671,     0,   691,     0,   468,   516,
     571,     0,   166,     0,     0,   167,   165,     0,     0,   375,
     753,     0,   750,  1385,     0,   192,     0,   723,     0,     0,
       0,     0,     0,  1193,   661,     0,   858,   860,   832,     0,
     703,     0,     0,   620,     0,   542,  1592,   603,     0,   573,
     468,   571,   580,     0,     0,   588,   374,     0,     0,   608,
     375,     0,     0,  1086,     0,   854,     0,     0,  1122,     0,
       0,     0,  1175,  1180,  1176,     0,  1155,  1137,     0,  1177,
       0,     0,  1183,  1108,  1157,  1109,  1427,  1428,  1425,  1426,
       0,     0,     0,     0,     0,     0,  1663,     0,     0,  1501,
       0,   910,     0,   893,     0,   895,   145,   740,     0,   145,
       0,     0,     0,     0,     0,     0,  1030,     0,  1024,  1026,
    1051,     0,     0,  1065,  1064,     0,  1055,  1063,  1061,  1062,
    1060,     0,     0,  1629,  1627,   606,     0,     0,   145,  1065,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2250,     0,  2281,  2277,     0,  2088,  2251,  2301,  2312,  2314,
    2141,  2304,     0,     0,     0,  2327,     0,     0,  2305,  2319,
    2318,     0,     0,  2317,  2305,  2305,  2143,     0,     0,     0,
    2206,     0,     0,  2040,  2052,  2053,  2054,  2266,     0,  2059,
       0,  2049,  2050,  2051,  2043,  2044,  2045,  2046,  2047,  2048,
    2055,  2270,  2269,     0,     0,  2115,  2116,  2117,  2272,  2124,
       0,  2422,  2163,     0,  2128,  2153,  2152,     0,     0,     0,
    2131,     0,     0,  2149,     0,  2207,  2360,  1974,     0,     0,
    2001,  2276,  2019,     0,  2035,  2037,  1997,  2226,     0,     0,
       0,     0,     0,  2006,     0,     0,  2203,     0,     0,     0,
    2185,  2182,     0,     0,     0,     0,  1715,  1714,  1720,  1781,
    2076,  1781,     0,     0,  1890,  1808,  1804,  1806,     0,  2765,
       0,  1811,  1818,     0,  1800,     0,  1834,  1830,     0,  1831,
       0,     0,  1832,     0,     0,  1802,     0,  1818,     0,  1858,
    1727,     0,  2174,     0,  1739,  1103,  1104,  1749,     0,  1752,
    2452,  1862,     0,  1618,     0,     0,     0,  1609,  1615,  1597,
       0,     0,     0,  1639,  1617,  1640,  1147,     0,     0,  1139,
    1076,  1077,  1080,  1078,  1075,  1079,     0,     0,     0,   806,
       0,     0,   552,     0,  1099,  1099,     0,   530,   540,   534,
     593,   540,   809,     0,     0,     0,   807,   145,  1259,     0,
       0,     0,     0,   652,  1379,  1260,     0,     0,     0,     0,
    1159,  1313,     0,     0,  1283,     0,   303,   486,   485,     0,
     483,   703,     0,     0,   310,   320,     0,   315,     0,  1311,
       0,     0,     0,     0,   314,   317,   316,   386,     0,   383,
       0,   145,   145,   361,   708,   372,   377,   378,   381,  1318,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   887,   870,     0,     0,   888,   889,     0,
       0,     0,  1216,  1217,  1215,  1350,  1351,  1357,  1354,  1352,
    1356,  1358,  1355,     0,  1266,     0,     0,   744,  1314,  1387,
    1389,  1388,     0,  1391,   160,   157,   158,   161,  1315,  1296,
    1277,  1340,   602,     0,     0,     0,  1275,     0,  1333,     0,
    1292,  1286,     0,     0,     0,     0,     0,  1378,  1306,  1338,
    1377,  1304,  1336,  1303,  1335,  1305,  1337,  1297,     0,     0,
    1869,   867,     0,     0,     0,   145,   145,   865,   742,  1279,
       0,  1342,  1288,     0,     0,     0,   960,     0,     0,     0,
     962,   418,   438,   150,     0,   762,   826,     0,     0,   842,
       0,   494,     0,   500,   507,     0,     0,   511,   512,   510,
     538,  1193,   542,  1193,   795,   796,     0,     0,   816,     0,
     667,     0,     0,   466,     0,   513,     0,     0,   470,   169,
     168,     0,     0,     0,   757,   761,   759,   758,   760,   755,
       0,   746,   194,  2510,     0,     0,     0,     0,   600,   594,
     597,  1400,   833,     0,  1868,   736,     0,   375,   616,     0,
       0,     0,   466,   608,     0,   471,   476,   477,   490,     0,
     581,   572,     0,   573,   582,   583,     0,   590,  1475,     0,
     609,   590,     0,     0,     0,   857,     0,   856,     0,  1125,
    1142,  1143,     0,     0,  1185,     0,     0,  1187,  1182,     0,
       0,   775,   778,   771,   654,   145,     0,  1504,   145,   145,
    1242,     0,   904,  1045,  1046,  1047,  1044,  1043,   646,     0,
    1049,  1008,  1058,   734,     0,   607,     0,  1009,   145,   985,
     977,   984,   973,   976,   978,     0,   980,   981,   975,   972,
     974,  2280,  2105,     0,  2311,  2313,  2139,  2324,  2323,  2138,
    2330,     0,  2321,  2320,     0,     0,  2108,  2119,     0,  2205,
    2236,     0,     0,  2060,     0,     0,     0,  2114,  2760,     0,
       0,  2167,  2168,     0,  2164,  2165,  2160,  2161,  2130,     0,
    2565,  2144,     0,     0,  2159,  2023,  2021,  2020,  2005,     0,
       0,  2003,  1999,     0,  2028,  2169,  2202,  2236,  2171,     0,
    1735,  1719,  1718,  1717,  1716,  2174,  2357,  2174,   239,  1706,
    1854,     0,  1857,     0,     0,  1810,     0,     0,  1812,     0,
       0,  1814,  1816,     0,     0,     0,     0,     0,     0,  2346,
       0,  1780,     0,  1735,     0,  1750,     0,  1616,  1601,     0,
    1602,  1608,     0,     0,     0,     0,     0,  1644,  1637,  1140,
    1148,     0,     0,     0,   529,     0,   547,     0,     0,     0,
    1092,   140,  1091,     0,     0,     0,     0,   811,   810,   813,
     808,   812,  1515,     0,   685,   686,   689,  1285,     0,  1346,
    1294,     0,  1633,   305,   482,   481,   490,   389,   313,   388,
       0,     0,     0,   307,   385,     0,   387,   308,   312,   366,
     329,   322,     0,     0,     0,  1281,     0,  1344,  1290,  1317,
    1369,  1264,  1328,     0,     0,   876,     0,     0,     0,     0,
    1370,  1265,  1329,     0,     0,     0,     0,     0,  1633,     0,
       0,     0,     0,     0,     0,     0,     0,  1524,     0,     0,
     365,   864,   863,   366,   401,  1308,     0,  2078,     0,   961,
     966,   967,   965,     0,   407,   415,   418,     0,     0,  1233,
    1233,     0,     0,   491,   508,     0,     0,   495,   592,   551,
     592,     0,     0,     0,     0,     0,   704,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   749,   748,   191,
       0,   466,     0,   703,     0,   861,     0,     0,     0,   608,
     468,     0,     0,  1589,   467,     0,     0,   479,     0,   584,
     573,   581,     0,     0,   605,     0,  1468,     0,   611,     0,
       0,     0,   805,  1181,     0,  1195,     0,  1136,  1106,  1190,
       0,  1711,  1861,     0,     0,     0,     0,   788,     0,   658,
    1234,  1502,   894,   896,   741,  1052,     0,  1065,  1057,   979,
    2300,  2329,  2136,  2328,  2265,  2207,  2057,     0,  2268,  2267,
    2271,     0,  2125,     0,  2126,  2166,  2132,  2145,     0,  2133,
    2157,     0,     0,  2024,  2022,  2007,  2204,     0,  2189,  1689,
    1688,     0,  1709,  1859,     0,     0,  1853,     0,     0,  1883,
       0,     0,     0,  1819,  1837,     0,  1815,  1813,     0,  1826,
       0,  1828,  2451,  2726,  2629,     0,  1767,  1769,  1772,  1774,
    1773,  1775,  1771,  2173,  2175,     0,  1746,  2228,  1863,     0,
       0,     0,  1087,     0,     0,  1645,  1646,  1641,  1053,     0,
     145,  1099,     0,  1193,   553,  2576,   554,  1098,  1102,   139,
       0,   539,   547,   547,   681,     0,     0,   284,   478,     0,
     311,   321,     0,   368,   380,     0,  1633,     0,     0,   874,
     883,   883,   871,     0,     0,   890,  1267,   745,     0,   556,
       0,   279,  1293,  1287,     0,     0,     0,  1526,  1527,     0,
       0,     0,     0,     0,  1316,   145,  1289,   969,     0,   440,
     447,   419,   423,  1518,     0,  1518,     0,   420,   424,  1518,
    1518,   417,  1861,   436,  1233,     0,  1230,  1229,   538,   622,
       0,   537,     0,   498,     0,   562,   497,     0,   817,     0,
       0,   702,     0,   468,   571,     0,   526,   517,   518,   519,
     520,   522,   521,   523,   524,   525,   515,   514,     0,   703,
     880,   375,  1475,   743,     0,     0,   716,     0,   703,     0,
    1592,   604,   573,   468,   571,   472,   490,     0,   588,   581,
     584,     0,   585,     0,   589,     0,     0,     0,   608,  1528,
    1086,     0,     0,   806,  1194,  1155,     0,     0,  1184,  1188,
    1189,     0,     0,     0,     0,  1237,   782,   783,   777,   779,
       0,   790,   794,   653,     0,     0,   657,   648,   703,   145,
       0,  2058,     0,     0,  2147,  2146,  2158,  2134,  2184,     0,
       0,     0,     0,     0,     0,     0,  1700,  1852,  1855,     0,
    1886,     0,     0,     0,     0,  1872,     0,  1817,     0,     0,
    1827,     0,     0,     0,  1776,     0,     0,     0,  1785,     0,
    1614,  1861,     0,  1611,     0,  1654,     0,  1647,  1072,     0,
    1073,  1093,     0,   592,     0,  1105,  1102,   542,  1193,  1193,
    1295,     0,   622,     0,     0,   324,     0,   292,  1291,     0,
       0,   885,   885,     0,     0,     0,     0,     0,     0,   395,
       0,     0,  1520,     0,  1521,  1522,  1525,   403,   416,     0,
     445,     0,   443,   442,   444,     0,   433,     0,     0,     0,
       0,     0,     0,   406,  1228,  1232,  1231,   499,     0,   501,
       0,     0,   548,   549,   550,     0,   503,   558,   559,   814,
       0,   819,     0,   705,     0,     0,   703,   570,   727,     0,
       0,     0,  1469,     0,     0,   595,   737,  1475,   608,   581,
       0,   573,   480,     0,   590,   584,   588,   586,   587,     0,
    1472,     0,   610,     0,  1095,   804,     0,  1185,  1196,  1191,
    1186,  1431,     0,     0,   780,   785,   784,  1518,   789,     0,
       0,     0,   656,   655,   731,  1010,  2264,  2150,  2127,  2148,
    2713,  2452,  2685,     0,  2201,  2190,  2201,  2201,  2181,     0,
       0,     0,     0,     0,  1884,  1885,  1870,     0,     0,  1874,
    1824,  1850,     0,     0,     0,  1770,  2176,  2177,  2376,  1603,
    1613,  1088,     0,     0,     0,  1654,     0,     0,   557,     0,
    1089,  1105,   551,   592,   592,  1633,   318,   309,   367,     0,
       0,     0,   881,   884,   872,   873,   892,   891,   747,  1633,
       0,   391,   390,     0,   394,     0,   441,   450,     0,   448,
     421,   426,     0,   432,   431,   428,   427,   422,   425,     0,
       0,     0,     0,     0,     0,   560,     0,   561,     0,   818,
       0,     0,     0,   729,   879,     0,     0,   466,   703,  1470,
    1590,   584,   573,   581,     0,     0,   575,  1099,  1099,   453,
     588,   590,  1473,  1474,     0,     0,   506,     0,  1107,  1430,
    1429,  1711,     0,     0,     0,   791,   792,   787,     0,     0,
       0,  2194,  2193,  2192,  2196,  2195,     0,  2188,  2186,  2187,
       0,     0,     0,  1856,     0,  1873,  1876,     0,     0,     0,
    1882,  1875,  1877,     0,  1836,     0,  1848,  1778,     0,  1777,
    1861,  1653,     0,     0,   145,   546,   806,   555,  1090,   562,
     806,   806,   285,  1633,   875,     0,   280,     0,   396,  1523,
     446,     0,   430,   429,   621,   502,   591,   567,     0,   566,
       0,   564,   563,   815,   820,     0,   703,   869,  1475,   717,
     588,   581,   584,     0,   574,     0,   140,   140,   590,   451,
       0,     0,   375,     0,  1413,  1711,  1412,  1414,  1422,  1419,
    1421,  1420,  1418,     0,  1240,  1241,   781,   786,     0,     0,
       0,     0,  2198,     0,  2199,     0,     0,     0,     0,  1879,
    1880,  1881,  1878,  1823,     0,  1779,  1610,  1656,     0,     0,
    1648,  1649,     0,  1074,   535,   806,   533,   531,   293,   882,
       0,   449,   565,   542,   542,   703,   728,  1471,   590,   584,
     588,  1099,   576,   578,   577,   455,  1095,  1096,     0,   590,
     794,     0,  1423,  1417,  1687,  1674,     0,     0,   793,     0,
    2191,  2197,  2200,     0,     0,     0,     0,     0,     0,  1651,
       0,     0,     0,  1650,   536,     0,   569,   568,   730,   454,
     588,   590,   140,   506,  1094,     0,  1861,     0,  1415,  1711,
       0,     0,   799,  1705,  1704,  2731,     0,     0,  1708,     0,
    1849,  1655,  1652,     0,     0,     0,     0,  1657,   392,   590,
     452,   579,   375,  1097,  1081,     0,  1416,     0,     0,   801,
       0,   797,   800,   802,   803,     0,     0,  1871,  1661,     0,
       0,     0,   456,   590,     0,     0,     0,   765,     0,  1735,
       0,     0,     0,     0,  1861,     0,     0,     0,   798,     0,
       0,  1658,  1662,     0,  1659,  1082,   799,  1238,  1239,     0,
    1707,     0,     0,     0,   766,  1660
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5708, -5708, -5708,  3896,  -615, -1727, -5058, -1125,  -779, -5708,
   -5708,  -956,  -458,  3130, -2419, -5708, -5708, -5708,  1425, -5708,
   -5708, -5708, -5708,  3859, -5708, -2918, -5708, -5708,   163,  3814,
   -1388,   147,  3432,  1439, -5708, -1017, -5708, -5708,  -613,     1,
   -5708,  3823,   448, -5708, -5708, -5708, -5708, -5708, -5708, -5708,
   -5708,  -901,  1897, -5708,  1991,  1236, -4828, -5708, -5708, -1518,
   -3733, -5708,   496, -5708,   522,   -33, -4817, -1102, -5708, -5708,
   -5708,  1888, -5708, -5708, -5708,  1832,  1032,  -509, -5708, -5708,
   -5708, -5708, -5708, -5708,  -941, -5708, -5708, -1212,     9,  -649,
   -2947, -4315, -5708, -5708,   353,  -555, -1498, -5708,   541, -5708,
     542, -5708, -4836, -5708,  -147, -2669, -2831, -5708, -5708, -5708,
    -525, -1462,  1333,  -748,    35,  -746, -1157,  1707, -2874, -1061,
   -5708,  -395, -3560, -1184,  -951,  -949, -1093, -4356, -4873, -5708,
   -5708, -1214, -3773, -5162, -5406, -4899, -5133,  1343, -5708,  -174,
     355, -5708,    13, -3642, -3764,    14,   328, -5708,    15,    16,
   -5708,   347,  -883,  -972, -1592, -5708,  -753, -5708, -5708, -5708,
   -3439, -5708, -5708, -5708,   165, -5708, -5708, -5708, -5708,   390,
   -5708, -5708, -5708, -5708, -5708, -5708, -3191,  1858,  1862, -5708,
   -4384, -5708,  -931, -5708,   551, -3491,  1266, -5708, -5708,  1027,
    3887,   376, -5708, -5708, -5708, -5708, -5708, -5708, -1789, -5708,
   -5708, -5708, -5708,  -152,  -490, -5708, -5708, -5708, -5708, -5708,
   -5708, -5708,    19, -5708,   994,   320, -5708, -5708,  -787, -5708,
   -5708, -5708, -5708, -5708, -5708, -1258, -5169, -1360, -1341, -5708,
   -3427, -5708, -5708, -5708,  -464, -5708, -5708, -5708, -5708, -5708,
    -961, -5708,  1089, -4161, -5708, -5708,   356, -5708, -5708, -5708,
   -5708, -5708, -1064,  -403,  3063, -5708,  -645,  -858, -5708, -5708,
   -5708,  -402, -5708, -5708, -5708, -5708, -5708,  -512, -1270,  4894,
    4274, -1104,  2473,  -838,  -582, -5708, -5708, -5708, -2702, -5708,
   -5708, -4299, -5708,  4886,  2448,  -146,    21, -5708,   -12,   101,
    3709, -5708,   957, -1167, -3095,   316,  -592, -5708, -5708, -5708,
     325, -5708, -1941, -5708, -5708, -5708, -5708, -4103,    22, -5708,
   -4381, -5183, -4598, -4105, -1218, -5708, -4318, -4373, -4101, -5708,
    1901, -5708, -5708,  -526,  -188,  3041, -5708, -1470,  2253, -1419,
   -5708, -2517,   385,  1453,  3053, -3269,  -133,  3040, -3004, -5708,
    -723,  1038, -5708,  -474, -3768, -5708, -5708, -5708, -2759,  -718,
   -5708, -5708,  1456,   513, -5708, -5708, -5708, -5708,  -654,  3022,
    -176, -5708, -5708,  4253, -5708, -4387, -5708,  4224, -5708, -5708,
   -5708, -5708, -5708, -5708, -5708, -5708, -5708, -1488,  1211, -5708,
    -814, -5708, -5708,  2008,   602, -5708, -5708, -5708, -5708,  1295,
    -417, -5708, -5708, -5708, -5708, -5708, -5708, -5708, -1032, -1229,
   -5708, -5708, -4743, -5708, -5708, -5708, -5708, -5708,  2107,  -953,
    -749,  4130,  1116,    28, -5357, -5708, -5708,  -887, -5708,  3470,
   -5708, -5708, -5708, -5708, -5708,   383,   391, -5708, -5708, -5708,
   -5708, -5224, -5708, -5708, -5070, -5708, -5708,  1996, -5708, -5708,
    1210,     6,  3174, -5708, -5708, -5708,   -25, -5708, -5708, -1023,
    2343, -5708, -2383, -5708,  -588, -5708, -5708, -1910,    30, -4348,
   -5708,     3, -5708, -5708, -5050, -1230,   193, -5708, -5708, -3996,
       4, -5708, -5708, -5708, -5708, -5065, -5708,    10, -5552,   747,
   -3337, -5708,     8, -5708,  -537,  -925, -5708, -5708, -5708, -3712,
      31,    33, -5708, -5708,     5,  3538,   -49,   -43,   -35,     2,
     148,  3580, -5708, -5708, -5708, -4548,  3620, -5708,    -8,  -868,
    4943,  4947, -5708,  -896,  -145,   342,  1553,  -688, -2598,  3540,
    3531, -5708,  1546,  2357, -2454, -2450, -5708, -1235,  -898,  -729,
   -5708, -5708, -5708, -5708, -1787,  -683, -2606, -5708,  3543, -5708,
   -5708, -5708, -2361, -3359, -3284,  1583, -3281, -3202, -5708,   835,
     819, -1216,  -206,    -4, -1475,  -788,  1537, -5708, -5708,  1597,
    -462, -5708, -5708,  -463, -3288,   782, -5708, -4581, -2815,  1602,
   -1152,  -871, -5708, -1004, -5708,  -694,  8937,  3603,  -825, -5708,
   -5708,  -776,  9651, -5708, -5708, -5708, 11781, 13251, -5708, -5708,
   14262, 14885, -5708,  -530, 15496,  9558,  -789, -1940,   220, 16260,
   18036, -1874,  2225,   127, -5708, -2965, -2409, -5708, -5708, -5708,
    -432,   928,   398, -5708, -5708, -4603, -4452, -5708,  2482, -2038,
   -5708,  -703,  1673,  -700, -5708, -5708, -5708, -3001, -4675, -3163,
    2489, -5708, -5708, -5708,  -136, -5708, 18237, -3253, -5708,  -442,
   -1003, -1596,  2973, -3113, -1895, -5708, -5708, -5708, -3098, -5708,
   -5708, -5708,  -733,  1695, -5708, -5708,  1820, -5708, -5708, -5708,
    -955,  2058,  -763, -1187,  1702, -1881, -5708, -3030, -1936,  1713,
   -3094, -5708, -1928,  1790,  1009, -5708,  -328, -5708,  4141,  -780,
    2495,  -786, 16885,  -644, 11311, -1271, -5708,  5432, -5707,   976,
    7183,    32,  -131,  2881,  -647,  2415,  2760, -5708, -5708,  5063,
    8409,  -581,  -880, -5708,    -6, 14058, 12683, -3647, -5708
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    57,    58,    59,    60,  1090,  1095,  1888,  1907,    61,
      62,  1610,  3018,  2871,  3836,  3837,    63,    64,  1606,    65,
      66,    67,    68,  1520,    69,  1860,  3032,    70,  2706,   832,
     833,   834,  2571,  2572,  2963,  2573,  2561,  1372,  1806,  1542,
     806,   807,  1502,  1543,    72,    73,  1366,  2552,    74,    75,
      76,  1573,  1667,  1574,  1575,  1514,  4960,  5755,  3624,  2826,
    3884,  3625,  3626,  4303,  4304,  5278,  4392,  5769,  5770,    77,
    1683,  1684,    78,    79,  3000,  3802,  4445,  5344,  5345,  5591,
     651,  4983,  4984,  5578,  5579,  5783,  5938,  5939,  3033,   682,
    3879,  4529,  3827,  5054,  3828,  5055,  3829,  5056,  4850,  4851,
    4293,  4294,  3813,  4476,  4477,  2060,  4996,  4478,  3830,  5015,
    5626,  3831,  2726,  5357,  5255,  3067,  1979,  1977,  5523,  5605,
    4811,  4812,  4366,  5806,  5807,  5808,  6061,  5017,  5060,  5061,
    5975,  5976,  3882,  4535,  5067,  5404,  5603,  3522,    81,  3855,
    3856,    82,   745,  1882,  3983,   746,  3070,   683,   747,  3034,
      87,  3060,  5799,  3061,  1636,  2885,  4458,  3959,    88,  1118,
    4268,  5429,  5686,  5687,   736,    89,  1868,    90,    91,  3013,
    3820,    92,  2743,  3539,    93,    94,  3558,  3559,  3560,    95,
    4486,  5365,  1576,  3613,  3614,  3615,  3616,  4324,    96,  1863,
    3041,  3042,    97,    98,    99,  3172,  3173,   100,  2949,   101,
     102,   103,   104,  4360,  4917,  5031,  3655,  3843,  4502,  5029,
     105,  3806,  3035,  3088,  3917,  3918,  5427,  5678,  5679,  5680,
    5857,  6096,  5682,  5859,  5997,  5861,  5006,  6220,  6221,  5663,
    4257,  4826,   107,  5007,  5008,  5812,   108,  2741,   109,   110,
    1837,  3006,  3007,  4459,  3077,  3892,  3893,  4515,  4516,   111,
    3742,   112,  4893,  4894,   684,  5820,  5761,  5924,   113,   114,
    4897,  4898,   115,   116,   117,   118,   119,   737,  1052,  1053,
     739,  1173,  1174,  3493,  1135,   120,  2581,   121,  3782,   122,
    1248,  5120,   123,   771,  1189,  1190,  3036,   125,   781,  3191,
     783,  3156,  3157,  1995,  3963,  3964,  4603,   126,   127,  3967,
    3968,  4610,  3169,   128,  1507,  2716,  2717,  4806,  3037,   685,
    3516,  5511,  5250,  5512,  5986,  6148,  5251,  3437,  4205,   130,
     686,  1548,  2782,  1141,  1142,  3081,  3897,  2686,  2687,  1706,
    4556,  2689,  3899,  2690,  1481,  2691,  1128,  1129,  3905,  3906,
    3907,  3908,  4552,  4562,  4563,  5421,  5671,  4559,  1856,  5415,
    5416,   131,  1545,  2779,   132,   133,   134,  1589,   976,  1151,
    1152,   135,   698,   699,   136,  5596,   137,  1131,   138,  5425,
     139,   140,  1233,  1234,   798,   141,   142,  2796,  4306,   143,
    1546,   144,   145,  3649,  3650,  4909,   146,   147,   148,  2857,
    2858,   149,   150,   151,   152,   153,  6086,  6151,  6152,  6153,
    4570,  5991,   154,  1221,   155,   156,   157,   158,   196,  1017,
    1018,  1019,   929,  3038,  5406,   160,   161,  1503,  1504,  1505,
    1506,  2711,   162,   163,   164,  3927,  3928,   165,   166,   167,
     168,  1840,   169,   170,  5569,   171,   172,  1810,   173,   174,
    1026,  1027,  1028,  1029,  1808,  3383,   645,   851,  1397,  1403,
    1446,  1447,  1448,   176,   749,   177,  1224,  1057,   750,  1182,
     179,   751,  2668,  3467,  4220,  4221,  4222,  4225,  5234,  4783,
     752,  3463,   182,  2002,  3178,  3181,  3459,   753,  3473,  3474,
    3475,  4229,   754,  5515,  5516,  5904,  6120,  6121,  6173,  6207,
     755,   773,  1121,  3092,   756,  1331,   188,   189,   190,   909,
     854,   855,  3388,  5472,  5706,   192,  2545,  3366,   790,  1452,
     897,   898,   899,   918,  2973,  2634,  2635,  2659,  2660,  1461,
    1462,  2647,  2651,  2652,  3450,  3443,  2640,  4199,  5496,  5497,
    5498,  5499,  5500,  5501,  4772,  2655,  2656,  1464,  1465,  1466,
    2664,   193,  2624,  3417,  3418,  3419,  4176,  4177,  6024,  4191,
    4187,  4757,  5211,  3420,   843,  1219,  1473,  4765,  6026,  3421,
    5200,  5201,  5476,  4195,  3429,  4216,  3867,  3868,  3869,  3422,
    5714,  5715,  6021,  6022,  5478,  5479,  2692,  1426,   882,  1332,
     883,  1439,  1333,  1413,   885,  1334,  1335,  1336,   888,  1337,
    1338,  1339,   891,  1405,  1340,  1341,  1422,  1435,  1436,  1342,
    1398,  5480,  1344,  1345,  1346,  3424,  1347,  4703,  5173,  5159,
    3288,  3289,  2568,  5462,  4699,  4091,  4693,  2538,  2542,  5223,
    5503,  5504,  3359,  4140,  4730,  5190,  5702,  5874,  5875,  6007,
    1348,  1349,  1350,  3351,  2532,   979,  1351,  4461,  2534,  3279,
    3257,  1709,  3258,  2005,  2027,  3210,  3226,  3227,  3327,  3259,
    3267,  3272,  3280,  3313,  1352,  3212,  3213,  4005,  2029,  1353,
    1023,  1712,  1024,  1441,  3308,  3232,  4016,  4017,  3237,  3328,
    4020,  3244,  3245,  4037,  4027,  3238,  1354,  4029,  1362,  1363,
    1356,  1996,   844,  5207,  1177,  1793,   787,  1357,  1358,  1359,
    1360,  1582,   950,  1144,  1145,   900,   902,   903,  2628,   641,
     633,   952,  3617,  2535,   642,   635,   636,  1798,  2536
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     634,    71,   191,   180,   181,   186,   175,   908,   184,    80,
     183,  1084,  1805,    83,    84,    85,    86,  1708,   942,   106,
    1635,   124,   129,   191,   810,  1467,   983,   748,   159,   988,
     178,   185,  1210,  1211,  1212,   977,  1367,   846,  1216,  1355,
     842,   639,  1922,  2898,   919,   896,  2725,  1453,   690,  1455,
    1976,  1418,  2820,  1688,   775,  3521,  2791,  1438,  1394,  3460,
     775,  2688,  1640,  1030,   930,  1700,  1216,  2024,  3461,  1799,
    3826,  2803,  1865,  1157,  2016,   978,  3193,  2783,  3909,  3857,
    1381,  4150,  1393,  4152,  1122,   986,  3055,  1170,  1409,  1410,
    1424,  1634,  2792,  1183,  1176,  1486,  3184,  3985,  1417,  1008,
    1666,  2008,  4774,  4214,  4367,  2010,  3243,  2967,  2011,  2012,
    1693,  3848,  4527,  1838,  4540,  3247,  1124,  1843,  4274,  4319,
    3739,  4321,  1847,  1850,   782,  2859,  2859,  4514,  2688,  2859,
    3209,  4173,  1857,   630,  1051,  4228,  5045,   811,  3297,  1874,
    4190,  4565,  1794,  4808,  1577,  4813,  1877,  5204,   921,  2774,
     913,  1167,  2928,  2929,  3707,  1184,   922,  4295,  3122,  3236,
    3239,  3074,  5074,  1030,  3249,  4463,  2620,   232,  4877,  1599,
    3486,  3488,  5408,  5014,  1616,  5063,  2924,  1911,  5053,  5509,
    3264,  1549,   805,  4203,  3369,  5216,  4227,  5218,  3371,   839,
    5401,   634,  1155,  5528,  5609,  1159,  3452,  5369,   857,  3381,
     634,   953,  3455,  2956,   831,  4022,  1581,  5537,   634,  2774,
     953,   634,  1374,  4234,  3425,  5062,  1030,  5252,  4188,  1544,
    4193,  1001,  5397,   757,   953,  4119,  2774,  5606,  5661,  4789,
    1460, -1953,  4524, -2494,  4122,  1463,   696,  5648,  4024, -2535,
    5164, -2560,  5834, -2418,  1124,  5400,  3431,  1873,   649, -2598,
    2754, -1953,  -150,  5561,   757,  5571,  5572,  4034,  -150, -1912,
    1544, -1945,  2579,  1516, -2385,  1544,  3845,   928, -1925,  1030,
    1393,   696,  1191, -2385, -2385,  5822,  1807,  1904, -2350, -1950,
    3785,  4108,  3788,  3789, -1970,  3189,  4550,  3793,  3794,  3795,
   -2386,  3797,  3798,  3799,  1242,  3306,  5024, -2776,  3052, -2386,
   -2386,  6203, -1940,  5760,  3987,  1428, -2776, -2776,  5260,  5249,
   -2498,   696,   696,  3306, -2349,   696,  5599,  1830,  2941,   940,
     696,   757,  5122,  5123,  5124,  1111,  5126,  5127,  5128,  5129,
    5130,  1030,  1406,  1407,  1578,  2081,  4055,  2794,  3167,  1195,
     757,  2625,   757,  1416,  2558,   757,  1578,   696,  2922,  1371,
    6030,  2935,   757,  2998,  3167,  3144,  1914,  4034,  1600,  5785,
   -1763,  5787,  1918,   696,  2081,  5791,  5792,  2585,  4275,  1013,
    3490,  3973,  1929,  3975,   696,  5802,  1932,  1517,  3804,  2859,
    1935,  1429,  1937,  5075,  4055,   849,  2938,  1243,  1945,  3219,
    3016,  5025,   696,  3630,  1951,  1904,  2585,  1954,  3766,  2059,
    2587,  1206,  1697,  3401, -2558,  3729,  3304,   763,  2844,  1904,
    1399,  2944,  1904,   763,  5722,   763,  5795,   763,  6253,  3021,
    4493,  1904,  4895,   763,  5362,  3354,  2631,  3281,  1700,  2587,
    5981,   764,  5536,  2623,  2794,  1904,  1852,   764,  1799,   764,
    5538,   764,  1904,   817,  3730,  4386,  1214,   764,  1124,  3185,
    5277,  3170,  3678,  1430,  3434,  3977,  1431,  2821,  6197,  2550,
    2559,  5543,  4390,   643,  5254,  5348,  3428,  5276,  1450,  5370,
    5969,  1014,  1601,  3507,  1835,  3402,  3030,  2960,  2081,  3731,
    5026,  5757,  4329,  1608,   763, -2211,  2627,  4055,  5836,   646,
    2961,  3053, -2211,  6204,  4330,  3348,  1409,  1410,  3999,  5349,
    3220,   696,  3349,  2596,  4025,  5575,  1930,  1609,   764,  3142,
    2585,  4391,  4511,  3145,  4451,   644,  4230,  5803,  5371,  6240,
    2962, -2230,  1424,  4035,  1417,  2580,  5637,  5649, -2230,   978,
    1015,  2551,  1078,  3678, -1763,  4109,  1215,  3978,  1088,  1920,
    3022,  2038,  5363,  2587,  3435,  4896,  3146,  3171,   818,  2845,
    1102,  2794,  2945,  2794,  1904,  2794,  2794,  1794,  3031,   870,
    3147,  3508,  2794,  3520,  1920,  3167,  6205,  1997,  2075,  1432,
    5796,  3355,  1905,  1451,  6078,  3282,  3221,  4051,  2007,   978,
    2731,  1698,  2794,  3491,  1207,  3305,  3492,  3017,  1016,  2560,
    3167,  1432,  3805,  5804,  1799,  2017,  3148,  1253,  2548,  1960,
    4055,  4494,  1209,   697, -2903, -2903, -2903,  1836,  2999,  3974,
    5908,  3976,  3631,  2708,  1192,  1194,  1196,  4110,  6201,  1198,
    1199,  1200,  2759,  4035,   941,  1518,  2562,  4003,  5952,  1205,
    4275,  2574,  2574,  5994,  2021,  3425,  5490,  -439,   953,  1215,
    5600,  6205,  5261,  2865,  2901,  3168,  1602,  5027,  3222,  1215,
    1588,  3223,   191,  1058,  1059,  1062,  2804,   953,  1061, -2558,
    1060,  1245,  2622,   953,  6138,  3307,  1124,  3054,  1116,  4443,
    4444,   961,  4551,  5980,  2893,   953,  1920,  2896,   962,   963,
     964,  1433,  4463,  4126,  2837,  1603,  2923,  2001,  2822,  1519,
    1905,   953,  1920,  2916,  2917,   908,   634,  6206,  2965,  2966,
    2942,   896,  4111,  5935,  1905,   634,   953,  1905,  4912,   650,
    2903,  6137,   634,  5455,   953,   634,  1905,  1404,  5028,  1608,
    1604,  1419,  1420,  1187,  1836,   850,  3398,   896,   953,  2943,
    1905,  1406,  1407,  1906,  6181, -2558,  4026,  1905,   953,  1957,
    1421,  1419,  1420,  1609,  1021,   191,  2964, -2558,  1022,   769,
     770, -2494,  3205,  -150,  -150,  4036,  3767, -2535,  2598, -2560,
    1423, -2418,  2936,  2556,  3224,  1416,  5023, -2598,  1408,  5829,
   -1945,  2838,  2761, -2385,  6209,  5070,  1468,  1412,  4230,  2665,
    6040,  6041,  2768,  4387,  2666,  1021,  1218, -2350, -1950,  1022,
    1188,   953,  1193,  2039,  1197,  1124,  2882,  2939,  5238, -2386,
    1201,  6080,  4919,  1124,  1124,  1204, -2776,  5071,  4923,  6070,
    5832, -1940,  2972,   634,   634,  1836,   769,   770,  3140,   953,
    2077,  2546,  2778, -2349,  3374,  4817,  5439,  4819, -2498,  6225,
    6099,  2626,   691,  2531,  4070,  1579,  1580,   769,   770,  1021,
     769,   770,  1218,  1022,   953,  3124,   634,  1579,  1580,  1905,
    6042,  1913,  1817, -2211,  2823,  1836,  1822,  4512,  1823,  2528,
    2529,  2530,  2531,  3350,  6046,  1917,   921,  1821,  1928,  2883,
     896,  4512,  2886,  2887,   922,  2778,  3225,  1950,  3150,  4067,
    4068,  4069,  4070,  2824,  2603,  2604,  4061,  4190,  2074, -2230,
    3165,  1953,  2778,   634,  3026,  4754,  3174,  4463,  1920,  4758,
    2955,  1812,  3562,  4605,  3638,  4424,   953,   978,  2825,  2821,
    6140,  4836,    71,   191,   180,   181,   186,   175,  2732,   184,
      80,   183,  1472,  5741,    83,    84,    85,    86,  4602,  4505,
     106,  4882,   124,   129,  1490,  5979,  1501,  1523,  2846,   159,
    4345,   178,   185,  4654,  4655,  4381,  4382,  4657,  4524,  2819,
    4383,  3009,  3533,  3816,  3211,  5953,  3008,  1013,  5973,  2000,
    4201,  4479,  1672,  5597,  4982,  4745,  2601,  4747,  4236,  4798,
    4237,  2526,  2527,  2528,  2529,  2530,  2531,  6180,  6128,  2805,
    4065,  4066,  4067,  4068,  4069,  4070,  1370,  3452,   923,  5694,
    1378,  4641,  4208,  2806,  3151,  2807,  1508,  5961,   774,  5636,
    4157,  1400,  5012,  3425,   774,  1673,  3425, -1912,  2753,  4985,
    4602,  4560,  1074,  5972,   634,   634,  1795,  3333,  6143,  6144,
    4464,  1491,  4986,   953,  1138,  3175,  4715, -2346,   634,  1854,
    1904,  1456,  2674,   896,   634,  2915,  1475,   696,   634,  3242,
     634,  4566,  1961,  3404,   896,  1963,  6234,  1965,  2733,  1967,
    1383,  1969,  4287,  3425,  4346,  1973,  3553,   923,  2808,  1014,
     896,  3425,  2821,  1253,  3817,  2986,  4055,  4467,  6117,  2627,
    4056,  4057,  4058,  3620,  1492,  5642,  2543,   924,  4024,  6118,
     696,  5460,  6079,  4297,  5423,  4503,  3598,  1855,  4438, -1912,
   -2903, -2903, -2903,  4065,  4066,  4067,  4068,  4069,  4070,  6071,
    2821,  1428,  4910,   789,   634,   696,   634,   634,  5321,  2727,
    1509,  3653,  4231,  5703,  1458,  1887,  2718,  1076,  1015,  1077,
    1799,  4384,  5232,  1110,  6211,   692,  4469,  4288,  5882,  3621,
    4567,  5544,  5322,  6057,  3662,  2719,  5094,  2728,  3068,  4890,
    2822,  5995,  4813,  3106,   805,  1658,   924,   953,  3554,  3599,
     916,  3113,  5039,  1253,  6229,  5745,  4055,  5461,  3334,  1432,
    4056,  4057,  4058,  3335,   967,   968,   969,   970,   971,   972,
     973,   974,   975,  2821,  5996,   634,  1016,  1429,  4708,  6145,
    6101,   916,  1493,  5704,  2862,   693,  1111,  2866,  3654,   191,
    1674,  2821,  4393,   925,  2720,  6000,  4385,  4298,   796,  5013,
    5651,  4270,  5695,  6261,  5684,  3162,  3163,  5794,   953,  3336,
    4943,  2734,  1869,  1836,  2721,  5652,  1939,   896,  3913,   953,
    1030,  1228,  3303,  1962,   694,  1964,   695,  1966,  4347,  1968,
    5352,  1970,  1971,  1972,  3464,  4472,   953,  3622,  1974,  6179,
    4607,   953,  3176,  1021,  2707,  5818,  1476,  1022,  6088,  1430,
    6186,  4059,  1431,   634,  5826,  1870,   785,   742,  5815,  1940,
    2895,  6102,  4891,  3177,  3818,  2821,  3152,  4348,  3485,  3563,
     914,  1112,  3103, -1912,  4060,  3534,  4480,    15,  4473,  5843,
    2001,   908,  6210,  1896,  1510,  4814,  3115,  5399,  5831,  5393,
    3581,   634,  5828,  2822,  4474,  4460,  1675,  4568,  5814,  3121,
    2729,  3846,  4349,  2735,  5864,  1384,  2823,  3914,  3126,  2075,
    6232,  1229,    20,  4040,  5387,   926,  5418,  1075,  3781,  4561,
     634,   634,   634,  1511,   634,  1905,  2722,  3557,  5830,  1139,
    3099,  2822, -2672,  1855,  6244,  2824,  2821,  3149,   915,  5424,
    5233,  3154,  6088,  2718,  4025,   634,  3161,  3639,  6058,  3164,
    3410,  1498,  4061,  1499,  3819,  1699,  6103,  3337,  1512,  1566,
    2825,  4371,  3120,  2821,  4060,  1432,  2971,  3670,  4569,  4892,
     953,  3133,  2583,  5911,  2723,  3776,  2544,   795,   953,   953,
    4608,  1385,  5244,  5685,   926,  4557,  5119,  4052,  4053,  2774,
    3101,  2821,  4072,  1239,  4475,  6119,  4944,  3769,  3255,  3027,
    5733,  2819,   634,  5653,  2822,  3114,  5323,  3623,  3116,  2632,
    2633,  6108,  2637,  2925,  4299,  4300,  5739,   922,   922,  3057,
     922,  2720,  2822,  4880,   916,  6160,  3465,  1513,  6059,  1113,
   -2672,  1795,  5963,  4103,  4104,  4155,  6171,  3025,  6133,  2821,
    1871,  2721,  4061,  6093,  1941,  4301,  6088,  2641,   634,  5989,
    3085,  2957,   634,   634,  3671,  5237,   978,  6060,  3153,  2823,
    3515,   662,  3159,  3160,  1897,  1472,  1114,  1472,   634,  2898,
    5205,  5208,  4271,  3086,   896, -1912,  5212,  1433,  1898,  5214,
    5004, -2672,  1230, -1912,  6017,  1408, -1912,  1437,  2824, -1912,
    2724,  2737,  3875,  2642, -2672,    40,  2822,  2823,  4881,   797,
   -2672,  2738,  1434,  4615,  6104,  6002, -2672,    32,  3672,  3064,
    3204, -1764, -2672,  2825,  6172, -2672,  4609,   997,  1013, -2672,
    5366,   816, -1086,  1231,  3564,  1232,  2824,  1115,  3520,  1116,
     664,  3915,    44,  1117,  1899,  3065,  5655,  6093,  4209,    40,
    -613,   896,  3640,  3370,  5656,  3916,  1872,  3857,   998, -2672,
    1942,  2825,  5084,  2722,  2819,  2643,  4062,  4063,  4064,  4065,
    4066,  4067,  4068,  4069,  4070,  4777,   917,  2822,  5734,  3673,
    2823,  5050,  1605,  5699,    48,  1516,    44, -2672,    35,   647,
    4800,  3206,   896,  3208,  6069,  1677,  3553,    49,  2823,  3215,
    4253,  1678,  2819,  1799,  2822,  3229,  3230,  5051,   840,  2824,
    6018,  2723,  5388,  4999,  3250,  2644,  6134,  1501,  3064,  2868,
    3898,    50,  1501,  3269,  5050,   896,  4379,  2824,    48,  3284,
    1014,  2641,  2822,  4822,  2825,  5641, -2672,  5901,  5650, -2672,
    3466,    49,   910,  5990,  3065, -2672,  1900,  3087,  5005,  4181,
    5051,  6093,  2825,  5560,  5910,  4463,  4062,  4063,  4064,  4065,
    4066,  4067,  4068,  4069,  4070,    50,  2919,  2688,  3723,  6076,
    6077,  2688,  2823,  6003,  3724,  2819,  2645,  2642,  1253,  4616,
    2822,  4055,  2739,  4182,    56,  4056,  4057,  4058,  3554,  1015,
     953,   194,  6136,  2819,  3674, -1764,  1501,  4389,  4760,  1517,
    1501,  2824, -2672,  4709,  3505,   634,   634,   634,  2712,  1679,
    5161,  -698,  1901,   675,  5044,   676,  4184,   662,  2769,  4823,
    2713,  2740,  4210,   813,  4426,  1253,  2825,  2724,  4055,    40,
    5657,  2081,  4056,  4057,  4058,   195, -2369,  5700,  2714,  3102,
    -173,   680,  3066,  2823,   774,  4976,   774,  1016,   774,  4778,
    4980,  1794,  4838,  5713,   774,  1202,  1203,  3566,  4668,   789,
    4669,  6178,  3112,  5570,  5041,  2638,    44,  2819,  5701,  5756,
    2823,  -173,  2824,  6019,  1056,  1590,   852,  6012,  6020,  5000,
    3425,  4801,  3725,  3095,  3425,  1920,   664, -2672,  4802,  2644,
    4824,   643,   194,  5202,  4825,  4803,  2587,  2825,  2823,  2824,
    4884,   978,   978,  1380,  5052,   953,  2888,  3553,    48,   911,
    1902, -2672,  3380, -2672, -2672,  2770,  5003,   896,  3675,  3457,
    6038,    49,  4460,  5162,  2825,   194,  3676,  2824,   896,  3677,
    6163,  4804,  3600,  6182,  5616, -2672,   195,  4186,  2819,    40,
    1795,  5381,  4775,   912,   896,    50,  2823,  5967,  4908,  1591,
    2645,  3425,  2825,  4805,  3567, -2672,  1608,  6164, -2672, -2672,
   -2672,  4997,  1376,   953,    56,  2819,  1180,  3557,  1418,   195,
    1456,   953,  1668,  2639,  2907,  2824,    44,   927,  5921,   953,
    1609,  5567,  -464,  1680,  3753,  2554,  5835,  3456,  5617,  4060,
    1678,  5618,  1529,  2819,  1384,  3601,  3579,  5619,   896,  3554,
    2825,  1920,  2715,  2908,  5842,  5568,  4670,   634,  5821,  3142,
     634,  1669,  5257,   896,  4776,  1670,   896,   896,    48,  3689,
     634,   634,  1681,   953,   953,  5620,   978,  3458,  1953,  2811,
    1566,    49,  1855,  4998,  3555,   634,  4060,   953,   634,  5486,
    1246,  2819,  1637,  1414,  1415,   774,  1671,   896,   896,  3627,
     953,   953,  5922,  1458,  2889,    50,  3726,  1682,  2890,   675,
      40,   676,  3142,  4218,  1186,  2812,  3737,  4061,  3506,  1253,
    1385,   191,  4055,  3556,    56,  3651,  4056,  4057,  4058,  1953,
    3732,  1638,  1239,  5621,  5258,  5855,  6147,  1851,   634,  3142,
    3688,  2081,   634,   634,  5179,  3727,  5622,    44,  3754,  5683,
    4219,  3235,  1459,  -464,  3134,  4822,  3135,  3179,  3136,  5623,
    3137,  3931,  3138,  3190,  4061,   774,  3139,  1227,   191,  1058,
    1059,  1062,  1800,  2585,  1061,  1801,  1060,   634,  3713,   634,
    3728,  5437,  5280,  5856,   634,   634,  4606,  4460,  1618,    48,
    5286,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,  2566,  5987,   634,  4618,   634,  2587,   634,   634,   634,
     634,   634,   634,  3760,  2869,   634,  5971,   634,   634,  2872,
    1395,   634,  1477,  2688,  5970,  3651,  5368,  1619,  3557,  3770,
    3771,  3772,  3857,  2688,  3733,   896,   634,   634,   634,  5988,
    6213,  4823,   928,  1639,  2567,    56,  4642,  3861,  3862,  3863,
    3864,  4646,  3866,  1456,   634,  4601,  1795,  2898,  3665,  1457,
    1482,  1478,  3425,  3425,  4286,  5392,  4630,  4099,  4653,  3734,
   -1687,  2852,   233,  3663,  5379,  3664,  2794,  3894,   648,  3194,
    3738,  5813,  1445, -1687,  3735,   936,   740,  2795,  2876, -1687,
    1124,  3814,  3690,  2947,  5672,  1483,  1479,  2953,  3576,  1484,
    3693,  3925,  4602,  3696,   814,  4645,  5518,  1487,  5520,  4649,
    4650, -1734,  4824,  1621,  4588,  2688,  4825, -1734,  3389,  3736,
    2958,  4062,  4063,  4064,  4065,  4066,  4067,  4068,  4069,  4070,
    4060,   938,  5788,  3776,  1485,  1622,  1458,  5789, -1687,  4433,
     763,  4180,  4664,  4665,  4666,  4667,  1488,  2859,  4671,  4672,
    4673,  4674,  4675,  4676,  4677,  4678,  4679,  4680,  5624,  2959,
    6072,  5625,   959,  5567,   764, -1111, -1687,  1621,  4062,  4063,
    4064,  4065,  4066,  4067,  4068,  4069,  4070,  4300, -1686,  1646,
    4962,  1489,  2728,  4388,   960,  1459,  1623,  5568,  5790,  1622,
    2794, -1686, -1687,  2830, -1734,  1103,  5846, -1686,   634,   757,
    1003,  2802,  5358,  4963,  5360, -1687,  5863,  4868,  4061,  4743,
    1953, -1687,  4719,  4720,  2799, -1687,  2800,  4181,  4994,  4854,
    1643,    29,  6084,    29, -1687,  3704,  4180,  3705,  4814,  4000,
    4425,  3709,  1104,  5339,  4001,  5340,  5341,  5342,  5825,  4342,
    1623,  1875,  4814, -1734,  1647,  4995, -1686,   634,  3969,  4233,
    4180,  4182,  4573,   662,  4855,  3426,  5735,  4574,  6139,  1644,
   -1687,  2969,  2970,  1947,  5793,  1876,  4183,  3386,  1105,  1021,
    1419,  1420,  1012,  1022, -1686,  3923,  1624, -1084,  4343,  2801,
    3929,  5736,  3930,  1020,  4184,  3887,  1648,  1948, -1687,  1421,
    1066,  3387,  3936,  1649,  1645,  3937,  1650,  3938,  3939,  3425,
     634,  3941,  4181,  4945,  1608,  3944,  3425,  3945,  6036,  6149,
    3947,  3425,  4185,  4344,  3425,   774,  1106,    40,  5567,    40,
     774,   774,   664, -1686,  1071,  4536,  4181,  4946,  1609,  2831,
    1624,  5676, -1686,  1085,  1625,   757,  4182, -1687,  1626,  4790,
    6165,  3849,  5568,  -612,  2888,  4856, -1687,  -150,  2602,  1419,
    1420,  4183,  1103,  2897,    44,  5677,    44,  2609,  1064,  2610,
    4182,  4206,  3958,  2613,  6166,  4089, -1687,   757,  1423,  4184,
    2619,  4096,  1611,  1107,  3986,  4183,   666,  5078,  4240,     3,
       4,  1099,  4574,  1408,  4112,  2621,  4113,  1628,  1625,  1104,
    1108,  1685,  1626,  4184,  1689,  5759,    48,  4185,    48,  1598,
    5763,  5764,  2811,  5900,  1615,  4186,  4814,  2897,  1109,    49,
    4114,    49,  4062,  4063,  4064,  4065,  4066,  4067,  4068,  4069,
    4070,  4185,  4797,  3290,  5209,  4506,  3293,  1408,  1126,  2621,
     772,  2075,  1630,    50,  4151,    50,   772,  1130,  2812,  6233,
    1253,  1628,  1146,  4055,   742,     3,     4,  4056,  4057,  4058,
    3453,  3454,    56, -1424,  6085, -1424,  1631,  1408,  1021,  1437,
   -2350,   774,  1022,  1959,    15,  5180,  1801,  1651,  3957,  5202,
    2025,   774,    56,  1106, -1686,  3317,  1633,   634,   634,   634,
     634,   634,   634,   634,   634,   634,  1630,   634, -1687,  6251,
    4186,  6254,  2889,  1147,  1490,   675,  2890,   676,   634,    20,
     634,  4081,  1652,  4083,  4084,  1080,  1653,  1081, -1111,  2009,
    1631,  6265,  1801,  1137,  4186,  1202,  1203,  1419,  1420,  3543,
     679,  3547,  3548,  1851,  3318,  3319,  3320,  3321, -1758, -1758,
    1633,  4115,  3546,  3318,  3319,  3320,  3321,  4116,   634,  1153,
    2582,  1654,   634,  1801,  3090,   634,  3091,   634,  1655,  3382,
     634,  4394,  2595,  4993,   634,  2596,  1021,  1164,   774,  1442,
    1022,   774,   774, -1762, -1762,  2629,  4162,  4163,  1801,  6124,
    3670,  3540,   978,  6126,  6127,  1795,  3130,   634,  1171,  2596,
    5210,  1491,  3141,  2574,  4153,  3142, -1761, -1761,  3425,  4276,
   -2342,  6054,  1181,  3832,   634,  1021,  5577,  1209,  1408,  1022,
    2621, -2343,   643,   634,   634,  4235,  1021,   757,  1209,  4018,
    1022,  4019,  1217,  3575,  3143,  4305,    40,  3142,  5748,  5749,
    4279,  5847,  5111,  3182,  4196,  3385,  3183,  4142,  1953,  4143,
     953,   932,   934,  3468,  1492,   937,  4124,   896,  5118,  1208,
    3390,   896,   896,  2596,  3477,  1220,  3573,  2596,   953,  3574,
    1236,  4060,   953,    44,  1213,   995,   953,  3671,  6174,  5876,
    5877,  3509,  1005,  3512,  3645,   953,  1226,  3646,  3810,  4867,
    1799,  3811,  5141,  6008,  6009,  4522,  3426,  2622,  5144,  5145,
    3949,  1225,  3998,  3142,   953,  2596,  4117,   634,  4007,  1240,
    4013,  2596,  5046,  2596,    32,    48,  4337,  4118,   634,  3669,
     896,   634,  6116,   634,   634,  4259,   896,  4144,    49,  4145,
    3423,  3672,  3561,  4014,  4032,  1209,  2596,  3769,   953,  4041,
    4074,  5581,  2596,  2596,  5743,  4088,    40,  4814,  2596,  4061,
    4093,  4160,    50,  4094,  2596,  4460,  1237,  4322,   953,   953,
    4323,  4857,  1493,  4864,  5152,  4327,  5153,   896,  4328,  4837,
    4533,    56,  4534,  4846,   774,  1124,  4353,  4422,  4545,  4354,
    4354,  4546,  1223,    44,  3425,  3833,  4987,  5582,  4988,  1795,
     953,  6034,  3673,  1795,   905,   906,  4309,  4617,  4311,  2688,
    3757,  4054,  4548,  4579,  3425,  4549,  4580,  6188,  4689,  6189,
    4509,  4690,  5583,  4082,  3403,  3405,  3406,   953,  3425,  1795,
    1442,  1238, -1675,   953,  1494,    48,  1239,  4883,  4452,   743,
    5584,  3660,  4700,  4711,  5585,  4701,  2596,   953,    49,  4481,
    4241,  4242,  4785,  1247,   953,  4786,  4244,   953,  5977,  4106,
    1379,  4791,  4796,   953,  4792,  3492,  5586,  1241,  1249,  1495,
    5587,  2080,    50,  1496,  2081,  1382,  5229,    35, -2903, -2903,
   -2903,  5047,  1386,   953,  3142,  5588,  1387,  5664,  6214,   953,
    5113,   744,  1388,  2001,  5149,  1396,   953,  2596,  5728,  5186,
    1392,  1401,  2596,  4137,  4362,  4739,  2585,  4741,  1497,  4368,
     953,  5240,  1402,  2586,  3492,  4263,  5246,  3674,  1408,  5247,
    5253,  3008,  5394,  3142,   953,  5395,  1404,  1411,  5431,  1795,
    3703,  4580,  1425,  5452,  5454,   953,  5453,  2596,   914,  2587,
    1412,  1498,  5195,  1499,  5197,    40,  6255,  1124,  1442,  5473,
    4412, -1735,  5474,   634,   634,   634,  4419, -1735,  4759,   634,
    4762,  3834,  1427,  4062,  4063,  4064,  4065,  4066,  4067,  4068,
    4069,  4070,  5483,  5489,  5491,  1953,  4519,  4519,  5611,  5913,
    5914,  5612,    44,  1443,  5589,  5631,   634,   896,  3142,  1454,
    1469,  5665,  3425,  1500,  5666,  1795,  2667,  4358,  2670,  3217,
    3218,  3991,  1470,  3993,  3994,  5064,   915,  1471,  1474,  4814,
    5392,  3835,  5711,  3251,  3252,  5712,  1437,  5717,  5720,  4374,
    1953,  4519,  5731,  1480,    48,  5732,  4787, -1687,   634,  5778,
    5817,  1521,  5779,  2553, -1735,  5590,  5844,    49,  1547,  5732,
   -1687,  3675,  5867,  3296,  5868,  4094, -1687,  2596,  5886,  3676,
   -2387,  5887,  3677,  3988,  2588,  3425,  5057,  1550,  3876,  2589,
     896,    50,  5890,  5891,   896,  1953,  2596,  5920,  5926,  3898,
    3183,  3183,  5927,  5930,  3426,  3183,  2596,  3426,   951,  5931,
      56,  1552,  2596, -1735,  4816,  4499,  4818,   987,  5932,  4821,
    5959,  5933,   916,  5960,  6013, -1687,  6027,  4519,  1553,  2596,
    5977,  1009,  1588,  1592,  6029,  2591,  4814,  2596,  6035,  1593,
    6050,  3142,  5898,  6051,  6074,  1594,  1065,  6075,  1068,  6115,
    2688,  1070,  5725, -1687,  3426,  6146,  6184,  6208,  5732,  6185,
    2596,  1605,  3426,  6227,  2627,  1096,  5887,  6237,  1607,  1617,
    6238,  1100,  4581,  1620,  4583,  6243,  4585,  5469,  4786,  5470,
     953,  6252,  1795,  6264,  2596,  1642,  6238,  1659,  1660,  1676,
    2592,  3423,  1686,  1687,  1690,  1695,  1696,   896,  1809,   953,
    1811,  1813, -1687,  4611,  1824,  4492,   953,  4495,  1818,  1829,
     634, -1687,   896,   634,   978,   634,   634,   896,  1832,  1834,
    1700,  1839,  1842,  1844,  4482,   634,  4484,  1836,  1853,  1858,
     634,  1861,  4695,  1859,   908,  4513,  -137,  1862,  1864,  1866,
    4814,  1867,  1878,  1885, -2902,  1887,  1890,   896,  3425,  1894,
    1903,   213,  1908,  1909,  1910,  1912,  1124,  1915,  1124,  4624,
    1916,  1799,  1919,  1920,   917,  1927,  1554,  1931,  1933,  1934,
    1936,  1938,  1555,  1943,  1944,   634,   634,   634,  1946,  1949,
     634,  1952,   908,  2594,  1955,  1956,  1958,  3306,   634,   634,
     634,   634,  1621,  2006,  1975,  2013,  4867,  5446,  2627,  1795,
    2015,  2018,  2022,  2080,   634,  1795,  2081,   634,  4554,   634,
    2023, -1916, -1923,  2032,  1622,  2030,  2031,  1557,  2033,  2034,
    4202,   634,   634,    56,  2036,   634,  2037, -1913, -1914,  2038,
    2040, -1917,  4596, -1915,  2059,  2041,  2042,  6082,  2585,  2043,
    1124,  2044, -2902,  3425,  2045, -2903,   634,  2046,   634,  2047,
     634,  2048,  2049, -1687,  2051,  2052,  2537,  2053,  2054,  2055,
    4619,  2541,  2056,  2539,  4858,  1623,  2057,  5273,  2058,   634,
    2061,  2587,  2062,  1558,  2063,  4147,  4148,  4149,  2064,  2543,
    1559,  2065,  2066,  1560,  2544,  2522,   908,  2553,  2067,  2068,
     953,  2557,  2569, -2902, -2903, -2903, -2903,  2526,  2527,  2528,
    2529,  2530,  2531,  2599,  2577,  2600, -2902,  2605,  2607,  2608,
    1561,  2611, -2902,  2612,  2617,  2614,  2615,  2623, -2902,  2616,
    2618,  1021,  1459,  2630, -2902,  1022,   634, -2902,  1457,   634,
    2661, -2902,  4861,  2663,  2673,  5091,  2675,   908,  2676,  2677,
    4105,  2678,   634,  2694,  3425,  2696,  1562,   634,  2695,  2621,
    2697,  4833,  2698,  2700,  2699,  1624,  2701,  2702,  1586,  1587,
    2703, -2902,   634, -2902,  2704,  2736,  2710,  2730,  3627,  2742,
    4878,  2756,  2760,  2762,  2763,  2764,   634,  2766,  2767,  2622,
    2784,  2780,  2785,  2786,   634,  2797, -2903,  2798,  2809, -2902,
    2815, -2903,  2813,  2816,  3651,  1253,   896,  2817,  4055,   896,
    2818,   896,  4056,  4057,  4058,  2827,   896,  2819,  2832,  4981,
    2829,  2833,  4968,  1625,  2828,  2834,  5689,  1626,  2839,  1663,
    2843,   953,   953,  1564,  2840,  2853,  2849,   634,  2850,  1814,
    2867,  2863,  2897,  1565,  6212,  2877,  2864, -2903, -2902,  2870,
    2884, -2902,  1566,  2891,  1826,  2894,  1566, -2902,  2920,   953,
    2873,  2874,   953,  2909,  1567,   896,  2911,  4973,   187,  3423,
    2879,  2913,  3423,   896,  1079,  2880,  1628,  2892,  2899,  2900,
    1079,  2905,  2906,  2912,  2918,  1848,  1849,  2914,  2937,   187,
    2926,  2921,  1079,  2980,  2927,  2940,  2951,  2982,   896,  2946,
    2968,  2983,  2592,  5691,  2984,  3425,  1569,  1570,  2975,  2985,
    2989,  1886,  2997,  2990, -2902,  2991,  2993,  3397,  3399,  3423,
    2994,  1630,  2995,  3407,   907,  2996,  3001,  3423,  3002,  3003,
    3004,  3011,  4907,  5710,  1795,  1795,  1795,  3012,  1571,  4661,
    3015,  2080,   657,  3020,  2081,  1631,  3028,  3039,  1639,  3044,
    3043,  1924,  1926,  3047,  3063,  3451,  3451,  3072,  3083,   953,
    3076,  3056,  3080,  3059,  3062,  1633,  3089,  3307,   896,  3093,
     896,  3105,  3098,  4688,  3107,  3108,  2585,  3110,   953,  3109,
    3123,  3155,  3180, -2903,  3192,  2080,  3166,  3211,  2081,  3216,
    3285,  2081,  3291,  3358,  5414, -2903,  3425,  3295,  3332, -2902,
     953,  3311,  3425,  3330,  3352,  3373,  4202,  1572,  3376,  2587,
    3377,  3357,  3392,  3378,  2654,  3379,  4060,   774,  3391,  3393,
    2585,  1432,  3394, -2902,  4727, -2902, -2902, -2903,  3395,  3396,
    3400,  3408,  3409,   915,  3433,  3428,  3445,  3446,  3447,  3448,
    3462,  3469,  3470,  3481,  3482,  3501,  3513, -2902,  3484,  3515,
    3517,  3510,  3518,  2587,  3525,  3969,  3530,  3541,  3535,   920,
    3519,  3549,  3536,  1376,   896,  3538,  3565,  3570,  3572,  1380,
   -2902,  3634, -2902, -2902,  3589,  3602,  3607,  3635,  4123,  3582,
    3608,  3636,  3641,  3652,  3659,  3661,  3644,  3662,   953,  1855,
    3628,  3683,  3699,   634,  4061,  3682,  3741, -2903,  3756,   634,
    3768,  3777,  3585,  3764,   916,  3784,  3425,  3790,   896,  2526,
    2527,  2528,  2529,  2530,  2531,  3765,  3796,  3801,  3791,  3792,
    3823,  3838,  4718,  3812, -2903,  3840,  3824,  3842,  3844, -2903,
    3852,  3870,  3878,  3871,  3873,  1795,   896,  5100,  3874,  3859,
    5102,   953,  3883,   953,  3885,  3865,  3886,  3889,  3890,  3895,
    3881,  3910,  3911,  3872,  3920,  3912,   953,  3921,   953,  3922,
    3940,  3924,  2627,  3926,  3942,  3943,  3946,  3948, -2903,  5117,
    3951,  3952,  3953, -2903,  5108, -2903,  5019,  5020,   634,  3954,
    3955,  3426,  3956,  3966,  3970,  3426,  1953,  1950,  1917,  3982,
    3972,   774,  3979,  3984,  3992,  5375,  4012,  4015,  4028,   774,
    4031, -2203,   774,  3233,   896,  4087,  3960,  4090,  4102,  5174,
    4107,  4121,  4158,  4131,   774,  3961,  4543,  4170,  3971, -2903,
    2080,  4539,  4051,  2081,  4198,   953,   896,  4132,  1215,  4009,
    2592,  4010,  5220,  4138,  4217,  4011,  4023,  4033,  4042,  4211,
    4213,  4204,  4043,  4224,  4047,  4049,  4238,  4134,   896,  3769,
    4050,  4073,  3426,  4243,  4078,  2585,  4246,  4576,  4164,  4079,
    2596,  4086, -2903,  5057,  4101,  4136,  4159,   953,  4165,  4166,
    4245,  2039,  4171,  4194,  2592,  4215,  4250,  5103,  5104,  5105,
    5106,  5107,  4179,  4232,  4255,  4258,   953,  4251,  2587,  4260,
     953,  4283,  4284,  4272,  4285,  4273,  4289,  1218,  4062,  4063,
    4064,  4065,  4066,  4067,  4068,  4069,  4070,  4290,  4291,  4296,
    4308,   953,  4292,  4307,  4256,  4310,  4316,  4317,  4318,  4725,
    4326,  4332,  4361, -2903,  4341,  4359,  4357,   634,  4365,  4369,
     896,  4363,  5227,  4370,  4373,  4355,   634,  4376,  4377,  4375,
    4378,  5746,  4380,  2775,  4395,  4397,  4398,  4396,  4399,  4411,
     634,  4402,  4400,  4401,   634,   634,  1253,  5346,  4403,  4055,
     634,  4404,  4405,  4056,  4057,  4058,  4407, -2903,  2814,  4406,
     634,  4408,   634,  4409,  4410,   634,  4414,  4416,  5262,   896,
     634,   634,   634,   634,  4418,  2935,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,  4420,  2938,  4421,   634,
     634,   634,  4437, -2903,   896,  4427,  4430,  4442, -2903,   634,
    4431,  4448,  4434,   908,   634,  4432,  1795,  4450,   634,  4485,
    4500,  4490,  5290,  5291,  4501, -2903,   634,  4491,  4497,   634,
    4504,   634,  4508,  4519,  4521,  5284,  4528,  2526,  2527,  2528,
    2529,  2530,  2531,  4518,  4537,  2904,  4538,   634,  4541,  5224,
     634,   634,  4531,  4542, -2903,   634,   634,  4544,  4558,  4572,
     634,   774,   634,  4575,  4732,  4733,  4734,  4735,  4590, -2903,
    4582,  4584,  4591,  6109,  6110,  2930,  2931,  2932,  2933,  4578,
    4592,  2526,  2527,  2528,  2529,  2530,  2531,  4593,  4594,  4595,
    4597,   191,  1058,  1059,  1062,   634,  4612,  1061,  2080,  1060,
    4613,  2081,  4620,   634,  4614,  4621,  4622,   634,  4623,  2592,
    4625,  2025,  4626,  3426,  3426,  4627,  5334,  5335,   187,  4628,
    4633,  4629,  4637,  4202,  4638,  5271,  4464,  4640,  4639,  4643,
    4644,  4647,  4465,  2585,  4651,  4652,  4656,  4055, -2202,   634,
   -2903,  4702,  4662,  4713,  4685,  4466,  4686,  4687,  4694,  4202,
    4714,  4717,  4728,  4740,  4742,  4748,   634,  4753,  4744,  4755,
    4756,  4751,   896,  4763,  4764,  4768,  2587, -2903,  4769,  4770,
    4771,  4773,  4779,  4467,   634,  4468,  4782,  5414,  5160,  4784,
    4788,  4799,  4807,  4829,  4832,  1621,  5359,  4830,  4831,  4839,
    4840,  4842,  4843,  4845,  4849,  4852,   953,  3241,  3241,  4853,
    4873,  4870, -2903,  4885,  4886,  4887,  4888,  1622,  4889,  3265,
    4901,   187,   907,  4899,  4900,  4902,  5317,  4903,  3286,  4904,
    4913,  4916,  2987,  2988,  5468,  4915,  4922,  4933,  5324,  5325,
    4939,  5327,  4469,  4849,  4934,  4721,  3423,  4942,  3005,  4958,
    3423,  4959,  4859,  4961,  4964,  4061,  5430,  1795,  4974,  5432,
    5433,  4975,  1795,   896,  1795,  4977,  4978,  5506,  1623,  4859,
    5001,  4470,  4979,  4990,  5016,  5011,  2733,  5022,  5030,  5438,
    5036,  5037,  3048,  3049,  3050,  3051,  5043,  5049,  1795,   896,
    4154, -2903,   774,  5059,  5042,  5065, -2903,  2898,  5066,  5076,
    5083,  5085,  5082,  5087,  5089,  5095,  5101,  5086,  4161,  5109,
    5115,  3167,  5116,  4860, -2903,  5090,  5125,  3423,  5133,  5132,
    5134,  5135,  5136,  5377,  5137,  5139,  2526,  2527,  2528,  2529,
    2530,  2531,  5146,  5138,   953,  4861,  5151,   953,  5157,  5142,
    5143,  4924, -2903,  5163,  5168, -2204,  4471,  5166,  4202,  5172,
    5167,  4472,  4932,  5185,  5199,  5213,  4207,  4207,  1624,  5189,
    3426,  5222,  5225,  3125,  5226,  5203,  5206,  3426,  5217,  3129,
    5236,  5239,  3426,  5241,  5243,  3426,  5249,  5248,  5281,  2080,
    5282,  5259,  2081,  5283,  5285,  5293,  5292,   920,  5294,   187,
    5287,  5306,  5309,  5313,  4473,  5315,  5319,  2592,  5320,  5328,
    5329,   634,  5336,  5580,  5337,  5772,  2080,  5774,  5338,  2081,
    4474,  5343,  5347,  5350,  2585,  5355,  1625,  5356,  5354,  5364,
    1626, -2903,  5376,  5373,  5367,  5374,  5372,   953,   953,  5380,
    5382,   896,  5386,  5391,  5398,  2897,  5402,  5396,   953,  4862,
    5403,  2585,  5405,  5407,  5409,   634,   634,  2587, -2903,  5410,
    5411,  5420,  3142,  5426,  5428,   953,  5435,  5436,  5441,  4062,
    4063,  4064,  4065,  4066,  4067,  4068,  4069,  4070,  5447,  1628,
    5442,  5443,  5451,  5457,  2587,  5458,  5467,  5459,   896,  5471,
    5475,  5481,  5068,   896,   634,   634,  5485,  5519,  5881,  5488,
   -2903,  5513,  5507,  5510,  5522,   634,  5530,  5532,  5531,  5533,
    5535,  5539,  5482,  5782,  5534,  5540,  5542,  2950,  5541,  5547,
    4475,  5553,  5554,  5482,  1630,  5573,  4722,  5558,  5564,  5565,
    5566,  5595,  5000,  5601,  5604,  5907,  5628,  5602,  5607,  5610,
    5615,  5635,  5634,  5614,  5526,  5639,   953,  5644,  1631,  1795,
    5646,  5662,  5673,  5183,  5667,  5675,  5674,  5681,  5697,  5705,
    5696,  5727,  5725,  3309,  5726,  5729,  5751,  5709,  1633,  3314,
    4863,  3315, -2903,  4292,  5752,   634,  5754, -2903,  5514,  5721,
    5723,  5742,  5944,  5946,  5744,  5760,  5798,   978,  3423,  3423,
    5766,   634,  5805,  5801,  5811,  3316,  5545,  5819,  5824, -2903,
    5550,  5833, -2903,  5809, -2903,  5837,   634,  5838,  5839,  5841,
    5840,  5850,  5851,  5860,  2526,  2527,  2528,  2529,  2530,  2531,
    5858,  5862,  5879, -2903,  5880,  5852,  5869,  5853,  5902,  5903,
    5878,  5905,  5906,  5893,   634,  4139,  5883,   634,  5919,  5942,
    5923,  5951,  5954,  5956,  5958,   634,   634,  5962,   896,  5965,
   -2903,  5966,   634,   634,  5982,  5983,  5999,   634,  5984,  3426,
    3317,  5985,   634,  5992,  5993,   634,   634,  6001,  6006,  6010,
    6023,  6011,   634,  6016,  5998,   187,  6025,  6032,  2592,  6037,
    6045,  6055,  2819,  6047,  5952,  5953,  6064,  6063,  6081,  6083,
    3029,  5740,   634,  6100,  6111,  6065,  6114,  6122,  3046,   634,
    6132,  6150,  6130,  6156,   634,  2592,  2950,   634,   634,  3318,
    3319,  3320,  3321,  6157,  5937,   634,  3322,  3323,  6161,  6162,
    6167,  6169,  3324,  6202,  6170,  6191,   634,  6192,  6190,  6215,
   -1970,  6230,  6217,  6218,   634,  6053,  6226,  6235,   774,  5228,
    5230,  4230,  6228,  2026,  6241,  5242,  5777,  6236,  6246,  6247,
    6205,  3104,  6259,  6250,   634,  6256,  5669,  1444,  1554,  6263,
    1551,  4496,  1657,  2035,  1555,  4156,  3714,  2576,  2952,  3633,
    1656, -2903,  4302,   896,  4876,  4869,  5949,  5784,  2950,  1661,
    5288,  6048,  3803,  5885,  3755,  4447,   953,  5592,  5936,  6131,
    5645,  5718,  4865,  4866,  5018,  5353,  5627,  4248, -2903,  3950,
    5797,  6039,  5524,  6105,  6106,  6125,  5256,  5957,  5955,  1557,
    6062,  6142,  4254,  5384,   896,  3444,  5069,  5040,  2072,  5916,
    5048,  5010,  3821,  1524,  4874,  3423,  3822,  4320,  4507,  5378,
    1641,   953,  3423,  5035,  5279,  3426,   896,  3423,  5633,  4547,
    3423,  5854,  6187,   953,  5093,  5279,  6262,  6248,  5608,  5580,
    4453,  6067,  5077,  5552,  5925,  3426,  5762,  5555,  1525,   634,
    5865,  3019,   738,  1662,   791,  1558,   634,  4598,  5110,  3426,
    1054,  3325,  1559, -2903,  1998,  1560,  5738,   953,  6183,  5776,
    5112,  3850,  3326,  3082,  5079,  2526,  2527,  2528,  2529,  2530,
    2531,  3487,  3078,  3094,  4564,  4239, -2674,  5670,  5848,  3111,
   -2903,  1125,  1561,  3752,  4417,  1165,  4905,  4364,   896,  6087,
    6216,  5096,  2526,  2527,  2528,  2529,  2530,  2531,   774,  1526,
    1389,  5097,  3780,  3432,  2709,  2977,  6231,  4793,  5737,  5231,
    6033,  2597,  2549,   819,   634,  5771,  4200,   820,  1562,  5140,
     920,   920,  2657,   920,  4212,  6028,  5895,  3442,  4174,  1124,
     634,  5912,  2658,  4746,  4761,  1795,  1527,  2662,  5487,  4168,
    5707,  5693,  5708,  4794,  4169,  6199,  6015,  6112,  5884,  5692,
    3353,  2606,  4696,  5896,   953,  5698,  4135,  5897,  3356,  3271,
    4129,   634,  4004,  3779,  5937,  4127,  4120,  4038,  4648,  3368,
    1440,     0,     0,  3430, -2674,     0,  5719,     0,     0,     0,
       0,  1528,     0,  2074,  5389,     0,     0,     0,     0,     0,
    3309,  1663,     0,     0,     0,  1564,     0,     0,     0,   632,
       0,     0,     0,     0,     0,  1565,     0,   896,     0,   896,
       0,     0,     0,  3426,  1566,     0,   784,     0,   786,     0,
    5909,     0,   792,  1530,     0, -2674,  1567,   800,   808,   812,
       0,   815,     0,     0,   808,   808,     0,   845, -2674,   848,
     953,     0,   978,     0, -2674,  5549,   904,   904,   904,     0,
   -2674,     0,  5767,  5768,     0,  1532, -2674,     0,  5551, -2674,
       0,     0,     0, -2674,     0,  1664,     0,     0,  1569,  1570,
       0,     0,   634,     0,     0,   634,  3426,     0,   634,   634,
     634,     0,     0,     0,     0,     0,  4202,     0,     0,     0,
    5594,     0,     0, -2674,  3423,     0,     0,    35,   978,  2776,
    1665,     0,  1534,   634,   634,     0,     0,   634,     0,     0,
       0,  1535,     0,     0,     0,     0,     0,     0,     0,     0,
    1536, -2674,     0,     0,     0,     0,     0,   634,  2777,     0,
    1124,     0,     0,   634,     0,     0,     0,   634,     0,     0,
    1538,     0,     0,   896,   634,     0,     0,     0,     0,  1539,
       0,     0,  6239,  1540,     0,     0,  3551,   634,     0,     0,
     634,     0,     0,     0,     0,   953,     0,   953,     0,  1572,
   -2674,   634,     0, -2674,     0,     0,     0,     0,     0, -2674,
       0,     0,     0,     0,     0,  6123,     0,     0,     0,  5508,
     632,   933,   933,     0,     0,   933,     0,     0,     0,   944,
       0,   845,     0,     0,   980,     0,     0,   944,  1541,  5892,
     944,  5894,     0,   845,     0,   933,   896,   953,   845,     0,
       0,     0,   933,     0,   845,     0,     0,   634,     0,     0,
       0,     0,     0,     0,     0,   774, -2674,     0,     0,  3426,
       0,     0,  6224,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   774,     0,     0,     0,     0,     0,  1795,     0,     0,
    3423,     0,   634,  6249,     0,   774,     0,     0,     0,     0,
       0,     0,  5771,     0,     0,     0,   774,     0,  6224,     0,
    3423,     0,     0,   789,  3691,     0,     0,  3694,     0,     0,
       0,     0,     0,     0,  3423,     0,  6224,     0,     0,     0,
       0,  5632,     0,     0,     0,     0,     0,  6176,  6177,     0,
       0, -2674,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3426,   634,  5660,     0,   896,     0,
       0,     0,  5658,     0,     0, -2674,     0, -2674, -2674,     0,
       0,     0,    71,   191,   180,   181,   186,   175,     0,   184,
      80,   183,  1202,  1203,    83,    84,    85,    86,   631, -2674,
     106,   634,   124,   129,     0,   634,   908,   634,     0,   159,
       0,   178,   185,     0,     0,     0,  3787,     0,     0, -2674,
       0,   634, -2674, -2674, -2674,     0,     0,     0,   634,  3800,
    1124,   634,     0,     0,     0,     0,     0,  3809,     0,     0,
       0,     0,   634,     0,     0,     0,  3265,  3265,     0,   634,
       0,  3265,     0,     0,     0,     0,     0,   187,     0,     0,
       0,     0,     0,     0,     0,  3426,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3853,     0,     0,     0,
     774,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3265,  3265,     0,     0,   634,  3877,  3423,     0,
       0,     0,   896,     0,   187,     0,     0,   896,   896,     0,
       0,     0,   634,     0,     0,     0,     0,  3478,   634,   634,
     953,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   774,   953,  3494,     0,     0,  3234,  3497,
    3932,     0,  3934,  3500,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   634,     0,     0,     0,  3283,     0,
       0,  3423,     0,   634,     0,     0,  1795,     0,   978,     0,
       0,  3526,     0,     0,     0,     0,     0,  1524,     0,     0,
       0,     0,  1554,     0,     0,     0,     0,     0,  1555,   931,
       0,   634,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,  1661,  5827,  3568,   943,     0,     0,   943,
       0,     0,  1525,     0,     0,     0,  3426,     0,     0,     0,
     896,   896,     0,     0,     0,  1079,     0,     0,     0,     0,
    3989,     0,     0,  1557,     0,     0,     0,  3996,     0,     0,
       0,     0,     0,     0,   634,     0,     0,     0,  6175,     0,
       0,     0,     0,   634,   634,   634,     0,  3618,     0,     0,
       0,     0,     0,     0,     0,     0,   634,  1795,  1033,     0,
     896,     0,     0,  1526,   845,   634,   933,   634,   933,   634,
       0,   933,     0,     0,  3647,     0,   634,  1662,   980,  1558,
    3656,     0,  6044,  1091,  5899,   933,  1559,     0,     0,  1560,
       0,   933,     0,     0,  3666,     0,     0,  3426,   634,     0,
    1527,  1079,     0,  3426,  3679,     0,     0,     0,     0,     0,
    3684,     0,     0,     0,  3423,   632,  1561,     0,     0,     0,
       0,     0,     0,  1795,   944,   953,     0,     0,   980,     0,
    3697,   944,     0,     0,   944,     0,  3700,  3312,  6242,     0,
       0,     0,     0,  3706,     0,  1528,     0,     0,     0,     0,
     933,     0,  1562,     0,  6094,  6095,     0,  3721,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3747,     0,     0,     0,     0,     0,   634,   774,     0,
       0,     0,  1079,  1529,   774,     0,     0,  1530,     0,   774,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   845,     0,     0,     0,  3426,     0,  3423,
       0,     0,  1235,     0,   634,     0,  5303,  5304,  1531,  1532,
       0,  5307,  5308,     0,     0,  1663,     0,   634,     0,  1564,
       0,     0,  1361,  1361,     0,   845,   808,   634,     0,  1565,
     808,     0,     0,     0,     0,     0,     0,   634,  1566,     0,
     953,     0,     0,     0,   845,     0,     0,  1533,     0,   845,
    1567,    35,     0,     0,   634,  1361,  1534,     0,     0,     0,
       0,     0,     0,     0,     0,  1535,     0,   953,     0,     0,
       0,     0,     0,     0,  1536,     0,     0,     0,     0,     0,
       0,     0,  1537,     0,     0,     0,     0,     0,     0,  3711,
       0,     0,  1569,  1570,  1538,     0,     0,     0,     0,     0,
    3423,     0,  1361,  1539,     0,     0,     0,  1540,   634,     0,
       0,  6068,     0,     0,     0,     0,   845,     0,   634,     0,
       0,     0,     0,     0,  3712,     0,   634,   634,     0,   845,
       0,     0,   634,   191,  6089,  6090,  6092,     0,     0,     0,
       0,  6091,     0,     0,   845,     0,     0,     0,     0,     0,
       0,   634,   634,     0,     0,     0,     0,  4265,  4266,     0,
       0,     0,  1541,   845,     0,     0,     0,     0,   933,   933,
       0,     0,     0,     0,     0,     0,  6155,     0,     0,     0,
       0,     0,     0,     0,     0,   953,     0,  3965,     0,     0,
       0,     0,     0,  1572,     0,     0,     0,     0,  6257,  6258,
     808,   808,     0,     0,     0,     0,  3981,     0,     0,   634,
       0,     0,     0,  3965,     0,   634,     0,     0,     0,     0,
   -2690,     0,     0,  1361,  1361,     0,     0,   191,  6089,  6090,
    6092,     0,     0,   634,   634,  6091,     0,   632,     0,   933,
       0,     0,     0,   944,     0,     0,   980,   944,   634,   944,
       0,  3423,     0,     0,   933,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   634,     0,     0,  3312,     0,     0,
       0,     0,     0,     0,   931,     0,     0,     0,   845,     0,
       0,     0,     0,   943,     0,   933,   933,     0,     0,     0,
     943,     0,     0,   943,     0,     0,     0,     0,     0,   634,
       0,  3416,     0,     0,     0,     0,     0,   845,   845,   845,
       0,   933,     0,   632,     0,   632,   632,     0, -2690,   634,
       0,     0,     0,     0,     0,     0,  1795,     0,     0,     0,
       0,   191,  6089,  6090,  6092,     0,     0,  3900,     0,  6091,
       0,     0,  3423,     0,     0,     0,   187,     0,  3423,   933,
       0,   933,   933,     0,     0,     0,     0,     0,     0,   634,
     634,  1524,     0,     0,   634,     0,     0,     0,   634, -2690,
       0,     0,  1795,     0,     0,     0,     0,     0,     0,     0,
     634,   634, -2690,     0,  1361,     0,     0,     0, -2690,     0,
    1795,     0,     0,     0, -2690,     0,  1525,     0,     0,  4436,
   -2690,  3241,     0, -2690,     0,     0,     0, -2690,   774,     0,
    1978,     0,  1978,     0,     0,     0,   845,     0,   784,     0,
       0,  3265,  3265,  3265,  3265,     0,     0,  3265,  3265,  3265,
    3265,  3265,  3265,  3265,  3265,  3265,  3265, -2690,     0,     0,
       0,     0,  2014,     0,   845,     0,     0,     0,  2020,     0,
       0,     0,  3423,     0,     0,  4692,     0,  1526,     0,     0,
       0,     0,  1361,     0,     0, -2690,     0,     0,     0,     0,
     701,     0,     0,     0,     0,  3196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3265,  3265,     0,  1527,     0,     0,     0,     0,     0,
    1361,     0,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -2690,     0,     0, -2690,     0,     0,
       0,     0,     0, -2690,     0,     0,   704,  3197,     0,  1361,
    1361,  1361,     0,  1361,  3901,     0,  4750,  1525,     0,  1528,
       0,     0,   705,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1361,     0,  4261,     0,     0,  4589,
    1038,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2690,  1530,     0,     0,  3198,     0,     0,     0,     0,     0,
       0,     0,     0,   845,     0,   708,     0,     0,  1526,     0,
       0,     0,     0,     0,   709,     0,   931,     0,     0,     0,
       0,  1361,   943,  1532,     0,     0,   943,   710,   943,     0,
       0,     0,     0,  3199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1527,     0,   789,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,     0,     0,    35,  4333,  1361,     0,     0,
    3902,  1361,  1361,     0,     0, -2690,     0,     0,     0,  1535,
       0,     0,   845,   845,   845,  2672,     0,  1361,  1536,     0,
    1528,     0,  1889,  3200,  1891,  1892,  2777,     0,     0, -2690,
       0, -2690, -2690,     0,     0,     0,   774,     0,  1538,     0,
     808,     0,     0,     0,     0,   714,     0,  1539,     0,     0,
       0,  1540,     0, -2690,     0,     0,     0,     0,  1529,     0,
       0,     0,  1530,     0,     0,     0,     0,     0,     0,     0,
       0,  3903,     0, -2690,     0,  2765, -2690, -2690, -2690,  1554,
     808,   187,     0,   933,     0,  1555,     0,     0,     0,     0,
       0,     0,  1621,  1595,  1532,     0,   845,  2793,     0,     0,
       0,     0,     0,     0,     0,   845,  1541,  1554,   933,     0,
    3904,     0,     0,  1555,  1622,     0,     0,     0,     0,     0,
     213,  3201,     0,     0,   719,  4428,     0,     0,  1556,     0,
    1557,     0,  1596,     0,     0,   980,    35,   845,     0,     0,
     808,  1534,     0,  2861,  2861,     0,     0,  2861,     0,     0,
    1535,  1045,     0,     0,  3202,     0,     0,   808,  1557,  1536,
     845,   723,     0,   845,     0,  1623,     0,  1597,   724,     0,
       0,   725,  3265,     0,     0,     0,     0,     0,     0,  1538,
       0,     0,     0,     0,     0,   933,  1558,     0,  1539,     0,
     726,     0,  1540,  1559,     0,     0,  1560,  1047,     0,     0,
       0,     0,     0,   845,   728,     0,     0,  1048,     0,     0,
       0,   730,     0,     0,  1558,   933,   933,   933,   933,   845,
       0,  1559,     0,  1561,  1560,     0,  3203,  5934,     0,     0,
       0,     0,     0,   845,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1361,  1361,  1361,  1541,     0,     0,
       0,  1561,   735,     0,     0,  1624,     0,     0,     0,  1562,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2072,     0,     0,     0,     0,     0,  1562,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2950,     0,     0,     0,     0,     0,
       0,     0,     0,  1625,     0,     0,     0,  1626,     0,     0,
       0,     0,     0,  4600,     0,     0,     0,  4604,     0,  2072,
       0,     0,  1627,     0,     0,     0,  1564,     0,     0,     0,
       0,     0,     0,   845,     0,     0,  1565,     0,     0,     0,
       0,     0,     0,  3312,   845,  1566,     0,     0,     0,     0,
    1563,     0,   933,   933,  1564,  1554,  1628,  1567,     0,  4133,
       0,  1555,     0,     0,  1565,     0,     0,     0,   933,     0,
       0,     0,     0,  1566,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1567,   845,  2861,  5165,     0,
       0,     0,     0,     0,  4989,     0,  1629,     0,     0,  1569,
    1570,  1630,   933,   933,   933,   933,  1557,     0,  4991,     0,
       0,   845,     0,     0,     0,     0,     0,     0,   845,     0,
    4167,  3075,     0,  4172,  1568,  1631,     0,  1569,  1570,     0,
       0,  1632,     0,     0,     0,     0,   632,     0,     0,   632,
       0,     0,     0,     0,     0,  1633,     0,     0,     0,   944,
     944,     0,     0,     0,     0,     0,     0,     0,     0,  1571,
     980,   980,  1558,     0,   944,     0,     0,   944,     0,  1559,
    3416,     0,  1560,     0,   907,     0,     0,     0,  3416,     0,
       0,     0,   933,   933,     0,     0,     0,     0,     0,   933,
       0,   845,     0,     0,     0,     0,     0,     0,     0,  1561,
    1572,     0,     0,     0,     0,     0,     0,     0,  1978,     0,
       0,     0,     0,     0,     0,   933,     0,   944,     0,     0,
    3158,   944,   944,     0,   845,   845,     0,   933,  1572,     0,
       0,     0,     0,     0,   845,  1562,     0,     0,     0,     0,
       0,   845,     0,     0,   845,  3075,     0,     0,   784,     0,
       0,   784,  3195,     0,     0,     0,  1361,     0,  1361,     0,
       0,     0,     0,  1361,  1361,     0,     0,     0,     0,     0,
    1361,  1361,  1361,  1361,  1361,  1361,  1361,  1361,  1361,  1361,
       0,     0,  1361,     0,  1361,   980,  1361,  1361,  1361,  1361,
    1361,  1361,     0,  -136,  1361,     0,  1361,  1361,     0,     0,
    1361,     0,     0,     0,     0,     0,     0,     0,  1663,     0,
       0,     0,  1564,     1,     0,  1361,  1361,  1361,     0,     0,
       0,     0,  1565,  4834,     2,     0,     3,     4,     0,     0,
       0,  1566,     0,  1361,     0,     0,  1554,     0,  6222,     0,
       0,     0,  1555,  1567,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     0,     8,     9,
     700,     0,     0,   933,  3900,    10,     0,    11,     0,   788,
       0,     0,  1691,     0,  6222,  1569,  1570,  1557,     0,    12,
       0,    13,     0,     0,     0,     0,     0,     0,  1524,     0,
       0,     0,  6222,     0,     0,     0,     0,     0,    14,     0,
       0,    15,     0,     0,     0,     0,     0,  1692,     0,     0,
       0,     0,     0,     0,     0,     0,    16,  2080,    17,     0,
    2081,     0,    18,  1525,  2082,  2083,  2084,     0,    19,     0,
       0,     0,     0,  1558,     0,     0,    20,     0,    21,     0,
    1559,  4947,  2584,  1560,  4950,    22,     0,     0,     0,     0,
       0,     0,  2585,     0,     0,     0,     0,     0,     0,  2586,
       0,     0,     0,    23,     0,     0,     0,  1361,     0,     0,
    1561,     0,     0,     0,     0,     0,  1572,     0,     0,     0,
      24,     0,     0,     0,  1526,  2587,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   931,     0,     0,   931,     0,
       0,     0,     0,     0,     0,     0,  1562,     0,   943,   943,
       0,     0,     0,     0,     0,     0,  1361,     0,     0,  1524,
       0,  1527,     0,   943,     0,     0,   943,     0,     0,    25,
      26,     0,     0,     0,     0,    27,  3265,     0,     0,     0,
       0,     0,     0,     0,     0,  5032,     0,     0,     0,    28,
       0,     0,     0,     0,  1525,     0,     0,     0,     0,     0,
       0,  3901,  2950,     0,     0,     0,  1528,    29,     0,  1361,
       0,     0,     0,     0,     0,     0,   943,  5326,     0,  1663,
     943,   943,     0,  1564,   187,     0,     0,     0,  3265,     0,
       0,     0,  5330,  1565,     0,     0,     0,     0,     0,     0,
    2588,     0,  1566,     0,     0,  2589,     0,     0,  1530,     0,
       0,    30,     0,     0,  1567,  1526,     0,     0,     0,     0,
     187,     0,     0,     0,     0,    31,     0,     0,  2590,  2271,
       0,    32,    33,     0,    34,     0,     0,     0,     0,    35,
    1532,     0,     0,  3965,     0,    36,     0,     0,    37,     0,
       0,  2591,  1527,  2757,     0,    38,  1569,  1570,     0,     0,
       0,     0,    39,    40,     0,     0,     0,     0,     0,     0,
      41,     0,     0,     0,    42,     0,     0,     0,     0,     0,
       0,     0,    35,  5390,    43,     0,     0,  1534,  2758,     0,
       0,     0,  2331,     0,     0,     0,  1535,  1528,     0,     0,
      44,     0,     0,     0,     0,  1536,  2592,     0,     0,  2593,
       0,     0,     0,  2777,     0,     0,     0,     0,     0,     0,
      45,     0,     0,     0,     0,  1538,     0,     0,     0,     0,
       0,    46,     0,     0,  1539,  1529,     0,    47,  1540,  1530,
       0,     0,    48,     0,     0,     0,  1361,  1361,  1361,  1361,
    1361,  1361,  1361,  1361,  1361,    49,  1361,  1572,  3903,     0,
       0,     0,     0,     0,     0,     0,   845,  1361,     0,  1361,
    1612,  1532,     0,     0,     0,     0,   845,     0,     0,    50,
       0,    51,    52,    53,    54,    55,     0,     0,     0,     0,
       0,     0,     0,  1541,     0,     0,     0,  3904,    56,  2594,
       0,  -136,     0,     0,     0,   845,     0,  1361,     0,  1613,
     933,  1361,     0,    35,  1361,     0,  1361,     0,  1534,  1361,
       0,     0,     0,  1361,     0,     0,     0,  1535,     0,     0,
    2072,     0,  3265,     0,     0,     0,  1536,     0,     0,     0,
       0,     0,     0,     0,  1614,     0,  3427,     0,     0,     0,
       0,     0,   845,   845,     0,     0,  1538,   187,     0,     0,
       0,     0,  3265,  1361,     0,  1539,     0,     0,     0,  1540,
       0,     0,  1361,  1361,     0,     0,     0,  3416,     0,     0,
       0,  3416,  5527,     0,  5529,     0,   845,     0,     0,     0,
       0,     0,     0,     0,  3471,     0,  3476,  2080,     0,     0,
    2081,  2522,     0,     0,  2082,  2083,  2084,     0,     0,     0,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,
       0,     0,  2584,     0,  1541,     0,     0,  4030,  5300,     0,
       0,     0,  2585,     0,     0,     0,   784,     0,   784,  2586,
    5310,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1361,     0,     0,     0,
       0,     0,     0,     0,     0,  2587,     0,   632,     0,     0,
     944,   980,   944,   944,     0,     0,   933,     0,     0,   845,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1055,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     808,     0,     0,     0,  1554,     0,     0,     0,     0,     0,
    1555,  2793,     0,     0,     0,     0,     0,     0,     0,  3586,
     845,     0,     0,     0,     0,     0,  3597,     0,     0,     0,
       0,     0,     0,     0,     0,   845,     0,     0,     0,     0,
    1123,   700,  5659,     0,     0,     0,     0,     0,     0,     0,
       0,  2080,     0,     0,  2081,  1557,     0,   845,  2082,  2083,
    2084,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2584,     0,   845,     0,
    2588,     0,     0,     0,     0,  2589,  2585,     0,     0,     0,
       0,   808,     0,  2586,     0,     0,     0,  3265,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2590,  2271,
       0,  1558,     0,     0,   933,     0,     0,   933,  1559,  2587,
       0,  1560,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2591,     0,     0,     0,     0,  1222,     0,     0,     0,
       0,     0,     0,   845,   845,     0,     0,     0,  1561,     0,
       0,     0,     0,     0,     0,     0,  1244,  3965,  3740,     0,
    3743,  3745,     0,     0,  1364,     0,     0,  1373,  1123,  1375,
       0,     0,  2331,     0,     0,     0,     0,     0,     0,  1554,
       0,     0,     0,     0,  1562,  1555,  2592,     0,     0,  2593,
       0,     0,  1361,  1361,  1361,     0,     0,     0,  1361,     0,
       0,     0,     0,  5773,     0,  5775,   933,     0,     0,  3416,
       0,     0,     0,     0,     0,   631,     0,     0,     0,   933,
       0,     0,     0,     0,     0,  1361,     0,   933,     0,     0,
    1557,     0,     0,     0,  2588,   187,     0,     0,     0,  2589,
    2793,     0,     0,     0,     0,   845,     0,     0,     0,     0,
       0,  3847,     0,     0,   784,     0,     0,  1563,     0,     0,
       0,  1564,  2590,  2271,     0,     0,   933,  3858,  6014,     0,
       0,  1565,     0,     0,     0,     0,     0,  3740,     0,  2594,
    1566,     0,  3965,     0,  3965,  2591,  1558,   933,     0,  3880,
       0,     0,  1567,  1559,     0,     0,  1560,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2080,     0,
       0,  2081,     0,     0,     0,  2082,  2083,  2084,     0,     0,
       0,     0,     0,  1561,     0,     0,  2331,     0,   933,     0,
     933,  2835,   933,  2584,  1569,  1570,   931,     0,     0,   943,
    2592,   943,   943,  2585,     0,     0,     0,     0,     0,     0,
    2586,     0,     0,     0,     0,     0,     0,     0,     0,  1562,
       0,     0,     0,     0,     0,  1978,  2836,     0,     0,     0,
       0,     0,  1123,     0,     0,     0,  2587,     0,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,     0,     0,     0,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,
       0,     0,  3265,  3265,     0,     0,  4046,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   632,
     933,     0,   944,     0,   944,   944,     0,   933,     0,     0,
       0,     0,  1663,  2594,  1361,  1572,  1564,     0,     0,  1361,
       0,     0,     0,     0,     0,     0,  1565,     0,     0,     0,
       0,     0,  5964,  3416,     0,  1566,     0,     0,  3416,     0,
       0,  3416,     0,     0,     0,     0,     0,  1567,     0,  2080,
       0,     0,  2081,     0,     0,     0,  2082,  2083,  2084,     0,
       0,     0,   187,   187,  1361,  1361,  1361,     0,     0,  1361,
       0,  2588,     0,     0,  2584,     0,  2589,  1361,  1361,  1361,
    1361,     0,     0,     0,  2585,     0,  3578,     0,     0,  1569,
    1570,  2586,     0,  1361,     0,     0,  1361,     0,  1361,  2590,
    2271,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,  1361,     0,     0,  1361,  2522,     0,  2587,     0,     0,
       0,  1571,  2591,     0,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,   980,     0,  1361,     0,  1361,     0,  1361,
       0,     0,     0,  2003,     0,     0,     0,     0,  6049,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1361,     0,
       0,  4141,     0,  2331,     0,   845,     0,     0,     0,     0,
    1123,     0,     0,     0,     0,     0,     0,  2592,     0,     0,
    2593,     0,     0,     0,     0,     0,   845,     0,     0,     0,
    1572,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     895,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   632,   631,     0,  3427,  4178,
       0,     0,     0,  4178,  4192,  4178,     0,     0,     0,     0,
       0,  1361,  2588,     0,     0,     0,  1361,  2589,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,     0,     0,     0,  2076,     0,     0,  6129,     0,
    2590,  2271,     0,     0,  2078,  3427,     0,     0,     0,  4223,
    2594,     0,  4226,  3427,     0,  3476,     0,     0,     0,     0,
    2547,     0,     0,  2591,     0,     0,     0,     0,     0,  1096,
    1096,     0,     0,     0,     0,     0,     0,     0,     0,  1123,
       0,     0,  2564,  2565,     0,     0,     0,  1123,  1123,     0,
       0,     0,     0,     0,     0,     0,  1361,     0,     0,     0,
       0,  4252,     0,     0,  2331,  2080,     0,   187,  2081,     0,
       0,     0,  2082,  2083,  2084,     0,     0,     0,  2592,     0,
       0,  2593,     0,     0,     0,     0,     0,   933,   933,     0,
    2584,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2585,     0,     0,     0,     0,     0,     0,  2586,   931,     0,
       0,   943,  2522,   943,   943,     0,     0,     0,     0,     0,
       0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,
       0,     0,     0,  2587,  4044,  1096,     0,  4045,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2594,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   845,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2861,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3416,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2588,     0,
       0,     0,     0,  2589,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3965,     0,     0,
       0,     0,     0,  2522,     0,     0,  2590,  2271,     0,     0,
       0,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,
    2531,     0,     0,     0,     0,     0,     0,     0,  4097,  2591,
       0,     0,  2902,     0,     0,     0,     0,     0,     0,     0,
    2910,     0,  1361,     0,     0,     0,     0,     0,  1361,     0,
       0,     0,     0,     0,   631,     0,     0,   631,     0,   933,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2331,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2592,     0,     0,  2593,     0,     0,
       0,     0,   652,     0,     0,     0,   845,   845,   845,     0,
       0,     0,     0,     0,   631,     0,     0,     0,     0,     0,
     653,     0,   631,   845,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   187,     0,     0,  1361,     0,     0,
       0,     0,     0,     0,     0,   654,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1978,   845,   845,   655,     0,
       0,   845,     0,     0,     0,   187,     0,     0,     0,     0,
       0,     0,     0,   845,  -878,     0,     0,     0,     0,   187,
       0,     0,     0,     0,     0,     0,     0,  2594,     0,     0,
       0,     0,   656,     0,     0,     0,     0,     0,   657,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   881,     0,
       0,     0,     0,     0,     0,  2080,   658,     0,  2081,     0,
       0,     0,  2082,  2083,  2084,     0,     0,   659,     0,   933,
       0,     0,     0,     0,     0,     0,   660,     0,     0,     0,
    2584,     0,     0,  3158,  4599,     0,     0,     0,     0,   661,
    2585,     0,     0,  2072,   845,     0,     0,  2586,   662,     0,
       0,     0,   663,     0,     0,  3040,     0,   845,     0,  3045,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -1084,  2587,     0,     0,  1361,     0,     0,  2522,
       0,     0,     0,     0,     0,  1361,     0,     0,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,  1361,
       0,  3294,     0,  1361,  1361,     0,     0,     0,     0,  1361,
       0,     0,     0,     0,     0,     0,     0,   664,     0,  1361,
       0,  1361,     0,     0,  1361,     0,   895,  -613,     0,  1361,
    1361,  1361,  1361,     0,     0,  1361,  1361,  1361,  1361,  1361,
    1361,  1361,  1361,  1361,  1361,     0,     0,     0,  1361,  1361,
    1361,     0,   895,     0,     0,     0,     0,     0,  1361,     0,
       0,     0,     0,  1361,     0,     0,     0,  1361,   665,     0,
       0,   666,     0,     0,     0,  1361,     0,     0,  1361,     0,
    1361,     0,     0,     0,     0,  3416,     0,   187,  2588,     0,
       0,     0,   667,  2589,     0,     0,  1361,     0,     0,  1361,
    1361,     0,     0,     0,  1361,  1361,   668,     0,     0,  1361,
       0,  1361,  4731,  -464,     0,     0,  2590,  2271,     0,     0,
     845,   845,   845,     0,     0,     0,     0,     0,     0,  3228,
       0,     0,     0,   669,     0,     0,     0,     0,     0,  2591,
    4178,  4192,  4178,   670,  1361,  4178,     0,     0,  4752,     0,
    -464,     0,  3427,   671,     0,     0,  3427,     0,     0,     0,
       0,     0,  4767,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   672,     0,     0,     0,     0,   187,     0,   673,
    2331,     0,     0,     0,     0,     0,  -464,     0,  1361,   674,
     675,     0,   676,   677,  2592,   895,     0,  2593,     0,     0,
       0,     0,     0,  3476,     0,  1361,     0,     0,   678,     0,
    1554,     0,     0,     0,     0,   679,  1555,     0,   680,     0,
       0,   681,     0,  4815,  1978,     0,  1978,     0,     0,  1978,
       0,     0,     0,     0,  -464,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1557,     0,     0,  2793,  4848,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4872,     0,     0,     0,  2594,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,  2081,     0,
       0,     0,  2082,  2083,  2084,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1558,     0,     0,
    2584,     0,     0,     0,  1559,     0,     0,  1560,     0,     0,
    2585,     0,     0,     0,     0,     0,  4921,  2586,     0,  1710,
       0,     0,     0,     0,  2080,     0,     0,  2081,     0,     0,
       0,  2082,  2083,  2084,  1561,     0,     0,     0,   895,     0,
       0,     0,     0,  2587,     0,     0,     0,     0,     0,   895,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2585,
       0,     0,     0,     0,     0,   895,  2586,     0,     0,  2522,
    1562,  4965,     0,     0,     0,     0,     0,     0,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,     0,
       0,  4039,  2587,     0,   187,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   933,     0,     0,  2080,     0,     0,
    2081,     0,     0,     0,  2082,  2083,  2084,     0,   933,   187,
    1361,     0,     0,     0,     0,     0,     0,   845,     0,     0,
       0,     0,  2584,  5009,     0,     0,     0,     0,     0,     0,
       0,     0,  2585,  1663,  2793,     0,     0,  1564,     0,  2586,
       0,     0,     0,     0,     0,     0,     0,  1565,  2588,   845,
       0,     0,     0,  2589,  3427,  3858,  1566,     0,     0,     0,
       0,     0,  3740,     0,     0,  2587,     0,     0,  1567,  1554,
       0,  5058,     0,     0,     0,  1555,  2590,  2271,     0,     0,
       0,   845,     0,     0,     0,     0,     0,     0,     0,   893,
       0,   631,     0,  1361,  1361,   631,     0,  2588,     0,  2591,
       0,     0,  2589,  6154,  1361,     0,     0,  3758,     0,     0,
    1569,  1570,   895,     0,     0,  1978,   845,     0,     0,     0,
    1557,     0,     0,     0,  1136,  2590,  2271,     0,     0,     0,
       0,     0,     0,   845,     0,     0,     0,     0,     0,     0,
    2331,     0,  3759,     0,     0,     0,     0,     0,  2591,     0,
    1136,     0,     0,     0,  2592,     0,     0,  2593,     0,     0,
       0,     0,   631,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1361,     0,  1558,     0,     0,     0,
    2588,     0,   884,  1559,     0,  2589,  1560,     0,  1554,  2331,
    1361,     0,     0,     0,  1555,     0,     0,     0,     0,     0,
       0,     0,     0,  2592,     0,  1361,     0,   187,  2590,  2271,
       0,  1572,     0,  1561,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3375,     0,     0,     0,
       0,  2591,     0,  1361,     0,     0,  1361,     0,     0,  1557,
       0,     0,     0,     0,  1361,  1361,     0,  2594,     0,  1562,
       0,  1361,  1361,     0,     0,     0,  1361,     0,     0,     0,
       0,  1361,     0,     0,  1361,  1361,     0,     0,     0,     0,
       0,  1361,  2331,     0,     0,   845,   845,   845,   845,     0,
       0,     0,     0,     0,     0,     0,  2592,     0,     0,  2593,
       0,   632,     0,     0,  4178,  1558,  2594,     0,  3427,     0,
       0,     0,  1559,  3427,     0,  1560,  3427,   632,     0,  3740,
       0,  5219,     0,     0,  1361,     0,   980,     0,     0,     0,
       0,     0,  1663,     0,     0,  1361,  1564,     0,     0,  4223,
       0,     0,  1561,  1361,     0,  3476,  1565,     0,     0,     0,
       0,     0,     0,     0,     0,  1566,     0,     0,     0,  2522,
     784,     0,     0,  1361,     0,     0,     0,  1567,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,  1562,  2693,
       0,  4449,     0,     0,  1123,     0,     0,     0,     0,  2594,
       0,     0,     0,     0,     0,     0,     0,     0,  2793,     0,
       0,     0,  5275,     0,     0,     0,  4277,     0,  2522,  1569,
    1570,     0,     0,     0,     0,     0,     0,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,     0,     0,     0,     0,
       0,     0,     0,   631,   631,     0,     0,     0,     0,     0,
       0,  4278,     0,     0,  1375,     0,  2693,     0,     0,     0,
       0,  1663,     0,     0,     0,  1564,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1816,     0,  1361,     0,
       0,     0,     0,     0,  1566,  1361,     0,  1825,     0,     0,
       0,     0,     0,     0,     0,     0,  1567,   895,     0,     0,
       0,  2522,     0,  1833,     0,     0,     0,   933,     0,     0,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,
    1572,     0,   933,  4635,     0,     0,     0,     0,     0,     0,
     895,     0,     0,     0,  1375,  4335,     0,     0,  1569,  1570,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1361,     0,     0,     0,     0,  1375,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   632,
    4336,     0,     0,     0,     0,     0,  2793,     0,     0,     0,
       0,  2080,     0,     0,  2081,  1978,     0,     0,  2082,  2083,
    2084,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3858,     0,     0,     0,     0,     0,  2584,     0,     0,     0,
    1710,  1710,  1710,   933,     0,  3880,  2585,     0,     0,     0,
       0,     0,  3746,  2586,     0,     0,  3750,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1572,
       0,   845,     0,     0,     0,     0,     0,     0,     0,  2587,
       0,     0,   845,     0,     0,     0,     0,     0,     0,     0,
    2004,     0,     0,  3783,     0,  3783,     0,  3783,  3783,     0,
       0,     0,  3783,  3783,  3783,     0,  3783,  3783,  3783,     0,
     631,     0,     0,     0,     0,     0,     0,   631,     0,     0,
       0,     0,   631,     0,     0,   631,  5215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,     0,     0,  1361,     0,     0,  1361,  1361,  1361,
       0,     0,   895,     0,     0,     0,     0,     0,     0,     0,
    3860,     0,     0,   895,     0,     0,     0,     0,     0,     0,
       0,     0,  1361,  1361,     0,     0,  1361,     0,     0,   895,
       0,     0,     0,     0,     0,  3888,     0,     0,     0,     0,
       0,     0,     0,     0,  2588,   893,  1361,     0,     0,  2589,
       0,     0,  1361,     0,     0,     0,  3427,     0,     0,     0,
    5219,     0,     0,  1361,     0,  5505,     0,     0,     0,     0,
       0,   893,  2590,  2271,     0,     0,  4815,     0,     0,  1361,
       0,     0,     0,   895,     0,     0,     0,     0,     0,     0,
    4815,   980,   933,     0,   933,  2591,     0,     0,   895,     0,
       0,   895,   895,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   895,   895,     0,     0,  2331,     0,   884,     0,
       0,     0,     0,     0,     0,     0,   944,   980,     0,     0,
    2592,     0,  2080,  2593,     0,  2081,     0,     0,     0,  2082,
    2083,  2084,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2585,     0,     0,
       0,   944,     0,     0,  2586,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5009,     0,     0,     0,     0,
     845,     0,     0,     0,   893,   845,     0,     0,  5361,     0,
    2587,     0,     0,     0,  2793,     0,     0,     0,     0,     0,
       0,  1710,     0,     0,   845,     0,     0,     0,  5058,     0,
       0,  5647,  1710,  2594,     0,  1710,     0,     0,     0,   631,
       0,     0,   933,   845,  4815,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     895,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,     0,     0,     0,  1361,     0,  1361,     0,     0,     0,
       0,     0,     0,     0,     0,  2842,  2080,   884,     0,  2081,
    1361,     0,     0,  2082,  2083,  2084,     0,   632,     0,     0,
    1361,     0,     0,     0,  5716,     0,     0,     0,     0,     0,
       0,  1361,     0,     0,     0,  2588,     0,     0,  1361,  1123,
    2589,  2585,     0,     0,     0,  2522,     0,     0,  2586,     0,
       0,     0,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,  2590,  2271,     0,     0,  4705,     0,     0,
       0,     0,     0,   845,  2587,     0,     0,   893,     0,     0,
       0,     0,     0,     0,     0,  1361,  2591,     0,   893,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,     0,     0,   893,     0,     0,  1361,  1361,     0,
       0,     0,   933,   933,   933,   933,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   631,     0,  2331,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2592,     0,  1361,  2593,   631,     0,     0,     0,     0,
       0,     0,   632,     0,     0,     0,     0,     0,     0,   631,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,   845,     0,     0,
    3427,   884,     0,     0,     0,     0,     0,     0,     0,  2588,
       0,     0,     0,     0,  2589,     0,     0,   884,     0,     0,
       0,  1123,     0,     0,  2080,   845,     0,  2081,     0,     0,
       0,  2082,  2083,  2084,     0,   943,     0, -2903, -2903,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2584,
    2981,     0,  4006,  1361,  2594,     0,     0,     0,     0,  2585,
    2591,  2992,  1361,  1361,  1361,     0,  2586,     0,  1978,     0,
       0,     0,  3740,     0,     0,  1361,     0,  3010,     0,     0,
     943,   893,     0,     0,  1361,     0,  1361,     0,  1361,  5505,
       0,     0,  2587,     0,     0,  4815,     0,     0,     0,  4325,
       0, -2903,     0,     0,     0,  1978,     0,   980,     0,     0,
       0,     0,     0,     0,     0,  2592,     0,  1361,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3084,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   631,     0,     0,  3096,     0,     0,  1136,
    3100,     0,  1978,  1978,     0,     0,  2522,  4372,     0,     0,
       0,     0,     0,     0,     0,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,   884,     0,     0,     0,  4809,     0,
    3119,  1136,   933,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5978,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   631,  2588,  2594,     0,
       0,     0,  2589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4415,     0,     0,     0,     0,
       0,     0,     0,  1361,     0,  2590,  2271,  2563,     0,     0,
       0,     0,     0,     0,     0,     0,  1361,     0,     0,     0,
    5716,     0,     0,     0,     0,  1710,  1361,     0,  2591,     0,
       0,     0,     0,     0,     0,  3476,  1361,     0,     0,     0,
       0,     0,     0,  3783,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,  4446,  4446,     0,     0,     0,
       0,     0,     0,     0,     0,  4462,     0,     0,   933,  2331,
    1123,     0,  1123,     0,     0,  1978,     0,     0,     0,     0,
    2522,     0,     0,  2592,     0,     0,  2593,     0,  3298,  2523,
    2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,
    2793,     0,     0,     0,     0,   701,     0,  1361,   893,     0,
    2744,  5810,     0,     0,     0,     0,     0,  4815,  4517,     0,
       0,     0,     0,     0,     0,   944,   944,  6097,     0,     0,
       0,  1361,     0,     0,     0,     0,     0,     0,     0,   631,
       0,     0,     0,  1978,  1978,  6107,     0,     0,  2745,     0,
    1361,  1361,     0,  4553,  1123,     0,  6113,     0,     0,     0,
       0,   704,  3483,     0,     0,     0,  2693,  3489,     0,     0,
       0,     0,     0,     0,     0,   893,  2594,   705,   933,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1038,     0,     0,     0,     0,
       0,   884,     0,     0,     0,     0,     0,     0,  5978,   933,
     933,     0,     0,     0,  4815,     0,   893,     0,     0,  2746,
       0,     0,     0,     0,     0,   895,     0,     0,     0,     0,
     708,   895,   632,  1361,   631,     0,     0,     0,     0,   709,
       0,     0,     0,     0,     0,     0,     0,  1361,     0,   893,
       0,     0,   710,     0,     0,     0,     0,     0,  2747,     0,
       0,     0,     0,  1361,     0,     0,     0,     0,   884,     0,
       0,     0,   895,     0,     0,     0,     0,     0,  2522,     0,
       0,     0,     0,     0,     0,  1041,     0,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,  6193,  6194,   632,  6198,
    5716,     0,     0,  3476,     0,     0,     0,     0,     0,   884,
       0,     0,     0,     0,     0,   933,     0,     0,  4815,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   631,     0,     0,     0,  4223,
     714,     0,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4706,     0,     0,     0,  1361,   632,
       0,     0,     0,  1361,     0,     0,     0,   632,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   944,
     944,  2748,     0,  6260,     0,     0,     0,     0,     0,   640,
       0,     0,     0,     0,     0,   689,   640,     0,     0,     0,
       0,   741,     0,   640,     0,     0,     0,     0,     0,   640,
       0,   794,     0,     0,     0,   213,  2749,     0,     0,   719,
       0,     0,   943,     0,     0,     0,     0,     0,     0,     0,
     856,   856,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   893,     0,     0,     0,     0,  1045,     0,     0,  2750,
    1710,     0,   893,     0,     0,     0,   723,     0,     0,     0,
       0,     0,     0,   724,     0,     0,   725,     0,   893,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   895,     0,     0,   726,   631,     0,     0,     0,
       0,     0,  1047,     0,   943,   943,     0,     0,     0,   728,
       0,     0,  1048,     0,     0,     0,   730,     0,     0,     0,
       0,     0,     0,     0,  2751,     0,     0,     0,     0,     0,
       0,  2752,   893,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,   893,     0,     0,
     893,   893,     0,     0,     0,   884,     0,   735,     0,     0,
       0,     0,     0,     0,     0,  2693,     0,     0,     0,  2693,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   893,   893,     0,     0,     0,     0,   631,     0,     0,
       0,   935,  4462,   631,     0,   939,     0,     0,     0,     0,
       0,     0,     0,   982,     0,     0,   984,     0,     0,   989,
     990,  6159,   993,     0,   996,     0,     0,  1002,  4911,  1004,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,  4925,     0,     0,  4926,     0,  4927,     0,
     884,     0,     0,   884,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   895,     0,   884,   884,     0,  6196,     0,     0,
       0,     0,     0,     0,  4967,     0,  2080,   895,     0,  2081,
       0,     0,   895,  2082,  2083,  2084,     0,   631,     0,     0,
    3783,     0,     0,     0,     0,  3783,     0,     0,     0,     0,
       0,  2584,     0,     0,     0,     0,     0,     0,     0,   893,
       0,  2585,   895,     0,     0,     0,     0,     0,  2586,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6196,     0,
       0,     0,     0,     0,     0,     0,  6245,     0,     0,     0,
       0,     0,     0,     0,  2587,     0,     0,     0,   943,   943,
    -136,     0,     0,  3542,     0,     0,     0,     0,     0,  3550,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     0,     3,     4,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5072,     0,     0,  4462,     0,     0,
    3583,     5,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     6,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     7,     0,     8,     9,     0,     0,     0,
       0,     0,    10,     0,    11,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2588,
       0,     0,     0,     0,  2589,    14,     0,     0,    15,     0,
       0,     0,     0,  5121,  5121,  5121,  5121,     0,  5121,  5121,
    5121,  5121,  5121,    16,     0,    17,     0,  2590,  2271,    18,
       0,     0,     0,     0,     0,    19,     0,     0,     0,     0,
       0,     0,   886,    20,     0,    21,     0,     0,     0,     0,
    2591,     0,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    24,     0,     0,
       0,  2331,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2693,     0,     0,  3489,  2592,  3489,     0,  2593,     0,
       0,  2693,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5196,     0,  5198,    25,    26,     0,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
    3808,     0,     0,     0,     0,     0,    28,     0,     0,     0,
     895,     0,     0,     0,     0,     0,  1032,     0,   895,     0,
       0,     0,     0,     0,    29,     0,     0,  1069,     0,     0,
       0,  1073,     0,     0,     0,     0,     0,     0,  1086,  1087,
       0,     0,  1093,  2693,  1097,  1098,     0,     0,  2594,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1120,
       0,     0,     0,     0,     0,     0,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,  1133,     0,     0,
       0,     0,    31,     0,     0,     0,     0,     0,    32,    33,
       0,    34,     0,     0,     0,     0,    35,     0,  1161,     0,
    1163,     0,    36,     0,     0,    37,     0,     0,     0,     0,
    1179,     0,    38,   895,     0,   895,     0,     0,     0,    39,
      40,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    43,     0,   640,     0,     0,     0,     0,     0,     0,
    2522,     0,     0,     0,     0,     0,     0,    44,     0,  2523,
    2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,
       0,     0,  5038,     0,     0,     0,     0,    45,     0,     0,
    3980,     0,     0,     0,     0,     0,     0,     0,    46,     0,
       0,     0,     0,     0,    47,  3990,     0,     0,     0,    48,
    3995,     0,     0,     0,     0,  5331,  5332,     0,     0,   895,
       0,     0,    49,     0,     0,     0,     0,     0,  3783,     0,
    3783,  3783,  3783,     0,   856,     0,  2080,     0,     0,  2081,
    4021,     0,     0,  2082,  2083,  2084,    50,     0,  1710,     0,
       0,     0,     0,     0,  1710,     0,     0,     0,     0,     0,
       0,  2584,     0,   895,     0,    56,     0,     0,  -136,     0,
       0,  2585,  2080,     0,     0,  2081,     0,     0,  2586,  2082,
    2083,  2084,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3489,     0,     0,     0,     0,  5385,  2584,     0,     0,
       0,     0,     0,     0,  2587,     0,     0,  2585,     0,     0,
       0,   893,     0,     0,  2586,   893,   893,     0,     0,  1515,
       0,  2080,     0,     0,  2081,     0,     0,     0,  2082,  2083,
    2084,     0,     0,     0,     0,  5413,     0,     0,     0,     0,
    2587,     0,     0,     0,     0,     0,  2584,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2585,     0,     0,   895,
       0,     0,     0,  2586,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   893,     0,     0,     0,  5121,     0,
     893,  3489,     0,     0,     0,     0,     0,     0,     0,  2587,
       0,     0,     0,  1694,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   895,   884,     0,     0,     0,   884,   884,
       0,     0,     0,     0,     0,     0,     0,     0,  1815,  2588,
       0,   893,     0,     0,  2589,     0,     0,     0,     0,     0,
       0,     0,     0,  1827,     0,  1828,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1831,     0,  2590,  2271,     0,
       0,     0,  1841,     0,     0,  2588,     0,     0,     0,     0,
    2589,     0,     0,     0,     0,     0,     0,   884,     0,     0,
    2591,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2590,  2271,   895,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1893,     0,  1895,     0,     0,
       0,     0,     0,     0,  2588,     0,  2591,     0,     0,  2589,
       0,  2331,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2592,     0,     0,  2593,     0,
       0,     0,  2590,  2271,   895,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4462,     0,  2331,  4264,     0,
       0,     0,     0,     0,     0,  2591,  4267,     0,   886,   895,
       0,  2592,     0,     0,  2593,     0,     0,     0,     0,     0,
       0,   640,     0,   640,     0,   640,     0,   640,     0,   640,
     640,   640,     0,     0,   886,     0,   640,     0,     0,     0,
       0,  3783,     0,     0,     0,     0,  2331,     0,  1999,     0,
    5593,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2592,     0,     0,  2593,     0,     0,     0,     0,  2594,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   893,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4350,     0,  4352,  2594,  2080,     0,     0,  2081,     0,
       0,     0,  2082,  2083,  2084,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2584,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2585,     0,     0,     0,     0,     0,     0,  2586,     0,     0,
       0,     0,     0,  2594,   893,     0,     0,     0,   893,     0,
       0,     0,     0,     0,     0,     0,     0,  2693,     0,     0,
    2522,     0,     0,  2587,   884,     0,     0,   886,     0,  2523,
    2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,
       0,     0,  5147,     0,     0,     0,     0,  4413,     0,     0,
       0,     0,     0,     0,     0,     0,  2522,     0,     0,     0,
       0,     0,     0,     0,     0,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,     0,     0,     0,     0,  5184,     0,
       0,     0,   856,     0,     0,     0,     0,     0,     0,     0,
       0,  4435,     0,     0,     0,     0,     0,   884,     0,     0,
       0,   884,     0,     0,     0,  2522,     0,     0,  3489,     0,
       0,   893,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,     0,     0,     0,   893,  5188,     0,     0,
       0,   893,     0,  1123,  3489,     0,     0,  5786,  2588,     0,
       0,     0,     0,  2589,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   893,     0,     0,     0,     0,  2590,  2271,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3583,     0,  2591,
     886,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,  2755,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   886,     0,   884,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
    2331,  4577,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2592,     0,     0,  2593,     0,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,   945,
     955,     0,     0,     0,     0,     0,     0,   945,     0,   955,
     945,     0,     0,     0,  2847,     0,   895,     0,     0,     0,
       0,     0,     0,   955,  2080,     0,     0,  2081,     0,     0,
       0,  2082,  2083,  2084,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2584,
       0,     0,     0,  4634,     0,     0,     0,     0,     0,  2585,
       0,     0,  2080,  3489,     0,  2081,  2586,     0,  2693,  2082,
    2083,  2084,     0,     0,  1123,     0,     0,  2594,  5940,     0,
    5941,     0,     0,     0,  5947,  5948,     0,  2584,     0,     0,
       0,     0,  2587,     0,     0,     0,     0,  2585,     0,     0,
       0,     0,  4663,     0,  2586,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4684,     0,     0,
    2587,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     893,     0,     0,   893,     0,   893,     0,     0,     0,     0,
     893,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2522,
       0,     0,     0,     0,     0,     0,     0,     0,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,     0,
       0,  5445,     0,     0,     0,     0,     0,  2588,     0,   893,
       0,     0,  2589,     0,     0,     0,     0,   893,     0,     0,
       0,     0,     0,   895,     0,     0,     0,     0,     0,     0,
    2978,     0,     0,     0,     0,  2590,  2271,     0,     0,     0,
       0,     0,   893,   884,     0,  2588,   884,     0,   884,     0,
    2589,     0,     0,   884,     0,     0,     0,     0,  2591,     0,
       0,     0,     0,     0,     0,  3014,     0,     0,     0,     0,
       0,     0,     0,  2590,  2271,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,  2331,
       0,     0,   884,     0,     0,     0,     0,     0,     0,     0,
     884,  3079,   893,  2592,   893,     0,  2593,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3097,     0,     0,     0,   884,     0,  2331,     0,     0,
       0,     0,     0,     0,  1123,     0,     0,     0,   895,     0,
       0,  2592,     0,     0,  2593,     0,     0,  3117,     0,  3118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,  3127,     0,  3128,     0,     0,     0,
       0,     0,   640,     0,   640,     0,   640,     0,   640,   895,
     640,     0,     0,     0,   640,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,  2594,   884,   893,     0,
       0,   895,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,  2081,     0,
       0,  3187,  2082,  2083,  2084,     0,     0,   955,   886,     0,
       0,     0,     0,     0,  2594,     0,     0,     0,     0,     0,
    2584,     0,   893,     0,     0,     0,   955,     0,     0,     0,
    2585,  2080,   955,     0,  2081,     0,     0,  2586,  2082,  2083,
    2084,     0,     0,     0,   955,     0,     0,     0,     0,   886,
     893,     0,     0,   895,     0,  6223,  2584,     0,     0,  2547,
     955,     0,     0,  2587,     0,     0,  2585,     0,     0,     0,
       0,   884,     0,  2586,   945,   955,     0,     0,  2522,     0,
       0,   945,   886,   955,   945,     0,     0,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,     0,   955,     0,  2587,
    5456,  6223,     0,     0,     0,     0,     0,   955,     0,     0,
       0,     0,     0,     0,  5021,   884,  2522,     0,   893,  6223,
       0,     0,  5196,     0,     0,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,     0,     0,     0,     0,  5466,     0,
     893,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2080,     0,     0,  2081,
     955,     0,   893,  2082,  2083,  2084,     0,     0,     0,     0,
       0,     0,  5417,     0,   895,     0,     0,     0,  2588,     0,
       0,  2584,     0,  2589,     0,     0,     0,     0,   955,     0,
       0,  2585,     0,     0,     0,     0,     0,     0,  2586,     0,
       0,     0,     0,     0,     0,     0,  2590,  2271,     0,     0,
       0,   884,     0,   955,  2588,     0,     0,     0,     0,  2589,
       0,     0,     0,     0,  2587,     0,     0,     0,     0,  2591,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,  2590,  2271,   893,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2591,     0,     0,     0,     0,
    2331,     0,     0,     0,   886,   955,     0,     0,     0,     0,
       0,     0,     0,     0,  2592,   886,     0,  2593,     0,     0,
       0,     0,     0,   893,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,  2331,     0,   895,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   893,     0,
    2592,     0,     0,  2593,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,  2588,
       0,     0,     0,     0,  2589,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   886,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2590,  2271,     0,
     886,     0,     0,   886,   886,     0,     0,  2594,     0,     0,
       0,  3489,     0,     0,     0,  1797,   884,     0,     0,     0,
    2591,     0,   955,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   945,   886,   886,     0,   945,     0,   945,
       0,   884,     0,  2594,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2331,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2592,  5263,     0,  2593,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   893,     0,     0,  2522,
       0,     0,     0,     0,     0,     0,     0,  5289,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,     0,
       0,  5521,     0,  3489,     0,     0,     0,     0,     0,  5305,
       0,     0,     0,     0,     0,  2522,   955,     0,     0,     0,
       0,     0,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,     0,     0,     0,     0,  5557,  2594,     0,
       0,     0,   886,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   893,     0,   884,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,  5333,     0,     0,     0,     0,     0,     0,   955,     0,
       0,     0,     0,   893,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   955,     0,     0,     0,     0,
     955,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   895,   887,     0,
    2522,     0,   895,   895,     0,     0,     0,     0,     0,  2523,
    2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,
     884,     0,  5559,     0,   887,     0,     0,     0,  3479,  3480,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,  3495,  3496,     0,
    3498,  3499,     0,     0,     0,  3502,  3503,     0,     0,     0,
       0,     0,  5419,     0,     0,     0,     0,     0,     0,     0,
    3514,     0,     0,     0,     0,     0,     0,     0,  3524,     0,
       0,     0,  3527,  3528,     0,     0,  3531,  3532,     0,     0,
       0,     0,     0,  3537,     0,   893,     0,     0,     0,   955,
       0,     0,     0,     0,     0,  3552,     0,   955,   955,     0,
       0,     0,     0,     0,     0,  5417,   895,  3569,     0,     0,
       0,     0,  3571,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1554,     0,  3577,     0,     0,
       0,  1555,   893,     0,     0,     0,  3584,   893,  1621,  3588,
       0,  3590,  3593,  3595,     0,     0,     0,     0,  3603,  3606,
    1797,     0,     0,     0,     0,   895,     0,   887,  3619,     0,
    1622,     0,     0,     0,  3629,     0,     0,     0,  3632,     0,
       0,     0,     0,     0,     0,     0,  1557,     0,   884,     0,
    3642,  3643,     0,     0,     0,  3648,  4413,     0,     0,     0,
       0,  3657,  3658,  2080,     0,     0,  2081,     0,     0,     0,
    2082,  2083,  2084,     0,     0,  3667,     0,     0,  3668,     0,
       0,  1623,     0,     0,     0,  3680,  3681,     0,  2584,     0,
       0,  3685,     0,     0,     0,   884,     0,     0,  2585,     0,
     884,     0,  1558,  3692,     0,  2586,  3695,     0,     0,  1559,
       0,  3698,  1560,     0,     0,     0,     0,  3701,  3702,  2080,
       0,     0,  2081,     0,     0,  3708,  2082,  2083,  2084,  3710,
       0,  2587,     0,  3717,  3718,  3719,  3720,     0,  3722,  1561,
       0,     0,     0,     0,  2584,     0,     0,     0,     0,     0,
       0,     0,  3748,  3749,  2585,  3751,     0,     0,     0,     0,
       0,  2586,   893,     0,     0,   954,  3761,  3762,  3763,     0,
       0,  1624,     0,     0,   954,  1562,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2587,   954,     0,
     887,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   889,     0,     0,     0,   887,     0,     0,
       0,     0,     0,  3815,     0,     0,     0,     0,     0,  1625,
       0,  3839,     0,  1626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2588,     0,  1627,     0,
    3851,  2589,  1564,     0,     0,   884,     0,     0,     0,     0,
       0,     0,  1565,     0,     0,     0,     0,     0,     0,   955,
       0,  1566,     0,     0,  2590,  2271,     0,     0,     0,     0,
       0,     0,  1628,  1567,     0,     0,     0,   893,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2591,     0,     0,
    3919,     0,  2588,     0,     0,     0,     0,  2589,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3933,
       0,  3935,  3686,     0,     0,  1569,  1570,  1630,   893,     0,
    2590,  2271,     0,     0,     0,     0,     0,     0,  2331,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     893,  1631,  2592,  2591,     0,  2593,     0,  3687,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,   886,   886,
       0,  1633,     0,     0,   887,     0,     0,     0,     0,     0,
     884,     0,     0,     0,   955,  2004,     0,     0,     0,     0,
    2004,  2004,     0,     0,  2331,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2592,     0,
       0,  2593,     0,     0,     0,     0,  3997,     0,     0,  1797,
       0,   884,   893,     0,     0,     0,  1572,   886,     0,     0,
       0,     0,     0,   886,     0,     0,     0,     0,     0,     0,
       0,     0,   955,   884,     0,  2594,     0,     0,     0,     0,
     955,     0,  2080,     0,     0,  2081,     0,     0,   955,  2082,
    2083,  2084,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,  2584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2585,     0,     0,
       0,     0,     0,     0,  2586,     0,     0,     0,     0,   945,
     945,  2594,   955,   955,  5849,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   945,   884,   955,   945,     0,     0,
    2587,     0,     0,     0,     0,     0,     0,     0,     0,   955,
     955,     0,     0,     0,  1710,     0,     0,     0,     0,     0,
       0,     0,     0,   893,     0,     0,     0,  2522,     0,     0,
       0,     0,     0,  5889,     0,     0,  2523,  2524,  2525,  2526,
    2527,  2528,  2529,  2530,  2531,     0,     0,   945,     0,  5598,
       0,   945,   945,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   954,  2522,     0,     0,     0,     0,     0,     0,
       0,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,
    2531,   954,     0,     0,     0,  5917,     0,   954,     0,     0,
       0,   887,     0,     0,     0,  2588,   884,     0,     0,   954,
    2589,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   954,     0,     0,     0,     0,
       0,     0,     0,  2590,  2271,     0,     0,     0,     0,     0,
     954,     0,     0,     0,     0,     0,     0,   893,   954,     0,
       0,     0,     0,     0,   886,  1797,  2591,     0,     0,     0,
       0,     0,   954,     0,     0,     0,     0,     0,   887,     0,
       0,     0,   954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4249,  2331,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   887,
       0,  2592,     0,     0,  2593,     0,     0,  4262,     0,     0,
     893,  2080,     0,     0,  2081,   954,     0,   886,  2082,  2083,
    2084,   886,     0,     0,  4269,     0,     0,     0,  4269,     0,
     884,     0,   887,  4280,  4281,  4282,  2584,     0,     0,     0,
       0,     0,     0,   954,     0,     0,  2585,     0,     0,     0,
       0,     0,     0,  2586,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   954,  4312,
    4313,  4314,  4315,     0,     0,     0,     0,     0,     0,  2587,
       0,  2080,     0,     0,  2081,     0,     0,     0,  2082,  2083,
    2084,     0,     0,     0,  2594,     0,   890,     0,     0,  4331,
       0,     0,     0,   884,     0,     0,  2584,  4334,     0,  4338,
    4339,  4340,     0,     0,     0,     0,  2585,     0,     0,     0,
       0,     0,     0,  2586,   886,     0,     0,     0,     0,   889,
     954,     0,   893,     0,     0,     0,     0,     0,     0,   886,
       0,     0,     0,     0,   886,     0,     0,     0,     0,  2587,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   886,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2588,     0,  2522,     0,     0,  2589,
       0,     0,     0,     0,     0,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,     0,     0,     0,     0,  5928,     0,
       0,     0,  2590,  2271,   887,   884,     0,  4423,     0,     0,
       0,     0,     0,     0,     0,   887,  4429,     0,     0,     0,
    1796,     0,     0,     0,     0,  2591,     0,   954,     0,     0,
       0,   887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4439,  4440,  2588,     0,   893,  4441,     0,  2589,
       0,   893,   893,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2331,     0,     0,  4483,
       0,     0,  2590,  2271,     0,     0,     0,     0,   889,     0,
    2592,     0,     0,  2593,     0,   887,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2591,     0,     0,     0,     0,
     887,     0,     0,   887,   887,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4520,     0,     0,     0,     0,  4526,     0,     0,     0,
       0,     0,  4532,     0,   887,   887,  2331,     0,     0,   884,
       0,     0,     0,     0,   884,   884,     0,     0,     0,     0,
    2592,   954,     0,  2593,     0,     0,     0,     0,     0,     0,
       0,     0,  4571,     0,     0,   893,     0,     0,     0,     0,
       0,     0,     0,  2594,     0,     0,     0,     0,  4697,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4586,     0,  4587,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   886,     0,     0,   886,     0,   886,     0,
       0,     0,   954,   886,   893,     0,     0,     0,     0,     0,
       0,     0,     0,   954,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,   889,     0,  2594,  1797,   954,     0,     0,     0,     0,
       0,     0,   889,     0,     0,     0,     0,     0,   884,     0,
    4698,     0,   886,     0,     0,     0,     0,     0,   889,     0,
     886,     0,   887,     0,     0,  2522,     0,     0,     0,     0,
       0,     0,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,     0,     0,   886,     0,  5950,     0,   955,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,   955,     0,     0,     0,   955,     0,     0,     0,     0,
       0,     0,     0,     0,   955,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2522,     0,     0,     0,     0,
       0,     0,     0,   955,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,     0,     0,   886,     0,   886,     0,     0,
     945,     0,   945,   945,   954,     0,     0,     0,     0,     0,
       0,     0,   954,   954,     0,     0,     0,   955,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   955,   955,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1796,     0,     0,  1797,   955,
       0,     0,  1797,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,   955,     0,  1797,     0,
       0,     0,   955,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   955,   892,     0,     0,
       0,     0,     0,   955,     0,     0,   955,     0,     0,     0,
       0,     0,   955,     0,     0,   886,  4820,     0,     0,  4827,
       0,  4828,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   955,     0,  4835,     0,     0,     0,   955,     0,
       0,     0,   890,   886,     0,   955,  4841,     0,     0,     0,
    4844,     0,     0,     0,     0,     0,     0,     0,     0,   955,
       0,     0,     0,     0,     0,     0,     0,     0,   890,  4871,
       0,     0,     0,   955,     0,     0,     0,     0,  1797,     0,
       0,     0,     0,     0,   955,     0,     0,  4875,     0,     0,
       0,     0,     0,  4879,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,     0,     0,  4914,     0,
       0,     0,  4918,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   886,     0,     0,     0,  4928,  4929,  4930,
    4931,     0,     0,     0,  1797,     0,     0,  4935,  4936,  4937,
    4938,     0,     0,     0,     0,   886,  4940,  4941,     0,     0,
       0,     0,  4948,  4949,     0,  4951,  4952,  4953,  4954,  4955,
    4956,  4957,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4966,     0,     0,     0,  4969,  4970,  4971,  4972,     0,
       0,     0,   889,     0,   954,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4269,
       0,   890,     0,     0,  2080,     0,     0,  2081,     0,     0,
       0,  2082,  2083,  2084,     0,     0,     0,  4992,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   886,     0,  2584,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2585,
       0,     0,     0,     0,  2080,     0,  2586,  2081,     0,   889,
       0,  2082,  2083,  2084,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2584,
       0,     0,  2587,     0,     0,     0,   886,     0,     0,  2585,
       0,     0,     0,     0,     0,     0,  2586,     0,     0,   955,
     889,  1797,     0,  5073,     0,     0,     0,     0,     0,   954,
       0,   886,     0,     0,     0,     0,     0,     0,   955,     0,
       0,     0,  2587,     0,     0,   955,     0,     0,     0,     0,
       0,     0,   945,   889,   945,   945,  4269,     0,     0,     0,
       0,     0,     0,  5098,  1796,  5099,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   954,     0,     0,
       0,     0,     0,  5114,   890,   954,     0,     0,     0,     0,
       0,     0,     0,   954,   887,   890,     0,     0,   887,   887,
       0,     0,     0,     0,     0,     0,     0,  2588,     0,     0,
       0,   890,  2589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1797,     0,
       0,     0,     0,     0,  1797,  2590,  2271,   954,   954,     0,
       0,     0,     0,     0,     0,     0,     0,  2588,     0,     0,
       0,   954,  2589,     0,     0,     0,     0,   887,  2591,     0,
       0,     0,     0,   887,   954,   954,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2590,  2271,     0,     0,   886,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2591,  2331,
       0,     0,     0,     0,   887,     0,     0,     0,     0,     0,
       0,     0,     0,  2592,     0,     0,  2593,     0,     0,   955,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,  2331,
       0,     0,     0,     0,     0,     0,   889,     0,     0,     0,
       0,     0,     0,  2592,     0,     0,  2593,     0,     0,     0,
       0,     0,   889,     0,     0,     0,     0,     0,   890,     0,
     886,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   886,     0,     0,     0,
       0,  5264,  5265,  5266,     0,     0,  2594,  5267,  5268,  5269,
    5270,     0,     0,     0,  5272,     0,   889,     0,     0,     0,
    1796,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   889,     0,     0,   889,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2594,     0,     0,     0,
     955,   955,     0,  5295,  5296,  5297,  5298,  5299,     0,  5301,
    5302,     0,     0,   892,     0,   889,   889,  2080,     0,     0,
    2081,  5311,  5312,     0,  2082,  2083,  2084,     0,   955,     0,
       0,   955,     0,     0,     0,     0,     0,     0,     0,   892,
       0,     0,  2584,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2585,     0,     0,  5318,     0,     0,  2522,  2586,
       0,     0,     0,     0,   887,     0,     0,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,     0,     0,     0,     0,
    6141,     0,     0,     0,     0,  2587,     0,     0,   886,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2522,     0,
       0,     0,     0,  1797,  1797,  1797,     0,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,     0,     0,     0,     0,
    6158,   894,     0,     0,     0,     0,     0,     0,   955,     0,
       0,     0,     0,     0,     0,   886,     0,   887,     0,     0,
     886,   887,     0,     0,     0,     0,     0,   955,     0,     0,
       0,     0,     0,   889,     0,     0,     0,  5383,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   955,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
       0,     0,   892,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,  2081,     0,
    2588,     0,  2082,  2083,  2084,  2589,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2584,     0,  5434,     0,     0,     0,     0,     0,  2590,  2271,
    2585,     0,     0,     0,     0,     0,     0,  2586,     0,     0,
       0,     0,   890,     0,   887,     0,     0,     0,     0,     0,
       0,  2591,     0,     0,  5440,     0,     0,   955,     0,   887,
       0,     0,     0,  2587,   887,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
       0,     0,  2331,     0,   887,   886,     0,     0,     0,     0,
       0,     0,     0,     0,  1797,     0,  2592,     0,     0,  2593,
     955,     0,   955,     0,     0,     0,   890,     0,     0,     0,
       0,     0,     0,     0,     0,   955,     0,   955,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   892,     0,   640,     0,     0,
       0,     0,     0,     0,     0,     0,   892,     0,     0,     0,
       0,     0,  2080,     0,     0,  2081,     0,     0,     0,  2082,
    2083,  2084,   892,     0,     0,     0,     0,     0,  2588,     0,
       0,     0,     0,  2589,     0,     0,     0,  2584,     0,     0,
       0,  3434,     0,     0,   955,     0,     0,  2585,     0,  2594,
       0,     0,     0,     0,  2586,     0,  2590,  2271,     0,     0,
       0,     0,     0,     0,     0,  5546,     0,     0,     0,     0,
     886,     0,     0,     0,     0,     0,     0,     0,     0,  2591,
    2587,     0,     0,     0,  5556,     0,   955,     0,     0,     0,
    5562,  5563,     0,     0,     0,     0,     0,     0,     0,     0,
    5574,     0,     0,     0,     0,   955,     0,  5576,     0,   955,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
    2331,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     955,  3435,     0,   886,  2592,     0,     0,  2593,     0,  1796,
       0,     0,     0,     0,  5629,  5630,     0,     0,     0,     0,
       0,  2522,     0,     0,     0,     0,     0,  5638,   890,  5640,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,   890,
       0,     0,     0,  6200,  5654,     0,     0,     0,     0,   892,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
       0,     0,     0,   887,   954,  2588,   887,     0,   887,  4269,
    2589,  2080,     0,   887,  2081,   886,     0,  5688,  2082,  2083,
    2084,     0,   954,     0,     0,     0,   954,     0,     0,     0,
     954,     0,     0,  2590,  2271,     0,  2584,  2594,     0,   954,
       0,     0,     0,     0,     0,  1797,  2585,     0,     0,   890,
       0,     0,     0,  2586,     0,     0,  2591,     0,   954,     0,
       0,     0,   887,     0,   890,     0,     0,   890,   890,     0,
     887,     0,     0,     0,     0,     0,     0,     0,     0,  2587,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5730,   954,     0,     0,   887,     0,  2331,   890,   890,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2592,   954,   954,  2593,     0,  5750,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5758,     0,
       0,     0,     0,     0,     0,     0,   886,     0,     0,  2522,
       0,     0,     0,  1796,   954,     0,     0,  1796,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,  2974,
       0,     0,     0,     0,     0,   887,     0,   887,     0,  4075,
       0,   954,     0,  1796,     0,  4076,     0,   954,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,     0,     0,  2588,     0,  5816,     0,   954,  2589,
       0,   954,     0,     0,  2594,     0,     0,   954,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,   889,
     889,     0,  2590,  2271,     0,   955,     0,   954,     0,     0,
       0,     0,     0,   954,     0,     0,   890,   894,     0,     0,
     954,     0,     0,     0,     0,  2591,   892,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,     0,
       0,   887,     0,   894,     0,  3436,  4269,     0,   954,     0,
     886,     0,     0,  1796,     0,     0,  1797,     0,   889,   954,
       0,  1797,     0,  1797,   889,     0,  2331,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2592,     0,     0,  2593,     0,   887,  2522,  1797,     0,     0,
       0,     0,     0,   892,     0,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,     0,   889,     0,     0,     0,     0,
       0,     0,  5915,   887,     0,     0,     0,     0,     0,  1796,
       0,     0,     0,   886,     0,     0,     0,  5929,     0,     0,
       0,     0,     0,   955,   892,     0,   955,     0,     0,     0,
       0,     0,     0,   958,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   992,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1011,   892,     0,     0,
       0,     0,     0,  4077,     0,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,  5968,   894,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   887,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   887,   955,   955,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,     0,     0,     0,     0,   886,     0,     0,     0,     0,
       0,     0,     0,     0,   955,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,  2522,  1796,     0,     0,     0,
    6043,     0,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,   954,     0,     0,     0,     0,     0,     0,
     954,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,  6056,     0,     0,   889,     0,     0,     0,  2080,
       0,     0,  2081,  6066,     0,     0,  2082,  2083,  2084,     0,
       0,     0,     0,     0,     0,   955,     0,     0,  1797,     0,
       0,     0,     0,     0,  2584,     0,     0,     0,     0,   894,
       0,     0,     0,     0,  2585,     0,   887,     0,     0,   892,
     894,  2586,     0,     0,     0,     0,     0,     0,     0,     0,
     892,     0,     0,     0,     0,     0,   894,     0,     0,   886,
       0,   887,     0,     0,   886,   886,   892,  2587,   889,     0,
       0,     0,   889,  1796,     0,     0,     0,     0,     0,  1796,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6135,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   892,     0,     0,   892,   892,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6004,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,   892,
     892,     0,     0,     0,     0,   889,     0,     0,   886,     0,
       0,     0,  2588,     0,     0,     0,     0,  2589,     0,     0,
     889,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2590,  2271,     0,   894,  2080,     0,     0,  2081,     0,   887,
       0,  2082,  2083,  2084,     0,   889,     0,   886,     0,     0,
       0,     0,     0,  2591,     0,     0,     0,     0,     0,  2584,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2585,
       0,     0,     0,     0,     0,   955,  2586,     0,     0,     0,
    1031,     0,     0,     0,     0,     0,  1063,     0,     0,     0,
       0,     0,     0,     0,  2331,     0,     0,     0,     0,     0,
       0,     0,  2587,     0,     0,     0,     0,     0,  2592,     0,
       0,  2593,     0,     0,     0,   954,   954,     0,   890,     0,
     955,     0,   890,   890,     0,     0,     0,   892,     0,     0,
     887,     0,   955,     0,  6005,     0,     0,     0,     0,     0,
       0,     0,     0,   954,     0,     0,   954,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   955,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,     0,     0,     0,   890,     0,     0,
    2080,     0,     0,  2081,     0,     0,     0,  2082,  2083,  2084,
       0,  2594,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2584,     0,  2588,  1796,  1796,
    1796,     0,  2589,     0,     0,  2585,     0,     0,   890,     0,
       0,     0,  2586,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   954,  1797,  2590,  2271,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1368,  2587,     0,
       0,     0,   954,   955,     0,     0,     0,     0,  2591,     0,
       0,     0,     0,     0,     0,     0,  1391,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,     0,
     894,     0,     0,     0,   889,     0,     0,   889,   887,   889,
       0,     0,     0,  2522,   889,     0,     0,     0,     0,  2331,
       0,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,
    2531,     0,     0,  2592,     0,     0,  2593,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   887,     0,     0,  1449,   955,
     887,     0,     0,   889,     0,     0,     0,   894,     0,     0,
       0,   889,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   954,  2588,     0,     0,     0,     0,  2589,     0,
       0,     0,     0,     0,     0,     0,   889,     0,     0,     0,
       0,     0,     0,     0,     0,  1585,     0,     0,   894,     0,
       0,  2590,  2271,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2594,     0,     0,  1796,
       0,     0,     0,     0,  2591,   954,     0,   954,     0,     0,
       0,   894,     0,     0,     0,     0,     0,     0,   890,     0,
     954,     0,   954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   889,     0,   889,     0,
       0,     0,     0,     0,     0,  2331,     0,     0,     0,     0,
       0,     0,     0,     0,   955,     0,   955,     0,     0,  2592,
       0,     0,  2593,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4048,     0,     0,     0,   887,     0,     0,     0,   954,
    1846,   890,     0,     0,     0,   890,     0,  4015,  2522,     0,
       0,     0,     0,     0,     0,     0,   955,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,   945,     0,     0,  1880,
    1883,  1884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,   889,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,     0,  2594,     0,   954,     0,  1797,     0,     0,     0,
       0,   945,     0,     0,     0,     0,     0,     0,     0,     0,
    2080,     0,     0,  2081,     0,   954,   889,  2082,  2083,  2084,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2584,     0,     0,   890,     0,
       0,     0,     0,   894,   889,  2585,     0,     0,     0,     0,
     887,     0,  2586,   890,   894,     0,     0,     0,   890,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1368,     0,
     894,     0,     0,     0,     0,     0,     0,     0,  2587,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   890,     0,
       0,   887,     0,     0,  2522,     0,  1368,     0,     0,     0,
       0,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2530,  2531,   889,   887,     0,     0,     0,     0,     0,     0,
    1796,     0,     0,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   889,     0,     0,     0,     0,   894,
       0,     0,   894,   894,     0,     0,     0,     0,     0,   892,
       0,     0,     0,   892,   892,     0,   889,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   894,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   887,     0,     0,  2080,     0,
       0,  2081,     0,  2588,     0,  2082,  2083,  2084,  2589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   892,  2584,     0,     0,  4080,     0,   892,   955,
       0,  2590,  2271,  2585,     0,     0,     0,     0,     0,     0,
    2586,     0,     0,   955,     0,     0,     0,     0,   889,     0,
       0,     0,     0,     0,  2591,  2578,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2080,  2587,     0,  2081,   892,
       0,     0,  2082,  2083,  2084,  1797,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2584,     0,     0,     0,     0,  2331,     0,   889,     0,     0,
    2585,     0,     0,     0,     0,     0,     0,  2586,     0,  2592,
     954,     0,  2593,     0,     0,     0,   887,     0,     0,     0,
       0,   894,   889,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2587,     0,  2669,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   890,     0,     0,
     890,     0,   890,     0,     0,     0,     0,   890,     0,     0,
       0,  1796,     0,     0,     0,     0,  1796,     0,  1796,     0,
       0,     0,     0,     0,     0,     0,  1797,     0,     0,     0,
       0,  2588,     0,     0,     0,     0,  2589,     0,     0,     0,
       0,     0,  1796,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2594,     0,     0,     0,   890,     0,     0,  2590,
    2271,     0,     0,     0,   890,     0,     0,     0,  2787,     0,
       0,     0,     0,     0,     0,     0,     0,  2810,     0,  4085,
       0,     0,  2591,     0,     0,  4631,     0,     0,   954,   890,
       0,   954,  1797,     0,   955,     0,     0,     0,  2588,     0,
     887,     0,     0,  2589,     0,     0,     0,     0,     0,  2848,
       0,     0,     0,     0,     0,  2860,  2860,     0,     0,  2860,
       0,     0,     0,  2331,     0,     0,  2590,  2271,     0,   892,
     889,     0,  2878,     0,     0,  2881,     0,  2592,     0,     0,
    2593,     0,     0,     0,     0,     0,     0,     0,     0,  2591,
       0,     0,     0,     0,  2522,     0,     0,     0,     0,   890,
       0,   890,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2530,  2531,     0,   887,     0,     0,     0,     0,     0,     0,
       0,   954,   954,     0,     0,     0,     0,     0,     0,     0,
    2331,  2934,   954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   892,     0,  2592,  2954,   892,  2593,     0,   954,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   955,
       0,   889,     0,     0,     0,     0,     0,     0,     0,     0,
    2594,     0,     0,   945,     0,  2080,     0,     0,  2081,     0,
       0,     0,  2082,  2083,  2084,     0,   955,   889,     0,     0,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
    2584,     0,     0,  4092,     0,     0,     0,     0,     0,     0,
    2585,     0,     0,     0,     0,     0,     0,  2586,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,     0,     0,  1796,     0,   887,     0,  2594,     0,   890,
       0,     0,     0,  2587,     0,   945,   945,     0,     0,   892,
       0,     0,     0,     0,     0,  2976,     0,     0,     0,     0,
       0,     0,     0,     0,   892,     0,  2979,   890,     0,   892,
    2080,     0,  2522,  2081,     0,     0,     0,  2082,  2083,  2084,
       0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,
       0,     0,     0,     0,     0,  2584,     0,     0,  4704,   892,
       0,     0,     0,     0,   955,  2585,     0,     0,  3023,  2860,
       0,     0,  2586,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   889,
       0,     0,     0,  3058,     0,   890,     0,     0,  2587,  2522,
    3071,     0,     0,     0,     0,     0,     0,     0,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,   890,  2588,  2080,
       0,     0,  2081,  2589,     0,     0,  2082,  2083,  2084,   887,
       0,     0,     0,     0,   887,   887,   889,     0,     0,   890,
       0,   889,     0,     0,  2584,     0,  2590,  2271,     0,     0,
       0,     0,     0,     0,  2585,     0,     0,     0,     0,     0,
       0,  2586,     0,     0,     0,     0,     0,     0,     0,  2591,
       0,     0,     0,  3132,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1343,  1343,  2587,     0,     0,
    2080,     0,     0,  2081,     0,     0,     0,  2082,  2083,  2084,
       0,     0,     0,     0,     0,  1797,  1368,  1368,     0,     0,
    2331,     0,     0,  2588,     0,  2584,     0,     0,  2589,     0,
       0,   890,     0,  3186,  2592,  2585,  3188,  2593,     0,     0,
     954,     0,  2586,     0,     0,     0,     0,     0,     0,     0,
       0,  2590,  2271,     0,     0,     0,     0,     0,   887,     0,
       0,  1797,     0,     0,     0,     0,     0,     0,  2587,   945,
     945,     0,     0,     0,  2591,  1343,     0,     0,     0,  1797,
     890,     0,     0,   894,     0,   954,     0,   894,   894,     0,
       0,     0,     0,  5148,     0,     0,     0,   954,     0,     0,
       0,     0,     0,     0,     0,   890,   889,   887,     0,     0,
       0,     0,  2588,     0,     0,  2331,     0,  2589,   892,     0,
       0,   892,     0,   892,     0,     0,     0,  2594,   892,  2592,
       0,   954,  2593,     0,     0,     0,     0,     0,     0,     0,
    2590,  2271,     0,     0,     0,     0,   894,     0,     0,     0,
       0,     0,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2591,  5154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   892,     0,     0,
       0,     0,     0,  2588,     0,   892,     0,     0,  2589,     0,
       0,     0,     0,   894,     0,     0,  1707,  1711,     0,     0,
       0,     0,     0,     0,  2331,     0,     0,     0,     0,  1796,
     892,  2590,  2271,     0,     0,     0,     0,     0,  2592,     0,
       0,  2593,  2594,     0,     0,     0,     0,     0,   954,  2522,
       0,   889,     0,     0,  2591,     0,     0,     0,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
       0,     0,   889,     0,     0,  2331,     0,     0,     0,     0,
     892,     0,   892,     0,     0,     0,     0,     0,     0,  2592,
       0,     0,  2593,     0,   889,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2594,     0,     0,   954,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2522,     0,     0,     0,     0,     0,
       0,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2530,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   890,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   889,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   892,     0,     0,     0,
     890,     0,  2594,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   894,     0,     0,     0,  2080,     0,     0,
    2081,     0,     0,  2522,  2082,  2083,  2084,     0,     0,     0,
     892,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,
    2531,     0,  2584,     0,     0,  2028,     0,     0,     0,   954,
       0,   954,  2585,     0,     0,     0,     0,     0,   892,  2586,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2050,     0,  2587,   894,     0,     0,     0,
     894,     0,     0,     0,  2522,     0,     0,   889,     0,     0,
       0,   954,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2530,  2531,  2069,  2070,  2071,     0,  2073,     0,     0,     0,
       0,     0,  2080,     0,     0,  2081,   892,     0,     0,  2082,
    2083,  2084,   890,     0,     0,     0,     0,  2540,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2584,   892,     0,
       0,  1796,  2080,     0,     0,  2081,     0,  2585,     0,  2082,
    2083,  2084,     0,     0,  2586,     0,     0,     0,     0,     0,
     892,     0,     0,     0,     0,  5155,     0,  2584,  3367,   890,
       0,     0,     0,     0,   890,     0,     0,  2585,  3372,     0,
    2587,     0,     0,   894,  2586,     0,     0,     0,     0,     0,
    2588,     0,     0,     0,     0,  2589,     0,     0,   894,     0,
       0,     0,     0,   894,     0,     0,     0,  1449,     0,     0,
    2587,     0,     0,     0,     0,     0,     0,     0,  2590,  2271,
       0,   889,     0,     0,     0,     0,     0,     0,     0,     0,
    2636,     0,     0,   894,  2648,  2653,     0,     0,     0,     0,
       0,  2591,   892,     0,     0,     0,     0,     0,     0,  5156,
    2080,     0,     0,  2081,  1449,  1449,     0,  2082,  2083,  2084,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2584,     0,     0,     0,     0,
       0,     0,  2331,     0,     0,  2585,     0,     0,  1368,     0,
       0,   892,  2586,     0,   889,  2588,  2592,     0,     0,  2593,
    2589,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   892,     0,  2587,     0,
    2533,     0,     0,  2590,  2271,  2588,     0,     0,     0,   890,
    2589,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2591,     0,     0,     0,
       0,     0,     0,  2590,  2271,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2533,  2591,     0,   954,     0,
       0,     0,     0,     0,     0,     0,     0,  2331,     0,  2594,
    2080,     0,     0,  2081,     0,     0,     0,  2082,  2083,  2084,
       0,  2592,     0,     0,  2593,     0,     0,     0,  5690,     0,
    1796,     0,     0,     0,     0,  2584,   889,  2331,     0,     0,
       0,     0,  3587,     0,     0,  2585,     0,     0,     0,     0,
       0,  2592,  2586,  2588,  2593,     0,     0,  3609,  2589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   890,     0,     0,     0,  2587,  3637,
       0,  2590,  2271,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   892,     0,     0,  1707,  1707,  1707,
       0,     0,   894,     0,  2591,   894,     0,   894,     0,     0,
       0,  2522,   894,     0,  2594,   890,     0,     0,     0,     0,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,     0,
       0,  1796,     0,     0,     0,     0,     0,   890,     0,     0,
       0,     0,     0,     0,  2594,  2331,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2592,
       0,   894,  2593,     0,     0,  3715,  3716,     0,     0,   894,
     889,     0,     0,     0,     0,   889,   889,     0,     0,     0,
       0,     0,     0,     0,     0,   892,     0,     0,     0,     0,
       0,     0,     0,  2588,   894,     0,     0,  1796,  2589,   954,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   890,
       0,   892,     0,     0,     0,     0,  2522,     0,     0,     0,
    5514,  2590,  2271,     0,     0,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2591,     0,  2522,     0,     0,     0,
       0,     0,  2594,     0,     0,  2523,  2524,  2525,  2526,  2527,
    2528,  2529,  2530,  2531,   894,     0,   894,  3841,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2331,     0,     0,     0,   889,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2592,
       0,     0,  2593,     0,  2533,     0,     0,     0,  2533,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,     0,
     890,     0,     0,     0,     0,     0,     0,     0,   889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,     0,   892,  2522,     0,     0,     0,     0,     0,
     894,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2530,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2594,     0,     0,     0,     0,     0,     0,     0,
     892,     0,     0,     0,   894,   892,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3214,     0,     0,     0,
       0,     0,   894,     0,     0,  3231,  3231,  3231,  3240,  3246,
    3248,  3231,     0,     0,     0,  3253,     0,  3254,     0,  3256,
       0,     0,  3270,  3273,  3278,     0,     0,     0,     0,     0,
    3287,     0,     0,  3292,   890,     0,     0,     0,     0,   954,
       0,     0,     0,     0,     0,     0,     0,     0,  3299,  3300,
    3301,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2522,     0,  3302,     0,     0,     0,
     894,     0,     0,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2530,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       1,     0,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     0,     3,     4,     0,     0,   890,     0,     0,
       0,     0,     0,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     892,     6,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     7,     0,     8,     9,     0,     0,     0,
       0,     0,    10,     0,    11,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,  4146,     0,     0,
    1796,     0,     0,     0,     0,    14,     0,     0,    15,     0,
       0,     0,     0,     0,     0,  2533,   894,     0,  1449,     0,
       0,     0,     0,    16,     0,    17,     0,     0,     0,    18,
    3310,     0,     0,     0,     0,  5668,     0,  2533,     0,     0,
       0,  3266,     0,    20,     0,    21,  1796,     0,     0,   890,
       0,     0,    22,     0,     0,     0,  2533,  2533,  2533,     0,
    2533,     0,     0,     0,  1796,   894,     0,     0,     0,     0,
      23,     0,     0,     0,     0,   892,     0,     0,     0,  3329,
       0,     0,     0,   701,     0,     0,     0,    24,   702,     0,
     894,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   892,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   703,     0,     0,     0,
       0,     0,  3331,     0,     0,     0,    25,    26,   892,   704,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   705,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   706,    29,     0,     0,     0,     0,     0,
       0,     0,     0,   890,     0,     0,     0,     0,   890,   890,
       0,     0,     0,     0,     0,     0,     0,   707,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   708,     0,
     892,     0,     0,     0,     0,     0,     0,   709,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     710,     0,    31,     0,     0,     0,   711,     0,    32,    33,
       0,    34,     0,   712,     0,     0,    35,     0,   894,  4561,
       0,     0,    36,     0,     0,    37,     0,     0,     0,     0,
       0,     0,    38,   713,     0,     0,     0,     0,     0,    39,
      40,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,     0,     0,     0,     0,     0,  4356,     0,     0,
       0,    43,     0,     0,     0,     0,     0,  2860,     0,     0,
       0,     0,   890,     0,     0,     0,     0,    44,     0,  3338,
    3339,  3340,  3341,  3342,  3343,  3344,  3345,  3346,   714,  3347,
       0,     0,     0,     0,     0,     0,     0,    45,     0,     0,
    1343,   892,  1707,     0,     0,     0,     0,     0,    46,   894,
       0,     0,     0,     0,    47,     0,     0,     0,     0,    48,
       0,   890,     0,     0,     0,     0,     0,     0,     0,   715,
       0,     0,    49,     0,     0,   894,     0,     0,     0,     0,
    3302,     0,   716,     0,  3310,     0,     0,  3329,     0,  3331,
       0,     0,  3384,   717,     0,     0,    50,     0,     0,     0,
       0,     0,     0,   213,   718,     0,     0,   719,     0,     0,
       0,     0,     0,     0,     0,    56,     0,     0,  -136,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   720,     0,     0,   721,     0,     0,
       0,   722,     0,     0,   723,  2070,  2071,     0,     0,     0,
       0,   724,     0,     0,   725,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4487,  4488,
    4489,     0,     0,   726,     0,   892,     0,   701,     0,     0,
     727,     0,  1034,     0,     0,  4498,     0,   728,     0,     0,
     729,     0,     0,     0,   730,     0,     0,     0,     0,     0,
       0,     0,   731,     0,   732,     0,     0,   197,     0,   733,
       0,     0,     0,     0,     0,     0,     0,   894,  4523,  4525,
    1035,     0,   734,  4530,     0,     0,     0,     0,     0,  3529,
       0,     0,     0,   704,  1036,   735,     0,  2533,     0,     0,
       0,     0,     0,     0,     0,  1037,     0,     0,   892,   705,
       0,     0,     0,     0,     0,     0,     0,     0,   198,     0,
       0,     0,     0,     0,   894,     0,     0,  1038,     0,   894,
       0,     0,     0,     0,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1039,   200,     0,     0,     0,     0,     0,   201,     0,
       0,     0,   708,     0,     0,     0,     0,     0,     0,     0,
       0,   709,     0,     0,     0,     0,   202,     0,     0,     0,
       0,     0,     0,     0,   710,     0,     0,   203,     0,  1368,
    1040,     0,     0,  2533,     0,     0,   204,     0,     0,     0,
       0,     0,     0,     0,     0,  2533,     0,     0,     0,   205,
    2533,     0,     0,     0,     0,   206,     0,  1041,     0,     0,
       0,     0,   207,     0,     0,     0,     0,     0,     0,     0,
     892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   208,     0,     0,     0,     0,     0,     0,     0,
    1042,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   714,     0,     0,   209,     0,     0,     0,     0,
       0,     0,     0,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3773,  3774,  1707,     0,     0,
       0,  3778,     0,     0,     0,     0,     0,   717,   211,     0,
       0,     0,     0,     0,     0,     0,     0,   213,  1044,     0,
       0,   719,  4736,  4737,  4738,     0,     0,     0,  3807,     0,
       0,     0,   212,     0,   892,     0,     0,     0,     0,   892,
     892,     0,   213,   214,     0,     0,   215,     0,  1045,     0,
       0,  1046,     0,     0,     0,   722,     0,     0,   723,     0,
       0,     0,     0,     0,     0,   724,     0,     0,   725,     0,
       0,     0,     0,   216,     0,     0,   217,     0,     0,   894,
     218,     0,     0,   219,     0,     0,     0,   726,     0,     0,
     220,     0,     0,   221,  1047,     0,     0,     0,     0,     0,
       0,   728,     0,     0,  1048,     0,     0,     0,   730,     0,
       0,     0,   222,     0,     0,     0,  1049,     0,   732,   223,
     894,     0,     0,  1050,   224,     0,   225,     0,     0,   226,
       0,     0,     0,   227,     0,     0,     0,     0,     0,     0,
       0,     0,   894,   228,     0,     0,     0,     0,   229,   735,
       0,     0,     0,   892,     0,     0,     0,     0,     0,     0,
       0,   230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   231,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   892,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4002,     0,     0,
       0,     0,  4008,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3278,     0,  3278,  3278,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4095,     0,     0,  4098,
       0,  4100,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   894,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5002,
       0,     0,     0,     0,     0,     0,     0,     0,  4125,     0,
    4128,     0,  4130,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5034,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3071,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2533,     0,     0,     0,     0,     0,     0,  5092,     0,
       0,     0,     0,     0,  4197,     0,     0,     0,  2533,  2636,
       0,     0,     0,     0,     0,  3132,     0,  2533,     0,   894,
       0,     0,     0,  2533,  2653,  2533,     0,     0,     0,     0,
    2533,  2533,     0,  2533,     0,     0,     0,     0,  3266,  3266,
       0,  4071,     0,  3266,     0,     0,     0,  2533,     0,     0,
    2533,     0,     0,     0,     0,  2533,     0,     0,     0,     0,
       0,     0,     0,     0,  2533,     0,     0,     0,     0,  2533,
       0,     0,     0,     0,     0,     0,  2533,  2533,  2533,  2533,
       0,     0,     0,     0,  3266,  3266,     0,  2533,     0,  4247,
       0,     0,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2533,     0,  2533,     0,
       0,     0,     0,     0,     0,  2533,  2533,  2533,  2533,  2533,
    2533,  2533,  2533,  2533,  2533,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5191,  5192,  5193,
    5194,  2533,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1707,     0,     0,   894,     0,
       0,  1707,     0,   894,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4510,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5412,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5422,     0,   894,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2533,  2533,     0,     0,     0,  2533,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4632,
       0,     0,     0,     0,  2533,     0,     0,     0,  4636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3231,     0,     0,     0,  3231,  3231,     0,     0,
       0,     0,  3246,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4658,     0,  4659,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4681,  4682,  4683,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3287,     0,     0,     0,     0,     0,     0,     0,  4707,     0,
       0,  4710,     0,  4712,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4716,
       0,     0,     0,     0,     0,     0,     0,  4723,  4724,     0,
       0,     0,     0,     0,  4729,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2533,
       0,     0,     0,     0,     0,  2533,     0,     0,     0,     0,
       0,  4781,  5613,     0,     0,     0,     0,  1368,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4795,     0,
       0,     0,     0,     0,     0,     0,  5643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4071,
    4071,     0,     0,  3266,  3266,  3266,  3266,     0,     0,  3266,
    3266,  3266,  3266,  3266,  3266,  3266,  3266,  3266,  3266,  4071,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2533,     0,     0,  2533,     0,  2533,     0,     0,
    4071,  4071,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2533,  3266,  3266,  2533,     0,  2533,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5747,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2533,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2533,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5845,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5080,  5081,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5088,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5131,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5150,     0,
       0,     0,     0,     0,  3266,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5169,  5171,     0,
       0,     0,     0,     0,  5175,  5176,     0,  2533,     0,  5177,
       0,     0,     0,     0,  5178,     0,     0,  5181,  5182,     0,
       0,     0,     0,     0,  5187,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5221,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1343,     0,
       0,     0,     0,     0,     0,     0,  5235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5245,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2533,
       0,     0,     0,  2533,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2533,  2533,     0,     0,     0,
       0,  4071,  4071,  4071,  4071,     0,     0,     0,  4071,  4071,
    4071,  4071,  4071,  4071,  4071,  4071,  4071,  4071,  2533,  2533,
    2533,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2533,     0,     0,  2533,     0,  2533,
       0,  5314,     0,  2533,     0,     0,  4071,  4071,  5316,     0,
    2533,  2533,     0,     0,     0,     0,  2533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2533,     0,
       0,     0,     0,     0,     0,     0,  5351,     0,     0,     0,
       0,     0,  2533,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5444,     0,     0,     0,     0,     0,
    5448,  5449,  5450,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5463,  5464,     0,     0,  5465,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4071,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5484,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5502,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5517,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2533,  2533,     0,
       0,     0,     0,     0,     0,  2533,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2533,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2533,  3266,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2533,     0,  2533,     0,
       0,     0,  2533,  2533,  2533,  2533,     0,     0,  2533,  2533,
       0,     0,     0,     0,  2533,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3266,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2533,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2533,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2533,     0,     0,     0,     0,  3287,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2073,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2533,     0,  2533,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5753,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2533,     0,
       0,     0,     0,     0,  5765,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5800,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2533,     0,  4071,  3266,  2533,  2533,  2533,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2533,  2533,  2533,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3266,     0,     0,  4071,     0,     0,
       0,  2533,     0,     0,     0,     0,  5866,     0,     0,     0,
       0,     0,     0,     0,     0,  5873,  5873,  5873,     0,  2533,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2533,     0,     0,     0,     0,     0,
       0,  5502,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5918,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5873,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4071,  5502,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6031,
       0,     0,     0,     0,     0,     0,     0,  4071,     0,  3266,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2533,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2533,     0,     0,     0,     0,     0,     0,     0,
    6073,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6098,     0,     0,  2533,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2533,     0,     0,     0,     0,     0,     0,
    2533,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5873,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6168,     0,     0,     0,     0,  2533,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3266,  3266,     0,     0,     0,     0,
       0,  1707,     0,     0,     0,     0,     0,     0,  2533,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2533,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2533,   234,     0,  1250,   696,
       0,  1251,  1252,  1253,   757,  1254,  4071,  4071,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,  1701,   244,   245,   246,     0,     0,     0,     0,
    1255,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1256,   260,  1257,  1258,
       0,   263,   264,   265,   266,   267,   268,   269,  1259,  1260,
     270,   271,  1261,  1262,   274,  2533,   275,   276,   277,   278,
    1263,     0,  1264,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,   302,   303,   304,   305,   306,   307,  1272,
    1273,   310,  1274,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,  1702,     0,   323,
     324,   866,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1275,   339,   340,
     341,   342,  1276,  1277,   344,     0,   345,   346,   347,  1278,
     349,     0,   350,     0,   351,   352,   353,     0,   354,   355,
     356,   357,   358,     0,   359,  1279,     0,  1280,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,  1281,  1282,
       0,  1283,     0,   392,   393,   394,   395,   396,  1284,  1285,
    1286,  1287,  1288,  1289,  1290,   404,   405,   406,   407,   408,
     409,     0,     0,   410,  1291,   412,   413,   414,     0,   415,
     416,   417,  1292,  1293,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1294,   437,  1295,   439,   440,   441,   442,   443,
     444,   445,   446,  1296,   448,  1297,   449,   450,   451,   452,
    1298,  1299,   454,  1300,   456,   457,   458,     0,   459,   460,
       0,     0,  1301,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,  1302,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,     0,   481,   482,  1303,   484,   485,
     486,   487,   488,     0,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,  1304,   500,   501,   502,   503,     0,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,     0,   517,   518,   519,   520,   521,   522,
     523,   524,  1305,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,  1306,
     541,   542,   543,   544,   545,   546,   547,   548,  1307,   550,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,  1308,   565,     0,   566,   567,  1309,
       0,   568,   569,   570,   571,   572,   573,   574,     0,   575,
    1310,  1311,     0,     0,   578,   579,  1312,   581,  1313,  1314,
     583,   584,   585,   586,   587,   588,   589,   590,     0,  1315,
     591,   592,   593,   594,   595,  1316,     0,   596,   597,   598,
     599,   600,   601,  1317,  1703,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,  1318,  1319,  1320,  1321,   621,  1322,  1323,
    1324,  1325,   626,   627,   628,   629,     0,  1326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1327,
    1328,  1704,     0,     0,     0,     0,     0,     0,  1330,  1705,
     234,     0,  1250,   696,     0,  1251,  1252,  1253,   757,  1254,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1255,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1256,   260,  1257,  1258,     0,   263,   264,   265,   266,   267,
     268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,
     275,   276,   277,   278,  1263,     0,  1264,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,
     305,   306,   307,  1272,  1273,   310,  1274,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   866,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1275,   339,   340,   341,   342,  1276,  1277,   344,     0,
     345,   346,   347,  1278,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,  1279,
       0,  1280,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,  1281,  1282,     0,  1283,     0,   392,   393,   394,
     395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,
     405,   406,   407,   408,   409,     0,     0,   410,  1291,   412,
     413,   414,     0,   415,   416,   417,  1292,  1293,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1294,   437,  1295,   439,
     440,   441,   442,   443,   444,   445,   446,  1296,   448,  1297,
     449,   450,   451,   452,  1298,  1299,   454,  1300,   456,   457,
     458,     0,   459,   460,     0,     0,  1301,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,  1302,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,     0,   481,
     482,  1303,   484,   485,   486,   487,   488,     0,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,  1304,   500,
     501,   502,   503,     0,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,     0,   517,   518,
     519,   520,   521,   522,   523,   524,  1305,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,    40,   536,   537,
     538,   539,   540,  1306,   541,   542,   543,   544,   545,   546,
     547,   548,  1307,   550,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,  1308,   565,
       0,   566,   567,  1309,    44,   568,   569,   570,   571,   572,
     573,   574,     0,   575,  1310,  1311,     0,     0,   578,   579,
    1312,   581,  1313,  1314,   583,   584,   585,   586,   587,   588,
     589,   590,     0,  1315,   591,   592,   593,   594,   595,  1316,
       0,   596,   597,   598,   599,   600,  1185,  1317,     0,   603,
     604,   605,   606,   607,   608,     0,     0,   609,     0,    49,
     610,   611,   612,   613,   614,   615,   616,  1318,  1319,  1320,
    1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,
       0,  1326,     0,    50,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1327,  1328,     0,     0,     0,     0,     0,
       0,     0,  1330,  5724,   234,     0,  1250,   696,     0,  1251,
    1252,  1253,   757,  1254,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1255,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1256,   260,  1257,  1258,     0,   263,
     264,   265,   266,   267,   268,   269,  1259,  1260,   270,   271,
    1261,  1262,   274,     0,   275,   276,   277,   278,  1263,     0,
    1264,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,   302,   303,   304,   305,   306,   307,  1272,  1273,   310,
    1274,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   866,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1275,   339,   340,   341,   342,
    1276,  1277,   344,     0,   345,   346,   347,  1278,   349,     0,
     350,     0,   351,   352,   353,     0,   354,   355,   356,   357,
     358,     0,   359,  1279,     0,  1280,   362,   363,     0,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1281,  1282,     0,  1283,
       0,   392,   393,   394,   395,   396,  1284,  1285,  1286,  1287,
    1288,  1289,  1290,   404,   405,   406,   407,   408,   409,     0,
       0,   410,  1291,   412,   413,   414,     0,   415,   416,   417,
    1292,  1293,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1294,   437,  1295,   439,   440,   441,   442,   443,   444,   445,
     446,  1296,   448,  1297,   449,   450,   451,   452,  1298,  1299,
     454,  1300,   456,   457,   458,     0,   459,   460,     0,     0,
    1301,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,  1302,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,  1303,   484,   485,   486,   487,
     488,     0,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,  1304,   500,   501,   502,   503,     0,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,     0,   517,   518,   519,   520,   521,   522,   523,   524,
    1305,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,  1306,   541,   542,
     543,   544,   545,   546,   547,   548,  1307,   550,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,  1308,   565,     0,   566,   567,  1309,     0,   568,
     569,   570,   571,   572,   573,   574,     0,   575,  1310,  1311,
       0,     0,   578,   579,  1312,   581,  1313,  1314,   583,   584,
     585,   586,   587,   588,   589,   590,     0,  1315,   591,   592,
     593,   594,   595,  1316,     0,   596,   597,   598,   599,   600,
     601,  1317,     0,   603,   604,   605,   606,   607,   608,     0,
       0,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,
     626,   627,   628,   629,     0,  1326,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1327,  1328,     0,
       0,     0,     0,     0,     0,     0,  1330,  3268,   234,     0,
    1250,   696,     0,  1251,  1252,  1253,   757,  1254,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1255,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1256,   260,
    1257,  1258,     0,   263,   264,   265,   266,   267,   268,   269,
    1259,  1260,   270,   271,  1261,  1262,   274,     0,   275,   276,
     277,   278,  1263,     0,  1264,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1265,  1266,
    1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,   306,
     307,  1272,  1273,   310,  1274,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   866,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1275,
     339,   340,   341,   342,  1276,  1277,   344,     0,   345,   346,
     347,  1278,   349,     0,   350,     0,   351,   352,   353,     0,
     354,   355,   356,   357,   358,     0,   359,  1279,     0,  1280,
     362,   363,     0,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
    1281,  1282,     0,  1283,     0,   392,   393,   394,   395,   396,
    1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,   406,
     407,   408,   409,     0,     0,   410,  1291,   412,   413,   414,
       0,   415,   416,   417,  1292,  1293,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1294,   437,  1295,   439,   440,   441,
     442,   443,   444,   445,   446,  1296,   448,  1297,   449,   450,
     451,   452,  1298,  1299,   454,  1300,   456,   457,   458,     0,
     459,   460,     0,     0,  1301,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,  1302,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,     0,   481,   482,  1303,
     484,   485,   486,   487,   488,     0,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,  1304,   500,   501,   502,
     503,     0,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,     0,   517,   518,   519,   520,
     521,   522,   523,   524,  1305,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
     540,  1306,   541,   542,   543,   544,   545,   546,   547,   548,
    1307,   550,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,  1308,   565,     0,   566,
     567,  1309,     0,   568,   569,   570,   571,   572,   573,   574,
       0,   575,  1310,  1311,     0,     0,   578,   579,  1312,   581,
    1313,  1314,   583,   584,   585,   586,   587,   588,   589,   590,
       0,  1315,   591,   592,   593,   594,   595,  1316,     0,   596,
     597,   598,   599,   600,   601,  1317,     0,   603,   604,   605,
     606,   607,   608,     0,     0,   609,     0,     0,   610,   611,
     612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,   621,
    1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,  1326,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1327,  1328,     0,     0,     0,     0,     0,     0,     0,
    1330,  4660,   234,     0,  1250,   696,     0,  1251,  1252,  1253,
     757,  1254,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,  1255,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1256,   260,  1257,  1258,     0,   263,   264,   265,
     266,   267,   268,   269,  1259,  1260,   270,   271,  1261,  1262,
     274,     0,   275,   276,   277,   278,  1263,     0,  1264,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,
     303,   304,   305,   306,   307,  1272,  1273,   310,  1274,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   866,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1275,   339,   340,   341,   342,  1276,  1277,
     344,     0,   345,   346,   347,  1278,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,  1279,     0,  1280,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1281,  1282,     0,  1283,     0,   392,
     393,   394,   395,   396,  1284,  1285,  1286,  1287,  1288,  1289,
    1290,   404,   405,   406,   407,   408,   409,     0,     0,   410,
    1291,   412,   413,   414,     0,   415,   416,   417,  1292,  1293,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1294,   437,
    1295,   439,   440,   441,   442,   443,   444,   445,   446,  1296,
     448,  1297,   449,   450,   451,   452,  1298,  1299,   454,  1300,
     456,   457,   458,     0,   459,   460,     0,     0,  1301,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,  1302,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,  1303,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
    1304,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,  1305,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,  1306,   541,   542,   543,   544,
     545,   546,   547,   548,  1307,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
    1308,   565,     0,   566,   567,  1309,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,  1310,  1311,     0,     0,
     578,   579,  1312,   581,  1313,  1314,   583,   584,   585,   586,
     587,   588,   589,   590,     0,  1315,   591,   592,   593,   594,
     595,  1316,     0,   596,   597,   598,   599,   600,   601,  1317,
       0,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,  1318,
    1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,   626,   627,
     628,   629,     0,  1326,     0,     0,     0,     0,     0,   637,
       0,     0,     0,     0,     0,  1327,  1328,     0,     0,     0,
       0,     0,     0,     0,  1330,  4726,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,  4175,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0, -1822,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0, -1822,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382, -1822,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
   -1822,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     0,     0,   410,   411, -1822,   413,
       0,     0,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436, -1822,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,     0,     0,   461,   462,   463,     0,     0,
     464,   465,   466,     0,   468,     0,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518, -1822,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,     0,     0,   568,     0,   570,   571,   572,   573,
     574,     0,   575,   576,   577,     0,     0,   578,   579,   580,
     581,   582,     0,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,   601,   602,     0,   603,     0,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,     0,
       0,     0,     0,     0,     0,     0,   858,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1442,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,     0,   859,   260,   860,   861,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   862,   863,   274,     0,   275,   276,   277,   278,
       0,     0,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,     0,     0,     0,   301,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   864,
     865,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   866,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   339,   340,
     341,   342,     0,     0,   344,     0,   345,   346,   347,   867,
     349,     0,   350,     0,   351,   352,   353,     0,   354,   355,
     356,   357,   358,     0,   359,     0,     0,     0,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,  2679,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,  2680,   385,   386,   387,   388,   868,   869,
       0,   870,     0,   392,   393,   394,   395,   396,   871,     0,
       0,     0,     0,     0,     0,   404,   405,   406,   407,   408,
     409,     0,     0,   410,     0,   412,   413,   414,     0,   415,
     416,   417,     0,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   872,   437,   873,   439,   440,   441,   442,   443,
     444,   445,     0,     0,   448,     0,   449,   450,   451,   452,
       0,     0,   454,   874,   456,   457,   458,     0,   459,   460,
       0,     0,   461,   462,   463,     0,     0,   464,   465,  2682,
     467,   468,   469,     0,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,     0,   481,   482,     0,   484,     0,
     486,   487,   488,     0,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   875,   500,   501,   502,   503,     0,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,     0,   517,   518,   519,   520,   521,   522,
     523,   524,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,     0,
     541,   542,  2683,   544,   545,   546,   547,   548,   877,   550,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,     0,   565,     0,   566,   567,     0,
       0,   568,   569,   570,   571,   572,   573,   574,     0,   575,
     878,   879,     0,     0,   578,   579,     0,   581,     0,     0,
     583,   584,   585,   586,   587,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   880,  2684,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,     0,   610,   611,   612,   613,
     614,   615,     0,   858,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   627,   628,   629,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,  2781,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   859,   260,   860,   861,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   862,
     863,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   864,   865,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   867,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,     0,     0,     0,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  2679,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
    2680,   385,   386,   387,   388,   868,   869,     0,   870,     0,
     392,   393,   394,   395,   396,   871,     0,     0,     0,     0,
       0,     0,   404,   405,   406,   407,   408,   409,     0,     0,
     410,     0,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   872,
     437,   873,   439,   440,   441,   442,   443,   444,   445,     0,
       0,   448,     0,   449,   450,   451,   452,     0,     0,   454,
     874,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,  2682,   467,   468,   469,
       0,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,     0,   484,     0,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   875,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,  2683,
     544,   545,   546,   547,   548,   877,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   878,   879,     0,
       0,   578,   579,     0,   581,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     880,  2684,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,     0,
     234,     0,  1250,   696,     0,  1251,  1252,  1253,   757,  1254,
     627,   628,   629,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1255,     0,  3896,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1256,   260,  1257,  1258,     0,   263,   264,   265,   266,   267,
     268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,
     275,   276,   277,   278,  1263,     0,  1264,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,
     305,   306,   307,  1272,  1273,   310,  1274,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   866,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1275,   339,   340,   341,   342,  1276,  1277,   344,     0,
     345,   346,   347,  1278,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,  1279,
       0,  1280,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,  1281,  1282,     0,  1283,     0,   392,   393,   394,
     395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,
     405,   406,   407,   408,   409,     0,     0,   410,  1291,   412,
     413,   414,     0,   415,   416,   417,  1292,  1293,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1294,   437,  1295,   439,
     440,   441,   442,   443,   444,   445,   446,  1296,   448,  1297,
     449,   450,   451,   452,  1298,  1299,   454,  1300,   456,   457,
     458,     0,   459,   460,     0,     0,  1301,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,  1302,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,     0,   481,
     482,  1303,   484,   485,   486,   487,   488,     0,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,  1304,   500,
     501,   502,   503,     0,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,  3233,   517,   518,
     519,   520,   521,   522,   523,   524,  1305,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,    40,   536,   537,
     538,   539,   540,  1306,   541,   542,   543,   544,   545,   546,
     547,   548,  1307,   550,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,  1308,   565,
       0,   566,   567,  1309,    44,   568,   569,   570,   571,   572,
     573,   574,     0,   575,  1310,  1311,     0,     0,   578,   579,
    1312,   581,  1313,  1314,   583,   584,   585,   586,   587,   588,
     589,   590,     0,  1315,   591,   592,   593,   594,   595,  1316,
       0,   596,   597,   598,   599,   600,  1185,  1317,     0,   603,
     604,   605,   606,   607,   608,     0,     0,   609,     0,    49,
     610,   611,   612,   613,   614,   615,   616,  1318,  1319,  1320,
    1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,
       0,  1326,     0,    50,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1327,  1328,     0,     0,     0,   234,     0,
    1250,   696,  1330,  1251,  1252,  1253,   757,  1254,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   243,     0,   244,   245,   246,     0,     0,
       0,     0,  1255,     0,     0,   247,   248,   249,     0,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1256,   260,
    1257,  1258,     0,   263,   264,   265,   266,   267,   268,   269,
    1259,  1260,   270,   271,  1261,  1262,   274,     0,   275,   276,
     277,   278,  1263,     0,  1264,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,     0,   291,   292,   293,
     294,   295,   296,     0,   297,   298,   299,   300,  1265,  1266,
    1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,   306,
     307,  1272,  1273,   310,  1274,   311,     0,   312,   313,   314,
     315,   316,   317,   318,     0,   319,   320,   321,   322,     0,
       0,   323,   324,   866,   326,   327,     0,   328,   329,   330,
       0,   331,   332,   333,     0,   334,   335,   336,   337,  1275,
     339,   340,   341,   342,  1276,  1277,   344,     0,   345,   346,
     347,  1278,   349,     0,   350,     0,   351,   352,   353,     0,
     354,   355,   356,   357,   358,     0,   359,  1279,     0,  1280,
     362,   363,     0,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,   381,     0,   382,   383,   384,   385,   386,   387,   388,
    1281,  1282,     0,  1283,     0,   392,   393,   394,   395,   396,
    1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,   406,
     407,   408,   409,     0,     0,   410,  1291,   412,   413,   414,
       0,   415,   416,   417,  1292,  1293,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1294,   437,  1295,   439,   440,   441,
     442,   443,   444,   445,   446,  1296,   448,  1297,   449,   450,
     451,   452,  1298,  1299,   454,  1300,   456,   457,   458,     0,
     459,   460,     0,     0,  1301,   462,   463,     0,     0,   464,
     465,   466,   467,   468,   469,  1302,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,     0,   481,   482,  1303,
     484,   485,   486,   487,   488,     0,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,  1304,   500,   501,   502,
     503,     0,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,     0,   517,   518,   519,   520,
     521,   522,   523,   524,  1305,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,    40,   536,   537,   538,   539,
     540,  1306,   541,   542,   543,   544,   545,   546,   547,   548,
    1307,   550,     0,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,  1308,   565,     0,   566,
     567,  1309,    44,   568,   569,   570,   571,   572,   573,   574,
       0,   575,  1310,  1311,     0,     0,   578,   579,  1312,   581,
    1313,  1314,   583,   584,   585,   586,   587,   588,   589,   590,
       0,  1315,   591,   592,   593,   594,   595,  1316,     0,   596,
     597,   598,   599,   600,  1185,  1317,     0,   603,   604,   605,
     606,   607,   608,     0,     0,   609,     0,    49,   610,   611,
     612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,   621,
    1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,  1326,
       0,    50,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1327,  1328,     0,     0,     0,   234,     0,  1250,   696,
    1330,  1251,  1252,  1253,   757,  1254,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
    1255,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1256,   260,  1257,  1258,
    3274,   263,   264,   265,   266,   267,   268,   269,  1259,  1260,
     270,   271,  1261,  1262,   274,     0,   275,   276,   277,   278,
    1263,     0,  1264,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,   297,   298,   299,   300,  1265,  1266,  1267,  1268,
    1269,  1270,  1271,   302,   303,   304,   305,   306,   307,  1272,
    1273,   310,  1274,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   866,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,  1275,   339,   340,
     341,   342,  1276,  1277,   344,     0,   345,   346,   347,  1278,
     349,     0,   350,     0,   351,   352,   353,  3275,   354,   355,
     356,   357,   358,     0,   359,  1279,     0,  1280,   362,   363,
       0,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,   383,   384,   385,   386,   387,   388,  1281,  1282,
       0,  1283,     0,   392,   393,   394,   395,   396,  1284,  1285,
    1286,  1287,  1288,  1289,  1290,   404,   405,   406,   407,   408,
     409,     0,  3276,   410,  1291,   412,   413,   414,     0,   415,
     416,   417,  1292,  1293,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1294,   437,  1295,   439,   440,   441,   442,   443,
     444,   445,   446,  1296,   448,  1297,   449,   450,   451,   452,
    1298,  1299,   454,  1300,   456,   457,   458,     0,   459,   460,
       0,     0,  1301,   462,   463,     0,     0,   464,   465,   466,
     467,   468,   469,  1302,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,     0,   481,   482,  1303,   484,   485,
     486,   487,   488,     0,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,  1304,   500,   501,   502,   503,     0,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,     0,   517,   518,   519,   520,   521,   522,
     523,   524,  1305,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,  1306,
     541,   542,   543,   544,   545,   546,   547,   548,  1307,   550,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,  1308,   565,     0,   566,   567,  1309,
       0,   568,   569,   570,   571,   572,   573,   574,     0,   575,
    1310,  1311,     0,  3277,   578,   579,  1312,   581,  1313,  1314,
     583,   584,   585,   586,   587,   588,   589,   590,     0,  1315,
     591,   592,   593,   594,   595,  1316,     0,   596,   597,   598,
     599,   600,   601,  1317,     0,   603,   604,   605,   606,   607,
     608,     0,     0,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,  1318,  1319,  1320,  1321,   621,  1322,  1323,
    1324,  1325,   626,   627,   628,   629,     0,  1326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1327,
    1328,     0,     0,     0,   234,     0,  1250,   696,  1330,  1251,
    1252,  1253,   757,  1254,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
   -2233,   244,   245,   246,     0,     0,     0, -2233,  1255,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1256,   260,  1257,  1258,     0,   263,
     264,   265,   266,   267,   268,   269,  1259,  1260,   270,   271,
    1261,  1262,   274,     0,   275,   276,   277,   278,  1263,     0,
    1264,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,   302,   303,   304,   305,   306,   307,  1272,  1273,   310,
    1274,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   866,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1275,   339,   340,   341,   342,
    1276,  1277,   344,     0,   345,   346,   347,  1278,   349,     0,
     350,     0,   351,   352,   353,     0,   354,   355,   356,   357,
     358,     0,   359,  1279,     0,  1280,   362,   363,     0,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1281,  1282,     0,  1283,
       0,   392,   393,   394,   395,   396,  1284,  1285,  1286,  1287,
    1288,  1289,  1290,   404,   405,   406,   407,   408,   409,     0,
       0,   410,  1291,   412,   413,   414,     0,   415,   416,   417,
    1292,  1293,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1294,   437,  1295,   439,   440,   441,   442,   443,   444,   445,
     446,  1296,   448,  1297,   449,   450,   451,   452,  1298,  1299,
     454,  1300,   456,   457,   458,     0,   459,   460,     0,     0,
    1301,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,  1302,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,  1303,   484,   485,   486,   487,
     488,     0,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,  1304,   500,   501,   502,   503,     0,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,     0,   517,   518,   519,   520,   521,   522,   523,   524,
    1305,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,  1306,   541,   542,
     543,   544,   545,   546,   547,   548,  1307,   550, -2233,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,  1308,   565,     0,   566,   567,  1309,     0,   568,
     569,   570,   571,   572,   573,   574,     0,   575,  1310,  1311,
       0,     0,   578,   579,  1312,   581,  1313,  1314,   583,   584,
     585,   586,   587,   588,   589,   590,     0,  1315,   591,   592,
     593,   594,   595,  1316,     0,   596,   597,   598,   599,   600,
     601,  1317,     0,   603,   604,   605,   606,   607,   608,     0,
       0,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,
     626,   627,   628,   629,     0,  1326,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1327,  1328,     0,
       0,     0,   234,     0,  1250,   696,  1330,  1251,  1252,  1253,
     757,  1254,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243, -2231,   244,
     245,   246,     0,     0,     0, -2231,  1255,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1256,   260,  1257,  1258,     0,   263,   264,   265,
     266,   267,   268,   269,  1259,  1260,   270,   271,  1261,  1262,
     274,     0,   275,   276,   277,   278,  1263,     0,  1264,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,
     303,   304,   305,   306,   307,  1272,  1273,   310,  1274,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   866,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,  1275,   339,   340,   341,   342,  1276,  1277,
     344,     0,   345,   346,   347,  1278,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,  1279,     0,  1280,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,  1281,  1282,     0,  1283,     0,   392,
     393,   394,   395,   396,  1284,  1285,  1286,  1287,  1288,  1289,
    1290,   404,   405,   406,   407,   408,   409,     0,     0,   410,
    1291,   412,   413,   414,     0,   415,   416,   417,  1292,  1293,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1294,   437,
    1295,   439,   440,   441,   442,   443,   444,   445,   446,  1296,
     448,  1297,   449,   450,   451,   452,  1298,  1299,   454,  1300,
     456,   457,   458,     0,   459,   460,     0,     0,  1301,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,  1302,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,  1303,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
    1304,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,  1305,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,  1306,   541,   542,   543,   544,
     545,   546,   547,   548,  1307,   550, -2231,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
    1308,   565,     0,   566,   567,  1309,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,  1310,  1311,     0,     0,
     578,   579,  1312,   581,  1313,  1314,   583,   584,   585,   586,
     587,   588,   589,   590,     0,  1315,   591,   592,   593,   594,
     595,  1316,     0,   596,   597,   598,   599,   600,   601,  1317,
       0,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,  1318,
    1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,   626,   627,
     628,   629,     0,  1326,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1327,  1328,     0,     0,     0,
     234,     0,  1250,   696,  1330,  1251,  1252,  1253,   757,  1254,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,   243,     0,   244,   245,   246,
       0,     0,     0,     0,  1255,     0,     0,   247,   248,   249,
       0,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1256,   260,  1257,  1258,     0,   263,   264,   265,   266,   267,
     268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,
     275,   276,   277,   278,  1263,     0,  1264,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,     0,   291,
     292,   293,   294,   295,   296,     0,   297,   298,   299,   300,
    1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,
     305,   306,   307,  1272,  1273,   310,  1274,   311,     0,   312,
     313,   314,   315,   316,   317,   318,     0,   319,   320,   321,
     322,     0,     0,   323,   324,   866,   326,   327,     0,   328,
     329,   330,     0,   331,   332,   333,     0,   334,   335,   336,
     337,  1275,   339,   340,   341,   342,  1276,  1277,   344,     0,
     345,   346,   347,  1278,   349,     0,   350,     0,   351,   352,
     353,     0,   354,   355,   356,   357,   358,     0,   359,  1279,
       0,  1280,   362,   363,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,   381,     0,   382,   383,   384,   385,   386,
     387,   388,  1281,  1282,     0,  1283,     0,   392,   393,   394,
     395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,
     405,   406,   407,   408,   409,     0,     0,   410,  1291,   412,
     413,   414,     0,   415,   416,   417,  1292,  1293,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1294,   437,  1295,   439,
     440,   441,   442,   443,   444,   445,   446,  1296,   448,  1297,
     449,   450,   451,   452,  1298,  1299,   454,  1300,   456,   457,
     458,     0,   459,   460,     0,     0,  1301,   462,   463,     0,
       0,   464,   465,   466,   467,   468,   469,  1302,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,     0,   481,
     482,  1303,   484,   485,   486,   487,   488,     0,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,  1304,   500,
     501,   502,   503,     0,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,     0,   517,   518,
     519,   520,   521,   522,   523,   524,  1305,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,  1306,   541,   542,   543,   544,   545,   546,
     547,   548,  1307,   550,     0,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,  1308,   565,
       0,   566,   567,  1309,     0,   568,   569,   570,   571,   572,
     573,   574,     0,   575,  1310,  1311,     0,     0,   578,   579,
    1312,   581,  1313,  1314,   583,   584,   585,   586,   587,   588,
     589,   590,     0,  1315,   591,   592,   593,   594,   595,  1316,
       0,   596,   597,   598,   599,   600,   601,  1317,     0,   603,
     604,   605,   606,   607,   608,     0,     0,   609,     0,     0,
     610,   611,   612,   613,   614,   615,   616,  1318,  1319,  1320,
    1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,
       0,  1326,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1327,  1328,     0,     0,     0,     0,     0,
    2025,  3207,  1330,   234,     0,  1250,   696,     0,  1251,  1252,
    1253,   757,  1254,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1255,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1256,   260,  1257,  1258,     0,   263,   264,
     265,   266,   267,   268,   269,  1259,  1260,   270,   271,  1261,
    1262,   274,     0,   275,   276,   277,   278,  1263,     0,  1264,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
     302,   303,   304,   305,   306,   307,  1272,  1273,   310,  1274,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1275,   339,   340,   341,   342,  1276,
    1277,   344,     0,   345,   346,   347,  1278,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1279,     0,  1280,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1281,  1282,     0,  1283,     0,
     392,   393,   394,   395,   396,  1284,  1285,  1286,  1287,  1288,
    1289,  1290,   404,   405,   406,   407,   408,   409,     0,     0,
     410,  1291,   412,   413,   414,     0,   415,   416,   417,  1292,
    1293,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1294,
     437,  1295,   439,   440,   441,   442,   443,   444,   445,   446,
    1296,   448,  1297,   449,   450,   451,   452,  1298,  1299,   454,
    1300,   456,   457,   458,     0,   459,   460,     0,     0,  1301,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
    1302,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,  1303,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,  1304,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,  1305,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,  1306,   541,   542,   543,
     544,   545,   546,   547,   548,  1307,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,  1308,   565,     0,   566,   567,  1309,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,  1310,  1311,     0,
       0,   578,   579,  1312,   581,  1313,  1314,   583,   584,   585,
     586,   587,   588,   589,   590,     0,  1315,   591,   592,   593,
     594,   595,  1316,     0,   596,   597,   598,   599,   600,   601,
    1317,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
    1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,   626,
     627,   628,   629,     0,  1326,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1327,  1328,  1329,     0,
       0,   234,     0,  1250,   696,  1330,  1251,  1252,  1253,   757,
    1254,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,  2646,   244,   245,
     246,     0,     0,     0,     0,  1255,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1256,   260,  1257,  1258,     0,   263,   264,   265,   266,
     267,   268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,
       0,   275,   276,   277,   278,  1263,     0,  1264,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,
     304,   305,   306,   307,  1272,  1273,   310,  1274,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   866,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1275,   339,   340,   341,   342,  1276,  1277,   344,
       0,   345,   346,   347,  1278,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1279,     0,  1280,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1281,  1282,     0,  1283,     0,   392,   393,
     394,   395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,
     404,   405,   406,   407,   408,   409,     0,     0,   410,  1291,
     412,   413,   414,     0,   415,   416,   417,  1292,  1293,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1294,   437,  1295,
     439,   440,   441,   442,   443,   444,   445,   446,  1296,   448,
    1297,   449,   450,   451,   452,  1298,  1299,   454,  1300,   456,
     457,   458,     0,   459,   460,     0,     0,  1301,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,  1302,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,  1303,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,  1304,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,  1305,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,  1306,   541,   542,   543,   544,   545,
     546,   547,   548,  1307,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,  1308,
     565,     0,   566,   567,  1309,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,  1310,  1311,     0,     0,   578,
     579,  1312,   581,  1313,  1314,   583,   584,   585,   586,   587,
     588,   589,   590,     0,  1315,   591,   592,   593,   594,   595,
    1316,     0,   596,   597,   598,   599,   600,   601,  1317,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,  1318,  1319,
    1320,  1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,
     629,     0,  1326,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1327,  1328,     0,     0,     0,   234,
       0,  1250,   696,  1330,  1251,  1252,  1253,   757,  1254,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1255,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1256,
     260,  1257,  1258,     0,   263,   264,   265,   266,   267,   268,
     269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,   275,
     276,   277,   278,  1263,     0,  1264,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,
     306,   307,  1272,  1273,   310,  1274,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   866,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1275,   339,   340,   341,   342,  1276,  1277,   344,     0,   345,
     346,   347,  1278,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1279,     0,
    1280,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1281,  1282,     0,  1283,     0,   392,   393,   394,   395,
     396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,
     406,   407,   408,   409,     0,     0,   410,  1291,   412,   413,
     414,     0,   415,   416,   417,  1292,  1293,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1294,   437,  1295,   439,   440,
     441,   442,   443,   444,   445,   446,  1296,   448,  1297,   449,
     450,   451,   452,  1298,  1299,   454,  1300,   456,   457,   458,
       0,   459,   460,     0,     0,  1301,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,  1302,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
    1303,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1304,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,  3233,   517,   518,   519,
     520,   521,   522,   523,   524,  1305,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,  1306,   541,   542,   543,   544,   545,   546,   547,
     548,  1307,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,  1308,   565,     0,
     566,   567,  1309,     0,   568,   569,   570,   571,   572,   573,
     574,     0,   575,  1310,  1311,     0,     0,   578,   579,  1312,
     581,  1313,  1314,   583,   584,   585,   586,   587,   588,   589,
     590,     0,  1315,   591,   592,   593,   594,   595,  1316,     0,
     596,   597,   598,   599,   600,   601,  1317,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,
     621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,
    1326,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1327,  1328,     0,     0,     0,   234,     0,  1250,
     696,  1330,  1251,  1252,  1253,   757,  1254,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1255,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1256,   260,  1257,
    1258,     0,   263,   264,   265,   266,   267,   268,   269,  1259,
    1260,   270,   271,  1261,  1262,   274,     0,   275,   276,   277,
     278,  1263,     0,  1264,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,   302,   303,   304,   305,   306,   307,
    1272,  1273,   310,  1274,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   866,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1275,   339,
     340,   341,   342,  1276,  1277,   344,     0,   345,   346,   347,
    1278,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1279,     0,  1280,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1281,
    1282,     0,  1283,     0,   392,   393,   394,   395,   396,  1284,
    1285,  1286,  1287,  1288,  1289,  1290,   404,   405,   406,   407,
     408,   409,     0,     0,   410,  1291,   412,   413,   414,     0,
     415,   416,   417,  1292,  1293,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,  1294,   437,  1295,   439,   440,   441,   442,
     443,   444,   445,   446,  1296,   448,  1297,   449,   450,   451,
     452,  1298,  1299,   454,  1300,   456,   457,   458,     0,   459,
     460,     0,     0,  1301,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,  1302,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,  1303,   484,
     485,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,  1304,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,   519,   520,   521,
     522,   523,   524,  1305,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
    1306,   541,   542,   543,   544,   545,   546,   547,   548,  1307,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,  1308,   565,     0,   566,   567,
    1309,     0,   568,   569,   570,   571,   572,   573,   574,     0,
     575,  1310,  1311,     0,     0,   578,   579,  1312,   581,  1313,
    1314,   583,   584,   585,   586,   587,   588,   589,   590,     0,
    1315,   591,   592,   593,   594,   595,  1316,     0,   596,   597,
     598,   599,   600,   601,  1317,  3775,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,  1318,  1319,  1320,  1321,   621,  1322,
    1323,  1324,  1325,   626,   627,   628,   629,     0,  1326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1327,  1328,     0,     0,     0,   234,     0,  1250,   696,  1330,
    1251,  1252,  1253,   757,  1254,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1255,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1256,   260,  1257,  1258,     0,
     263,   264,   265,   266,   267,   268,   269,  1259,  1260,   270,
     271,  1261,  1262,   274,     0,   275,   276,   277,   278,  1263,
       0,  1264,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,   302,   303,   304,   305,   306,   307,  1272,  1273,
     310,  1274,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     866,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1275,   339,   340,   341,
     342,  1276,  1277,   344,     0,   345,   346,   347,  1278,   349,
       0,   350,     0,   351,   352,   353,  3275,   354,   355,   356,
     357,   358,     0,   359,  1279,     0,  1280,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1281,  1282,     0,
    1283,     0,   392,   393,   394,   395,   396,  1284,  1285,  1286,
    1287,  1288,  1289,  1290,   404,   405,   406,   407,   408,   409,
       0,     0,   410,  1291,   412,   413,   414,     0,   415,   416,
     417,  1292,  1293,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,  1294,   437,  1295,   439,   440,   441,   442,   443,   444,
     445,   446,  1296,   448,  1297,   449,   450,   451,   452,  1298,
    1299,   454,  1300,   456,   457,   458,     0,   459,   460,     0,
       0,  1301,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,  1302,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,  1303,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,  1304,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,  1305,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,  1306,   541,
     542,   543,   544,   545,   546,   547,   548,  1307,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,  1308,   565,     0,   566,   567,  1309,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,  1310,
    1311,     0,     0,   578,   579,  1312,   581,  1313,  1314,   583,
     584,   585,   586,   587,   588,   589,   590,     0,  1315,   591,
     592,   593,   594,   595,  1316,     0,   596,   597,   598,   599,
     600,   601,  1317,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,
    1325,   626,   627,   628,   629,     0,  1326,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1327,  1328,
       0,     0,     0,   234,     0,  1250,   696,  1330,  1251,  1252,
    1253,   757,  1254,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1255,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1256,   260,  1257,  1258,     0,   263,   264,
     265,   266,   267,   268,   269,  1259,  1260,   270,   271,  1261,
    1262,   274,     0,   275,   276,   277,   278,  1263,     0,  1264,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
     302,   303,   304,   305,   306,   307,  1272,  1273,   310,  1274,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1275,   339,   340,   341,   342,  1276,
    1277,   344,     0,   345,   346,   347,  1278,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1279,     0,  1280,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1281,  1282,     0,  1283,     0,
     392,   393,   394,   395,   396,  1284,  1285,  1286,  1287,  1288,
    1289,  1290,   404,   405,   406,   407,   408,   409,     0,     0,
     410,  1291,   412,   413,   414,     0,   415,   416,   417,  1292,
    1293,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1294,
     437,  1295,   439,   440,   441,   442,   443,   444,   445,   446,
    1296,   448,  1297,   449,   450,   451,   452,  1298,  1299,   454,
    1300,   456,   457,   458,     0,   459,   460,     0,     0,  1301,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
    1302,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,  1303,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,  1304,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,  1305,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,  1306,   541,   542,   543,
     544,   545,   546,   547,   548,  1307,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,  1308,   565,     0,   566,   567,  1309,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,  1310,  1311,  3332,
       0,   578,   579,  1312,   581,  1313,  1314,   583,   584,   585,
     586,   587,   588,   589,   590,     0,  1315,   591,   592,   593,
     594,   595,  1316,     0,   596,   597,   598,   599,   600,   601,
    1317,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
    1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,   626,
     627,   628,   629,     0,  1326,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1327,  1328,     0,     0,
       0,   234,     0,  1250,   696,  1330,  1251,  1252,  1253,   757,
    1254,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1255,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1256,   260,  1257,  1258,     0,   263,   264,   265,   266,
     267,   268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,
       0,   275,   276,   277,   278,  1263,     0,  1264,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,
     304,   305,   306,   307,  1272,  1273,   310,  1274,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   866,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1275,   339,   340,   341,   342,  1276,  1277,   344,
       0,   345,   346,   347,  1278,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1279,     0,  1280,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1281,  1282,     0,  1283,     0,   392,   393,
     394,   395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,
     404,   405,   406,   407,   408,   409,     0,     0,   410,  1291,
     412,   413,   414,     0,   415,   416,   417,  1292,  1293,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1294,   437,  1295,
     439,   440,   441,   442,   443,   444,   445,   446,  1296,   448,
    1297,   449,   450,   451,   452,  1298,  1299,   454,  1300,   456,
     457,   458,     0,   459,   460,     0,     0,  1301,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,  1302,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,  1303,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,  1304,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,  1305,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,  1306,   541,   542,   543,   544,   545,
     546,   547,   548,  1307,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,  1308,
     565,     0,   566,   567,  1309,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,  1310,  1311,     0,     0,   578,
     579,  1312,   581,  1313,  1314,   583,   584,   585,   586,   587,
     588,   589,   590,     0,  1315,   591,   592,   593,   594,   595,
    1316,     0,   596,   597,   598,   599,   600,   601,  1317,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,  1318,  1319,
    1320,  1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,
     629,     0,  1326,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1327,  1328,     0,     0,     0,   234,
       0,  1250,   696,  1330,  1251,  1252,  1253,   757,  1254,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1255,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1256,
     260,  1257,  1258,     0,   263,   264,   265,   266,   267,   268,
     269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,   275,
     276,   277,   278,  1263,     0,  1264,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,
     306,   307,  1272,  1273,   310,  1274,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   866,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1275,   339,   340,   341,   342,  1276,  1277,   344,     0,   345,
     346,   347,  1278,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1279,     0,
    1280,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1281,  1282,     0,  1283,     0,   392,   393,   394,   395,
     396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,
     406,   407,   408,   409,     0,     0,   410,  1291,   412,   413,
     414,     0,   415,   416,   417,  1292,  1293,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1294,   437,  1295,   439,   440,
     441,   442,   443,   444,   445,   446,  1296,   448,  1297,   449,
     450,   451,   452,  1298,  1299,   454,  1300,   456,   457,   458,
       0,   459,   460,     0,     0,  1301,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,  1302,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
    1303,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1304,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,   522,   523,   524,  1305,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,  1306,   541,   542,   543,   544,   545,   546,   547,
     548,  1307,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,  1308,   565,     0,
     566,   567,  1309,     0,   568,   569,   570,   571,   572,   573,
     574,     0,   575,  1310,  1311,     0,     0,   578,   579,  1312,
     581,  1313,  1314,   583,   584,   585,   586,   587,   588,   589,
     590,     0,  1315,   591,   592,   593,   594,   595,  1316,     0,
     596,   597,   598,   599,   600,   601,  1317,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,
     621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,
    1326,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2649,  2650,     0,     0,     0,   234,     0,  3449,
     696,  1330,  1251,  1252,  1253,   757,  1254,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1255,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,  1256,   260,  1257,
    1258,     0,   263,   264,   265,   266,   267,   268,   269,  1259,
    1260,   270,   271,  1261,  1262,   274,     0,   275,   276,   277,
     278,  1263,     0,  1264,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,   302,   303,   304,   305,   306,   307,
    1272,  1273,   310,  1274,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   866,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1275,   339,
     340,   341,   342,  1276,  1277,   344,     0,   345,   346,   347,
    1278,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1279,     0,  1280,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1281,
    1282,     0,  1283,     0,   392,   393,   394,   395,   396,  1284,
    1285,  1286,  1287,  1288,  1289,  1290,   404,   405,   406,   407,
     408,   409,     0,     0,   410,  1291,   412,   413,   414,     0,
     415,   416,   417,  1292,  1293,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,  1294,   437,  1295,   439,   440,   441,   442,
     443,   444,   445,   446,  1296,   448,  1297,   449,   450,   451,
     452,  1298,  1299,   454,  1300,   456,   457,   458,     0,   459,
     460,     0,     0,  1301,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,  1302,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,  1303,   484,
     485,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,  1304,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,   519,   520,   521,
     522,   523,   524,  1305,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
    1306,   541,   542,   543,   544,   545,   546,   547,   548,  1307,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,  1308,   565,     0,   566,   567,
    1309,     0,   568,   569,   570,   571,   572,   573,   574,     0,
     575,  1310,  1311,     0,     0,   578,   579,  1312,   581,  1313,
    1314,   583,   584,   585,   586,   587,   588,   589,   590,     0,
    1315,   591,   592,   593,   594,   595,  1316,     0,   596,   597,
     598,   599,   600,   601,  1317,     0,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,  1318,  1319,  1320,  1321,   621,  1322,
    1323,  1324,  1325,   626,   627,   628,   629,     0,  1326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1327,  1328,     0,     0,     0,   234,     0,  1250,   696,  1330,
    1251,  1252,  1253,   757,  1254,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1255,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1256,   260,  1257,  1258,     0,
     263,   264,   265,   266,   267,   268,   269,  1259,  1260,   270,
     271,  1261,  1262,   274,     0,   275,   276,   277,   278,  1263,
       0,  1264,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,  4780,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,   302,   303,   304,   305,   306,   307,  1272,  1273,
     310,  1274,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     866,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1275,   339,   340,   341,
     342,  1276,  1277,   344,     0,   345,   346,   347,  1278,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,  1279,     0,  1280,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1281,  1282,     0,
    1283,     0,   392,   393,   394,   395,   396,  1284,  1285,  1286,
    1287,  1288,  1289,  1290,   404,   405,   406,   407,   408,   409,
       0,     0,   410,  1291,   412,   413,   414,     0,   415,   416,
     417,  1292,  1293,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,  1294,   437,  1295,   439,   440,   441,   442,   443,   444,
     445,   446,  1296,   448,  1297,   449,   450,   451,   452,  1298,
    1299,   454,  1300,   456,   457,   458,     0,   459,   460,     0,
       0,  1301,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,  1302,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,  1303,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,  1304,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,  1305,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,  1306,   541,
     542,   543,   544,   545,   546,   547,   548,  1307,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,  1308,   565,     0,   566,   567,  1309,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,  1310,
    1311,     0,     0,   578,   579,  1312,   581,  1313,  1314,   583,
     584,   585,   586,   587,   588,   589,   590,     0,  1315,   591,
     592,   593,   594,   595,  1316,     0,   596,   597,   598,   599,
     600,   601,  1317,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,
    1325,   626,   627,   628,   629,     0,  1326,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1327,  1328,
       0,     0,     0,   234,     0,  1250,   696,  1330,  1251,  1252,
    1253,   757,  1254,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1255,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1256,   260,  1257,  1258,     0,   263,   264,
     265,   266,   267,   268,   269,  1259,  1260,   270,   271,  1261,
    1262,   274,     0,   275,   276,   277,   278,  1263,     0,  1264,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
     302,   303,   304,   305,   306,   307,  1272,  1273,   310,  1274,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1275,   339,   340,   341,   342,  1276,
    1277,   344,     0,   345,   346,   347,  1278,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1279,     0,  1280,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1281,  1282,     0,  1283,     0,
     392,   393,   394,   395,   396,  1284,  1285,  1286,  1287,  1288,
    1289,  1290,   404,   405,   406,   407,   408,   409,     0,     0,
     410,  1291,   412,   413,   414,     0,   415,   416,   417,  1292,
    1293,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1294,
     437,  1295,   439,   440,   441,   442,   443,   444,   445,   446,
    1296,   448,  1297,   449,   450,   451,   452,  1298,  1299,   454,
    1300,   456,   457,   458,     0,   459,   460,     0,     0,  1301,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
    1302,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,  1303,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,  1304,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,  1305,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,  1306,   541,   542,   543,
     544,   545,   546,   547,   548,  1307,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,  1308,   565,     0,   566,   567,  1309,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,  1310,  1311,     0,
       0,   578,   579,  1312,   581,  1313,  1314,   583,   584,   585,
     586,   587,   588,   589,   590,     0,  1315,   591,   592,   593,
     594,   595,  1316,     0,   596,   597,   598,   599,   600,   601,
    1317,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,  5158,
    1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,   626,
     627,   628,   629,     0,  1326,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1327,  1328,     0,     0,
       0,   234,     0,  1250,   696,  1330,  1251,  1252,  1253,   757,
    1254,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1255,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1256,   260,  1257,  1258,     0,   263,   264,   265,   266,
     267,   268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,
       0,   275,   276,   277,   278,  1263,     0,  1264,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,
     304,   305,   306,   307,  1272,  1273,   310,  1274,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   866,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1275,   339,   340,   341,   342,  1276,  1277,   344,
       0,   345,   346,   347,  1278,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1279,     0,  1280,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1281,  1282,     0,  1283,     0,   392,   393,
     394,   395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,
     404,   405,   406,   407,   408,   409,     0,     0,   410,  1291,
     412,   413,   414,     0,   415,   416,   417,  1292,  1293,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1294,   437,  1295,
     439,   440,   441,   442,   443,   444,  5170,   446,  1296,   448,
    1297,   449,   450,   451,   452,  1298,  1299,   454,  1300,   456,
     457,   458,     0,   459,   460,     0,     0,  1301,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,  1302,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,  1303,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,  1304,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,  1305,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,  1306,   541,   542,   543,   544,   545,
     546,   547,   548,  1307,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,  1308,
     565,     0,   566,   567,  1309,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,  1310,  1311,     0,     0,   578,
     579,  1312,   581,  1313,  1314,   583,   584,   585,   586,   587,
     588,   589,   590,     0,  1315,   591,   592,   593,   594,   595,
    1316,     0,   596,   597,   598,   599,   600,   601,  1317,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,  1318,  1319,
    1320,  1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,
     629,     0,  1326,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1327,  1328,     0,     0,     0,   234,
       0,  1250,   696,  1330,  1251,  1252,  1253,   757,  1254,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1255,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1256,
     260,  1257,  1258,     0,   263,   264,   265,   266,   267,   268,
     269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,   275,
     276,   277,   278,  1263,     0,  1264,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,  5492,   300,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,
     306,   307,  1272,  1273,   310,  1274,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   866,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1275,   339,   340,   341,   342,  1276,  1277,   344,     0,   345,
     346,   347,  1278,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1279,     0,
    5493,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1281,  1282,     0,  1283,     0,   392,   393,   394,   395,
     396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,
     406,   407,   408,   409,     0,     0,   410,  1291,   412,   413,
     414,     0,   415,   416,   417,  1292,  1293,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1294,   437,  1295,   439,   440,
     441,   442,   443,   444,   445,   446,  1296,   448,  1297,   449,
     450,   451,   452,  1298,  1299,   454,  1300,   456,   457,   458,
       0,   459,   460,     0,     0,  1301,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,  1302,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
    1303,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1304,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,  5494,   523,   524,  1305,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,  1306,   541,   542,   543,   544,   545,   546,   547,
     548,  1307,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,  1308,   565,     0,
     566,   567,  1309,     0,   568,   569,   570,   571,   572,   573,
     574,     0,   575,  1310,  1311,     0,     0,   578,   579,  1312,
     581,  1313,  1314,   583,   584,   585,   586,   587,   588,   589,
     590,     0,  1315,   591,   592,   593,   594,   595,  1316,     0,
     596,   597,   598,   599,   600,   601,  1317,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,
     621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,
    1326,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1327,  1328,     0,     0,     0,   234,     0,  1250,
     696,  5495,  1251,  1252,  1253,   757,  1254,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,  1255,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,  5870,  1256,   260,  1257,
    1258,     0,   263,   264,   265,   266,   267,   268,   269,  1259,
    1260,   270,   271,  1261,  1262,   274,     0,   275,   276,   277,
     278,  1263,     0,  1264,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,  5871,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,   302,   303,   304,   305,   306,   307,
    1272,  1273,   310,  1274,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   866,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,  1275,   339,
     340,   341,   342,  1276,  1277,   344,     0,   345,   346,   347,
    1278,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1279,     0,  1280,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,  1281,
    1282,     0,  1283,     0,   392,   393,   394,   395,   396,  1284,
    1285,  1286,  1287,  1288,  1289,  1290,   404,   405,   406,   407,
     408,   409,     0,     0,   410,  1291,   412,   413,   414,     0,
     415,   416,   417,  1292,  1293,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,  1294,   437,  1295,   439,   440,   441,   442,
     443,   444,   445,   446,  1296,   448,  1297,   449,   450,   451,
     452,  1298,  1299,   454,  1300,   456,   457,   458,     0,   459,
     460,     0,     0,  1301,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,  1302,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,  1303,   484,
     485,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,  1304,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,   519,   520,   521,
     522,   523,   524,  1305,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
    1306,   541,   542,   543,   544,   545,   546,   547,   548,  1307,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,  1308,   565,     0,   566,   567,
    1309,     0,   568,   569,   570,   571,   572,   573,   574,     0,
     575,  1310,  1311,     0,     0,   578,   579,  1312,   581,  1313,
    1314,   583,   584,   585,   586,   587,  5872,   589,   590,     0,
    1315,   591,   592,   593,   594,   595,  1316,     0,   596,   597,
     598,   599,   600,   601,  1317,     0,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,  1318,  1319,  1320,  1321,   621,  1322,
    1323,  1324,  1325,   626,   627,   628,   629,     0,  1326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1327,  1328,     0,     0,     0,   234,     0,  1250,   696,  1330,
    1251,  1252,  1253,   757,  1254,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1255,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1256,   260,  1257,  1258,     0,
     263,   264,   265,   266,   267,   268,   269,  1259,  1260,   270,
     271,  1261,  1262,   274,     0,   275,   276,   277,   278,  1263,
       0,  1264,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,  5871,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,   302,   303,   304,   305,   306,   307,  1272,  1273,
     310,  1274,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     866,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1275,   339,   340,   341,
     342,  1276,  1277,   344,     0,   345,   346,   347,  1278,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,  1279,     0,  1280,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1281,  1282,     0,
    1283,     0,   392,   393,   394,   395,   396,  1284,  1285,  1286,
    1287,  1288,  1289,  1290,   404,   405,   406,   407,   408,   409,
       0,     0,   410,  1291,   412,   413,   414,     0,   415,   416,
     417,  1292,  1293,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,  1294,   437,  1295,   439,   440,   441,   442,   443,   444,
     445,   446,  1296,   448,  1297,   449,   450,   451,   452,  1298,
    1299,   454,  1300,   456,   457,   458,     0,   459,   460,     0,
       0,  1301,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,  1302,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,  1303,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,  1304,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,  1305,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,  1306,   541,
     542,   543,   544,   545,   546,   547,   548,  1307,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,  1308,   565,     0,   566,   567,  1309,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,  1310,
    1311,     0,     0,   578,   579,  1312,   581,  1313,  1314,   583,
     584,   585,   586,   587,  5872,   589,   590,     0,  1315,   591,
     592,   593,   594,   595,  1316,     0,   596,   597,   598,   599,
     600,   601,  1317,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,
    1325,   626,   627,   628,   629,     0,  1326,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1327,  1328,
       0,     0,     0,   234,     0,  1250,   696,  1330,  1251,  1252,
    1253,   757,  1254,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,  1255,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1256,   260,  1257,  1258,     0,   263,   264,
     265,   266,   267,   268,   269,  1259,  1260,   270,   271,  1261,
    1262,   274,     0,   275,   276,   277,   278,  1263,     0,  1264,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
     302,   303,   304,   305,   306,   307,  1272,  1273,   310,  5477,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,  1275,   339,   340,   341,   342,  1276,
    1277,   344,     0,   345,   346,   347,  1278,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1279,     0,  1280,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1281,  1282,     0,  1283,     0,
     392,   393,   394,   395,   396,  1284,  1285,  1286,  1287,  1288,
    1289,  1290,   404,   405,   406,   407,   408,   409,     0,     0,
     410,  1291,   412,   413,   414,     0,   415,   416,   417,  1292,
    1293,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1294,
     437,  1295,   439,   440,   441,   442,   443,   444,   445,   446,
    1296,   448,     0,   449,   450,   451,   452,  1298,  1299,   454,
    1300,   456,   457,   458,     0,   459,   460,     0,     0,  1301,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
    1302,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,  1303,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,  1304,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,  3260,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,  1306,   541,   542,   543,
     544,   545,   546,   547,   548,  1307,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,  1308,   565,     0,   566,   567,  1309,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,  1310,  1311,     0,
       0,   578,   579,  1312,   581,  1313,  1314,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  1316,     0,   596,   597,   598,   599,   600,   601,
    1317,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
    1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,   626,
     627,   628,   629,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3261,  3262,     0,     0,
       0,   234,     0,  1250,   696,  3263,  1251,  1252,  1253,   757,
    1254,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1255,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
   -2903,  1256,   260,  1257,  1258,     0,   263,   264,   265,   266,
     267,   268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,
       0,   275,   276,   277,   278,  1263,     0,  1264,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
    5871,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,
     304,   305,   306,   307,  1272,  1273,   310,  1274,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   866,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1275,   339,   340,   341,   342,  1276,  1277,   344,
       0,   345,   346,   347,  1278,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1279,     0,  1280,   362,   363,     0,   364,   365,   366,   367,
     368, -2903,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1281,  1282,     0,  1283,     0,   392,     0,
       0,   395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,
     404,   405,   406,   407,   408,   409,     0,     0,   410,  1291,
     412,   413, -2903,     0,   415,   416,   417,  1292,  1293,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1294,   437,  1295,
     439,   440,   441,   442,   443,   444,   445,   446,  1296,   448,
    1297,   449,   450,     0,   452,  1298,  1299,   454,  1300,   456,
     457,   458,     0,   459,   460,     0,     0,  1301,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,  1302,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,  1303,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,  1304,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,  1305,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,  1306,   541,   542,   543,   544,   545,
   -2903,   547,   548,  1307,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,  1308,
     565,     0,   566,   567,  1309,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,  1310,  1311,     0,     0,   578,
     579,  1312,   581,  1313,  1314,   583,   584,   585,   586,   587,
    5872,   589,   590,     0,  1315,   591,   592,   593,   594,   595,
    1316,     0,   596,   597,   598,   599,   600,   601,  1317,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,  1318,  1319,
    1320,  1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,
     629,     0, -2903,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1327,  1328,     0,     0,     0,   234,
       0,  1250,   696,  1330,  1251,  1252,  1253,   757,  1254,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1255,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1256,
     260,  1257,  1258,     0,   263,   264,   265,   266,   267,   268,
     269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,   275,
     276,   277,   278,  1263,     0,  1264,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,
     306,   307,  1272,  1273,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   866,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1275,   339,   340,   341,   342,  1276,  1277,   344,     0,   345,
     346,   347,  1278,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1279,     0,
    1280,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1281,  1282,     0,  1283,     0,   392,   393,   394,   395,
     396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,
     406,   407,   408,   409,     0,     0,   410,  1291,   412,   413,
     414,     0,   415,   416,   417,  1292,  1293,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1294,   437,  1295,   439,   440,
     441,   442,   443,   444,   445,   446,  1296,   448,     0,   449,
     450,   451,   452,  1298,  1299,   454,  1300,   456,   457,   458,
       0,   459,   460,     0,     0,  1301,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,  1302,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
    1303,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1304,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,   522,   523,   524,  3260,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,  1306,   541,   542,   543,   544,   545,   546,   547,
     548,  1307,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,  1308,   565,     0,
     566,   567,  1309,     0,   568,   569,   570,   571,   572,   573,
     574,     0,   575,  1310,  1311,     0,     0,   578,   579,  1312,
     581,  1313,  1314,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,  1316,     0,
     596,   597,   598,   599,   600,   601,  1317,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,
     621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3261,  3262,   234,     0,  1250,   696,     0,  1251,
    1252,  3263,   757,  1254,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,  1255,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1256,   260,  1257,  1258,     0,   263,
     264,   265,   266,   267,   268,   269,  1259,  1260,   270,   271,
    1261,  1262,   274,     0,   275,   276,   277,   278,  1263,     0,
    1264,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
     297,   298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,   302,   303,   304,   305,   306,   307,  1272,  1273,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   866,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,  1275,   339,   340,   341,   342,
    1276,  1277,   344,     0,   345,   346,   347,  1278,   349,     0,
     350,     0,   351,   352,   353,     0,   354,   355,   356,   357,
     358,     0,   359,  1279,     0,  1280,   362,   363,     0,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,     0,   382,
     383,   384,   385,   386,   387,   388,  1281,  1282,     0,  1283,
       0,   392,   393,   394,   395,   396,  1284,  1285,  1286,  1287,
    1288,  1289,  1290,   404,   405,   406,   407,   408,   409,     0,
       0,   410,  1291,   412,   413,   414,     0,   415,   416,   417,
    1292,  1293,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
    1294,   437,  1295,   439,   440,   441,   442,   443,   444,   445,
     446,  1296,   448,     0,   449,   450,   451,   452,  1298,  1299,
     454,  1300,   456,   457,   458,     0,   459,   460,     0,     0,
     461,   462,   463,     0,     0,   464,   465,   466,   467,   468,
     469,  1302,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,  1303,   484,   485,   486,   487,
     488,     0,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,  1304,   500,   501,   502,   503,     0,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,     0,   517,   518,   519,   520,   521,   522,   523,   524,
    3438,  3439,   527,   528,   529,   530,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,  1306,   541,   542,
     543,   544,   545,   546,   547,   548,  1307,   550,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,  1308,   565,     0,   566,   567,  1309,     0,   568,
     569,   570,   571,   572,   573,   574,     0,   575,  1310,  1311,
       0,     0,   578,   579,  1312,   581,  1313,  1314,   583,   584,
     585,   586,   587,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,  1316,     0,   596,   597,   598,   599,   600,
     601,  1317,     0,   603,   604,   605,   606,   607,   608,     0,
       0,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,
     626,   627,   628,   629,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3440,  3441,   234,
       0,  1250,   696,     0,  1251,  1252,  3263,   757,  1254,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,  1255,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,  1256,
     260,  1257,  1258,     0,   263,   264,   265,   266,   267,   268,
     269,  1259,  1260,   270,   271,  1261,  1262,   274,     0,   275,
     276,   277,   278,  1263,     0,  1264,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,
     306,   307,  1272,  1273,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   866,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
    1275,   339,   340,   341,   342,  1276,  1277,   344,     0,   345,
     346,   347,  1278,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1279,     0,
    1280,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,  1281,  1282,     0,  1283,     0,   392,   393,   394,   395,
     396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,
     406,   407,   408,   409,     0,     0,   410,  1291,   412,   413,
     414,     0,   415,   416,   417,  1292,  1293,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,  1294,   437,  1295,   439,   440,
     441,   442,   443,   444,   445,   446,  1296,   448,     0,   449,
     450,   451,   452,  1298,  1299,   454,  1300,   456,   457,   458,
       0,   459,   460,     0,     0,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,  1302,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
    1303,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1304,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,   522,   523,   524,  3260,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,  1306,   541,   542,   543,   544,   545,   546,   547,
     548,  1307,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,  1308,   565,     0,
     566,   567,  1309,     0,   568,   569,   570,   571,   572,   573,
     574,     0,   575,  1310,  1311,     0,     0,   578,   579,  1312,
     581,  1313,  1314,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,  1316,     0,
     596,   597,   598,   599,   600,   601,  1317,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,
     621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,
       0,     0,     0,     0,     0,   234,     0,  1250,   696,     0,
    1251,  1252,     0,   757,  1254,     0,     0,     0,     0,     0,
       0,  3263,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,  1255,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,  1256,   260,  1257,  1258,     0,
     263,  4691,   265,   266,   267,   268,   269,  1259,  1260,   270,
     271,  1261,  1262,   274,     0,   275,   276,   277,   278,  1263,
       0,  1264,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,   302,   303,   304,   305,   306,   307,  1272,  1273,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     866,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,  1275,   339,   340,   341,
     342,  1276,  1277,   344,     0,   345,   346,   347,  1278,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,  1279,     0,  1280,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,  1281,  1282,     0,
    1283,     0,   392,   393,   394,   395,   396,  1284,  1285,  1286,
    1287,  1288,  1289,  1290,   404,   405,   406,   407,   408,   409,
       0,     0,   410,  1291,   412,   413,   414,     0,   415,   416,
     417,  1292,  1293,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,  1294,   437,  1295,   439,   440,   441,   442,   443,   444,
     445,   446,  1296,   448,     0,   449,   450,   451,   452,  1298,
    1299,   454,  1300,   456,   457,   458,     0,   459,   460,     0,
       0,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,  1302,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,  1303,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,  1304,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,  3260,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,  1306,   541,
     542,   543,   544,   545,   546,   547,   548,  1307,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,  1308,   565,     0,   566,   567,  1309,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,  1310,
    1311,     0,     0,   578,   579,  1312,   581,  1313,  1314,   583,
     584,   585,   586,   587,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,  1316,     0,   596,   597,   598,   599,
     600,   601,  1317,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,
    1325,   626,   627,   628,   629,     0,     0,     0,     0,     0,
       0,   234,     0,  1250,   696,     0,  1251,  1252,     0,   757,
    1254,     0,     0,     0,     0,     0,     0,  3263,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,  1255,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,  1256,   260,  1257,  1258,     0,   263,   264,   265,   266,
     267,   268,   269,  1259,  1260,   270,   271,  1261,  1262,   274,
       0,   275,   276,   277,   278,  1263,     0,  1264,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,
     304,   305,   306,   307,  1272,  1273,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   866,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,  1275,   339,   340,   341,   342,  1276,  1277,   344,
       0,   345,   346,   347,  1278,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1279,     0,  1280,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,  1281,  1282,     0,  1283,     0,   392,   393,
     394,   395,   396,  1284,  1285,  1286,  1287,  1288,  1289,  1290,
     404,   405,   406,   407,   408,   409,     0,     0,   410,  1291,
     412,   413,   414,     0,   415,   416,   417,  1292,  1293,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1294,   437,  1295,
     439,   440,   441,   442,   443,   444,   445,   446,  1296,   448,
       0,   449,   450,   451,   452,  1298,  1299,   454,  1300,   456,
     457,   458,     0,   459,   460,     0,     0,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,  1302,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,  1303,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,  1304,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,  3260,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,  1306,   541,   542,   543,   544,   545,
     546,   547,   548,  1307,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,  1308,
     565,     0,   566,   567,  1309,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,  1310,  1311,     0,     0,   578,
     579,  1312,   581,  1313,  1314,   583,   584,   585,   586,   587,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
    1316,     0,   596,   597,   598,   599,   600,   601,  1317,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,  1318,  1319,
    1320,  1321,  4749,  1322,  1323,  1324,  1325,   626,   627,   628,
     629,     0,     0,     0,     0,     0,     0,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3263,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
    1260,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,  1263,     0,  1264,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1276,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1279,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,  3411,
    1285,  1286,  1287,  1288,  1289,  1290,   404,   405,   406,   407,
     408,   409,  3412,     0,   410,  1291,   412,   413,   414,     0,
     415,   416,   417,  1292,  1293,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,  1296,   448,     0,   449,   450,   451,
     452,     0,  1299,   454,   455,   456,   457,   458,     0,   459,
     460,     0,   841,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,  1302,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,  1303,   484,
     485,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,   519,   520,   521,
     522,   523,   524,   525,  3413,   527,   528,   529,   530,   531,
     532,   533,   534,   535,    40,   536,   537,   538,   539,   540,
    1306,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,  1308,   565,     0,   566,   567,
    1309,    44,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,     0,     0,   578,   579,  1312,   581,  1313,
       0,   583,   584,   585,   586,   587,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,  1316,     0,   596,   597,
     598,   599,   600,  1185,   602,     0,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,    49,   610,   611,   612,
     613,   614,   615,   616,  1318,  1319,  1320,  1321,   621,  1322,
    1323,  1324,  1325,  3414,   627,   628,   629,     0,     0,     0,
      50,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3415,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,  1260,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,  1263,     0,  1264,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1276,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1279,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,  3411,  1285,  1286,  1287,  1288,
    1289,  1290,   404,   405,   406,   407,   408,   409,  3412,     0,
     410,  1291,   412,   413,   414,     0,   415,   416,   417,  1292,
    1293,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
    1296,   448,     0,   449,   450,   451,   452,     0,  1299,   454,
     455,   456,   457,   458,     0,   459,   460,     0,   841,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
    1302,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,  1303,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
    3413,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,  1306,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,  1308,   565,     0,   566,   567,  1309,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,  1312,   581,  1313,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  1316,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
    1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,  3414,
     627,   628,   629,     0,     0,     0,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3415,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,  1260,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,  1263,     0,  1264,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,  1265,
    1266,  1267,  1268,  1269,  1270,  1271,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,  1276,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,  1279,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,  3411,  1285,  1286,  1287,  1288,  1289,  1290,   404,   405,
     406,   407,   408,   409,     0,     0,   410,  1291,   412,   413,
     414,     0,   415,   416,   417,  1292,  1293,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,  1296,   448,     0,   449,
     450,   451,   452,     0,  1299,   454,   455,   456,   457,   458,
       0,   459,   460,     0,     0,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,  1302,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
    1303,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,  1306,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,  1308,   565,     0,
     566,   567,  1309,     0,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,     0,     0,   578,   579,  1312,
     581,  1313,     0,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,  1316,     0,
     596,   597,   598,   599,   600,   601,   602,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,  1318,  1319,  1320,  1321,
     621,  1322,  1323,  1324,  1325,   626,   627,   628,   629,     0,
       0,     0,     0,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3854,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,  1260,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,  1263,
       0,  1264,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,  1265,  1266,  1267,  1268,  1269,
    1270,  1271,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,  1276,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,  1279,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,  3411,  1285,  1286,
    1287,  1288,  1289,  1290,   404,   405,   406,   407,   408,   409,
       0,     0,   410,  1291,   412,   413,   414,     0,   415,   416,
     417,  1292,  1293,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,  1296,   448,     0,   449,   450,   451,   452,     0,
    1299,   454,   455,   456,   457,   458,     0,   459,   460,     0,
       0,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,  1302,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,  1303,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,   525,  3413,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,  1306,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,  1308,   565,     0,   566,   567,  1309,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,     0,     0,   578,   579,  1312,   581,  1313,     0,   583,
     584,   585,   586,   587,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,  1316,     0,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,  1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,
    1325,  3414,   627,   628,   629,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    56,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,  1260,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,  1263,     0,  1264,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,  1276,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
    1279,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,   393,
     394,   395,   396,  3411,  1285,  1286,  1287,  1288,  1289,  1290,
     404,   405,   406,   407,   408,   409,     0,     0,   410,  1291,
     412,   413,   414,     0,   415,   416,   417,  1292,  1293,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,  1296,   448,
       0,   449,   450,   451,   452,     0,  1299,   454,   455,   456,
     457,   458,     0,   459,   460,     0,     0,   461,   462,   463,
       0,     0,   464,   465,   466,   467,   468,   469,  1302,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,  1303,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,  1306,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,  1308,
     565,     0,   566,   567,  1309,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   576,   577,     0,     0,   578,
     579,  1312,   581,  1313,     0,   583,   584,   585,   586,   587,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
    1316,     0,   596,   597,   598,   599,   600,   601,   602,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,  1318,  1319,
    1320,  1321,   621,  1322,  1323,  1324,  1325,   626,   627,   628,
     629,     0,     0,     0,     0,     0,     0,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4810,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
    1260,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,  1263,     0,  1264,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,  1265,  1266,  1267,
    1268,  1269,  1270,  1271,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1276,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,  1279,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,   393,   394,   395,   396,  3411,
    1285,  1286,  1287,  1288,  1289,  1290,   404,   405,   406,   407,
     408,   409,     0,     0,   410,  1291,   412,   413,   414,     0,
     415,   416,   417,  1292,  1293,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,  1296,   448,     0,   449,   450,   451,
     452,     0,  1299,   454,   455,   456,   457,   458,     0,   459,
     460,     0,     0,   461,   462,   463,     0,     0,   464,   465,
     466,   467,   468,   469,  1302,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,  1303,   484,
     485,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
    1306,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,  1308,   565,     0,   566,   567,
    1309,     0,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   576,   577,     0,     0,   578,   579,  1312,   581,  1313,
       0,   583,   584,   585,   586,   587,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,  1316,     0,   596,   597,
     598,   599,   600,   601,   602,     0,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,  1318,  1319,  1320,  1321,   621,  1322,
    1323,  1324,  1325,   626,   627,   628,   629,     0,     0,     0,
       0,     0,     0,   946,     0,  1578,   696,     0,     0,     0,
       0,   757,     0,     0,     0,     0,     0,     0,     0,  5974,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1802,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,  1803,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,  1804,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,     0,     0,     0,     0,     0,     0,   946,
       0,     0,     0,     0,     0,     0,  1579,  1580,  5780,     0,
       0,     0,     0,     0,     0,  5781,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     3,
       4,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     0,     0,   410,   411,   412,   413,
     414,     0,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,     0,     0,   461,   462,   463,     0,     0,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,    40,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,     0,    44,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   576,   577,     0,     0,   578,   579,   580,
     581,   582,     0,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,  1185,   602,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,    49,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,  1025,
       0,     0,    50,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    56,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       0,     0,   410,   411,   412,   413,   414,     0,   415,   416,
     417,     0,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,     0,
       0,   461,   462,   463,     0,     0,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   576,
     577,     0,     0,   578,   579,   580,   581,   582,     0,   583,
     584,   585,   586,   587,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,   601,   602,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,     0,     0,     0,     0,     0,
       0,   637,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5548,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     0,     0,   410,   411,
       0,   413,     0,     0,   415,   416,   417,     0,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,     0,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,     0,     0,   461,   462,   463,
       0,     0,   464,   465,   466,     0,   468,     0,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,    40,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,     0,    44,   568,     0,   570,   571,
     572,   573,   574,     0,   575,   576,   577,     0,     0,   578,
     579,   580,   581,   582,     0,   583,   584,   585,   586,   587,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,  1185,   602,     0,
     603,     0,   605,   606,   607,   608,     0,     0,   609,     0,
      49,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,     0,     0,     0,    50,     0,     0,   637,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    56,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   276,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
    2854,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   344,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     0,     0,   410,   411,     0,   413,     0,     0,
     415,   416,   417,     0,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,     0,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,     0,   841,   461,   462,   463,     0,     0,   464,   465,
     466,     0,   468,     0,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
       0,  2855,  2856,     0,   570,   571,   572,   573,   574,     0,
     575,   576,   577,     0,     0,   578,   579,   580,   581,   582,
       0,   583,   584,   585,   586,   587,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,   601,   602,     0,   603,     0,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,     0,     0,     0,
       0,     0,     0,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1836,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,     0,     0,     0,     0,     0,     0,   637,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1390,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,     0,   255,   256,   257,   258,   259,
       0,   261,   262,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   272,   273,   274,     0,   275,
     276,   277,   278,   279,     0,     0,     0,   281,   282,   283,
     284,   285,   286,     0,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,     0,   298,   299,   300,     0,
       0,     0,     0,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   308,   309,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   325,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,     0,   344,     0,   345,
     346,   347,   348,   349,     0,   350,     0,   351,   352,     0,
       0,     0,   355,   356,   357,   358,     0,   359,   360,     0,
     361,   362,   363,     0,   364,   365,   366,   367,   368,     0,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,     0,   384,   385,   386,   387,
     388,   389,   390,     0,   391,     0,   392,     0,     0,   395,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,     0,     0,   410,   411,     0,   413,
       0,     0,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,     0,   449,
     450,     0,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,     0,     0,   461,   462,   463,     0,     0,
     464,   465,   466,     0,   468,     0,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
     483,   484,   485,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,     0,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,     0,   541,   542,   543,   544,   545,     0,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,     0,     0,   568,     0,   570,   571,   572,   573,
     574,     0,   575,   576,   577,     0,     0,   578,   579,   580,
     581,   582,     0,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,   601,   602,     0,   603,     0,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,     0,
       0,     0,     0,     0,     0,   637,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3472,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,   276,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,   344,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,   368,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       0,     0,   410,   411,     0,   413,     0,     0,   415,   416,
     417,     0,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,     0,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,     0,
       0,   461,   462,   463,     0,     0,   464,   465,   466,     0,
     468,     0,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,     0,
     568,     0,   570,   571,   572,   573,   574,     0,   575,   576,
     577,     0,     0,   578,   579,   580,   581,   582,     0,   583,
     584,   585,   586,   587,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,   601,   602,     0,   603,     0,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,     0,     0,     0,     0,     0,
       0,   637,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4139,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     0,     0,   410,   411,
       0,   413,     0,     0,   415,   416,   417,     0,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,     0,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,     0,     0,   461,   462,   463,
       0,     0,   464,   465,   466,     0,   468,     0,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,     0,     0,   568,     0,   570,   571,
     572,   573,   574,     0,   575,   576,   577,     0,     0,   578,
     579,   580,   581,   582,     0,   583,   584,   585,   586,   587,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,   601,   602,     0,
     603,     0,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     858,     0,  1578,   696,     0,     0,     0,   961,   757,     0,
       0,     0,     0,  4766,   962,   963,   964,   235,   236,   237,
     238,   239,   240,   241,   242,   243,  1714,   244,   245,   246,
    1715,  1716,  1717,  1718,  1719,  1720,  1721,   247,   248,   249,
    1722,   250,   251,   252,   253,   254,   255,   256,   257,     0,
     859,   260,   860,   861,  1723,   263,   264,   265,   266,   267,
     268,   269,  1724,  1725,   270,   271,   862,   863,   274,  1726,
     275,   276,   277,   278,     0,  1727,   280,  1728,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,  1729,   291,
     292,   293,   294,   295,   296,  1730,   297,   298,   299,   300,
    1731,  1732,  1733,   301,  1734,  1735,  1736,   302,   303,   304,
     305,   306,   307,   864,   865,   310,  1737,   311,  1738,   312,
     313,   314,   315,   316,   317,   318,  1739,   319,   320,   321,
     322,  1740,  1741,   323,   324,   866,   326,   327,  1742,   328,
     329,   330,  1743,   331,   332,   333,  1744,   334,   335,   336,
     337,     0,   339,   340,   341,   342,     0,  1745,   344,  1746,
     345,   346,   347,   867,   349,  1747,   350,  1748,   351,   352,
     353,  1749,   354,   355,   356,   357,   358,  1750,   359,     0,
    1751,     0,   362,   363,  1752,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,  1753,   374,   375,   376,   377,
     378,   379,   380,   381,  1754,   382,   383,     0,   385,   386,
     387,   388,   868,   869,  1755,   870,  1756,   392,   393,   394,
     395,   396,   871,     0,     0,     0,     0,     0,     0,   404,
     405,   406,   407,   408,   409,  1757,  1758,   410,     0,   412,
     413,   414,  1759,   415,   416,   417,  1760,  1761,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   872,   437,   873,   439,
     440,   441,   442,   443,   444,   445,  4454,     0,   448,  1762,
     449,   450,   451,   452,  1763,     0,   454,   874,   456,   457,
     458,  1764,   459,   460,  1765,  1766,  4455,   462,   463,  1767,
    1768,   464,   465,     0,   467,   468,   469,     0,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,  1769,   481,
     482,     0,   484,     0,   486,   487,   488,  1770,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   875,   500,
     501,   502,   503,  1771,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,  1772,   517,   518,
     519,   520,   521,   522,   523,   524,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,  1773,   536,   537,
     538,   539,   540,  1774,   541,   542,  2683,   544,   545,   546,
     547,   548,   877,   550,  1775,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,     0,   565,
    1776,   566,   567,  1777,  1778,   568,   569,   570,   571,   572,
     573,   574,  1779,   575,   878,   879,  1780,  1781,   578,   579,
       0,   581,     0,  1782,   583,   584,   585,   586,   587,   588,
     589,   590,  1783,  1784,   591,   592,   593,   594,   595,  1785,
    1786,   596,   597,   598,   599,   600,     0,   880,  1787,   603,
     604,   605,   606,   607,   608,  1788,  1789,   609,  1790,  1791,
     610,   611,   612,   613,   614,   615,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   627,   628,   629,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     967,   968,   969,  4456,  4457,   972,   973,   974,   975,   858,
       0,  1578,   696,     0,     0,     0,   961,   757,     0,     0,
       0,     0,     0,   962,   963,   964,   235,   236,   237,   238,
     239,   240,   241,   242,   243,  1714,   244,   245,   246,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,   247,   248,   249,  1722,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   859,
     260,   860,   861,  1723,   263,   264,   265,   266,   267,   268,
     269,  1724,  1725,   270,   271,   862,   863,   274,  1726,   275,
     276,   277,   278,     0,  1727,   280,  1728,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,  1729,   291,   292,
     293,   294,   295,   296,  1730,   297,   298,   299,   300,  1731,
    1732,  1733,   301,  1734,  1735,  1736,   302,   303,   304,   305,
     306,   307,   864,   865,   310,  1737,   311,  1738,   312,   313,
     314,   315,   316,   317,   318,  1739,   319,   320,   321,   322,
    1740,  1741,   323,   324,   866,   326,   327,  1742,   328,   329,
     330,  1743,   331,   332,   333,  1744,   334,   335,   336,   337,
       0,   339,   340,   341,   342,     0,  1745,   344,  1746,   345,
     346,   347,   867,   349,  1747,   350,  1748,   351,   352,   353,
    1749,   354,   355,   356,   357,   358,  1750,   359,     0,  1751,
       0,   362,   363,  1752,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,  1753,   374,   375,   376,   377,   378,
     379,   380,   381,  1754,   382,   383,     0,   385,   386,   387,
     388,   868,   869,  1755,   870,  1756,   392,   393,   394,   395,
     396,   871,     0,     0,     0,     0,     0,     0,   404,   405,
     406,   407,   408,   409,  1757,  1758,   410,     0,   412,   413,
     414,  1759,   415,   416,   417,  1760,  1761,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   872,   437,   873,   439,   440,
     441,   442,   443,   444,   445,  4906,     0,   448,  1762,   449,
     450,   451,   452,  1763,     0,   454,   874,   456,   457,   458,
    1764,   459,   460,  1765,  1766,  4455,   462,   463,  1767,  1768,
     464,   465,     0,   467,   468,   469,     0,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,  1769,   481,   482,
       0,   484,     0,   486,   487,   488,  1770,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   875,   500,   501,
     502,   503,  1771,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,  1772,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,  1773,   536,   537,   538,
     539,   540,  1774,   541,   542,  2683,   544,   545,   546,   547,
     548,   877,   550,  1775,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   565,  1776,
     566,   567,  1777,  1778,   568,   569,   570,   571,   572,   573,
     574,  1779,   575,   878,   879,  1780,  1781,   578,   579,     0,
     581,     0,  1782,   583,   584,   585,   586,   587,   588,   589,
     590,  1783,  1784,   591,   592,   593,   594,   595,  1785,  1786,
     596,   597,   598,   599,   600,     0,   880,  1787,   603,   604,
     605,   606,   607,   608,  1788,  1789,   609,  1790,  1791,   610,
     611,   612,   613,   614,   615,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   627,   628,   629,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   967,
     968,   969,  4456,  4457,   972,   973,   974,   975,  2079,     0,
       0,     0,     0,     0,     0,  2080,     0,     0,  2081,     0,
       0,     0,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,     0,  2102,  2103,  2104,  2105,  2106,  2107,  2108,
    2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,
    2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,
    2129,  2130,  2131,  2132,     0,     0,  2133,  2134,  2135,  2136,
    2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,
    2147,  2148,  2149,  2150,  2151,  2152,  2153,  2154,  2155,  2156,
    2157,  2158,  2159,     0,  2160,  2161,  2162,  2163,  2164,  2165,
    2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,     0,
    2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2185,  2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,  2207,  2208,     0,  2209,  2210,  2211,  2212,  2213,
    2214,  2215,  2216,  2217,  2218,  2219,  2220,     0,     0,  2221,
    2222,  2223,  2224,     0,  2225,  2226,  2227,  2228,  2229,     0,
    2230,  2231,  2232,  2233,  2234,     0,  2235,  2236,     0,  2237,
    2238,  2239,     0,  2240,  2241,     0,  2242,  2243,  2244,  2245,
    2246,  2247,  2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,
    2256,  2257,  2258,  2259,  2260,  2261,  2262,  2263,  2264,  2265,
    2266,  2267,     0,  2268,     0,  2269,  2270,  2271,  2272,  2273,
    2274,  2275,  2276,  2277,  2278,  2279,  2280,  2281,  2282,  2283,
    2284,  2285,  2286,  2287,  2288,  2289,  2290,  2291,  2292,  2293,
       0,  2294,  2295,  2296,  2297,  2298,  2299,  2300,  2301,  2302,
    2303,  2304,  2305,  2306,  2307,  2308,  2309,     0,  2310,  2311,
       0,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,
    2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,
    2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,     0,
    2340,  2341,     0,  2342,  2343,  2344,  2345,  2346,     0,  2347,
    2348,  2349,  2350,     0,     0,  2351,  2352,  2353,  2354,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,
    2366,     0,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,
    2375,  2376,  2377,  2378,  2379,  2380,  2381,  2382,  2383,  2384,
    2385,  2386,  2387,  2388,  2389,  2390,  2391,  2392,  2393,  2394,
    2395,  2396,  2397,  2398,  2399,     0,  2400,  2401,  2402,  2403,
    2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,
    2414,  2415,  2416,     0,  2417,  2418,  2419,  2420,  2421,  2422,
    2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,
    2433,  2434,  2435,  2436,  2437,  2438,  2439,  2440,  2441,  2442,
    2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,     0,  2467,  2468,  2469,  2470,  2471,
    2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,
       0,  2482,  2483,  2484,  2485,  2486,  2487,  2488,  2489,  2490,
    2491,  2492,  2493,  2494,  2495,  2496,  2497,     0,  2498,  2499,
    2500,  2501,  2502,  2503,     0,  2504,     0,     0,     0,     0,
    2505,  2506,  2507,  2508,  2509,  2510,  2511,  2512,  2513,  2514,
    2515,  2516,  2517,  2518,  2519,     0,  2520,  2521,     0,  2522,
       0,     0,     0,     0,     0,     0,     0,     0,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,   637,     0,     0,
       0,     0,     0,     0,   961,     0,     0,     0,     0,     0,
       0,   962,   963,   964,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,     0,   255,   256,   257,   258,   259,     0,   261,
     262,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   272,   273,   274,     0,   275,   965,   277,
     278,   279,     0,     0,     0,   281,   282,   283,   284,   285,
     286,     0,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,     0,   298,   299,   300,     0,     0,     0,
       0,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     308,   309,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   325,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   966,     0,   345,   346,   347,
     348,   349,     0,   350,     0,   351,   352,     0,     0,     0,
     355,   356,   357,   358,     0,   359,   360,     0,   361,   362,
     363,     0,   364,   365,   366,   367,   368,     0,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,     0,   384,   385,   386,   387,   388,   389,
     390,     0,   391,     0,   392,     0,     0,   395,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,     0,     0,   410,   411,     0,   413,     0,     0,
     415,   416,   417,     0,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     0,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,     0,   449,   450,     0,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,     0,     0,   461,   462,   463,     0,     0,   464,   465,
     466,     0,   468,     0,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,   483,   484,
     485,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,     0,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
       0,   541,   542,   543,   544,   545,     0,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
       0,     0,   568,     0,   570,   571,   572,   573,   574,     0,
     575,   576,   577,     0,     0,   578,   579,   580,   581,   582,
       0,   583,   584,   585,   586,   587,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,   601,   602,     0,   603,     0,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   967,   968,   969,
     970,   971,   972,   973,   974,   975,   637,     0,     0,     0,
       0,     0,     0,   961,     0,     0,     0,     0,     0,     0,
     962,   963,   964,   235,   236,   237,   238,   239,   240,   241,
     242,   243,     0,   244,   245,   246,     0,     0,     0,     0,
       0,     0,     0,   247,   248,   249,     0,   250,   251,   252,
     253,     0,   255,   256,   257,   258,   259,     0,   261,   262,
       0,   263,   264,   265,   266,   267,   268,   269,     0,     0,
     270,   271,   272,   273,   274,     0,   275,  1082,   277,   278,
     279,     0,     0,     0,   281,   282,   283,   284,   285,   286,
       0,   288,   289,   290,     0,   291,   292,   293,   294,   295,
     296,     0,     0,   298,   299,   300,     0,     0,     0,     0,
       0,     0,     0,   302,   303,   304,   305,   306,   307,   308,
     309,   310,     0,   311,     0,   312,   313,   314,   315,   316,
     317,   318,     0,   319,   320,   321,   322,     0,     0,   323,
     324,   325,   326,   327,     0,   328,   329,   330,     0,   331,
     332,   333,     0,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,     0,  1083,     0,   345,   346,   347,   348,
     349,     0,   350,     0,   351,   352,     0,     0,     0,   355,
     356,   357,   358,     0,   359,   360,     0,   361,   362,   363,
       0,   364,   365,   366,   367,   368,     0,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,   381,
       0,   382,     0,   384,   385,   386,   387,   388,   389,   390,
       0,   391,     0,   392,     0,     0,   395,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,     0,     0,   410,   411,     0,   413,     0,     0,   415,
     416,   417,     0,     0,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,     0,   449,   450,     0,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
       0,     0,   461,   462,   463,     0,     0,   464,   465,   466,
       0,   468,     0,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,     0,   481,   482,   483,   484,   485,
     486,   487,   488,     0,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,     0,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,     0,   517,   518,     0,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,     0,
     541,   542,   543,   544,   545,     0,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,     0,
       0,   568,     0,   570,   571,   572,   573,   574,     0,   575,
     576,   577,     0,     0,   578,   579,   580,   581,   582,     0,
     583,   584,   585,   586,   587,   588,   589,   590,     0,     0,
     591,   592,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,   601,   602,     0,   603,     0,   605,   606,   607,
     608,     0,     0,   609,     0,     0,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   637,     0,     0,     0,     0,
       0,     0,   961,     0,     0,     0,     0,     0,     0,   962,
     963,   964,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
       0,   255,   256,   257,   258,   259,     0,   261,   262,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   272,   273,   274,     0,   275,  1148,   277,   278,   279,
       0,     0,     0,   281,   282,   283,   284,   285,   286,     0,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,     0,   298,   299,   300,     0,     0,     0,     0,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   308,   309,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     325,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,     0,  1149,     0,   345,   346,   347,   348,   349,
       0,   350,     0,   351,   352,     0,     0,     0,   355,   356,
     357,   358,     0,   359,   360,     0,   361,   362,   363,     0,
     364,   365,   366,   367,  1150,     0,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,     0,   384,   385,   386,   387,   388,   389,   390,     0,
     391,     0,   392,     0,     0,   395,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
       0,     0,   410,   411,     0,   413,     0,     0,   415,   416,
     417,     0,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     0,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,     0,   449,   450,     0,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,     0,
       0,   461,   462,   463,     0,     0,   464,   465,   466,     0,
     468,     0,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,   483,   484,   485,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,     0,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,     0,   541,
     542,   543,   544,   545,     0,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,     0,     0,
     568,     0,   570,   571,   572,   573,   574,     0,   575,   576,
     577,     0,     0,   578,   579,   580,   581,   582,     0,   583,
     584,   585,   586,   587,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,   601,   602,     0,   603,     0,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   967,   968,   969,   970,   971,
     972,   973,   974,   975,   637,     0,     0,     0,     0,     0,
       0,   961,     0,     0,     0,     0,     0,     0,   962,   963,
     964,   235,   236,   237,   238,   239,   240,   241,   242,   243,
       0,   244,   245,   246,     0,     0,     0,     0,     0,     0,
       0,   247,   248,   249,     0,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,     0,   261,   262,     0,   263,
     264,   265,   266,   267,   268,   269,     0,     0,   270,   271,
     272,   273,   274,     0,   275,  1819,   277,   278,   279,     0,
       0,     0,   281,   282,   283,   284,   285,   286,     0,   288,
     289,   290,     0,   291,   292,   293,   294,   295,   296,     0,
       0,   298,   299,   300,     0,     0,     0,     0,     0,     0,
       0,   302,   303,   304,   305,   306,   307,   308,   309,   310,
       0,   311,     0,   312,   313,   314,   315,   316,   317,   318,
       0,   319,   320,   321,   322,     0,     0,   323,   324,   325,
     326,   327,     0,   328,   329,   330,     0,   331,   332,   333,
       0,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,     0,  1820,     0,   345,   346,   347,   348,   349,     0,
     350,     0,   351,   352,     0,     0,     0,   355,   356,   357,
     358,     0,   359,   360,     0,   361,   362,   363,     0,   364,
     365,   366,   367,   368,     0,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,   381,     0,   382,
       0,   384,   385,   386,   387,   388,   389,   390,     0,   391,
       0,   392,     0,     0,   395,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,     0,
       0,   410,   411,     0,   413,     0,     0,   415,   416,   417,
       0,     0,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,     0,   449,   450,     0,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,     0,     0,
     461,   462,   463,     0,     0,   464,   465,   466,     0,   468,
       0,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,     0,   481,   482,   483,   484,   485,   486,   487,
     488,     0,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,     0,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,     0,   517,   518,     0,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,     0,   541,   542,
     543,   544,   545,     0,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,     0,   566,   567,     0,     0,   568,
       0,   570,   571,   572,   573,   574,     0,   575,   576,   577,
       0,     0,   578,   579,   580,   581,   582,     0,   583,   584,
     585,   586,   587,   588,   589,   590,     0,     0,   591,   592,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
     601,   602,     0,   603,     0,   605,   606,   607,   608,     0,
       0,   609,     0,     0,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   637,     0,     0,     0,     0,     0,     0,
     961,     0,     0,     0,     0,     0,     0,   962,   963,   964,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   637,     0,     0,     0,     0,     0,     0,   961,
       0,     0,     0,     0,     0,     0,   962,   963,   964,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,  3544,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
    3545,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,     0,     0,     0,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,     0,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,     0,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
       0,     0,   395,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     0,     0,   410,
     411,     0,   413,     0,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,     0,     0,   461,   462,
     463,     0,     0,   464,   465,   466,     0,   468,     0,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,     0,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,     0,   568,     0,   570,
     571,   572,   573,   574,     0,   575,   576,   577,     0,     0,
     578,   579,   580,   581,   582,     0,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,   601,   602,
       0,   603,     0,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   637,     0,     0,     0,     0,     0,     0,   961,     0,
       0,     0,     0,     0,     0,   962,   963,   964,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,     0,   261,   262,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   272,   273,   274,
       0,   275,   276,   277,   278,   279,     0,     0,     0,   281,
     282,   283,   284,   285,   286,     0,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,     0,   298,   299,
     300,     0,     0,     0,     0,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   308,   309,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   325,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   344,
       0,   345,   346,   347,   348,   349,     0,   350,     0,   351,
     352,     0,     0,     0,   355,   356,   357,   358,     0,   359,
     360,     0,   361,   362,   363,     0,   364,   365,   366,   367,
     368,     0,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,     0,   384,   385,
     386,   387,   388,   389,   390,     0,   391,     0,   392,     0,
       0,   395,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,     0,     0,   410,   411,
       0,   413,     0,     0,   415,   416,   417,     0,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
       0,   449,   450,     0,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,     0,     0,  5525,   462,   463,
       0,     0,   464,   465,   466,     0,   468,     0,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,   483,   484,   485,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,     0,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,     0,   541,   542,   543,   544,   545,
       0,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,     0,     0,   568,     0,   570,   571,
     572,   573,   574,     0,   575,   576,   577,     0,     0,   578,
     579,   580,   581,   582,     0,   583,   584,   585,   586,   587,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,   601,   602,     0,
     603,     0,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,     0,     0,  1713,     0,     0,     0,     0,     0,     0,
       0,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1714,
     244,   245,   246,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
     247,   248,   249,  1722,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,  1723,   263,   264,
     265,   266,   267,   268,   269,  1724,  1725,   270,   271,   272,
     273,   274,  1726,   275,   276,   277,   278,   279,  1727,   280,
    1728,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,  1729,   291,   292,   293,   294,   295,   296,  1730,   297,
     298,   299,   300,  1731,  1732,  1733,   301,  1734,  1735,  1736,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  1737,
     311,  1738,   312,   313,   314,   315,   316,   317,   318,  1739,
     319,   320,   321,   322,  1740,  1741,   323,   324,   325,   326,
     327,  1742,   328,   329,   330,  1743,   331,   332,   333,  1744,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1745,   344,  1746,   345,   346,   347,   348,   349,  1747,   350,
    1748,   351,   352,   353,  1749,   354,   355,   356,   357,   358,
    1750,   359,   360,  1751,   361,   362,   363,  1752,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  1753,   374,
     375,   376,   377,   378,   379,   380,   381,  1754,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1755,   391,  1756,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,  1757,  1758,
     410,   411,   412,   413,   414,  1759,   415,   416,   417,  1760,
    1761,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  1762,   449,   450,   451,   452,  1763,   453,   454,
     455,   456,   457,   458,  1764,   459,   460,  1765,  1766,   461,
     462,   463,  1767,  1768,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,  1769,   481,   482,   483,   484,   485,   486,   487,   488,
    1770,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,  1771,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
    1772,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
    1773,   536,   537,   538,   539,   540,  1774,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,  1775,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,  1776,   566,   567,  1777,  1778,   568,   569,
     570,   571,   572,   573,   574,  1779,   575,   576,   577,  1780,
    1781,   578,   579,   580,   581,   582,  1782,   583,   584,   585,
     586,   587,   588,   589,   590,  1783,  1784,   591,   592,   593,
     594,   595,  1785,  1786,   596,   597,   598,   599,   600,   601,
     602,  1787,   603,   604,   605,   606,   607,   608,  1788,  1789,
     609,  1790,  1791,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1792,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   847,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5943,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5945,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   858,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6052,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   859,   260,   860,   861,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   862,
     863,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   864,   865,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   867,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,     0,     0,     0,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  2679,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
    2680,   385,   386,   387,   388,   868,   869,     0,   870,     0,
     392,   393,   394,   395,   396,   871,     0,     0,     0,     0,
       0,     0,   404,   405,   406,   407,   408,   409,     0,     0,
     410,     0,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   872,
     437,   873,   439,   440,   441,   442,   443,   444,   445,     0,
       0,   448,     0,   449,   450,   451,   452,     0,     0,   454,
     874,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,  2681,   464,   465,  2682,   467,   468,   469,
       0,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,     0,   484,     0,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   875,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,  2683,
     544,   545,   546,   547,   548,   877,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   878,   879,     0,
       0,   578,   579,     0,   581,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     880,  2684,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,     0,
       0,     0,  3891,     0,     0,     0,     0,     0,     0,     0,
     627,   628,   629,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,  2685,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,     0,   859,   260,   860,   861,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   862,   863,
     274,     0,   275,   276,   277,   278,     0,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   864,   865,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   866,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   339,   340,   341,   342,     0,     0,
     344,     0,   345,   346,   347,   867,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,     0,     0,     0,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,  2679,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,  2680,
     385,   386,   387,   388,   868,   869,     0,   870,     0,   392,
     393,   394,   395,   396,   871,     0,     0,     0,     0,     0,
       0,   404,   405,   406,   407,   408,   409,     0,     0,   410,
       0,   412,   413,   414,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   872,   437,
     873,   439,   440,   441,   442,   443,   444,   445,     0,     0,
     448,     0,   449,   450,   451,   452,     0,     0,   454,   874,
     456,   457,   458,     0,   459,   460,     0,     0,   461,   462,
     463,     0,  2681,   464,   465,  2682,   467,   468,   469,     0,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,     0,   484,     0,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     875,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,     0,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,  2683,   544,
     545,   546,   547,   548,   877,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
       0,   565,     0,   566,   567,     0,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   878,   879,     0,     0,
     578,   579,     0,   581,     0,     0,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   880,
    2684,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   627,
     628,   629,   946,     0,  1578,   696,     0,     0,     0,     0,
     757,     0,     0,     0,     0,     0,     0,  2685,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,  2570,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1802,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     0,     0,   410,
     411,   412,   413,   414,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,  1803,     0,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,     0,     0,
     578,   579,   580,   581,   582,  1804,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   946,     0,  1578,   696,     0,     0,     0,     0,
     757,     0,     0,     0,     0,  1579,  1580,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,  2575,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1802,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     0,     0,   410,
     411,   412,   413,   414,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,  1803,     0,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,     0,     0,
     578,   579,   580,   581,   582,  1804,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   946,     0,  1578,   696,     0,     0,     0,     0,
     757,     0,     0,     0,     0,  1579,  1580,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,  3504,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1802,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     0,     0,   410,
     411,   412,   413,   414,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,  1803,     0,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,     0,     0,
     578,   579,   580,   581,   582,  1804,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   946,     0,  1578,   696,     0,     0,     0,     0,
     757,     0,     0,     0,     0,  1579,  1580,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  1802,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     0,     0,   410,
     411,   412,   413,   414,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,  1803,     0,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,     0,     0,
     578,   579,   580,   581,   582,  1804,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   637,     0,     0,     0,     0,     0,     0,     0,
     757,     0,     0,     0,     0,  1579,  1580,     0,     0,   235,
     236,   758,   238,   239,   240,   241,   242,   243,   759,   244,
     245,   246,     0,     0,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,     0,   760,   256,
     257,   258,   259,     0,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,     0,     0,
     281,   282,   283,   284,   285,   286,     0,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,     0,   298,
     299,   300,     0,     0,     0,     0,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   761,   348,   349,     0,   350,     0,
     351,   762,     0,   763,     0,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,     0,   370,   371,   372,   373,   764,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,     0,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
       0,     0,   395,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   765,     0,     0,   410,
     411,     0,   413,     0,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,     0,
     438,   439,   766,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,     0,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,     0,     0,   461,   462,
     463,     0,     0,   464,   465,   466,     0,   468,     0,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     767,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   505,   506,   768,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,     0,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,     0,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,     0,   568,     0,   570,
     571,   572,   573,   574,     0,   575,   576,   577,     0,     0,
     578,   579,   580,   581,   582,     0,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,   601,   602,
       0,   603,     0,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   946,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   769,   770,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   243,     0,   244,
     245,   246,     3,     4,     0,     0,     0,     0,     0,   247,
     248,   249,     0,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,     0,   263,   264,   265,
     266,   267,   268,   269,     0,     0,   270,   271,   272,   273,
     274,     0,   275,   276,   277,   278,   279,     0,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
       0,   291,   292,   293,   294,   295,   296,     0,   297,   298,
     299,   300,     0,     0,     0,   301,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   309,   310,     0,   311,
       0,   312,   313,   314,   315,   316,   317,   318,     0,   319,
     320,   321,   322,     0,     0,   323,   324,   325,   326,   327,
       0,   328,   329,   330,     0,   331,   332,   333,     0,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,     0,
     344,     0,   345,   346,   347,   348,   349,     0,   350,     0,
     351,   352,   353,     0,   354,   355,   356,   357,   358,     0,
     359,   360,     0,   361,   362,   363,     0,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,   381,     0,   382,   383,   384,
     385,   386,   387,   388,   389,   390,     0,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,     0,     0,   410,
     411,   412,   413,   414,     0,   415,   416,   417,     0,     0,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,     0,   449,   450,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,     0,     0,   461,   462,
     463,     0,     0,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
       0,   481,   482,   483,   484,   485,   486,   487,   488,     0,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,     0,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,     0,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,     0,     0,   568,   569,   570,
     571,   572,   573,   574,     0,   575,   576,   577,     0,     0,
     578,   579,   580,   581,   582,     0,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,   591,   592,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,   601,   602,
       0,   603,   604,   605,   606,   607,   608,     0,     0,   609,
       0,     0,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,  1025,  1713,     0,  6219,   696,     0,     0,     0,
       0,   757,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1714,
     244,   245,   246,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
     247,   248,   249,  1722,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,  1723,   263,   264,
     265,   266,   267,   268,   269,  1724,  1725,   270,   271,   272,
     273,   274,  1726,   275,   276,   277,   278,   279,  1727,   280,
    1728,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,  1729,   291,   292,   293,   294,   295,   296,  1730,   297,
     298,   299,   300,  1731,  1732,  1733,   301,  1734,  1735,  1736,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  1737,
     311,  1738,   312,   313,   314,   315,   316,   317,   318,  1739,
     319,   320,   321,   322,  1740,  1741,   323,   324,   325,   326,
     327,  1742,   328,   329,   330,  1743,   331,   332,   333,  1744,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1745,   344,  1746,   345,   346,   347,   348,   349,  1747,   350,
    1748,   351,   352,   353,  1749,   354,   355,   356,   357,   358,
    1750,   359,   360,  1751,   361,   362,   363,  1752,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  1753,   374,
     375,   376,   377,   378,   379,   380,   381,  1754,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1755,   391,  1756,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,  1757,  1758,
     410,   411,   412,   413,   414,  1759,   415,   416,   417,  1760,
    1761,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  1762,   449,   450,   451,   452,  1763,   453,   454,
     455,   456,   457,   458,  1764,   459,   460,  1765,  1766,   461,
     462,   463,  1767,  1768,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,  1769,   481,   482,   483,   484,   485,   486,   487,   488,
    1770,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,  1771,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
    1772,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
    1773,   536,   537,   538,   539,   540,  1774,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,  1775,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,  1776,   566,   567,  1777,  1778,   568,   569,
     570,   571,   572,   573,   574,  1779,   575,   576,   577,  1780,
    1781,   578,   579,   580,   581,   582,  1782,   583,   584,   585,
     586,   587,   588,   589,   590,  1783,  1784,   591,   592,   593,
     594,   595,  1785,  1786,   596,   597,   598,   599,   600,   601,
     602,  1787,   603,   604,   605,   606,   607,   608,  1788,  1789,
     609,  1790,  1791,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,  1713,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1714,
     244,   245,   246,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
     247,   248,   249,  1722,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,  1723,   263,   264,
     265,   266,   267,   268,   269,  1724,  1725,   270,   271,   272,
     273,   274,  1726,   275,   276,   277,   278,   279,  1727,   280,
    1728,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,  1729,   291,   292,   293,   294,   295,   296,  1730,   297,
     298,   299,   300,  1731,  1732,  1733,   301,  1734,  1735,  1736,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  1737,
     311,  1738,   312,   313,   314,   315,   316,   317,   318,  1739,
     319,   320,   321,   322,  1740,  1741,   323,   324,   325,   326,
     327,  1742,   328,   329,   330,  1743,   331,   332,   333,  1744,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1745,   344,  1746,   345,   346,   347,   348,   349,  1747,   350,
    1748,   351,   352,   353,  1749,   354,   355,   356,   357,   358,
    1750,   359,   360,  1751,   361,   362,   363,  1752,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  1753,   374,
     375,   376,   377,   378,   379,   380,   381,  1754,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1755,   391,  1756,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,  1757,  1758,
     410,   411,   412,   413,   414,  1759,   415,   416,   417,  1760,
    1761,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  1762,   449,   450,   451,   452,  1763,   453,   454,
     455,   456,   457,   458,  1764,   459,   460,  1765,  1766,   461,
     462,   463,  1767,  1768,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,  1769,   481,   482,   483,   484,   485,   486,   487,   488,
    1770,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,  1771,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
    1772,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
    1773,   536,   537,   538,   539,   540,  1774,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,  1775,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,  1776,   566,   567,  1777,  1778,   568,   569,
     570,   571,   572,   573,   574,  1779,   575,   576,   577,  1780,
    1781,   578,   579,   580,   581,   582,  1782,   583,   584,   585,
     586,   587,   588,   589,   590,  1783,  1784,   591,   592,   593,
     594,   595,  1785,  1786,   596,   597,   598,   599,   600,   601,
     602,  1787,   603,   604,   605,   606,   607,   608,  1788,  1789,
     609,  1790,  1791,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,  1713,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,  3610,   241,   242,   243,  1714,
     244,   245,   246,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
     247,   248,   249,  1722,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,  1723,   263,   264,
     265,   266,   267,   268,   269,  1724,  1725,   270,   271,   272,
     273,   274,  1726,   275,   276,   277,   278,   279,  1727,   280,
    1728,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,  1729,   291,   292,   293,   294,   295,   296,  1730,   297,
     298,   299,   300,  1731,  1732,  1733,   301,  1734,  1735,  1736,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  1737,
     311,  1738,   312,   313,   314,   315,   316,   317,   318,  1739,
     319,   320,   321,   322,  1740,  1741,   323,   324,   325,  3611,
     327,  1742,   328,   329,   330,  1743,   331,   332,   333,  1744,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1745,   344,  1746,   345,   346,   347,   348,   349,  1747,   350,
    1748,   351,   352,   353,  1749,   354,   355,   356,   357,   358,
    1750,   359,   360,  1751,   361,   362,   363,  1752,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  1753,   374,
     375,   376,   377,   378,   379,   380,   381,  1754,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1755,   391,  1756,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,  1757,  1758,
     410,   411,   412,   413,   414,  1759,   415,   416,   417,  1760,
    1761,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  1762,   449,   450,   451,   452,  1763,   453,   454,
     455,   456,   457,   458,  1764,   459,   460,  1765,  1766,   461,
     462,   463,  1767,  1768,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,  1769,   481,   482,   483,   484,   485,   486,   487,   488,
    1770,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,  1771,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
    1772,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
    1773,   536,   537,   538,   539,   540,  1774,  3612,   542,   543,
     544,   545,   546,   547,   548,   549,   550,  1775,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,  1776,   566,   567,  1777,  1778,   568,   569,
     570,   571,   572,   573,   574,  1779,   575,   576,   577,  1780,
    1781,   578,   579,   580,   581,   582,  1782,   583,   584,   585,
     586,   587,   588,   589,   590,  1783,  1784,   591,   592,   593,
     594,   595,  1785,  1786,   596,   597,   598,   599,   600,   601,
     602,  1787,   603,   604,   605,   606,   607,   608,  1788,  1789,
     609,  1790,  1791,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,  1260,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,  1263,     0,  1264,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,  1265,  1266,  1267,  1268,  1269,  1270,  1271,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1276,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,  1279,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,  3411,  1285,  1286,  1287,  1288,
    1289,  1290,   404,   405,   406,   407,   408,   409,     0,     0,
     410,  1291,   412,   413,   414,     0,   415,   416,   417,  1292,
    1293,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
    1296,   448,     0,   449,   450,   451,   452,     0,  1299,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
    1302,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,  1303,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,  1306,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,  1308,   565,     0,   566,   567,  1309,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,  1312,   581,  1313,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  1316,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
    1318,  1319,  1320,  1321,   621,  1322,  1323,  1324,  1325,   626,
     627,   628,   629,   234,     0,  1250,   696,     0,  1251,  1252,
       0,   757,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,  1256,   260,  1257,  1258,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,  1261,
    1262,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,  1272,  1273,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1277,   344,     0,   345,   346,   347,  1278,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,  1281,  1282,     0,  1283,     0,
     392,   393,   394,   395,   396,  6195,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1294,
     437,  1295,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,  1298,   453,   454,
    1300,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,  1304,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,  1307,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,  1310,  1311,     0,
       0,   578,   579,   580,   581,   582,  1314,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
    1317,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   985,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1006,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,  1007,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  2948,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,  3962,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,   696,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1802,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,  1803,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,  1804,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,  1101,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1143,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1156,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,   947,   301,     0,     0,   948,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1168,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,  1169,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   949,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,   696,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  2555,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,   696,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1127,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1140,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1154,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1158,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,  2718,   275,   276,   277,   278,   279,     0,     0,
    2788,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,  2719,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
    2789,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
    2721,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  2790,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  2722,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
    2723,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,  2724,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,  2718,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,  2719,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
    2789,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
    2721,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,  3825,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  2722,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
    2723,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,  2724,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,  2718,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,  2719,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
    2789,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
    2721,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,  2722,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
    2723,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,  2724,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   776,
     244,   777,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,   778,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
     809,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   779,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     780,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   776,
     244,   777,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,   778,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
    3511,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   779,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     780,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   776,
     244,   777,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,   778,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   779,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     780,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  3024,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,  2854,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,   841,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,  2855,  2856,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1980,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,  1981,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,  1982,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
    1983,   351,   352,     0,     0,     0,  1984,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,  1985,  1986,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,  1987,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,  1988,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,  1989,   524,   525,
     526,   527,   528,   529,  1990,   531,   532,   533,   534,   535,
       0,  1991,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,  1992,   568,     0,
    1993,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,  1994,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   777,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,   778,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   779,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     780,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,  2854,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,   841,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,  2855,  2856,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   999,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1000,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,   841,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  3591,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  3592,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  3604,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,  3605,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   638,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   687,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   688,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   801,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   802,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   803,   577,     0,
       0,   804,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   835,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   836,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   837,   577,     0,
       0,   838,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,   841,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,   901,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   956,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   957,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1119,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1365,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,  1376,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,  1377,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   826,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,  1369,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,   829,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1522,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,   841,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,  1583,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1584,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   801,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,  3360,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,  3361,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,  3362,   568,     0,
     570,  3363,   572,  3364,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,  3365,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,   696,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,   757,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,  4175,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,  4189,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  4847,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,  4920,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,  5274,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   793,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   799,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   822,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   823,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   826,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   827,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,   829,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   853,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   981,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   991,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   994,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1010,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1067,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1072,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1089,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1092,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1094,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1132,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1160,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1162,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1172,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1175,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1178,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   826,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,  1369,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,   829,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1845,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1879,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1881,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1921,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1923,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  1925,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,  2019,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,  2671,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,     0,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   826,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,  1369,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
    2705,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,   829,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,  2771,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,  2772,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,  2773,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,  2851,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,  2772,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,  2773,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,  2875,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,  2772,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,  2773,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3069,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3073,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3131,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3523,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   821,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   824,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   825,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   826,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,  2772,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   828,   577,     0,
       0,  2773,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   830,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3580,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3594,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3596,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  3744,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,  3786,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,   362,   363,     0,   364,   365,
     366,   367,  5033,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,     0,   255,
     256,   257,   258,   259,     0,   261,   262,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   272,
     273,   274,     0,   275,   276,   277,   278,   279,     0,     0,
       0,   281,   282,   283,   284,   285,   286,     0,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,     0,
     298,   299,   300,     0,     0,     0,     0,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   308,   309,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   344,     0,   345,   346,   347,   348,   349,     0,   350,
       0,   351,   352,     0,     0,     0,   355,   356,   357,   358,
       0,   359,   360,     0,   361,     0,   363,     0,   364,   365,
     366,   367,   368,     0,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,     0,
     384,   385,   386,   387,   388,   389,   390,     0,   391,     0,
     392,     0,     0,   395,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,     0,     0,
     410,   411,     0,   413,     0,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       0,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,     0,   449,   450,     0,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,   466,     0,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,     0,   479,
     480,     0,   481,   482,   483,   484,   485,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,     0,
     498,   499,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,     0,   520,   521,   522,   523,   524,   525,
       0,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   543,
     544,   545,     0,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,     0,     0,   568,     0,
     570,   571,   572,   573,   574,     0,   575,   576,   577,     0,
       0,   578,   579,   580,   581,   582,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,   601,
     602,     0,   603,     0,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   858,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   859,   260,   860,   861,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   862,
     863,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   864,   865,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   867,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,     0,     0,     0,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,  2679,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
    2680,   385,   386,   387,   388,   868,   869,     0,   870,     0,
     392,   393,   394,   395,   396,   871,     0,     0,     0,     0,
       0,     0,   404,   405,   406,   407,   408,   409,     0,     0,
     410,     0,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   872,
     437,   873,   439,   440,   441,   442,   443,   444,   445,     0,
       0,   448,     0,   449,   450,   451,   452,     0,     0,   454,
     874,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,  2682,   467,   468,   469,
       0,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,     0,   484,     0,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   875,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,  2683,
     544,   545,   546,   547,   548,   877,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   878,   879,     0,
       0,   578,   579,     0,   581,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     880,  2684,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   858,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     627,   628,   629,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   859,
     260,   860,   861,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   862,   863,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   864,   865,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   866,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   339,   340,   341,   342,     0,     0,   344,     0,   345,
     346,   347,   867,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,     0,     0,
       0,   362,   363,     0,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,     0,   385,   386,   387,
     388,   868,   869,     0,   870,     0,   392,   393,   394,   395,
     396,   871,     0,     0,     0,     0,     0,     0,   404,   405,
     406,   407,   408,   409,     0,     0,   410,     0,   412,   413,
     414,     0,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   872,   437,   873,   439,   440,
     441,   442,   443,   444,   445,     0,     0,   448,     0,   449,
     450,   451,   452,  2767,     0,   454,   874,   456,   457,   458,
       0,   459,   460,     0,     0,   461,   462,   463,     0,     0,
     464,   465,     0,   467,   468,   469,     0,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
       0,   484,     0,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   875,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,     0,   541,   542,  2683,   544,   545,   546,   547,
     548,   877,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   565,     0,
     566,   567,     0,  4555,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   878,   879,     0,     0,   578,   579,     0,
     581,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   880,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   858,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   627,   628,   629,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   859,   260,   860,   861,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   862,   863,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   864,   865,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     866,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   339,   340,   341,
     342,     0,     0,   344,     0,   345,   346,   347,   867,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,     0,     0,     0,   362,   363,     0,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,     0,   385,   386,   387,   388,   868,   869,     0,
     870,     0,   392,   393,   394,   395,   396,   871,     0,     0,
       0,     0,     0,     0,   404,   405,   406,   407,   408,   409,
       0,     0,   410,     0,   412,   413,   414,     0,   415,   416,
     417,     0,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   872,   437,   873,   439,   440,   441,   442,   443,   444,
     445,  2841,     0,   448,     0,   449,   450,   451,   452,     0,
       0,   454,   874,   456,   457,   458,     0,   459,   460,     0,
       0,   461,   462,   463,     0,     0,   464,   465,     0,   467,
     468,   469,     0,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,     0,   484,     0,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   875,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,     0,   541,
     542,   876,   544,   545,   546,   547,   548,   877,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   565,     0,   566,   567,     0,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   878,
     879,     0,     0,   578,   579,     0,   581,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   880,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   858,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   627,   628,   629,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   859,   260,   860,   861,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   862,   863,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   864,   865,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   866,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   339,   340,   341,   342,     0,     0,   344,
       0,   345,   346,   347,   867,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
       0,     0,     0,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,     0,   385,
     386,   387,   388,   868,   869,     0,   870,     0,   392,   393,
     394,   395,   396,   871,     0,     0,     0,     0,     0,     0,
     404,   405,   406,   407,   408,   409,     0,     0,   410,     0,
     412,   413,   414,     0,   415,   416,   417,     0,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   872,   437,   873,
     439,   440,   441,   442,   443,   444,   445,  4351,     0,   448,
       0,   449,   450,   451,   452,     0,     0,   454,   874,   456,
     457,   458,     0,   459,   460,     0,     0,   461,   462,   463,
       0,     0,   464,   465,     0,   467,   468,   469,     0,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,     0,   484,     0,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   875,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,     0,   541,   542,   876,   544,   545,
     546,   547,   548,   877,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     565,     0,   566,   567,     0,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   878,   879,     0,     0,   578,
     579,     0,   581,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   880,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   858,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   627,   628,
     629,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   859,   260,   860,
     861,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   862,   863,   274,     0,   275,   276,   277,
     278,     0,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,     0,
     301,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     864,   865,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   866,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   339,
     340,   341,   342,     0,     0,   344,     0,   345,   346,   347,
     867,   349,  5888,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,     0,     0,     0,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,     0,   385,   386,   387,   388,   868,
     869,     0,   870,     0,   392,   393,   394,   395,   396,   871,
       0,     0,     0,     0,     0,     0,   404,   405,   406,   407,
     408,   409,     0,     0,   410,     0,   412,   413,   414,     0,
     415,   416,   417,     0,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   872,   437,   873,   439,   440,   441,   442,
     443,   444,   445,     0,     0,   448,     0,   449,   450,   451,
     452,     0,     0,   454,   874,   456,   457,   458,     0,   459,
     460,     0,     0,   461,   462,   463,     0,     0,   464,   465,
       0,   467,   468,   469,     0,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,     0,   484,
       0,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   875,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
       0,   541,   542,   876,   544,   545,   546,   547,   548,   877,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   565,     0,   566,   567,
       0,     0,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   878,   879,     0,     0,   578,   579,     0,   581,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   880,     0,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   858,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   627,   628,   629,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,   859,   260,   860,   861,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,   862,
     863,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,   864,   865,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   866,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,   867,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,     0,     0,     0,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
       0,   385,   386,   387,   388,   868,   869,     0,   870,     0,
     392,   393,   394,   395,   396,   871,     0,     0,     0,     0,
       0,     0,   404,   405,   406,   407,   408,   409,     0,     0,
     410,     0,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   872,
     437,   873,   439,   440,   441,   442,   443,   444,   445,     0,
       0,   448,     0,   449,   450,   451,   452,     0,     0,   454,
     874,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,     0,   467,   468,   469,
       0,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,     0,   484,     0,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   875,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,   876,
     544,   545,   546,   547,   548,   877,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,   878,   879,     0,
       0,   578,   579,     0,   581,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     880,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,   858,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     627,   628,   629,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,   243,     0,   244,   245,   246,     0,
       0,     0,     0,     0,     0,     0,   247,   248,   249,     0,
     250,   251,   252,   253,   254,   255,   256,   257,     0,   859,
     260,   860,   861,     0,   263,   264,   265,   266,   267,   268,
     269,     0,     0,   270,   271,   862,   863,   274,     0,   275,
     276,   277,   278,     0,     0,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,     0,   291,   292,
     293,   294,   295,   296,     0,   297,   298,   299,   300,     0,
       0,     0,   301,     0,     0,     0,   302,   303,   304,   305,
     306,   307,   864,   865,   310,     0,   311,     0,   312,   313,
     314,   315,   316,   317,   318,     0,   319,   320,   321,   322,
       0,     0,   323,   324,   866,   326,   327,     0,   328,   329,
     330,     0,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   339,   340,   341,   342,     0,     0,   344,     0,   345,
     346,   347,   867,   349,     0,   350,     0,   351,   352,   353,
       0,   354,   355,   356,   357,   358,     0,   359,     0,     0,
       0,   362,   363,     0,   364,   365,   366,   367,  1134,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,   381,     0,   382,   383,     0,   385,   386,   387,
     388,   868,   869,     0,   870,     0,   392,   393,   394,   395,
     396,   871,     0,     0,     0,     0,     0,     0,   404,   405,
     406,   407,   408,   409,     0,     0,   410,     0,   412,   413,
     414,     0,   415,   416,   417,     0,     0,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   872,   437,   873,   439,   440,
     441,   442,   443,   444,   445,     0,     0,   448,     0,   449,
     450,   451,   452,     0,     0,   454,   874,   456,   457,   458,
       0,   459,   460,     0,     0,   461,   462,   463,     0,     0,
     464,   465,     0,   467,   468,   469,     0,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,     0,   481,   482,
       0,   484,     0,   486,   487,   488,     0,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   875,   500,   501,
     502,   503,     0,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,     0,   517,   518,   519,
     520,   521,   522,   523,   524,     0,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,     0,   541,   542,   876,   544,   545,   546,   547,
     548,   877,   550,     0,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,   565,     0,
     566,   567,     0,     0,   568,   569,   570,   571,   572,   573,
     574,     0,   575,   878,   879,     0,     0,   578,   579,     0,
     581,     0,     0,   583,   584,   585,   586,   587,   588,   589,
     590,     0,     0,   591,   592,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   880,     0,   603,   604,
     605,   606,   607,   608,     0,     0,   609,     0,     0,   610,
     611,   612,   613,   614,   615,   858,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   627,   628,   629,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
     243,     0,   244,   245,   246,     0,     0,     0,     0,     0,
       0,     0,   247,   248,   249,     0,   250,   251,   252,   253,
     254,   255,   256,   257,     0,   859,   260,   860,   861,     0,
     263,   264,   265,   266,   267,   268,   269,     0,     0,   270,
     271,   862,   863,   274,     0,   275,   276,   277,   278,     0,
       0,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     0,   291,   292,   293,   294,   295,   296,
       0,   297,   298,   299,   300,     0,     0,     0,   301,     0,
       0,     0,   302,   303,   304,   305,   306,   307,   864,   865,
     310,     0,   311,     0,   312,   313,   314,   315,   316,   317,
     318,     0,   319,   320,   321,   322,     0,     0,   323,   324,
     866,   326,   327,     0,   328,   329,   330,     0,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   339,   340,   341,
     342,     0,     0,   344,     0,   345,   346,   347,   867,   349,
       0,   350,     0,   351,   352,   353,     0,   354,   355,   356,
     357,   358,     0,   359,     0,     0,     0,   362,   363,     0,
     364,   365,   366,   367,  1166,   369,   370,   371,   372,   373,
       0,   374,   375,   376,   377,   378,   379,   380,   381,     0,
     382,   383,     0,   385,   386,   387,   388,   868,   869,     0,
     870,     0,   392,   393,   394,   395,   396,   871,     0,     0,
       0,     0,     0,     0,   404,   405,   406,   407,   408,   409,
       0,     0,   410,     0,   412,   413,   414,     0,   415,   416,
     417,     0,     0,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   872,   437,   873,   439,   440,   441,   442,   443,   444,
     445,     0,     0,   448,     0,   449,   450,   451,   452,     0,
       0,   454,   874,   456,   457,   458,     0,   459,   460,     0,
       0,   461,   462,   463,     0,     0,   464,   465,     0,   467,
     468,   469,     0,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,     0,   481,   482,     0,   484,     0,   486,
     487,   488,     0,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   875,   500,   501,   502,   503,     0,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,     0,   517,   518,   519,   520,   521,   522,   523,
     524,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,     0,   541,
     542,   876,   544,   545,   546,   547,   548,   877,   550,     0,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,     0,   565,     0,   566,   567,     0,     0,
     568,   569,   570,   571,   572,   573,   574,     0,   575,   878,
     879,     0,     0,   578,   579,     0,   581,     0,     0,   583,
     584,   585,   586,   587,   588,   589,   590,     0,     0,   591,
     592,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   880,     0,   603,   604,   605,   606,   607,   608,
       0,     0,   609,     0,     0,   610,   611,   612,   613,   614,
     615,   858,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   627,   628,   629,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,   243,     0,   244,   245,
     246,     0,     0,     0,     0,     0,     0,     0,   247,   248,
     249,     0,   250,   251,   252,   253,   254,   255,   256,   257,
       0,   859,   260,   860,   861,     0,   263,   264,   265,   266,
     267,   268,   269,     0,     0,   270,   271,   862,   863,   274,
       0,   275,   276,   277,   278,     0,     0,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,     0,
     291,   292,   293,   294,   295,   296,     0,   297,   298,   299,
     300,     0,     0,     0,   301,     0,     0,     0,   302,   303,
     304,   305,   306,   307,   864,   865,   310,     0,   311,     0,
     312,   313,   314,   315,   316,   317,   318,     0,   319,   320,
     321,   322,     0,     0,   323,   324,   866,   326,   327,     0,
     328,   329,   330,     0,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   339,   340,   341,   342,     0,     0,   344,
       0,   345,   346,   347,   867,   349,     0,   350,     0,   351,
     352,   353,     0,   354,   355,   356,   357,   358,     0,   359,
       0,     0,     0,   362,   363,     0,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,   381,     0,   382,   383,     0,   385,
     386,   387,   388,   868,   869,     0,   870,     0,   392,   393,
     394,   395,   396,   871,     0,     0,     0,     0,     0,     0,
     404,   405,   406,   407,   408,   409,     0,     0,   410,     0,
     412,   413,   414,     0,   415,   416,   417,     0,     0,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   872,   437,   873,
     439,   440,   441,   442,   443,   444,   445,     0,     0,   448,
       0,   449,   450,   451,   452,     0,     0,   454,   874,   456,
     457,   458,     0,   459,   460,     0,     0,   461,   462,   463,
       0,     0,   464,   465,     0,   467,   468,   469,     0,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,     0,
     481,   482,     0,   484,     0,   486,   487,   488,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   875,
     500,   501,   502,   503,     0,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,     0,   517,
     518,   519,   520,   521,   522,   523,   524,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,     0,   541,   542,  2683,   544,   545,
     546,   547,   548,   877,   550,     0,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,     0,
     565,     0,   566,   567,     0,     0,   568,   569,   570,   571,
     572,   573,   574,     0,   575,   878,   879,     0,     0,   578,
     579,     0,   581,     0,     0,   583,   584,   585,   586,   587,
     588,   589,   590,     0,     0,   591,   592,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   880,     0,
     603,   604,   605,   606,   607,   608,     0,     0,   609,     0,
       0,   610,   611,   612,   613,   614,   615,   858,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   627,   628,
     629,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   243,     0,   244,   245,   246,     0,     0,     0,
       0,     0,     0,     0,   247,   248,   249,     0,   250,   251,
     252,   253,   254,   255,   256,   257,     0,   859,   260,   860,
     861,     0,   263,   264,   265,   266,   267,   268,   269,     0,
       0,   270,   271,   862,   863,   274,     0,   275,   276,   277,
     278,     0,     0,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,     0,   291,   292,   293,   294,
     295,   296,     0,   297,   298,   299,   300,     0,     0,     0,
     301,     0,     0,     0,   302,   303,   304,   305,   306,   307,
     864,   865,   310,     0,   311,     0,   312,   313,   314,   315,
     316,   317,   318,     0,   319,   320,   321,   322,     0,     0,
     323,   324,   866,   326,   327,     0,   328,   329,   330,     0,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   339,
     340,   341,   342,     0,     0,   344,     0,   345,   346,   347,
     867,   349,     0,   350,     0,   351,   352,   353,     0,   354,
     355,   356,   357,   358,     0,   359,     0,     0,     0,   362,
     363,     0,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,     0,   374,   375,   376,   377,   378,   379,   380,
     381,     0,   382,   383,     0,   385,   386,   387,   388,   868,
     869,     0,   870,     0,   392,   393,   394,   395,   396,   871,
       0,     0,     0,     0,     0,     0,   404,   405,   406,   407,
     408,   409,     0,     0,   410,     0,   412,   413,   414,     0,
     415,   416,   417,     0,     0,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   872,   437,   873,   439,   440,   441,   442,
     443,   444,   445,     0,     0,   448,     0,   449,   450,   451,
     452,     0,     0,   454,   874,   456,   457,   458,     0,   459,
     460,     0,     0,   461,   462,   463,     0,     0,   464,   465,
       0,   467,   468,   469,     0,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,     0,   481,   482,     0,   484,
       0,   486,   487,   488,     0,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   875,   500,   501,   502,   503,
       0,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,     0,   517,   518,   519,   520,   521,
     522,   523,   524,     0,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
       0,   541,   542,     0,   544,   545,   546,   547,   548,   877,
     550,     0,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,     0,   565,     0,   566,   567,
       0,     0,   568,   569,   570,   571,   572,   573,   574,     0,
     575,   878,   879,     0,     0,   578,   579,     0,   581,     0,
       0,   583,   584,   585,   586,   587,   588,   589,   590,     0,
       0,   591,   592,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   880,     0,   603,   604,   605,   606,
     607,   608,     0,     0,   609,     0,     0,   610,   611,   612,
     613,   614,   615,   858,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   627,   628,   629,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   243,     0,
     244,   245,   246,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,     0,   250,   251,   252,   253,   254,   255,
     256,   257,     0,     0,   260,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,     0,     0,   270,   271,     0,
       0,   274,     0,   275,   276,   277,   278,     0,     0,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,     0,   291,   292,   293,   294,   295,   296,     0,   297,
     298,   299,   300,     0,     0,     0,   301,     0,     0,     0,
     302,   303,   304,   305,   306,   307,     0,     0,   310,     0,
     311,     0,   312,   313,   314,   315,   316,   317,   318,     0,
     319,   320,   321,   322,     0,     0,   323,   324,   325,   326,
     327,     0,   328,   329,   330,     0,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   339,   340,   341,   342,     0,
       0,   344,     0,   345,   346,   347,     0,   349,     0,   350,
       0,   351,   352,   353,     0,   354,   355,   356,   357,   358,
       0,   359,     0,     0,     0,   362,   363,     0,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,   381,     0,   382,   383,
       0,   385,   386,   387,   388,     0,     0,     0,     0,     0,
     392,   393,   394,   395,   396,     0,     0,     0,     0,     0,
       0,     0,   404,   405,   406,   407,   408,   409,     0,     0,
     410,     0,   412,   413,   414,     0,   415,   416,   417,     0,
       0,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,     0,   439,   440,   441,   442,   443,   444,   445,     0,
       0,   448,     0,   449,   450,   451,   452,     0,     0,   454,
       0,   456,   457,   458,     0,   459,   460,     0,     0,   461,
     462,   463,     0,     0,   464,   465,     0,   467,   468,   469,
       0,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,     0,   481,   482,     0,   484,     0,   486,   487,   488,
       0,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,     0,   500,   501,   502,   503,     0,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
       0,   517,   518,   519,   520,   521,   522,   523,   524,     0,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,     0,   541,   542,     0,
     544,   545,   546,   547,   548,     0,   550,     0,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,     0,   565,     0,   566,   567,     0,     0,   568,   569,
     570,   571,   572,   573,   574,     0,   575,     0,     0,     0,
       0,   578,   579,     0,   581,     0,     0,   583,   584,   585,
     586,   587,   588,   589,   590,     0,     0,   591,   592,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
       0,     0,   603,   604,   605,   606,   607,   608,     0,     0,
     609,     0,     0,   610,   611,   612,   613,   614,   615,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     627,   628,   629
};

static const yytype_int16 yycheck[] =
{
       6,     0,     0,     0,     0,     0,     0,    56,     0,     0,
       0,   665,  1029,     0,     0,     0,     0,  1020,   206,     0,
     992,     0,     0,    21,    36,   921,   214,    21,     0,   217,
       0,     0,   778,   779,   780,   211,   822,    45,   784,   819,
      44,     8,  1146,  1635,   189,    51,  1508,   915,    15,   917,
    1207,   876,  1570,  1009,    22,  2724,  1554,   895,   846,  2665,
      28,  1480,   993,   644,   197,  1018,   812,  1254,  2666,  1024,
    3017,  1559,  1095,   720,  1241,   211,  2017,  1547,  3082,  3044,
     829,  3369,   845,  3371,   697,   216,  1875,   734,   864,   865,
     879,   992,  1554,   742,   738,   933,  2006,  3192,   874,   230,
    1001,  1226,  4203,  3462,  3664,  1230,  2042,  1703,  1233,  1234,
    1011,  3029,  3876,  1069,  3887,  2043,   697,  1073,  3557,  3610,
    2935,  3612,  1078,  1084,    23,  1600,  1601,  3860,  1547,  1604,
    2025,  3415,  1088,     6,   646,  3472,  4520,    36,  2078,  1100,
    3421,  3909,  1022,  4246,   958,  4250,  1102,  4750,   191,  1537,
     175,   733,  1670,  1671,  2913,   743,   191,  3584,  1947,  2040,
    2041,  1888,  4543,   744,  2045,  3812,  1437,     2,  4329,   983,
    2687,  2688,  5071,  4488,   988,  4531,  1664,  1133,  4526,  5229,
    2054,   944,    35,  3436,  2545,  4766,  3470,  4768,  2549,    42,
    5063,   197,   718,  5251,  5363,   721,  2650,  5014,    50,  2582,
     206,   207,  2652,  1691,    41,  3235,   959,  5272,   214,  1597,
     216,   217,   825,  3482,  2623,  4530,   797,  4815,  3420,   942,
    3422,   225,  5058,    11,   230,  3323,  1614,  5360,  5411,  4225,
     918,     6,  3874,     0,  3328,   918,     6,  5399,    21,     0,
    4692,     0,  5648,     0,   825,  5062,  2629,    38,    54,     0,
    1520,     6,     5,  5318,    11,  5325,  5326,    21,    11,     6,
     983,     6,    94,    25,     6,   988,  3025,    35,     6,   850,
    1033,     6,    29,    15,    16,  5632,  1029,    63,     6,     6,
    2982,    37,  2984,  2985,     6,  2012,   119,  2989,  2990,  2991,
       6,  2993,  2994,  2995,   174,    43,    29,     6,   146,    15,
      16,   119,     6,   168,   174,   114,    15,    16,   121,    78,
       0,     6,     6,    43,     6,     6,   191,  1063,    47,   112,
       6,    11,  4621,  4622,  4623,    91,  4625,  4626,  4627,  4628,
    4629,   912,   862,   863,     5,    13,    13,    80,   181,    29,
      11,    15,    11,   873,     3,    11,     5,     6,    91,   119,
    5902,    47,    11,   174,   181,   177,  1135,    21,    25,  5583,
     298,  5585,  1141,     6,    13,  5589,  5590,    45,  3559,   121,
     303,   152,  1151,   152,     6,   175,  1155,   139,   203,  1854,
    1159,   190,  1161,  4544,    13,   175,    47,   300,  1167,     3,
     318,   124,     6,    76,  1173,    63,    45,  1176,    85,   289,
      78,   332,   298,   190,   174,   313,   248,   174,   374,    63,
     852,   374,    63,   174,   388,   174,    42,   174,   311,   344,
     183,    63,   176,   174,    35,   369,  1449,   134,  1381,    78,
    5836,   198,   387,   174,    80,    63,  1085,   198,  1393,   198,
    5276,   198,    63,    29,   352,    91,   429,   198,  1029,   429,
     119,   149,  2871,   262,    39,   369,   265,    23,  6165,   122,
     119,  5289,   119,   463,   474,   176,   469,  4851,    29,   151,
    5827,   223,   139,   364,   174,   262,    98,   340,    13,   387,
     213,  5546,   505,   472,   174,    29,  1441,    13,  5650,   297,
     353,   339,    36,   311,   517,    29,  1272,  1273,   514,   210,
     114,     6,    36,   519,   287,  5333,  1153,   496,   198,   519,
      45,   168,   174,   335,   174,   515,   519,   317,   200,  6226,
     383,    29,  1311,   287,  1300,   357,   174,  5400,    36,   665,
     282,   194,   663,  2952,   472,   291,   519,   451,   669,   519,
     465,   515,   153,    78,   129,   299,   368,   245,   134,   515,
     681,    80,   515,    80,    63,    80,    80,  1437,   180,   218,
     382,   452,    80,   453,   519,   181,   459,  1214,  1331,   378,
     196,   515,   358,   134,  5980,   282,   190,   515,  1225,   715,
      91,   477,    80,   516,   515,   427,   519,   515,   340,   248,
     181,   378,   417,   393,  1549,  1242,   418,    10,  1361,  1187,
      13,   364,   515,   235,    17,    18,    19,   515,   429,   390,
    5743,   390,   295,  1500,   760,   761,   762,   373,  6170,   765,
     766,   767,  1523,   287,   417,   387,  1379,   141,   124,   775,
    3821,  1384,  1385,  5857,  1247,  3044,  5217,   126,   644,   519,
     515,   459,   455,  1604,   287,   472,   313,   380,   262,   519,
     515,   265,   650,   650,   650,   650,    32,   663,   650,   429,
     650,   429,  1438,   669,  6070,   413,  1247,   515,   434,   404,
     405,    10,   505,  5835,  1630,   681,   519,  1633,    17,    18,
      19,   490,  4329,   413,  1585,   352,   429,   519,   254,   451,
     358,   697,   519,  1654,  1655,   744,   702,   515,  1701,  1702,
     429,   707,   458,  5773,   358,   711,   712,   358,  4355,   515,
    1641,  6068,   718,  5165,   720,   721,   358,   462,   451,   472,
     387,   496,   497,   748,   515,   515,   514,   733,   734,   458,
     358,  1261,  1262,   519,  6140,   505,   519,   358,   744,  1181,
     515,   496,   497,   496,   513,   743,  1699,   517,   517,   506,
     507,   518,  2022,   506,   507,   519,   443,   518,  1402,   518,
     515,   518,   458,  1376,   378,  1295,  4499,   518,   515,  5642,
     515,  1585,  1525,   515,  6180,  4539,   921,   515,   519,  1467,
    5913,  5914,  1535,   429,  1467,   513,   790,   515,   515,   517,
     758,   797,   760,   515,   762,  1376,  1621,   458,  4794,   515,
     768,  5984,  4362,  1384,  1385,   772,   515,  4540,  4368,  5971,
    5646,   515,  1708,   819,   820,   515,   506,   507,  1975,   825,
     515,   515,  1545,   515,   515,  4252,  5125,  4254,   518,   515,
    5999,   505,    29,   511,   511,   506,   507,   506,   507,   513,
     506,   507,   846,   517,   850,  1949,   852,   506,   507,   358,
    5915,   519,  1040,   397,   420,   515,  1044,   519,  1046,   508,
     509,   510,   511,   397,  5929,   519,   909,  1043,   519,  1622,
     876,   519,  1625,  1626,   909,  1598,   490,   519,  1982,   508,
     509,   510,   511,   449,  1414,  1415,   299,  4168,  1330,   397,
    1994,   519,  1615,   899,  1855,  4179,    23,  4544,   519,  4183,
     429,  1034,   429,   519,   429,   429,   912,  1043,   474,    23,
    6072,   429,   911,   911,   911,   911,   911,   911,   429,   911,
     911,   911,   926,  5521,   911,   911,   911,   911,   519,  3847,
     911,   429,   911,   911,     3,  5834,   935,   941,  1592,   911,
      25,   911,   911,  4037,  4038,  3704,  3705,  4045,  4590,   515,
    3709,  1838,    32,    63,   468,   451,  1836,   121,  5831,   198,
     299,   153,    88,  5350,   453,  4167,  1408,  4169,  3485,  4238,
    3487,   506,   507,   508,   509,   510,   511,  6139,  6043,   355,
     506,   507,   508,   509,   510,   511,   823,  3441,   124,   278,
     827,  4021,  3442,   369,   112,   371,    25,  5814,    22,  5383,
    3383,   853,   318,  3412,    28,   131,  3415,    37,  1520,  4448,
     519,    51,   112,  5830,  1020,  1021,  1022,    52,  6076,  6077,
      72,    90,  4449,  1029,   112,   152,  4120,   297,  1034,   168,
      63,   162,  1474,  1039,  1040,   337,    68,     6,  1044,  2042,
    1046,   124,  1188,   262,  1050,  1191,  6215,  1193,   119,  1195,
     174,  1197,   312,  3462,   139,  1201,   186,   124,   434,   223,
    1066,  3470,    23,    10,   174,  1818,    13,   119,   124,  2024,
      17,    18,    19,   119,   143,  5390,   219,   213,    21,   135,
       6,   202,  5981,    25,   174,  3844,   371,   472,  3790,   119,
     503,   504,   505,   506,   507,   508,   509,   510,   511,  5972,
      23,   114,  4355,   417,  1110,     6,  1112,  1113,   174,    91,
     139,   352,  3473,    58,   245,    87,    72,   421,   282,   423,
    2075,   312,   297,    28,  6182,   322,   178,   387,  5709,   175,
     213,  5292,   198,    63,   519,    91,  4575,   119,  1884,   176,
     254,   369,  5247,  1922,   997,   998,   213,  1153,   278,   434,
     303,  1930,  4511,    10,  6204,  5528,    13,   278,   193,   378,
      17,    18,    19,   198,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    23,   402,  1181,   340,   190,    35,  6078,
     102,   303,   251,   128,  1601,   382,    91,  1604,   429,  1187,
     316,    23,   164,   260,   150,  5870,   387,   139,   258,   515,
     124,   186,   491,  6253,   278,  1991,  1992,  5594,  1214,   244,
     168,   282,    88,   515,   170,   139,    88,  1223,   124,  1225,
    1801,   113,  2102,  1190,   421,  1192,   423,  1194,   313,  1196,
     282,  1198,  1199,  1200,   119,   287,  1242,   283,  1205,  6138,
     160,  1247,   369,   513,   313,  5629,   278,   517,  5991,   262,
    6149,   198,   265,  1259,  5638,   131,   170,    98,  5614,   131,
     374,   183,   299,   390,   374,    23,   384,   352,  2687,  2757,
     149,   176,  1919,   303,   221,   355,   468,   118,   330,  5660,
     519,  1330,  6181,  1118,   313,  4250,  1933,  5060,  5644,  5053,
    2788,  1297,  5640,   254,   346,  3812,   422,   380,  5613,  1946,
     282,  3028,   387,   374,  5688,   429,   420,   213,  1952,  2072,
    6209,   203,   153,  3249,  5047,   451,  5084,   417,   287,   359,
    1326,  1327,  1328,   352,  1330,   358,   282,   457,  5643,   417,
    1912,   254,     0,   472,  6233,   449,    23,  1981,   217,   429,
     515,  1985,  6085,    72,   287,  1351,  1990,  2835,   278,  1993,
    2621,   420,   299,   422,   464,   519,   278,   392,   387,   301,
     474,   287,  1944,    23,   221,   378,   519,     3,   451,   406,
    1376,  1959,  1397,  5746,   330,  2971,   519,   312,  1384,  1385,
     300,   505,  4809,   457,   451,  3902,   287,  3261,  3262,  2777,
    1916,    23,  3266,   517,   446,   451,   354,   519,  2052,  1857,
     283,   515,  1408,   327,   254,  1931,   472,   453,  1934,  1452,
    1453,  6014,  1455,   374,   356,   357,  5519,  1452,  1453,  1877,
    1455,   150,   254,   312,   303,  6100,   311,   456,   358,   334,
      98,  1437,  5816,  3307,  3308,  3375,   135,  1854,   119,    23,
     316,   170,   299,  5991,   316,   387,  6189,   232,  1454,    30,
      27,   374,  1458,  1459,    90,  4792,  1592,   387,  1984,   420,
     453,   179,  1988,  1989,    40,  1469,   371,  1471,  1474,  3061,
    4751,  4755,   457,    50,  1480,   505,  4760,   490,    54,  4763,
     176,   149,   374,   513,     3,   515,   516,   517,   449,   519,
     446,   132,   153,   278,   162,   380,   254,   420,   387,   515,
     168,   142,   515,   112,   426,   167,   174,   348,   144,   292,
    2022,   298,   180,   474,   213,   183,   436,   356,   121,   187,
    5011,   234,   515,   415,   374,   417,   449,   432,   453,   434,
     248,   437,   417,   438,   110,   318,    64,  6085,   298,   380,
     258,  1547,   374,  2546,    72,   451,   422,  4512,   387,   217,
     422,   474,  4556,   282,   515,   340,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   298,   445,   254,   451,   205,
     420,   292,   198,   185,   459,    25,   417,   245,   356,   329,
     177,  2023,  1588,  2025,  5968,    25,   186,   472,   420,  2031,
     515,    31,   515,  2548,   254,  2037,  2038,   318,   431,   449,
     119,   330,   153,   121,  2046,   390,   287,  1606,   292,   387,
    3080,   496,  1611,  2055,   292,  1621,   374,   449,   459,  2061,
     223,   232,   254,   121,   474,  5389,   294,  5732,  5401,   297,
     515,   472,     0,   214,   318,   303,   212,   214,   334,   175,
     318,  6189,   474,   387,  5745,  5292,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   496,  1660,  3076,    25,  5977,
    5978,  3080,   420,   325,    31,   515,   451,   278,    10,   278,
     254,    13,   313,   209,   515,    17,    18,    19,   278,   282,
    1686,   431,  6066,   515,   320,   472,  1685,   374,   224,   139,
    1689,   449,   360,    35,  2711,  1701,  1702,  1703,   168,   139,
     345,   301,   278,   421,  4519,   423,   242,   179,   123,   207,
     180,   352,   472,   329,   374,    10,   474,   446,    13,   380,
     248,    13,    17,    18,    19,   475,   352,   339,   198,  1917,
     356,   449,   515,   420,   758,  4437,   760,   340,   762,   472,
    4442,  2621,   374,    38,   768,   769,   770,   123,   134,   417,
     136,  6135,  1928,   354,  4513,   165,   417,   515,   370,   387,
     420,   387,   449,   282,   648,   313,   515,   387,   287,   287,
    4179,   368,   139,  1906,  4183,   519,   248,   445,   375,   390,
     278,   463,   431,  4748,   282,   382,    78,   474,   420,   449,
     374,  1927,  1928,   396,   515,  1801,   111,   186,   459,   518,
     376,   469,  2581,   471,   472,   220,  4475,  1813,   444,   286,
    5911,   472,  4329,   458,   474,   431,   452,   449,  1824,   455,
     387,   418,   371,  6141,    29,   493,   475,   363,   515,   380,
    1836,   515,   165,   515,  1840,   496,   420,   515,  4355,   387,
     451,  4250,   474,   440,   220,   513,   472,   387,   516,   517,
     518,   122,    48,  1859,   515,   515,   740,   457,  2683,   475,
     162,  1867,   313,   273,   374,   449,   417,   519,   303,  1875,
     496,   472,   344,   313,    25,    71,  5649,  2663,    83,   221,
      31,    86,   278,   515,   429,   434,  2787,    92,  1894,   278,
     474,   519,   362,   403,  5658,   496,   282,  1903,  5631,   519,
    1906,   352,   122,  1909,   237,   356,  1912,  1913,   459,  2881,
    1916,  1917,   352,  1919,  1920,   120,  2052,   394,   519,   169,
     301,   472,   472,   194,   313,  1931,   221,  1933,  1934,  5213,
     814,   515,   313,    69,    70,   959,   387,  1943,  1944,  2819,
    1946,  1947,   377,   245,   259,   496,   313,   387,   263,   421,
     380,   423,   519,   415,   744,   205,   352,   299,  2711,    10,
     505,  1959,    13,   352,   515,  2845,    17,    18,    19,   519,
    2931,   352,   517,   178,   194,   369,  6081,   449,  1984,   519,
    2881,    13,  1988,  1989,    35,   352,   191,   417,   139,  5428,
     452,  2040,   294,   465,  1961,   121,  1963,  2001,  1965,   204,
    1967,  3105,  1969,  2015,   299,  1029,  1973,   797,  2006,  2006,
    2006,  2006,   516,    45,  2006,   519,  2006,  2023,  2919,  2025,
     387,  5116,  4853,   417,  2030,  2031,  3967,  4544,   313,   459,
    4861,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,    93,   168,  2049,  3985,  2051,    78,  2053,  2054,  2055,
    2056,  2057,  2058,  2954,  1606,  2061,  5829,  2063,  2064,  1611,
     850,  2067,   313,  3482,  5828,  2945,  5013,   352,   457,  2965,
    2966,  2967,  5037,  3492,   352,  2081,  2082,  2083,  2084,  5847,
    6185,   207,    35,   464,   136,   515,  4022,  3048,  3049,  3050,
    3051,  4027,  3053,   162,  2100,   472,  2102,  3689,  2861,   168,
     313,   352,  4511,  4512,  3574,  5052,  4001,  3294,  4036,   387,
     149,  1598,     5,  2859,  5032,  2861,    80,  3078,    11,  2018,
    2934,  5612,   912,   162,   352,   332,    19,    91,  1615,   168,
    2711,  3011,  2885,  1685,  5422,   348,   387,  1689,  2785,   352,
    2893,  3097,   519,  2896,    37,  4026,  5241,   313,  5243,  4030,
    4031,   162,   278,    38,  3943,  3574,   282,   168,  2600,   387,
     313,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     221,   434,   282,  3769,   387,    60,   245,   287,   217,  3775,
     174,    99,  4056,  4057,  4058,  4059,   352,  3662,  4062,  4063,
    4064,  4065,  4066,  4067,  4068,  4069,  4070,  4071,   403,   352,
    5973,   406,   291,   472,   198,    91,   245,    38,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   357,   149,    25,
      27,   387,   119,  3711,   465,   294,   111,   496,   338,    60,
      80,   162,   149,     5,   245,   344,  5663,   168,  2244,    11,
     377,    91,  5001,    50,  5003,   162,  5685,   387,   299,  4159,
     519,   168,  4126,  4127,   369,   294,   371,   175,    32,   156,
     313,   284,   283,   284,   303,  2909,    99,  2911,  5233,   514,
    3758,  2915,   381,  4975,   519,  4977,  4978,  4979,  5637,   313,
     111,   168,  5247,   294,    90,    59,   217,  2293,  3168,  3476,
      99,   209,   297,   179,   191,  2623,   257,   302,  6071,   352,
     217,    15,    16,   168,  5592,   192,   224,   258,   417,   513,
     496,   497,   235,   517,   245,  3094,   201,   203,   352,   434,
    3099,   282,  3101,   515,   242,  3071,   132,   192,   245,   515,
     515,   282,  3111,   139,   387,  3114,   142,  3116,  3117,  4748,
    2346,  3120,   175,   168,   472,  3124,  4755,  3126,  5908,  6082,
    3129,  4760,   270,   387,  4763,  1379,   465,   380,   472,   380,
    1384,  1385,   248,   294,   434,  3883,   175,   192,   496,     5,
     201,   272,   303,   354,   259,    11,   209,   294,   263,   297,
     429,  3030,   496,   258,   111,   282,   303,   515,  1412,   496,
     497,   224,   344,   278,   417,   296,   417,  1421,   261,  1423,
     209,     5,  3155,  1427,   453,  3285,   445,    11,   515,   242,
    1434,  3291,   987,   258,  3193,   224,   302,   297,   510,    33,
      34,   377,   302,   515,   134,   517,   136,   312,   259,   381,
      95,  1006,   263,   242,  1009,  5548,   459,   270,   459,   983,
    5553,  5554,   169,  5731,   988,   363,  5411,   278,   203,   472,
     160,   472,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   270,   510,  2065,   297,   417,  2068,   515,   261,   517,
      22,  3234,   357,   496,  3370,   496,    28,   192,   205,  6212,
      10,   312,    87,    13,    98,    33,    34,    17,    18,    19,
     369,   370,   515,   516,   515,   518,   381,   515,   513,   517,
     515,  1525,   517,   516,   118,    35,   519,   313,  3152,  5474,
     513,  1535,   515,   465,   445,   225,   401,  2523,  2524,  2525,
    2526,  2527,  2528,  2529,  2530,  2531,   357,  2533,   445,  6241,
     363,  6243,   259,   465,     3,   421,   263,   423,  2544,   153,
    2546,  3274,   348,  3276,  3277,   421,   352,   423,   434,   516,
     381,  6263,   519,   434,   363,  1579,  1580,   496,   497,  2747,
     446,  2749,  2750,   449,   274,   275,   276,   277,   369,   370,
     401,   281,  2748,   274,   275,   276,   277,   287,  2584,    59,
     516,   387,  2588,   519,   472,  2591,   474,  2593,   394,  2583,
    2596,  3716,   516,  4467,  2600,   519,   513,   377,  1622,   516,
     517,  1625,  1626,   369,   370,   516,  3395,  3396,   519,  6036,
       3,  2744,  2748,  6040,  6041,  2621,   516,  2623,   235,   519,
     453,    90,   516,  3376,  3373,   519,   369,   370,  5037,  3560,
     508,   516,   515,    26,  2640,   513,  5338,   515,   515,   517,
     517,   508,   463,  2649,  2650,  3483,   513,    11,   515,   472,
     517,   474,   374,  2784,   516,  3586,   380,   519,  5532,  5533,
    3561,  5665,  4603,   516,  3427,   516,   519,   421,   519,   423,
    2676,   198,   199,  2668,   143,   202,  3330,  2683,  4619,   415,
     516,  2687,  2688,   519,   516,   519,   516,   519,  2694,   519,
      48,   221,  2698,   417,   297,   222,  2702,    90,  6125,  5700,
    5701,  2713,   229,  2715,   516,  2711,   465,   519,   516,  4301,
    3665,   519,  4648,  5876,  5877,  3872,  3044,  3493,  4654,  4655,
     516,    59,   516,   519,  2730,   519,   436,  2733,   516,   300,
     516,   519,  4521,   519,   348,   459,  3637,   447,  2744,  2870,
    2746,  2747,  6030,  2749,  2750,  3524,  2752,   421,   472,   423,
    2623,   144,  2756,   516,   516,   515,   519,   519,  2764,   516,
     516,    54,   519,   519,  5523,   516,   380,  5732,   519,   299,
     516,   516,   496,   519,   519,  5292,   492,   516,  2784,  2785,
     519,  4299,   251,  4301,   134,   516,   136,  2793,   519,  4277,
     472,   515,   474,  4291,  1818,  3376,   516,   516,   516,   519,
     519,   519,   515,   417,  5213,   198,   472,   100,   474,  2815,
    2816,  5906,   205,  2819,    54,    55,  3595,  3984,  3597,  4238,
    2951,  3263,   516,   516,  5233,   519,   519,   516,   516,   518,
    3853,   519,   125,  3275,  2614,  2615,  2616,  2843,  5247,  2845,
     516,   223,   518,  2849,   313,   459,   517,  4335,  3809,   463,
     143,  2855,   516,   516,   147,   519,   519,  2863,   472,  3815,
    3507,  3508,   516,   168,  2870,   519,  3510,  2873,  5833,  3311,
     492,   516,   516,  2879,   519,   519,   169,   297,   297,   348,
     173,    10,   496,   352,    13,   300,   311,   356,    17,    18,
      19,   516,    48,  2899,   519,   188,   492,  5414,  6186,  2905,
     516,   515,   223,   519,   516,   173,  2912,   519,  5506,   516,
     508,   519,   519,  3355,  3660,  4150,    45,  4152,   387,  3665,
    2926,   516,   515,    52,   519,  3538,   516,   320,   515,   519,
     516,  3811,   516,   519,  2940,   519,   462,   326,   516,  2945,
    2908,   519,    37,   516,   516,  2951,   519,   519,   149,    78,
     515,   420,  4739,   422,  4741,   380,  6244,  3538,   516,   516,
    3739,   162,   519,  2969,  2970,  2971,  3745,   168,  4184,  2975,
    4186,   364,   515,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   516,   516,   516,   519,   519,   519,   516,  5748,
    5749,   519,   417,   516,   287,   516,  3002,  3003,   519,    59,
     174,   516,  5411,   472,   519,  3011,  1469,  3654,  1471,  2033,
    2034,  3199,   219,  3201,  3202,  4533,   217,   219,   515,  5984,
    5967,   414,   516,  2047,  2048,   519,   517,   516,   516,  3676,
     519,   519,   516,   515,   459,   519,  4223,   149,  3044,   516,
     516,   476,   519,   519,   245,   338,   516,   472,   515,   519,
     162,   444,   516,  2077,   516,   519,   168,   519,   516,   452,
     515,   519,   455,  3196,   193,  5474,  4528,   352,  3063,   198,
    3076,   496,   516,   516,  3080,   519,   519,   516,   516,  4549,
     519,   519,   516,   516,  3412,   519,   519,  3415,   207,   516,
     515,   198,   519,   294,  4251,  3841,  4253,   216,   516,  4256,
     516,   519,   303,   519,   516,   217,   516,   519,   154,   519,
    6075,   230,   515,   517,   516,   244,  6081,   519,   516,   154,
     516,   519,  5728,   519,   516,   297,   653,   519,   655,   516,
    4549,   658,   519,   245,  3462,   516,   516,   516,   519,   519,
     519,   198,  3470,   516,  4099,   672,   519,   516,   352,   297,
     519,   678,  3931,   154,  3933,   516,  3935,  5195,   519,  5197,
    3166,   516,  3168,   516,   519,   154,   519,   198,   154,   297,
     299,  3044,   168,   352,   154,   243,   121,  3183,   453,  3185,
     297,   515,   294,  3971,   168,  3832,  3192,  3834,   291,   516,
    3196,   303,  3198,  3199,  3330,  3201,  3202,  3203,    72,   282,
    4153,    38,   282,   476,  3817,  3211,  3819,   515,   297,   282,
    3216,   282,  4092,    48,  3263,  3859,    48,   439,   282,    90,
    6185,   313,   465,   465,     0,    87,   434,  3233,  5637,   168,
     154,   333,   154,   515,   154,   154,  3817,   476,  3819,  3992,
     154,  4196,   154,   519,   445,   154,    25,   154,   154,   154,
     154,   154,    31,   168,   154,  3261,  3262,  3263,   154,   154,
    3266,   154,  3311,   392,   154,   297,   417,    43,  3274,  3275,
    3276,  3277,    38,    38,   515,   243,  4868,  5151,  4233,  3285,
     168,   168,   297,    10,  3290,  3291,    13,  3293,  3901,  3295,
     515,     6,     6,   168,    60,   515,   515,    76,   515,   515,
    3436,  3307,  3308,   515,   515,  3311,   515,     6,     6,   515,
     515,     6,  3956,     6,   289,   515,   515,  5986,    45,   515,
    3901,   515,    98,  5732,   515,    52,  3332,   515,  3334,   515,
    3336,   515,   515,   445,   515,   515,   473,   515,   515,   515,
    3987,   163,   515,   309,  4300,   111,   515,  4845,   515,  3355,
     515,    78,   515,   132,   515,  3363,  3364,  3365,   515,   219,
     139,   515,   515,   142,   519,   494,  3415,   519,   515,   515,
    3376,    38,   102,   149,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    38,   243,   515,   162,    37,   427,   427,
     169,   513,   168,   513,   515,   429,   429,   174,   174,   429,
     429,   513,   294,   519,   180,   517,  3412,   183,   168,  3415,
     168,   187,   178,   292,   387,  4572,    68,  3466,   429,   429,
     147,   374,  3428,   429,  5833,   429,   205,  3433,   464,   517,
     374,  4269,   429,   374,   429,   201,   245,   429,   965,   966,
      79,   217,  3448,   219,   429,    91,   505,   429,  4328,   374,
    4330,   154,   297,   379,   240,   429,  3462,   429,   287,  4235,
     429,   127,   452,   420,  3470,   318,   193,   297,   369,   245,
     515,   198,   292,   429,  4354,    10,  3482,   429,    13,  3485,
     191,  3487,    17,    18,    19,    91,  3492,   515,   313,  4445,
     127,   198,  4423,   259,   519,   154,  5437,   263,   453,   278,
     429,  3507,  3508,   282,   453,   127,   429,  3513,   429,  1036,
     113,   429,   278,   292,  6183,   127,   429,   244,   294,   429,
      59,   297,   301,    59,  1051,   267,   301,   303,   318,  3535,
     429,   429,  3538,   337,   313,  3541,   337,  4433,     0,  3412,
     429,   337,  3415,  3549,   663,   429,   312,   429,   429,   429,
     669,   429,   429,   429,   420,  1082,  1083,   429,    47,    21,
     429,   318,   681,   221,   429,   429,   429,   221,  3574,   519,
     516,   297,   299,  5447,   221,  5984,   355,   356,   520,   221,
     221,  1108,   429,   221,   360,   221,   221,  2611,  2612,  3462,
     221,   357,   221,  2617,    56,   297,   439,  3470,   515,    38,
     154,   297,  4355,  5477,  3610,  3611,  3612,   154,   387,  4051,
     282,    10,   119,   453,    13,   381,   154,   154,   464,   297,
     154,  1148,  1149,   251,    38,  2649,  2650,   168,    38,  3635,
     515,   282,   515,   282,   282,   401,   235,   413,  3644,   376,
    3646,   154,   515,  4085,   154,   453,    45,   453,  3654,   154,
     154,   291,   286,    52,   174,    10,   429,   468,    13,   515,
     267,    13,   267,   308,  5083,   392,  6075,   519,   429,   445,
    3676,   515,  6081,   515,   183,   431,  3812,   456,   519,    78,
     516,   515,   513,   191,  1459,   191,   221,  2711,   516,   492,
      45,   378,   492,   469,  4136,   471,   472,    52,   516,   516,
     516,   265,   516,   217,   519,   469,   390,   232,   298,   519,
     453,    38,   453,   306,    59,   464,   515,   493,   516,   453,
     232,   374,   287,    78,   287,  4605,   287,   515,   429,   191,
     232,   168,   429,    48,  3740,   429,   287,   297,   297,   396,
     516,   297,   518,   519,   243,   243,   243,   429,   147,   282,
     369,   420,   127,   297,   297,   198,   519,   519,  3764,   472,
     261,   352,   387,  3769,   299,   297,   192,   494,   384,  3775,
     340,   516,  2796,   429,   303,    38,  6185,   221,  3784,   506,
     507,   508,   509,   510,   511,   429,   235,   336,   453,   453,
     154,   168,   147,   505,   193,   465,   292,    38,   418,   198,
     170,   384,   292,   154,   154,  3811,  3812,  4586,   154,   337,
    4589,  3817,   472,  3819,   282,   515,    38,   282,   297,    27,
     453,   297,   235,   515,   189,   292,  3832,   189,  3834,   168,
     235,    38,  4787,   169,   384,   168,   297,   282,   193,  4618,
     198,   198,   198,   198,  4597,   244,  4493,  4494,  3854,   198,
     198,  4179,   476,    59,   429,  4183,   519,   519,   519,   472,
     174,  2885,   264,   297,   291,  5022,   174,   493,   303,  2893,
     458,   309,  2896,   360,  3880,   134,   519,   319,   492,  4704,
     174,   281,   258,   429,  2908,   517,  3890,   174,   515,   244,
      10,  3886,   515,    13,   183,  3901,  3902,   515,   519,   516,
     299,   516,  4770,   469,   459,   516,   516,   516,   516,   451,
     253,   495,   516,   297,   516,   516,    59,   515,  3924,   519,
     516,   516,  4250,   297,   516,    45,   297,  3922,   514,   516,
     519,   516,    52,  5395,   516,   515,   515,  3943,   514,   516,
     300,   515,   515,   496,   299,   469,   515,  4591,  4592,  4593,
    4594,  4595,   519,   505,   203,   154,  3962,   515,    78,   429,
    3966,   211,   287,   429,   157,   429,   429,  3971,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   282,   154,   387,
     154,  3987,   406,   379,   515,   154,   379,   379,   243,  4134,
     203,   157,   157,   392,   297,   453,   429,  4003,   469,   245,
    4006,   374,  4782,   320,   320,   505,  4012,   157,   429,   450,
     429,  5529,   403,  1540,   429,   255,   255,   429,   255,   127,
    4026,   374,   429,   429,  4030,  4031,    10,  4983,   429,    13,
    4036,   429,   374,    17,    18,    19,   374,   392,  1565,   429,
    4046,   429,  4048,   374,   429,  4051,   282,   387,  4827,  4055,
    4056,  4057,  4058,  4059,   154,    47,  4062,  4063,  4064,  4065,
    4066,  4067,  4068,  4069,  4070,  4071,   429,    47,   429,  4075,
    4076,  4077,   221,   193,  4080,   429,   516,   221,   198,  4085,
     516,   186,   514,  4132,  4090,   516,  4092,   516,  4094,   301,
       3,   516,  4871,  4872,   168,   494,  4102,   519,   439,  4105,
      48,  4107,   112,   519,   168,  4858,   515,   506,   507,   508,
     509,   510,   511,   516,    38,  1642,   154,  4123,   429,  4773,
    4126,  4127,   516,   154,   244,  4131,  4132,   505,   168,   292,
    4136,  3155,  4138,   186,  4142,  4143,  4144,  4145,   154,   494,
     453,   453,   374,  6017,  6018,  1672,  1673,  1674,  1675,   515,
     374,   506,   507,   508,   509,   510,   511,   374,   374,   374,
     519,  4159,  4159,  4159,  4159,  4171,   384,  4159,    10,  4159,
     152,    13,   221,  4179,   152,   221,   221,  4183,   221,   299,
     221,   513,   221,  4511,  4512,   221,  4965,  4966,   650,   221,
     145,   221,   225,  4329,   446,  4842,    72,   516,   446,   297,
     297,    59,    78,    45,   297,   297,   516,    13,   309,  4215,
      52,   464,   519,   174,   516,    91,   516,   516,   516,  4355,
     281,   516,   519,   516,   516,   515,  4232,   515,   514,   224,
     307,   516,  4238,   224,   419,   515,    78,   221,   304,    59,
     187,   515,   426,   119,  4250,   121,   360,  5666,  4690,   458,
      89,   439,   168,    38,   235,    38,  5002,   453,   453,   429,
     211,    59,   420,   154,    86,   403,  4272,  2042,  2043,   178,
     379,   439,   392,   429,   157,   429,   429,    60,   374,  2054,
     374,   743,   744,   429,   429,   516,  4933,   516,  2063,   516,
     352,   472,  1819,  1820,  5190,   515,   515,    59,  4942,  4943,
     459,  4945,   178,    86,   420,   147,  4179,   168,  1835,   297,
    4183,    78,   112,   154,   439,   299,  5095,  4323,   516,  5098,
    5099,   221,  4328,  4329,  4330,   221,   221,  5223,   111,   112,
     232,   207,   221,   515,   206,   515,   119,   515,   429,  5118,
     476,   297,  1869,  1870,  1871,  1872,   519,    38,  4354,  4355,
    3374,   193,  3376,   318,   516,   295,   198,  5949,   297,     3,
     515,   439,   519,    44,   429,   516,   384,   519,  3392,   180,
     112,   181,   174,   156,   494,   515,   221,  4250,   143,   516,
     233,   233,   516,  5030,   287,   516,   506,   507,   508,   509,
     510,   511,   516,   287,  4400,   178,   174,  4403,   516,   287,
     287,  4369,   244,    59,   516,   309,   282,   470,  4544,   519,
     470,   287,  4380,   516,   516,   224,  3440,  3441,   201,   318,
    4748,   471,   426,  1950,   292,   515,   515,  4755,   515,  1956,
     505,   439,  4760,   429,   174,  4763,    78,   472,   192,    10,
     192,   205,    13,   287,    38,    59,   505,   909,   420,   911,
     287,   519,   519,   429,   330,    72,   429,   299,   429,   154,
     157,  4467,   429,  5343,   516,  5569,    10,  5571,   221,    13,
     346,   515,   126,   176,    45,    38,   259,   278,   119,   198,
     263,    52,    38,   384,   292,   453,   515,  4493,  4494,   282,
     170,  4497,   384,   292,    59,   278,    84,   472,  4504,   282,
     420,    45,   472,    38,   174,  4511,  4512,    78,    52,   297,
     515,   168,   519,   347,   208,  4521,   300,   219,   516,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   174,   312,
     516,   516,   515,   458,    78,   400,    59,   516,  4544,   377,
      38,    81,  4537,  4549,  4550,  4551,   515,   297,  5705,   515,
     392,   135,   516,    91,   199,  4561,   346,   516,   309,   516,
     429,    38,  5206,  5580,   516,   154,   515,  1686,   154,   429,
     446,   515,   515,  5217,   357,   168,   147,   515,   515,   515,
     515,    38,   287,   205,   256,  5742,  5372,   453,   515,   515,
     384,   112,   154,   516,  5248,    38,  4602,   516,   381,  4605,
     301,   174,   398,   147,   439,   516,   398,   168,   516,   111,
     202,    38,   519,  2140,   519,   458,   420,   515,   401,   134,
     403,   136,   193,   406,   191,  4631,   453,   198,   468,   515,
     515,   515,  5789,  5790,   515,   168,   515,  4773,  4511,  4512,
     420,  4647,   297,   203,     6,   160,  5293,   161,   476,   193,
    5304,   515,   494,   516,   198,   370,  4662,   370,    72,    72,
     300,   518,   135,   468,   506,   507,   508,   509,   510,   511,
     140,   457,   165,   244,   165,   472,   458,   472,   387,    35,
     516,   257,   174,   515,  4690,   515,   519,  4693,   420,   287,
     343,   420,   297,   297,   515,  4701,  4702,   384,  4704,    38,
     244,    38,  4708,  4709,   300,   300,   153,  4713,   515,  5037,
     225,   199,  4718,   176,   176,  4721,  4722,   369,   150,    59,
      38,    59,  4728,   304,   515,  1187,   353,   425,   299,   516,
      59,   407,   515,   429,   124,   451,     6,   516,   515,   140,
    1859,  5520,  4748,    35,   287,   384,   515,   425,  1867,  4755,
      24,   369,   515,   519,  4760,   299,  1875,  4763,  4764,   274,
     275,   276,   277,   519,  5781,  4771,   281,   282,   369,   305,
      81,   283,   287,   283,   387,   174,  4782,   515,   429,   153,
       6,   515,   398,   398,  4790,  5942,   119,   472,  3812,  4784,
    4785,   519,   459,  1255,   458,  4807,  5575,   472,   176,   176,
     459,  1920,   516,   453,  4810,   515,  5421,   911,    25,   458,
     951,  3835,   998,  1275,    31,  3376,  2919,  1385,  1688,  2828,
     997,   392,  3586,  4829,  4328,  4303,  5798,  5580,  1947,    46,
    4863,  5933,  3000,  5713,  2946,  3803,  4842,  5346,  5779,  6051,
    5395,  5485,  4301,  4301,  4491,  4992,  5371,  3514,   392,  3142,
    5598,  5912,  5247,  6010,  6011,  6039,  4821,  5808,  5807,    76,
    5953,  6075,  3519,  5037,  4870,  2640,  4538,  4512,  1330,  5752,
    4523,  4481,  3014,    62,  4323,  4748,  3014,  3611,  3851,  5031,
     993,  4887,  4755,  4507,  4852,  5213,  4892,  4760,  5378,  3895,
    4763,  5678,  6150,  4899,  4574,  4863,  6256,  6238,  5362,  5779,
    3811,  5965,  4546,  5306,  5762,  5233,  5551,  5309,    97,  4915,
    5689,  1848,    18,   130,    28,   132,  4922,  3960,  4602,  5247,
     646,   436,   139,   494,  1215,   142,  5518,  4933,  6146,  5573,
    4605,  3030,   447,  1892,  4549,   506,   507,   508,   509,   510,
     511,  2688,  1889,  1903,  3906,  3492,     0,  5421,  5666,  1927,
     494,   698,   169,  2945,  3743,   731,  4354,  3662,  4964,  5991,
    6189,  4578,   506,   507,   508,   509,   510,   511,  3992,   158,
     840,  4580,  2976,  2630,  1504,  1801,  6206,  4230,  5515,  4786,
    5905,  1401,  1362,    40,  4990,  5566,  3433,    40,   205,  4647,
    1452,  1453,  1461,  1455,  3448,  5893,  5725,  2640,  3415,  5580,
    5006,  5747,  1462,  4168,  4185,  5011,   195,  1464,  5214,  3412,
    5473,  5453,  5474,  4231,  3412,  6167,  5887,  6021,  5712,  5451,
    2538,  1418,  4094,  5726,  5030,  5467,  3353,  5727,  2539,  2056,
    3335,  5037,  3212,  2975,  6051,  3333,  3323,  3247,  4029,  2544,
     899,    -1,    -1,  2628,    98,    -1,  5488,    -1,    -1,    -1,
      -1,   240,    -1,  5495,  5049,    -1,    -1,    -1,    -1,    -1,
    2587,   278,    -1,    -1,    -1,   282,    -1,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,   292,    -1,  5083,    -1,  5085,
      -1,    -1,    -1,  5411,   301,    -1,    23,    -1,    25,    -1,
    5744,    -1,    29,   282,    -1,   149,   313,    34,    35,    36,
      -1,    38,    -1,    -1,    41,    42,    -1,    44,   162,    46,
    5116,    -1,  5248,    -1,   168,  5303,    53,    54,    55,    -1,
     174,    -1,  5564,  5565,    -1,   314,   180,    -1,  5304,   183,
      -1,    -1,    -1,   187,    -1,   352,    -1,    -1,   355,   356,
      -1,    -1,  5148,    -1,    -1,  5151,  5474,    -1,  5154,  5155,
    5156,    -1,    -1,    -1,    -1,    -1,  5292,    -1,    -1,    -1,
    5348,    -1,    -1,   217,  5037,    -1,    -1,   356,  5304,   358,
     387,    -1,   361,  5179,  5180,    -1,    -1,  5183,    -1,    -1,
      -1,   370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     379,   245,    -1,    -1,    -1,    -1,    -1,  5203,   387,    -1,
    5781,    -1,    -1,  5209,    -1,    -1,    -1,  5213,    -1,    -1,
     399,    -1,    -1,  5219,  5220,    -1,    -1,    -1,    -1,   408,
      -1,    -1,  6225,   412,    -1,    -1,  2753,  5233,    -1,    -1,
    5236,    -1,    -1,    -1,    -1,  5241,    -1,  5243,    -1,   456,
     294,  5247,    -1,   297,    -1,    -1,    -1,    -1,    -1,   303,
      -1,    -1,    -1,    -1,    -1,  6034,    -1,    -1,    -1,  5226,
     197,   198,   199,    -1,    -1,   202,    -1,    -1,    -1,   206,
      -1,   208,    -1,    -1,   211,    -1,    -1,   214,   467,  5721,
     217,  5723,    -1,   220,    -1,   222,  5292,  5293,   225,    -1,
      -1,    -1,   229,    -1,   231,    -1,    -1,  5303,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4329,   360,    -1,    -1,  5637,
      -1,    -1,  6192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4355,    -1,    -1,    -1,    -1,    -1,  5343,    -1,    -1,
    5213,    -1,  5348,  6239,    -1,  4369,    -1,    -1,    -1,    -1,
      -1,    -1,  5933,    -1,    -1,    -1,  4380,    -1,  6238,    -1,
    5233,    -1,    -1,   417,  2891,    -1,    -1,  2894,    -1,    -1,
      -1,    -1,    -1,    -1,  5247,    -1,  6256,    -1,    -1,    -1,
      -1,  5376,    -1,    -1,    -1,    -1,    -1,  6133,  6134,    -1,
      -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5732,  5411,  5410,    -1,  5414,    -1,
      -1,    -1,  5407,    -1,    -1,   469,    -1,   471,   472,    -1,
      -1,    -1,  5421,  5421,  5421,  5421,  5421,  5421,    -1,  5421,
    5421,  5421,  4456,  4457,  5421,  5421,  5421,  5421,     6,   493,
    5421,  5447,  5421,  5421,    -1,  5451,  5495,  5453,    -1,  5421,
      -1,  5421,  5421,    -1,    -1,    -1,  2983,    -1,    -1,   513,
      -1,  5467,   516,   517,   518,    -1,    -1,    -1,  5474,  2996,
    6051,  5477,    -1,    -1,    -1,    -1,    -1,  3004,    -1,    -1,
      -1,    -1,  5488,    -1,    -1,    -1,  3261,  3262,    -1,  5495,
      -1,  3266,    -1,    -1,    -1,    -1,    -1,  1959,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3043,    -1,    -1,    -1,
    4544,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3307,  3308,    -1,    -1,  5542,  3064,  5411,    -1,
      -1,    -1,  5548,    -1,  2006,    -1,    -1,  5553,  5554,    -1,
      -1,    -1,  5558,    -1,    -1,    -1,    -1,  2676,  5564,  5565,
    5566,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4597,  5580,  2694,    -1,    -1,  2040,  2698,
    3107,    -1,  3109,  2702,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5600,    -1,    -1,    -1,  2060,    -1,
      -1,  5474,    -1,  5609,    -1,    -1,  5612,    -1,  5744,    -1,
      -1,  2730,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    31,   197,
      -1,  5637,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,
      -1,    -1,    -1,    46,  5639,  2764,   214,    -1,    -1,   217,
      -1,    -1,    97,    -1,    -1,    -1,  5984,    -1,    -1,    -1,
    5666,  5667,    -1,    -1,    -1,  2784,    -1,    -1,    -1,    -1,
    3197,    -1,    -1,    76,    -1,    -1,    -1,  3204,    -1,    -1,
      -1,    -1,    -1,    -1,  5690,    -1,    -1,    -1,  6130,    -1,
      -1,    -1,    -1,  5699,  5700,  5701,    -1,  2816,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5712,  5713,   645,    -1,
    5716,    -1,    -1,   158,   651,  5721,   653,  5723,   655,  5725,
      -1,   658,    -1,    -1,  2843,    -1,  5732,   130,   665,   132,
    2849,    -1,  5920,   670,  5729,   672,   139,    -1,    -1,   142,
      -1,   678,    -1,    -1,  2863,    -1,    -1,  6075,  5754,    -1,
     195,  2870,    -1,  6081,  2873,    -1,    -1,    -1,    -1,    -1,
    2879,    -1,    -1,    -1,  5637,   702,   169,    -1,    -1,    -1,
      -1,    -1,    -1,  5779,   711,  5781,    -1,    -1,   715,    -1,
    2899,   718,    -1,    -1,   721,    -1,  2905,  2249,  6230,    -1,
      -1,    -1,    -1,  2912,    -1,   240,    -1,    -1,    -1,    -1,
     737,    -1,   205,    -1,  5992,  5993,    -1,  2926,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2940,    -1,    -1,    -1,    -1,    -1,  5833,  4852,    -1,
      -1,    -1,  2951,   278,  4858,    -1,    -1,   282,    -1,  4863,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   790,    -1,    -1,    -1,  6185,    -1,  5732,
      -1,    -1,   799,    -1,  5870,    -1,  4890,  4891,   313,   314,
      -1,  4895,  4896,    -1,    -1,   278,    -1,  5883,    -1,   282,
      -1,    -1,   819,   820,    -1,   822,   823,  5893,    -1,   292,
     827,    -1,    -1,    -1,    -1,    -1,    -1,  5903,   301,    -1,
    5906,    -1,    -1,    -1,   841,    -1,    -1,   352,    -1,   846,
     313,   356,    -1,    -1,  5920,   852,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   370,    -1,  5933,    -1,    -1,
      -1,    -1,    -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   387,    -1,    -1,    -1,    -1,    -1,    -1,   352,
      -1,    -1,   355,   356,   399,    -1,    -1,    -1,    -1,    -1,
    5833,    -1,   899,   408,    -1,    -1,    -1,   412,  5974,    -1,
      -1,  5966,    -1,    -1,    -1,    -1,   913,    -1,  5984,    -1,
      -1,    -1,    -1,    -1,   387,    -1,  5992,  5993,    -1,   926,
      -1,    -1,  5998,  5991,  5991,  5991,  5991,    -1,    -1,    -1,
      -1,  5991,    -1,    -1,   941,    -1,    -1,    -1,    -1,    -1,
      -1,  6017,  6018,    -1,    -1,    -1,    -1,  3544,  3545,    -1,
      -1,    -1,   467,   960,    -1,    -1,    -1,    -1,   965,   966,
      -1,    -1,    -1,    -1,    -1,    -1,  6085,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6051,    -1,  3166,    -1,    -1,
      -1,    -1,    -1,   456,    -1,    -1,    -1,    -1,  6246,  6247,
     997,   998,    -1,    -1,    -1,    -1,  3185,    -1,    -1,  6075,
      -1,    -1,    -1,  3192,    -1,  6081,    -1,    -1,    -1,    -1,
       0,    -1,    -1,  1020,  1021,    -1,    -1,  6085,  6085,  6085,
    6085,    -1,    -1,  6099,  6100,  6085,    -1,  1034,    -1,  1036,
      -1,    -1,    -1,  1040,    -1,    -1,  1043,  1044,  6114,  1046,
      -1,  5984,    -1,    -1,  1051,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6130,    -1,    -1,  2589,    -1,    -1,
      -1,    -1,    -1,    -1,   702,    -1,    -1,    -1,  1075,    -1,
      -1,    -1,    -1,   711,    -1,  1082,  1083,    -1,    -1,    -1,
     718,    -1,    -1,   721,    -1,    -1,    -1,    -1,    -1,  6165,
      -1,  2623,    -1,    -1,    -1,    -1,    -1,  1104,  1105,  1106,
      -1,  1108,    -1,  1110,    -1,  1112,  1113,    -1,    98,  6185,
      -1,    -1,    -1,    -1,    -1,    -1,  6192,    -1,    -1,    -1,
      -1,  6189,  6189,  6189,  6189,    -1,    -1,    38,    -1,  6189,
      -1,    -1,  6075,    -1,    -1,    -1,  2668,    -1,  6081,  1146,
      -1,  1148,  1149,    -1,    -1,    -1,    -1,    -1,    -1,  6225,
    6226,    62,    -1,    -1,  6230,    -1,    -1,    -1,  6234,   149,
      -1,    -1,  6238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6246,  6247,   162,    -1,  1181,    -1,    -1,    -1,   168,    -1,
    6256,    -1,    -1,    -1,   174,    -1,    97,    -1,    -1,  3786,
     180,  4036,    -1,   183,    -1,    -1,    -1,   187,  5292,    -1,
    1207,    -1,  1209,    -1,    -1,    -1,  1213,    -1,  1215,    -1,
      -1,  4056,  4057,  4058,  4059,    -1,    -1,  4062,  4063,  4064,
    4065,  4066,  4067,  4068,  4069,  4070,  4071,   217,    -1,    -1,
      -1,    -1,  1239,    -1,  1241,    -1,    -1,    -1,  1245,    -1,
      -1,    -1,  6185,    -1,    -1,  4090,    -1,   158,    -1,    -1,
      -1,    -1,  1259,    -1,    -1,   245,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4126,  4127,    -1,   195,    -1,    -1,    -1,    -1,    -1,
    1297,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   294,    -1,    -1,   297,    -1,    -1,
      -1,    -1,    -1,   303,    -1,    -1,    79,    80,    -1,  1326,
    1327,  1328,    -1,  1330,   235,    -1,  4171,    97,    -1,   240,
      -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1351,    -1,  3535,    -1,    -1,  3946,
     113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     360,   282,    -1,    -1,   137,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1390,    -1,   148,    -1,    -1,   158,    -1,
      -1,    -1,    -1,    -1,   157,    -1,  1034,    -1,    -1,    -1,
      -1,  1408,  1040,   314,    -1,    -1,  1044,   170,  1046,    -1,
      -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   195,    -1,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     203,    -1,    -1,    -1,    -1,   356,  3635,  1454,    -1,    -1,
     361,  1458,  1459,    -1,    -1,   445,    -1,    -1,    -1,   370,
      -1,    -1,  1469,  1470,  1471,  1472,    -1,  1474,   379,    -1,
     240,    -1,  1110,   236,  1112,  1113,   387,    -1,    -1,   469,
      -1,   471,   472,    -1,    -1,    -1,  5580,    -1,   399,    -1,
    1497,    -1,    -1,    -1,    -1,   258,    -1,   408,    -1,    -1,
      -1,   412,    -1,   493,    -1,    -1,    -1,    -1,   278,    -1,
      -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   432,    -1,   513,    -1,  1532,   516,   517,   518,    25,
    1537,  3063,    -1,  1540,    -1,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    38,   313,   314,    -1,  1553,  1554,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1562,   467,    25,  1565,    -1,
     471,    -1,    -1,    31,    60,    -1,    -1,    -1,    -1,    -1,
     333,   334,    -1,    -1,   337,  3764,    -1,    -1,    46,    -1,
      76,    -1,   352,    -1,    -1,  1592,   356,  1594,    -1,    -1,
    1597,   361,    -1,  1600,  1601,    -1,    -1,  1604,    -1,    -1,
     370,   364,    -1,    -1,   367,    -1,    -1,  1614,    76,   379,
    1617,   374,    -1,  1620,    -1,   111,    -1,   387,   381,    -1,
      -1,   384,  4467,    -1,    -1,    -1,    -1,    -1,    -1,   399,
      -1,    -1,    -1,    -1,    -1,  1642,   132,    -1,   408,    -1,
     403,    -1,   412,   139,    -1,    -1,   142,   410,    -1,    -1,
      -1,    -1,    -1,  1660,   417,    -1,    -1,   420,    -1,    -1,
      -1,   424,    -1,    -1,   132,  1672,  1673,  1674,  1675,  1676,
      -1,   139,    -1,   169,   142,    -1,   439,  5771,    -1,    -1,
      -1,    -1,    -1,  1690,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1701,  1702,  1703,   467,    -1,    -1,
      -1,   169,   465,    -1,    -1,   201,    -1,    -1,    -1,   205,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3263,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3943,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   259,    -1,    -1,    -1,   263,    -1,    -1,
      -1,    -1,    -1,  3962,    -1,    -1,    -1,  3966,    -1,  3311,
      -1,    -1,   278,    -1,    -1,    -1,   282,    -1,    -1,    -1,
      -1,    -1,    -1,  1800,    -1,    -1,   292,    -1,    -1,    -1,
      -1,    -1,    -1,  3335,  1811,   301,    -1,    -1,    -1,    -1,
     278,    -1,  1819,  1820,   282,    25,   312,   313,    -1,  3351,
      -1,    31,    -1,    -1,   292,    -1,    -1,    -1,  1835,    -1,
      -1,    -1,    -1,   301,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   313,  1853,  1854,  4693,    -1,
      -1,    -1,    -1,    -1,  4451,    -1,   352,    -1,    -1,   355,
     356,   357,  1869,  1870,  1871,  1872,    76,    -1,  4465,    -1,
      -1,  1878,    -1,    -1,    -1,    -1,    -1,    -1,  1885,    -1,
    3412,  1888,    -1,  3415,   352,   381,    -1,   355,   356,    -1,
      -1,   387,    -1,    -1,    -1,    -1,  1903,    -1,    -1,  1906,
      -1,    -1,    -1,    -1,    -1,   401,    -1,    -1,    -1,  1916,
    1917,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   387,
    1927,  1928,   132,    -1,  1931,    -1,    -1,  1934,    -1,   139,
    3462,    -1,   142,    -1,  3466,    -1,    -1,    -1,  3470,    -1,
      -1,    -1,  1949,  1950,    -1,    -1,    -1,    -1,    -1,  1956,
      -1,  1958,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
     456,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1975,    -1,
      -1,    -1,    -1,    -1,    -1,  1982,    -1,  1984,    -1,    -1,
    1987,  1988,  1989,    -1,  1991,  1992,    -1,  1994,   456,    -1,
      -1,    -1,    -1,    -1,  2001,   205,    -1,    -1,    -1,    -1,
      -1,  2008,    -1,    -1,  2011,  2012,    -1,    -1,  2015,    -1,
      -1,  2018,  2019,    -1,    -1,    -1,  2023,    -1,  2025,    -1,
      -1,    -1,    -1,  2030,  2031,    -1,    -1,    -1,    -1,    -1,
    2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,
      -1,    -1,  2049,    -1,  2051,  2052,  2053,  2054,  2055,  2056,
    2057,  2058,    -1,     0,  2061,    -1,  2063,  2064,    -1,    -1,
    2067,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   278,    -1,
      -1,    -1,   282,    20,    -1,  2082,  2083,  2084,    -1,    -1,
      -1,    -1,   292,  4272,    31,    -1,    33,    34,    -1,    -1,
      -1,   301,    -1,  2100,    -1,    -1,    25,    -1,  6192,    -1,
      -1,    -1,    31,   313,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    76,
      17,    -1,    -1,  2140,    38,    82,    -1,    84,    -1,    26,
      -1,    -1,   352,    -1,  6238,   355,   356,    76,    -1,    96,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,
      -1,    -1,  6256,    -1,    -1,    -1,    -1,    -1,   115,    -1,
      -1,   118,    -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   133,    10,   135,    -1,
      13,    -1,   139,    97,    17,    18,    19,    -1,   145,    -1,
      -1,    -1,    -1,   132,    -1,    -1,   153,    -1,   155,    -1,
     139,  4400,    35,   142,  4403,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,   180,    -1,    -1,    -1,  2244,    -1,    -1,
     169,    -1,    -1,    -1,    -1,    -1,   456,    -1,    -1,    -1,
     197,    -1,    -1,    -1,   158,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1903,    -1,    -1,  1906,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,  1916,  1917,
      -1,    -1,    -1,    -1,    -1,    -1,  2293,    -1,    -1,    62,
      -1,   195,    -1,  1931,    -1,    -1,  1934,    -1,    -1,   246,
     247,    -1,    -1,    -1,    -1,   252,  5151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4504,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,    -1,
      -1,   235,  4521,    -1,    -1,    -1,   240,   284,    -1,  2346,
      -1,    -1,    -1,    -1,    -1,    -1,  1984,  4944,    -1,   278,
    1988,  1989,    -1,   282,  3886,    -1,    -1,    -1,  5203,    -1,
      -1,    -1,  4959,   292,    -1,    -1,    -1,    -1,    -1,    -1,
     193,    -1,   301,    -1,    -1,   198,    -1,    -1,   282,    -1,
      -1,   328,    -1,    -1,   313,   158,    -1,    -1,    -1,    -1,
    3922,    -1,    -1,    -1,    -1,   342,    -1,    -1,   221,   222,
      -1,   348,   349,    -1,   351,    -1,    -1,    -1,    -1,   356,
     314,    -1,    -1,  4602,    -1,   362,    -1,    -1,   365,    -1,
      -1,   244,   195,   352,    -1,   372,   355,   356,    -1,    -1,
      -1,    -1,   379,   380,    -1,    -1,    -1,    -1,    -1,    -1,
     387,    -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   356,  5050,   401,    -1,    -1,   361,   387,    -1,
      -1,    -1,   285,    -1,    -1,    -1,   370,   240,    -1,    -1,
     417,    -1,    -1,    -1,    -1,   379,   299,    -1,    -1,   302,
      -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,    -1,    -1,
     437,    -1,    -1,    -1,    -1,   399,    -1,    -1,    -1,    -1,
      -1,   448,    -1,    -1,   408,   278,    -1,   454,   412,   282,
      -1,    -1,   459,    -1,    -1,    -1,  2523,  2524,  2525,  2526,
    2527,  2528,  2529,  2530,  2531,   472,  2533,   456,   432,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2543,  2544,    -1,  2546,
     313,   314,    -1,    -1,    -1,    -1,  2553,    -1,    -1,   496,
      -1,   498,   499,   500,   501,   502,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   467,    -1,    -1,    -1,   471,   515,   392,
      -1,   518,    -1,    -1,    -1,  2582,    -1,  2584,    -1,   352,
    2587,  2588,    -1,   356,  2591,    -1,  2593,    -1,   361,  2596,
      -1,    -1,    -1,  2600,    -1,    -1,    -1,   370,    -1,    -1,
    4132,    -1,  5447,    -1,    -1,    -1,   379,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   387,    -1,  2623,    -1,    -1,    -1,
      -1,    -1,  2629,  2630,    -1,    -1,   399,  4159,    -1,    -1,
      -1,    -1,  5477,  2640,    -1,   408,    -1,    -1,    -1,   412,
      -1,    -1,  2649,  2650,    -1,    -1,    -1,  4179,    -1,    -1,
      -1,  4183,  5249,    -1,  5251,    -1,  2663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2671,    -1,  2673,    10,    -1,    -1,
      13,   494,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
      -1,    -1,    35,    -1,   467,    -1,    -1,   520,  4887,    -1,
      -1,    -1,    45,    -1,    -1,    -1,  2713,    -1,  2715,    52,
    4899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2733,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,  2744,    -1,    -1,
    2747,  2748,  2749,  2750,    -1,    -1,  2753,    -1,    -1,  2756,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     647,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2777,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      31,  2788,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2796,
    2797,    -1,    -1,    -1,    -1,    -1,  2803,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2812,    -1,    -1,    -1,    -1,
     697,   698,  5409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    76,    -1,  2834,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,  2855,    -1,
     193,    -1,    -1,    -1,    -1,   198,    45,    -1,    -1,    -1,
      -1,  2868,    -1,    52,    -1,    -1,    -1,  5712,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
      -1,   132,    -1,    -1,  2891,    -1,    -1,  2894,   139,    78,
      -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   244,    -1,    -1,    -1,    -1,   793,    -1,    -1,    -1,
      -1,    -1,    -1,  2920,  2921,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   813,  5116,  2935,    -1,
    2937,  2938,    -1,    -1,   821,    -1,    -1,   824,   825,   826,
      -1,    -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,   205,    31,   299,    -1,    -1,   302,
      -1,    -1,  2969,  2970,  2971,    -1,    -1,    -1,  2975,    -1,
      -1,    -1,    -1,  5570,    -1,  5572,  2983,    -1,    -1,  4511,
      -1,    -1,    -1,    -1,    -1,  2623,    -1,    -1,    -1,  2996,
      -1,    -1,    -1,    -1,    -1,  3002,    -1,  3004,    -1,    -1,
      76,    -1,    -1,    -1,   193,  4537,    -1,    -1,    -1,   198,
    3017,    -1,    -1,    -1,    -1,  3022,    -1,    -1,    -1,    -1,
      -1,  3028,    -1,    -1,  3031,    -1,    -1,   278,    -1,    -1,
      -1,   282,   221,   222,    -1,    -1,  3043,  3044,  5883,    -1,
      -1,   292,    -1,    -1,    -1,    -1,    -1,  3054,    -1,   392,
     301,    -1,  5241,    -1,  5243,   244,   132,  3064,    -1,  3066,
      -1,    -1,   313,   139,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,   169,    -1,    -1,   285,    -1,  3105,    -1,
    3107,   352,  3109,    35,   355,   356,  2744,    -1,    -1,  2747,
     299,  2749,  2750,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,
      -1,    -1,    -1,    -1,    -1,  3142,   387,    -1,    -1,    -1,
      -1,    -1,  1029,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
      -1,    -1,  6017,  6018,    -1,    -1,   519,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3196,
    3197,    -1,  3199,    -1,  3201,  3202,    -1,  3204,    -1,    -1,
      -1,    -1,   278,   392,  3211,   456,   282,    -1,    -1,  3216,
      -1,    -1,    -1,    -1,    -1,    -1,   292,    -1,    -1,    -1,
      -1,    -1,  5819,  4755,    -1,   301,    -1,    -1,  4760,    -1,
      -1,  4763,    -1,    -1,    -1,    -1,    -1,   313,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,  4784,  4785,  3261,  3262,  3263,    -1,    -1,  3266,
      -1,   193,    -1,    -1,    35,    -1,   198,  3274,  3275,  3276,
    3277,    -1,    -1,    -1,    45,    -1,   352,    -1,    -1,   355,
     356,    52,    -1,  3290,    -1,    -1,  3293,    -1,  3295,   221,
     222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3307,  3308,    -1,    -1,  3311,   494,    -1,    78,    -1,    -1,
      -1,   387,   244,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,  3330,    -1,  3332,    -1,  3334,    -1,  3336,
      -1,    -1,    -1,  1220,    -1,    -1,    -1,    -1,  5935,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3355,    -1,
      -1,  3358,    -1,   285,    -1,  3362,    -1,    -1,    -1,    -1,
    1247,    -1,    -1,    -1,    -1,    -1,    -1,   299,    -1,    -1,
     302,    -1,    -1,    -1,    -1,    -1,  3383,    -1,    -1,    -1,
     456,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3412,  3044,    -1,  3415,  3416,
      -1,    -1,    -1,  3420,  3421,  3422,    -1,    -1,    -1,    -1,
      -1,  3428,   193,    -1,    -1,    -1,  3433,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3448,    -1,    -1,    -1,  1332,    -1,    -1,  6045,    -1,
     221,   222,    -1,    -1,  1341,  3462,    -1,    -1,    -1,  3466,
     392,    -1,  3469,  3470,    -1,  3472,    -1,    -1,    -1,    -1,
    1357,    -1,    -1,   244,    -1,    -1,    -1,    -1,    -1,  6076,
    6077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1376,
      -1,    -1,  1379,  1380,    -1,    -1,    -1,  1384,  1385,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3513,    -1,    -1,    -1,
      -1,  3518,    -1,    -1,   285,    10,    -1,  5049,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,   299,    -1,
      -1,   302,    -1,    -1,    -1,    -1,    -1,  3544,  3545,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,  3196,    -1,
      -1,  3199,   494,  3201,  3202,    -1,    -1,    -1,    -1,    -1,
      -1,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    78,   516,  6182,    -1,   519,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3652,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3662,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,
      -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5906,    -1,    -1,
      -1,    -1,    -1,   494,    -1,    -1,   221,   222,    -1,    -1,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   519,   244,
      -1,    -1,  1639,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1647,    -1,  3769,    -1,    -1,    -1,    -1,    -1,  3775,    -1,
      -1,    -1,    -1,    -1,  3412,    -1,    -1,  3415,    -1,  3786,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   299,    -1,    -1,   302,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,  3823,  3824,  3825,    -1,
      -1,    -1,    -1,    -1,  3462,    -1,    -1,    -1,    -1,    -1,
      41,    -1,  3470,  3840,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5376,    -1,    -1,  3854,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3872,  3873,  3874,    79,    -1,
      -1,  3878,    -1,    -1,    -1,  5407,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3890,    95,    -1,    -1,    -1,    -1,  5421,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    10,   137,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,   148,    -1,  3946,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,
      35,    -1,    -1,  3960,  3961,    -1,    -1,    -1,    -1,   170,
      45,    -1,    -1,  5495,  3971,    -1,    -1,    52,   179,    -1,
      -1,    -1,   183,    -1,    -1,  1862,    -1,  3984,    -1,  1866,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   203,    78,    -1,    -1,  4003,    -1,    -1,   494,
      -1,    -1,    -1,    -1,    -1,  4012,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,  4026,
      -1,   516,    -1,  4030,  4031,    -1,    -1,    -1,    -1,  4036,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,  4046,
      -1,  4048,    -1,    -1,  4051,    -1,   707,   258,    -1,  4056,
    4057,  4058,  4059,    -1,    -1,  4062,  4063,  4064,  4065,  4066,
    4067,  4068,  4069,  4070,  4071,    -1,    -1,    -1,  4075,  4076,
    4077,    -1,   733,    -1,    -1,    -1,    -1,    -1,  4085,    -1,
      -1,    -1,    -1,  4090,    -1,    -1,    -1,  4094,   299,    -1,
      -1,   302,    -1,    -1,    -1,  4102,    -1,    -1,  4105,    -1,
    4107,    -1,    -1,    -1,    -1,  5637,    -1,  5639,   193,    -1,
      -1,    -1,   323,   198,    -1,    -1,  4123,    -1,    -1,  4126,
    4127,    -1,    -1,    -1,  4131,  4132,   337,    -1,    -1,  4136,
      -1,  4138,  4139,   344,    -1,    -1,   221,   222,    -1,    -1,
    4147,  4148,  4149,    -1,    -1,    -1,    -1,    -1,    -1,  2036,
      -1,    -1,    -1,   364,    -1,    -1,    -1,    -1,    -1,   244,
    4167,  4168,  4169,   374,  4171,  4172,    -1,    -1,  4175,    -1,
     381,    -1,  4179,   384,    -1,    -1,  4183,    -1,    -1,    -1,
      -1,    -1,  4189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   403,    -1,    -1,    -1,    -1,  5729,    -1,   410,
     285,    -1,    -1,    -1,    -1,    -1,   417,    -1,  4215,   420,
     421,    -1,   423,   424,   299,   876,    -1,   302,    -1,    -1,
      -1,    -1,    -1,  4230,    -1,  4232,    -1,    -1,   439,    -1,
      25,    -1,    -1,    -1,    -1,   446,    31,    -1,   449,    -1,
      -1,   452,    -1,  4250,  4251,    -1,  4253,    -1,    -1,  4256,
      -1,    -1,    -1,    -1,   465,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    -1,    -1,  4291,  4292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4310,    -1,    -1,    -1,   392,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,    -1,
      35,    -1,    -1,    -1,   139,    -1,    -1,   142,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,  4363,    52,    -1,  1020,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,   169,    -1,    -1,    -1,  1039,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,  1050,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,  1066,    52,    -1,    -1,   494,
     205,  4418,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,    -1,
      -1,   516,    78,    -1,  5966,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4451,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,  4465,  5991,
    4467,    -1,    -1,    -1,    -1,    -1,    -1,  4474,    -1,    -1,
      -1,    -1,    35,  4480,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,   278,  4491,    -1,    -1,   282,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   292,   193,  4506,
      -1,    -1,    -1,   198,  4511,  4512,   301,    -1,    -1,    -1,
      -1,    -1,  4519,    -1,    -1,    78,    -1,    -1,   313,    25,
      -1,  4528,    -1,    -1,    -1,    31,   221,   222,    -1,    -1,
      -1,  4538,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,  4179,    -1,  4550,  4551,  4183,    -1,   193,    -1,   244,
      -1,    -1,   198,  6085,  4561,    -1,    -1,   352,    -1,    -1,
     355,   356,  1223,    -1,    -1,  4572,  4573,    -1,    -1,    -1,
      76,    -1,    -1,    -1,   707,   221,   222,    -1,    -1,    -1,
      -1,    -1,    -1,  4590,    -1,    -1,    -1,    -1,    -1,    -1,
     285,    -1,   387,    -1,    -1,    -1,    -1,    -1,   244,    -1,
     733,    -1,    -1,    -1,   299,    -1,    -1,   302,    -1,    -1,
      -1,    -1,  4250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4631,    -1,   132,    -1,    -1,    -1,
     193,    -1,    51,   139,    -1,   198,   142,    -1,    25,   285,
    4647,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,  4662,    -1,  6189,   221,   222,
      -1,   456,    -1,   169,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2563,    -1,    -1,    -1,
      -1,   244,    -1,  4690,    -1,    -1,  4693,    -1,    -1,    76,
      -1,    -1,    -1,    -1,  4701,  4702,    -1,   392,    -1,   205,
      -1,  4708,  4709,    -1,    -1,    -1,  4713,    -1,    -1,    -1,
      -1,  4718,    -1,    -1,  4721,  4722,    -1,    -1,    -1,    -1,
      -1,  4728,   285,    -1,    -1,  4732,  4733,  4734,  4735,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   299,    -1,    -1,   302,
      -1,  4748,    -1,    -1,  4751,   132,   392,    -1,  4755,    -1,
      -1,    -1,   139,  4760,    -1,   142,  4763,  4764,    -1,  4766,
      -1,  4768,    -1,    -1,  4771,    -1,  4773,    -1,    -1,    -1,
      -1,    -1,   278,    -1,    -1,  4782,   282,    -1,    -1,  4786,
      -1,    -1,   169,  4790,    -1,  4792,   292,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   301,    -1,    -1,    -1,   494,
    4807,    -1,    -1,  4810,    -1,    -1,    -1,   313,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,   205,  1480,
      -1,   516,    -1,    -1,  2711,    -1,    -1,    -1,    -1,   392,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4845,    -1,
      -1,    -1,  4849,    -1,    -1,    -1,   352,    -1,   494,   355,
     356,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4511,  4512,    -1,    -1,    -1,    -1,    -1,
      -1,   387,    -1,    -1,  2771,    -1,  1547,    -1,    -1,    -1,
      -1,   278,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   292,  1039,    -1,  4915,    -1,
      -1,    -1,    -1,    -1,   301,  4922,    -1,  1050,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   313,  1588,    -1,    -1,
      -1,   494,    -1,  1066,    -1,    -1,    -1,  4944,    -1,    -1,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
     456,    -1,  4959,   516,    -1,    -1,    -1,    -1,    -1,    -1,
    1621,    -1,    -1,    -1,  2851,   352,    -1,    -1,   355,   356,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4990,    -1,    -1,    -1,    -1,  2875,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5006,
     387,    -1,    -1,    -1,    -1,    -1,  5013,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,  5022,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5037,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
    1701,  1702,  1703,  5050,    -1,  5052,    45,    -1,    -1,    -1,
      -1,    -1,  2939,    52,    -1,    -1,  2943,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   456,
      -1,  5078,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,  5089,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1223,    -1,    -1,  2980,    -1,  2982,    -1,  2984,  2985,    -1,
      -1,    -1,  2989,  2990,  2991,    -1,  2993,  2994,  2995,    -1,
    4748,    -1,    -1,    -1,    -1,    -1,    -1,  4755,    -1,    -1,
      -1,    -1,  4760,    -1,    -1,  4763,  4764,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5148,    -1,    -1,  5151,    -1,    -1,  5154,  5155,  5156,
      -1,    -1,  1813,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3047,    -1,    -1,  1824,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5179,  5180,    -1,    -1,  5183,    -1,    -1,  1840,
      -1,    -1,    -1,    -1,    -1,  3072,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   193,   707,  5203,    -1,    -1,   198,
      -1,    -1,  5209,    -1,    -1,    -1,  5213,    -1,    -1,    -1,
    5217,    -1,    -1,  5220,    -1,  5222,    -1,    -1,    -1,    -1,
      -1,   733,   221,   222,    -1,    -1,  5233,    -1,    -1,  5236,
      -1,    -1,    -1,  1894,    -1,    -1,    -1,    -1,    -1,    -1,
    5247,  5248,  5249,    -1,  5251,   244,    -1,    -1,  1909,    -1,
      -1,  1912,  1913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1943,  1944,    -1,    -1,   285,    -1,   707,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5303,  5304,    -1,    -1,
     299,    -1,    10,   302,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,   733,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,  5348,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5362,    -1,    -1,    -1,    -1,
    5367,    -1,    -1,    -1,   876,  5372,    -1,    -1,  5006,    -1,
      78,    -1,    -1,    -1,  5381,    -1,    -1,    -1,    -1,    -1,
      -1,  2042,    -1,    -1,  5391,    -1,    -1,    -1,  5395,    -1,
      -1,  5398,  2053,   392,    -1,  2056,    -1,    -1,    -1,  5037,
      -1,    -1,  5409,  5410,  5411,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5447,    -1,    -1,    -1,  5451,    -1,  5453,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1588,    10,   876,    -1,    13,
    5467,    -1,    -1,    17,    18,    19,    -1,  5474,    -1,    -1,
    5477,    -1,    -1,    -1,  5481,    -1,    -1,    -1,    -1,    -1,
      -1,  5488,    -1,    -1,    -1,   193,    -1,    -1,  5495,  3376,
     198,    45,    -1,    -1,    -1,   494,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   221,   222,    -1,    -1,   516,    -1,    -1,
      -1,    -1,    -1,  5530,    78,    -1,    -1,  1039,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5542,   244,    -1,  1050,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5558,    -1,    -1,  1066,    -1,    -1,  5564,  5565,    -1,
      -1,    -1,  5569,  5570,  5571,  5572,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5213,    -1,   285,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,    -1,  5600,   302,  5233,    -1,    -1,    -1,    -1,
      -1,    -1,  5609,    -1,    -1,    -1,    -1,    -1,    -1,  5247,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1039,    -1,    -1,    -1,    -1,    -1,    -1,  5634,    -1,    -1,
    5637,  1050,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
      -1,    -1,    -1,    -1,   198,    -1,    -1,  1066,    -1,    -1,
      -1,  3538,    -1,    -1,    10,  5662,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,  5303,    -1,   221,   222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
    1813,    -1,    38,  5690,   392,    -1,    -1,    -1,    -1,    45,
     244,  1824,  5699,  5700,  5701,    -1,    52,    -1,  5705,    -1,
      -1,    -1,  5709,    -1,    -1,  5712,    -1,  1840,    -1,    -1,
    5348,  1223,    -1,    -1,  5721,    -1,  5723,    -1,  5725,  5726,
      -1,    -1,    78,    -1,    -1,  5732,    -1,    -1,    -1,  3616,
      -1,   285,    -1,    -1,    -1,  5742,    -1,  5744,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   299,    -1,  5754,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5411,    -1,    -1,  1909,    -1,    -1,  1912,
    1913,    -1,  5789,  5790,    -1,    -1,   494,  3674,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,  1223,    -1,    -1,    -1,   516,    -1,
    1943,  1944,  5819,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5833,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5474,   193,   392,    -1,
      -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3742,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5870,    -1,   221,   222,  1379,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5883,    -1,    -1,    -1,
    5887,    -1,    -1,    -1,    -1,  2546,  5893,    -1,   244,    -1,
      -1,    -1,    -1,    -1,    -1,  5902,  5903,    -1,    -1,    -1,
      -1,    -1,    -1,  3790,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5920,    -1,  3802,  3803,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3812,    -1,    -1,  5935,   285,
    3817,    -1,  3819,    -1,    -1,  5942,    -1,    -1,    -1,    -1,
     494,    -1,    -1,   299,    -1,    -1,   302,    -1,  2081,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
    5967,    -1,    -1,    -1,    -1,    23,    -1,  5974,  1480,    -1,
      28,  5609,    -1,    -1,    -1,    -1,    -1,  5984,  3865,    -1,
      -1,    -1,    -1,    -1,    -1,  5992,  5993,  5994,    -1,    -1,
      -1,  5998,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5637,
      -1,    -1,    -1,  6010,  6011,  6012,    -1,    -1,    66,    -1,
    6017,  6018,    -1,  3900,  3901,    -1,  6023,    -1,    -1,    -1,
      -1,    79,  2683,    -1,    -1,    -1,  2687,  2688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1547,   392,    95,  6045,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,
      -1,  1480,    -1,    -1,    -1,    -1,    -1,    -1,  6075,  6076,
    6077,    -1,    -1,    -1,  6081,    -1,  1588,    -1,    -1,   137,
      -1,    -1,    -1,    -1,    -1,  2746,    -1,    -1,    -1,    -1,
     148,  2752,  6099,  6100,  5732,    -1,    -1,    -1,    -1,   157,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6114,    -1,  1621,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,   176,    -1,
      -1,    -1,    -1,  6130,    -1,    -1,    -1,    -1,  1547,    -1,
      -1,    -1,  2793,    -1,    -1,    -1,    -1,    -1,   494,    -1,
      -1,    -1,    -1,    -1,    -1,   203,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,  6163,  6164,  6165,  6166,
    6167,    -1,    -1,  6170,    -1,    -1,    -1,    -1,    -1,  1588,
      -1,    -1,    -1,    -1,    -1,  6182,    -1,    -1,  6185,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5833,    -1,    -1,    -1,  6206,
     258,    -1,  1621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4101,    -1,    -1,    -1,  6225,  6226,
      -1,    -1,    -1,  6230,    -1,    -1,    -1,  6234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6246,
    6247,   299,    -1,  6250,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    -1,    -1,    -1,
      -1,    20,    -1,    22,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    30,    -1,    -1,    -1,   333,   334,    -1,    -1,   337,
      -1,    -1,  5920,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1813,    -1,    -1,    -1,    -1,   364,    -1,    -1,   367,
    2971,    -1,  1824,    -1,    -1,    -1,   374,    -1,    -1,    -1,
      -1,    -1,    -1,   381,    -1,    -1,   384,    -1,  1840,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3003,    -1,    -1,   403,  5984,    -1,    -1,    -1,
      -1,    -1,   410,    -1,  5992,  5993,    -1,    -1,    -1,   417,
      -1,    -1,   420,    -1,    -1,    -1,   424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,
      -1,   439,  1894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1813,    -1,    -1,  1909,    -1,    -1,
    1912,  1913,    -1,    -1,    -1,  1824,    -1,   465,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3076,    -1,    -1,    -1,  3080,
      -1,  1840,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1943,  1944,    -1,    -1,    -1,    -1,  6075,    -1,    -1,
      -1,   200,  4329,  6081,    -1,   204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   212,    -1,    -1,   215,    -1,    -1,   218,
     219,  6099,   221,    -1,   223,    -1,    -1,   226,  4355,   228,
      -1,    -1,    -1,    -1,    -1,  1894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4370,    -1,    -1,  4373,    -1,  4375,    -1,
    1909,    -1,    -1,  1912,  1913,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3183,    -1,  1943,  1944,    -1,  6165,    -1,    -1,
      -1,    -1,    -1,    -1,  4421,    -1,    10,  3198,    -1,    13,
      -1,    -1,  3203,    17,    18,    19,    -1,  6185,    -1,    -1,
    4437,    -1,    -1,    -1,    -1,  4442,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2081,
      -1,    45,  3233,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,  6246,  6247,
       0,    -1,    -1,  2746,    -1,    -1,    -1,    -1,    -1,  2752,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    -1,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4541,    -1,    -1,  4544,    -1,    -1,
    2793,    51,  2081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
      -1,    -1,    -1,    -1,   198,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,  4620,  4621,  4622,  4623,    -1,  4625,  4626,
    4627,  4628,  4629,   133,    -1,   135,    -1,   221,   222,   139,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,
      -1,    -1,    51,   153,    -1,   155,    -1,    -1,    -1,    -1,
     244,    -1,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,
      -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3482,    -1,    -1,  3485,   299,  3487,    -1,   302,    -1,
      -1,  3492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4740,    -1,  4742,   246,   247,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3003,    -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,
    3541,    -1,    -1,    -1,    -1,    -1,   645,    -1,  3549,    -1,
      -1,    -1,    -1,    -1,   284,    -1,    -1,   656,    -1,    -1,
      -1,   660,    -1,    -1,    -1,    -1,    -1,    -1,   667,   668,
      -1,    -1,   671,  3574,   673,   674,    -1,    -1,   392,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,
      -1,    -1,   342,    -1,    -1,    -1,    -1,    -1,   348,   349,
      -1,   351,    -1,    -1,    -1,    -1,   356,    -1,   727,    -1,
     729,    -1,   362,    -1,    -1,   365,    -1,    -1,    -1,    -1,
     739,    -1,   372,  3644,    -1,  3646,    -1,    -1,    -1,   379,
     380,    -1,    -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,
      -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   401,    -1,   772,    -1,    -1,    -1,    -1,    -1,    -1,
     494,    -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,   516,    -1,    -1,    -1,    -1,   437,    -1,    -1,
    3183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   448,    -1,
      -1,    -1,    -1,    -1,   454,  3198,    -1,    -1,    -1,   459,
    3203,    -1,    -1,    -1,    -1,  4962,  4963,    -1,    -1,  3740,
      -1,    -1,   472,    -1,    -1,    -1,    -1,    -1,  4975,    -1,
    4977,  4978,  4979,    -1,   853,    -1,    10,    -1,    -1,    13,
    3233,    -1,    -1,    17,    18,    19,   496,    -1,  3769,    -1,
      -1,    -1,    -1,    -1,  3775,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,  3784,    -1,   515,    -1,    -1,   518,    -1,
      -1,    45,    10,    -1,    -1,    13,    -1,    -1,    52,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3812,    -1,    -1,    -1,    -1,  5043,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    45,    -1,    -1,
      -1,  2683,    -1,    -1,    52,  2687,  2688,    -1,    -1,   938,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,  5082,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,  3880,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2746,    -1,    -1,    -1,  5125,    -1,
    2752,  3902,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,  1012,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3924,  2683,    -1,    -1,    -1,  2687,  2688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1037,   193,
      -1,  2793,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1052,    -1,  1054,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1064,    -1,   221,   222,    -1,
      -1,    -1,  1071,    -1,    -1,   193,    -1,    -1,    -1,    -1,
     198,    -1,    -1,    -1,    -1,    -1,    -1,  2746,    -1,    -1,
     244,    -1,    -1,  2752,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,  4006,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1114,    -1,  1116,    -1,    -1,
      -1,    -1,    -1,    -1,   193,    -1,   244,    -1,    -1,   198,
      -1,   285,    -1,    -1,  2793,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   299,    -1,    -1,   302,    -1,
      -1,    -1,   221,   222,  4055,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5292,    -1,   285,  3541,    -1,
      -1,    -1,    -1,    -1,    -1,   244,  3549,    -1,   707,  4080,
      -1,   299,    -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,
      -1,  1190,    -1,  1192,    -1,  1194,    -1,  1196,    -1,  1198,
    1199,  1200,    -1,    -1,   733,    -1,  1205,    -1,    -1,    -1,
      -1,  5338,    -1,    -1,    -1,    -1,   285,    -1,  1217,    -1,
    5347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     299,    -1,    -1,   302,    -1,    -1,    -1,    -1,   392,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3644,    -1,  3646,   392,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,   392,  3076,    -1,    -1,    -1,  3080,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4238,    -1,    -1,
     494,    -1,    -1,    78,  3003,    -1,    -1,   876,    -1,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,   516,    -1,    -1,    -1,    -1,  3740,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,    -1,    -1,    -1,   516,    -1,
      -1,    -1,  1401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3784,    -1,    -1,    -1,    -1,    -1,  3076,    -1,    -1,
      -1,  3080,    -1,    -1,    -1,   494,    -1,    -1,  4329,    -1,
      -1,  3183,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,  3198,   516,    -1,    -1,
      -1,  3203,    -1,  5580,  4355,    -1,    -1,  5584,   193,    -1,
      -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3233,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3880,    -1,   244,
    1039,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1050,  1521,    -1,  3183,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1066,    -1,  3198,
      -1,    -1,    -1,    -1,  3203,    -1,    -1,    -1,    -1,    -1,
     285,  3924,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   299,    -1,    -1,   302,    -1,    -1,
      -1,    -1,    -1,    -1,  3233,    -1,    -1,    -1,    -1,   206,
     207,    -1,    -1,    -1,    -1,    -1,    -1,   214,    -1,   216,
     217,    -1,    -1,    -1,  1593,    -1,  4497,    -1,    -1,    -1,
      -1,    -1,    -1,   230,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,  4006,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    10,  4544,    -1,    13,    52,    -1,  4549,    17,
      18,    19,    -1,    -1,  5781,    -1,    -1,   392,  5785,    -1,
    5787,    -1,    -1,    -1,  5791,  5792,    -1,    35,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,  4055,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1223,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4080,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3482,    -1,    -1,  3485,    -1,  3487,    -1,    -1,    -1,    -1,
    3492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,    -1,
      -1,   516,    -1,    -1,    -1,    -1,    -1,   193,    -1,  3541,
      -1,    -1,   198,    -1,    -1,    -1,    -1,  3549,    -1,    -1,
      -1,    -1,    -1,  4704,    -1,    -1,    -1,    -1,    -1,    -1,
    1809,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,  3574,  3482,    -1,   193,  3485,    -1,  3487,    -1,
     198,    -1,    -1,  3492,    -1,    -1,    -1,    -1,   244,    -1,
      -1,    -1,    -1,    -1,    -1,  1844,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,    -1,   285,
      -1,    -1,  3541,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3549,  1890,  3644,   299,  3646,    -1,   302,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1910,    -1,    -1,    -1,  3574,    -1,   285,    -1,    -1,
      -1,    -1,    -1,    -1,  6051,    -1,    -1,    -1,  4829,    -1,
      -1,   299,    -1,    -1,   302,    -1,    -1,  1936,    -1,  1938,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1480,    -1,    -1,  1953,    -1,  1955,    -1,    -1,    -1,
      -1,    -1,  1961,    -1,  1963,    -1,  1965,    -1,  1967,  4870,
    1969,    -1,    -1,    -1,  1973,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3644,   392,  3646,  3740,    -1,
      -1,  4892,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,  2010,    17,    18,    19,    -1,    -1,   644,  1547,    -1,
      -1,    -1,    -1,    -1,   392,    -1,    -1,    -1,    -1,    -1,
      35,    -1,  3784,    -1,    -1,    -1,   663,    -1,    -1,    -1,
      45,    10,   669,    -1,    13,    -1,    -1,    52,    17,    18,
      19,    -1,    -1,    -1,   681,    -1,    -1,    -1,    -1,  1588,
    3812,    -1,    -1,  4964,    -1,  6192,    35,    -1,    -1,  6196,
     697,    -1,    -1,    78,    -1,    -1,    45,    -1,    -1,    -1,
      -1,  3740,    -1,    52,   711,   712,    -1,    -1,   494,    -1,
      -1,   718,  1621,   720,   721,    -1,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   734,    -1,    78,
     516,  6238,    -1,    -1,    -1,    -1,    -1,   744,    -1,    -1,
      -1,    -1,    -1,    -1,  4497,  3784,   494,    -1,  3880,  6256,
      -1,    -1,  6259,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,    -1,    -1,    -1,   516,    -1,
    3902,    -1,    -1,  3812,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
     797,    -1,  3924,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,  5083,    -1,  5085,    -1,    -1,    -1,   193,    -1,
      -1,    35,    -1,   198,    -1,    -1,    -1,    -1,   825,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,
      -1,  3880,    -1,   850,   193,    -1,    -1,    -1,    -1,   198,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,   244,
      -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   221,   222,  4006,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3924,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,
     285,    -1,    -1,    -1,  1813,   912,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   299,  1824,    -1,   302,    -1,    -1,
      -1,    -1,    -1,  4055,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1840,    -1,    -1,    -1,    -1,   285,    -1,  5219,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4080,    -1,
     299,    -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4006,    -1,   193,
      -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,    -1,
    1909,    -1,    -1,  1912,  1913,    -1,    -1,   392,    -1,    -1,
      -1,  5292,    -1,    -1,    -1,  1022,  4055,    -1,    -1,    -1,
     244,    -1,  1029,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1040,  1943,  1944,    -1,  1044,    -1,  1046,
      -1,  4080,    -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   299,  4829,    -1,   302,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4238,    -1,    -1,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4870,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,    -1,
      -1,   516,    -1,  5414,    -1,    -1,    -1,    -1,    -1,  4892,
      -1,    -1,    -1,    -1,    -1,   494,  1153,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,   516,   392,    -1,
      -1,    -1,  2081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4329,    -1,  4238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1214,    -1,    -1,
      -1,  4964,    -1,    -1,    -1,    -1,    -1,    -1,  1225,    -1,
      -1,    -1,    -1,  4355,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1242,    -1,    -1,    -1,    -1,
    1247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5548,   707,    -1,
     494,    -1,  5553,  5554,    -1,    -1,    -1,    -1,    -1,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
    4329,    -1,   516,    -1,   733,    -1,    -1,    -1,  2677,  2678,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4355,  2696,  2697,    -1,
    2699,  2700,    -1,    -1,    -1,  2704,  2705,    -1,    -1,    -1,
      -1,    -1,  5085,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2719,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2727,    -1,
      -1,    -1,  2731,  2732,    -1,    -1,  2735,  2736,    -1,    -1,
      -1,    -1,    -1,  2742,    -1,  4497,    -1,    -1,    -1,  1376,
      -1,    -1,    -1,    -1,    -1,  2754,    -1,  1384,  1385,    -1,
      -1,    -1,    -1,    -1,    -1,  5666,  5667,  2766,    -1,    -1,
      -1,    -1,  2771,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    -1,  2786,    -1,    -1,
      -1,    31,  4544,    -1,    -1,    -1,  2795,  4549,    38,  2798,
      -1,  2800,  2801,  2802,    -1,    -1,    -1,    -1,  2807,  2808,
    1437,    -1,    -1,    -1,    -1,  5716,    -1,   876,  2817,    -1,
      60,    -1,    -1,    -1,  2823,    -1,    -1,    -1,  2827,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,  4497,    -1,
    2839,  2840,    -1,    -1,    -1,  2844,  5219,    -1,    -1,    -1,
      -1,  2850,  2851,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,  2864,    -1,    -1,  2867,    -1,
      -1,   111,    -1,    -1,    -1,  2874,  2875,    -1,    35,    -1,
      -1,  2880,    -1,    -1,    -1,  4544,    -1,    -1,    45,    -1,
    4549,    -1,   132,  2892,    -1,    52,  2895,    -1,    -1,   139,
      -1,  2900,   142,    -1,    -1,    -1,    -1,  2906,  2907,    10,
      -1,    -1,    13,    -1,    -1,  2914,    17,    18,    19,  2918,
      -1,    78,    -1,  2922,  2923,  2924,  2925,    -1,  2927,   169,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2941,  2942,    45,  2944,    -1,    -1,    -1,    -1,
      -1,    52,  4704,    -1,    -1,   207,  2955,  2956,  2957,    -1,
      -1,   201,    -1,    -1,   216,   205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,   230,    -1,
    1039,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1050,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    -1,  1066,    -1,    -1,
      -1,    -1,    -1,  3012,    -1,    -1,    -1,    -1,    -1,   259,
      -1,  3020,    -1,   263,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,   278,    -1,
    3039,   198,   282,    -1,    -1,  4704,    -1,    -1,    -1,    -1,
      -1,    -1,   292,    -1,    -1,    -1,    -1,    -1,    -1,  1686,
      -1,   301,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,
      -1,    -1,   312,   313,    -1,    -1,    -1,  4829,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,    -1,
    3089,    -1,   193,    -1,    -1,    -1,    -1,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3108,
      -1,  3110,   352,    -1,    -1,   355,   356,   357,  4870,    -1,
     221,   222,    -1,    -1,    -1,    -1,    -1,    -1,   285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4892,   381,   299,   244,    -1,   302,    -1,   387,    -1,    -1,
      -1,    -1,    -1,    -1,  2683,    -1,    -1,    -1,  2687,  2688,
      -1,   401,    -1,    -1,  1223,    -1,    -1,    -1,    -1,    -1,
    4829,    -1,    -1,    -1,  1801,  5548,    -1,    -1,    -1,    -1,
    5553,  5554,    -1,    -1,   285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,    -1,
      -1,   302,    -1,    -1,    -1,    -1,  3205,    -1,    -1,  1836,
      -1,  4870,  4964,    -1,    -1,    -1,   456,  2746,    -1,    -1,
      -1,    -1,    -1,  2752,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1859,  4892,    -1,   392,    -1,    -1,    -1,    -1,
    1867,    -1,    10,    -1,    -1,    13,    -1,    -1,  1875,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2793,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,  1916,
    1917,   392,  1919,  1920,  5667,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1931,  4964,  1933,  1934,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1946,
    1947,    -1,    -1,    -1,  6225,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5085,    -1,    -1,    -1,   494,    -1,    -1,
      -1,    -1,    -1,  5716,    -1,    -1,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,  1984,    -1,   516,
      -1,  1988,  1989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   644,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   663,    -1,    -1,    -1,   516,    -1,   669,    -1,    -1,
      -1,  1480,    -1,    -1,    -1,   193,  5085,    -1,    -1,   681,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   697,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
     712,    -1,    -1,    -1,    -1,    -1,    -1,  5219,   720,    -1,
      -1,    -1,    -1,    -1,  3003,  2102,   244,    -1,    -1,    -1,
      -1,    -1,   734,    -1,    -1,    -1,    -1,    -1,  1547,    -1,
      -1,    -1,   744,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3515,   285,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1588,
      -1,   299,    -1,    -1,   302,    -1,    -1,  3536,    -1,    -1,
    5292,    10,    -1,    -1,    13,   797,    -1,  3076,    17,    18,
      19,  3080,    -1,    -1,  3553,    -1,    -1,    -1,  3557,    -1,
    5219,    -1,  1621,  3562,  3563,  3564,    35,    -1,    -1,    -1,
      -1,    -1,    -1,   825,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   850,  3598,
    3599,  3600,  3601,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,   392,    -1,    51,    -1,    -1,  3628,
      -1,    -1,    -1,  5292,    -1,    -1,    35,  3636,    -1,  3638,
    3639,  3640,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,  3183,    -1,    -1,    -1,    -1,   707,
     912,    -1,  5414,    -1,    -1,    -1,    -1,    -1,    -1,  3198,
      -1,    -1,    -1,    -1,  3203,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,   733,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3233,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   193,    -1,   494,    -1,    -1,   198,
      -1,    -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,    -1,    -1,    -1,   516,    -1,
      -1,    -1,   221,   222,  1813,  5414,    -1,  3756,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1824,  3765,    -1,    -1,    -1,
    1022,    -1,    -1,    -1,    -1,   244,    -1,  1029,    -1,    -1,
      -1,  1840,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3791,  3792,   193,    -1,  5548,  3796,    -1,   198,
      -1,  5553,  5554,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,  3818,
      -1,    -1,   221,   222,    -1,    -1,    -1,    -1,   876,    -1,
     299,    -1,    -1,   302,    -1,  1894,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,
    1909,    -1,    -1,  1912,  1913,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3870,    -1,    -1,    -1,    -1,  3875,    -1,    -1,    -1,
      -1,    -1,  3881,    -1,  1943,  1944,   285,    -1,    -1,  5548,
      -1,    -1,    -1,    -1,  5553,  5554,    -1,    -1,    -1,    -1,
     299,  1153,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3911,    -1,    -1,  5667,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   392,    -1,    -1,    -1,    -1,   327,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3940,    -1,  3942,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3482,    -1,    -1,  3485,    -1,  3487,    -1,
      -1,    -1,  1214,  3492,  5716,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1242,  1039,    -1,   392,  2621,  1247,    -1,    -1,    -1,    -1,
      -1,    -1,  1050,    -1,    -1,    -1,    -1,    -1,  5667,    -1,
     409,    -1,  3541,    -1,    -1,    -1,    -1,    -1,  1066,    -1,
    3549,    -1,  2081,    -1,    -1,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,  3574,    -1,   516,    -1,  2676,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5716,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2694,    -1,    -1,
      -1,  2698,    -1,    -1,    -1,  2702,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2711,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2730,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,  3644,    -1,  3646,    -1,    -1,
    2747,    -1,  2749,  2750,  1376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1384,  1385,    -1,    -1,    -1,  2764,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2784,  2785,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1223,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1437,    -1,    -1,  2815,  2816,
      -1,    -1,  2819,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3740,    -1,    -1,    -1,    -1,  2843,    -1,  2845,    -1,
      -1,    -1,  2849,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2863,    51,    -1,    -1,
      -1,    -1,    -1,  2870,    -1,    -1,  2873,    -1,    -1,    -1,
      -1,    -1,  2879,    -1,    -1,  3784,  4255,    -1,    -1,  4258,
      -1,  4260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2899,    -1,  4273,    -1,    -1,    -1,  2905,    -1,
      -1,    -1,   707,  3812,    -1,  2912,  4285,    -1,    -1,    -1,
    4289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2926,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   733,  4308,
      -1,    -1,    -1,  2940,    -1,    -1,    -1,    -1,  2945,    -1,
      -1,    -1,    -1,    -1,  2951,    -1,    -1,  4326,    -1,    -1,
      -1,    -1,    -1,  4332,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3880,    -1,    -1,    -1,    -1,    -1,    -1,  4357,    -1,
      -1,    -1,  4361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3902,    -1,    -1,    -1,  4376,  4377,  4378,
    4379,    -1,    -1,    -1,  3011,    -1,    -1,  4386,  4387,  4388,
    4389,    -1,    -1,    -1,    -1,  3924,  4395,  4396,    -1,    -1,
      -1,    -1,  4401,  4402,    -1,  4404,  4405,  4406,  4407,  4408,
    4409,  4410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4420,    -1,    -1,    -1,  4424,  4425,  4426,  4427,    -1,
      -1,    -1,  1480,    -1,  1686,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4448,
      -1,   876,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,  4466,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4006,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    10,    -1,    52,    13,    -1,  1547,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    78,    -1,    -1,    -1,  4055,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,  3166,
    1588,  3168,    -1,  4542,    -1,    -1,    -1,    -1,    -1,  1801,
      -1,  4080,    -1,    -1,    -1,    -1,    -1,    -1,  3185,    -1,
      -1,    -1,    78,    -1,    -1,  3192,    -1,    -1,    -1,    -1,
      -1,    -1,  3199,  1621,  3201,  3202,  4575,    -1,    -1,    -1,
      -1,    -1,    -1,  4582,  1836,  4584,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1859,    -1,    -1,
      -1,    -1,    -1,  4612,  1039,  1867,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1875,  2683,  1050,    -1,    -1,  2687,  2688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,  1066,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3285,    -1,
      -1,    -1,    -1,    -1,  3291,   221,   222,  1919,  1920,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,  1933,   198,    -1,    -1,    -1,    -1,  2746,   244,    -1,
      -1,    -1,    -1,  2752,  1946,  1947,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,  4238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,   285,
      -1,    -1,    -1,    -1,  2793,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,   302,    -1,    -1,  3376,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1813,    -1,    -1,    -1,   285,
      -1,    -1,    -1,    -1,    -1,    -1,  1824,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,   302,    -1,    -1,    -1,
      -1,    -1,  1840,    -1,    -1,    -1,    -1,    -1,  1223,    -1,
    4329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4355,    -1,    -1,    -1,
      -1,  4830,  4831,  4832,    -1,    -1,   392,  4836,  4837,  4838,
    4839,    -1,    -1,    -1,  4843,    -1,  1894,    -1,    -1,    -1,
    2102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1909,    -1,    -1,  1912,  1913,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   392,    -1,    -1,    -1,
    3507,  3508,    -1,  4882,  4883,  4884,  4885,  4886,    -1,  4888,
    4889,    -1,    -1,   707,    -1,  1943,  1944,    10,    -1,    -1,
      13,  4900,  4901,    -1,    17,    18,    19,    -1,  3535,    -1,
      -1,  3538,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   733,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,  4934,    -1,    -1,   494,    52,
      -1,    -1,    -1,    -1,  3003,    -1,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,
     516,    -1,    -1,    -1,    -1,    78,    -1,    -1,  4497,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   494,    -1,
      -1,    -1,    -1,  3610,  3611,  3612,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,
     516,    51,    -1,    -1,    -1,    -1,    -1,    -1,  3635,    -1,
      -1,    -1,    -1,    -1,    -1,  4544,    -1,  3076,    -1,    -1,
    4549,  3080,    -1,    -1,    -1,    -1,    -1,  3654,    -1,    -1,
      -1,    -1,    -1,  2081,    -1,    -1,    -1,  5036,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3676,
      -1,    -1,    -1,    -1,    -1,  1480,    -1,    -1,    -1,    -1,
      -1,    -1,   876,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
     193,    -1,    17,    18,    19,   198,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,  5101,    -1,    -1,    -1,    -1,    -1,   221,   222,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,  1547,    -1,  3183,    -1,    -1,    -1,    -1,    -1,
      -1,   244,    -1,    -1,  5133,    -1,    -1,  3764,    -1,  3198,
      -1,    -1,    -1,    78,  3203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1588,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,    -1,  3233,  4704,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3811,    -1,   299,    -1,    -1,   302,
    3817,    -1,  3819,    -1,    -1,    -1,  1621,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3832,    -1,  3834,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1039,    -1,  5226,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1050,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,  1066,    -1,    -1,    -1,    -1,    -1,   193,    -1,
      -1,    -1,    -1,   198,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    39,    -1,    -1,  3901,    -1,    -1,    45,    -1,   392,
      -1,    -1,    -1,    -1,    52,    -1,   221,   222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5294,    -1,    -1,    -1,    -1,
    4829,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      78,    -1,    -1,    -1,  5313,    -1,  3943,    -1,    -1,    -1,
    5319,  5320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5329,    -1,    -1,    -1,    -1,  3962,    -1,  5336,    -1,  3966,
      -1,  4870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3987,   129,    -1,  4892,   299,    -1,    -1,   302,    -1,  2621,
      -1,    -1,    -1,    -1,  5373,  5374,    -1,    -1,    -1,    -1,
      -1,   494,    -1,    -1,    -1,    -1,    -1,  5386,  1813,  5388,
     503,   504,   505,   506,   507,   508,   509,   510,   511,  1824,
      -1,    -1,    -1,   516,  5403,    -1,    -1,    -1,    -1,  1223,
      -1,    -1,    -1,    -1,    -1,  1840,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3482,  2676,   193,  3485,    -1,  3487,  5428,
     198,    10,    -1,  3492,    13,  4964,    -1,  5436,    17,    18,
      19,    -1,  2694,    -1,    -1,    -1,  2698,    -1,    -1,    -1,
    2702,    -1,    -1,   221,   222,    -1,    35,   392,    -1,  2711,
      -1,    -1,    -1,    -1,    -1,  4092,    45,    -1,    -1,  1894,
      -1,    -1,    -1,    52,    -1,    -1,   244,    -1,  2730,    -1,
      -1,    -1,  3541,    -1,  1909,    -1,    -1,  1912,  1913,    -1,
    3549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5510,  2764,    -1,    -1,  3574,    -1,   285,  1943,  1944,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,  2784,  2785,   302,    -1,  5535,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5547,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5085,    -1,    -1,   494,
      -1,    -1,    -1,  2815,  2816,    -1,    -1,  2819,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,   514,
      -1,    -1,    -1,    -1,    -1,  3644,    -1,  3646,    -1,   168,
      -1,  2843,    -1,  2845,    -1,   174,    -1,  2849,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2863,    -1,    -1,   193,    -1,  5615,    -1,  2870,   198,
      -1,  2873,    -1,    -1,   392,    -1,    -1,  2879,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2683,    -1,    -1,    -1,  2687,
    2688,    -1,   221,   222,    -1,  4272,    -1,  2899,    -1,    -1,
      -1,    -1,    -1,  2905,    -1,    -1,  2081,   707,    -1,    -1,
    2912,    -1,    -1,    -1,    -1,   244,  1480,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2926,    -1,    -1,    -1,    -1,    -1,
      -1,  3740,    -1,   733,    -1,   453,  5685,    -1,  2940,    -1,
    5219,    -1,    -1,  2945,    -1,    -1,  4323,    -1,  2746,  2951,
      -1,  4328,    -1,  4330,  2752,    -1,   285,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     299,    -1,    -1,   302,    -1,  3784,   494,  4354,    -1,    -1,
      -1,    -1,    -1,  1547,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,  2793,    -1,    -1,    -1,    -1,
      -1,    -1,  5751,  3812,    -1,    -1,    -1,    -1,    -1,  3011,
      -1,    -1,    -1,  5292,    -1,    -1,    -1,  5766,    -1,    -1,
      -1,    -1,    -1,  4400,  1588,    -1,  4403,    -1,    -1,    -1,
      -1,    -1,    -1,   208,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   231,  1621,    -1,    -1,
      -1,    -1,    -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3880,    -1,    -1,    -1,  5824,   876,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3924,  4493,  4494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4504,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5414,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4521,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3166,   494,  3168,    -1,    -1,    -1,
    5919,    -1,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,  3185,    -1,    -1,    -1,    -1,    -1,    -1,
    3192,    -1,    -1,    -1,    -1,    -1,    -1,  4006,    -1,    -1,
      -1,    -1,  5951,    -1,    -1,  3003,    -1,    -1,    -1,    10,
      -1,    -1,    13,  5962,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,  4602,    -1,    -1,  4605,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,  1039,
      -1,    -1,    -1,    -1,    45,    -1,  4055,    -1,    -1,  1813,
    1050,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1824,    -1,    -1,    -1,    -1,    -1,  1066,    -1,    -1,  5548,
      -1,  4080,    -1,    -1,  5553,  5554,  1840,    78,  3076,    -1,
      -1,    -1,  3080,  3285,    -1,    -1,    -1,    -1,    -1,  3291,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6065,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1894,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1909,    -1,    -1,  1912,  1913,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3376,    -1,    -1,    -1,    -1,  1943,
    1944,    -1,    -1,    -1,    -1,  3183,    -1,    -1,  5667,    -1,
      -1,    -1,   193,    -1,    -1,    -1,    -1,   198,    -1,    -1,
    3198,    -1,    -1,    -1,    -1,  3203,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     221,   222,    -1,  1223,    10,    -1,    -1,    13,    -1,  4238,
      -1,    17,    18,    19,    -1,  3233,    -1,  5716,    -1,    -1,
      -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,  4842,    52,    -1,    -1,    -1,
     645,    -1,    -1,    -1,    -1,    -1,   651,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,   299,    -1,
      -1,   302,    -1,    -1,    -1,  3507,  3508,    -1,  2683,    -1,
    4887,    -1,  2687,  2688,    -1,    -1,    -1,  2081,    -1,    -1,
    4329,    -1,  4899,    -1,   325,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3535,    -1,    -1,  3538,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4355,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4933,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2746,    -1,    -1,    -1,    -1,    -1,  2752,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,   193,  3610,  3611,
    3612,    -1,   198,    -1,    -1,    45,    -1,    -1,  2793,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3635,  5011,   221,   222,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   822,    78,    -1,
      -1,    -1,  3654,  5030,    -1,    -1,    -1,    -1,   244,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   841,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3676,    -1,    -1,    -1,    -1,    -1,
    1480,    -1,    -1,    -1,  3482,    -1,    -1,  3485,  4497,  3487,
      -1,    -1,    -1,   494,  3492,    -1,    -1,    -1,    -1,   285,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,    -1,   299,    -1,    -1,   302,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4544,    -1,    -1,   913,  5116,
    4549,    -1,    -1,  3541,    -1,    -1,    -1,  1547,    -1,    -1,
      -1,  3549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3764,   193,    -1,    -1,    -1,    -1,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3574,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   960,    -1,    -1,  1588,    -1,
      -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   392,    -1,    -1,  3811,
      -1,    -1,    -1,    -1,   244,  3817,    -1,  3819,    -1,    -1,
      -1,  1621,    -1,    -1,    -1,    -1,    -1,    -1,  3003,    -1,
    3832,    -1,  3834,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3644,    -1,  3646,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5241,    -1,  5243,    -1,    -1,   299,
      -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   321,    -1,    -1,    -1,  4704,    -1,    -1,    -1,  3901,
    1075,  3076,    -1,    -1,    -1,  3080,    -1,   493,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5293,   503,   504,   505,
     506,   507,   508,   509,   510,   511,  5303,    -1,    -1,  1104,
    1105,  1106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3943,  3740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3962,    -1,   392,    -1,  3966,    -1,  5343,    -1,    -1,    -1,
      -1,  5348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,  3987,  3784,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,  3183,    -1,
      -1,    -1,    -1,  1813,  3812,    45,    -1,    -1,    -1,    -1,
    4829,    -1,    52,  3198,  1824,    -1,    -1,    -1,  3203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1213,    -1,
    1840,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3233,    -1,
      -1,  4870,    -1,    -1,   494,    -1,  1241,    -1,    -1,    -1,
      -1,    -1,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,  3880,  4892,    -1,    -1,    -1,    -1,    -1,    -1,
    4092,    -1,    -1,    -1,  1894,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,  1909,
      -1,    -1,  1912,  1913,    -1,    -1,    -1,    -1,    -1,  2683,
      -1,    -1,    -1,  2687,  2688,    -1,  3924,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1943,  1944,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4964,    -1,    -1,    10,    -1,
      -1,    13,    -1,   193,    -1,    17,    18,    19,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2746,    35,    -1,    -1,    38,    -1,  2752,  5566,
      -1,   221,   222,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,  5580,    -1,    -1,    -1,    -1,  4006,    -1,
      -1,    -1,    -1,    -1,   244,  1390,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    78,    -1,    13,  2793,
      -1,    -1,    17,    18,    19,  5612,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,   285,    -1,  4055,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,   299,
    4272,    -1,   302,    -1,    -1,    -1,  5085,    -1,    -1,    -1,
      -1,  2081,  4080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,  1470,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3482,    -1,    -1,
    3485,    -1,  3487,    -1,    -1,    -1,    -1,  3492,    -1,    -1,
      -1,  4323,    -1,    -1,    -1,    -1,  4328,    -1,  4330,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5713,    -1,    -1,    -1,
      -1,   193,    -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,
      -1,    -1,  4354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   392,    -1,    -1,    -1,  3541,    -1,    -1,   221,
     222,    -1,    -1,    -1,  3549,    -1,    -1,    -1,  1553,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1562,    -1,   174,
      -1,    -1,   244,    -1,    -1,   425,    -1,    -1,  4400,  3574,
      -1,  4403,  5779,    -1,  5781,    -1,    -1,    -1,   193,    -1,
    5219,    -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,  1594,
      -1,    -1,    -1,    -1,    -1,  1600,  1601,    -1,    -1,  1604,
      -1,    -1,    -1,   285,    -1,    -1,   221,   222,    -1,  3003,
    4238,    -1,  1617,    -1,    -1,  1620,    -1,   299,    -1,    -1,
     302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,    -1,    -1,    -1,   494,    -1,    -1,    -1,    -1,  3644,
      -1,  3646,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,  5292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4493,  4494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,  1676,  4504,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3076,    -1,   299,  1690,  3080,   302,    -1,  4521,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5906,
      -1,  4329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     392,    -1,    -1,  5920,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,  5933,  4355,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3740,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4602,    -1,    -1,  4605,    -1,  5414,    -1,   392,    -1,  3784,
      -1,    -1,    -1,    78,    -1,  5992,  5993,    -1,    -1,  3183,
      -1,    -1,    -1,    -1,    -1,  1800,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3198,    -1,  1811,  3812,    -1,  3203,
      10,    -1,   494,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    38,  3233,
      -1,    -1,    -1,    -1,  6051,    45,    -1,    -1,  1853,  1854,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4497,
      -1,    -1,    -1,  1878,    -1,  3880,    -1,    -1,    78,   494,
    1885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,  3902,   193,    10,
      -1,    -1,    13,   198,    -1,    -1,    17,    18,    19,  5548,
      -1,    -1,    -1,    -1,  5553,  5554,  4544,    -1,    -1,  3924,
      -1,  4549,    -1,    -1,    35,    -1,   221,   222,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,    -1,    -1,  1958,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   819,   820,    78,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,  6192,  1991,  1992,    -1,    -1,
     285,    -1,    -1,   193,    -1,    35,    -1,    -1,   198,    -1,
      -1,  4006,    -1,  2008,   299,    45,  2011,   302,    -1,    -1,
    4842,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,   222,    -1,    -1,    -1,    -1,    -1,  5667,    -1,
      -1,  6238,    -1,    -1,    -1,    -1,    -1,    -1,    78,  6246,
    6247,    -1,    -1,    -1,   244,   899,    -1,    -1,    -1,  6256,
    4055,    -1,    -1,  2683,    -1,  4887,    -1,  2687,  2688,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,  4899,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4080,  4704,  5716,    -1,    -1,
      -1,    -1,   193,    -1,    -1,   285,    -1,   198,  3482,    -1,
      -1,  3485,    -1,  3487,    -1,    -1,    -1,   392,  3492,   299,
      -1,  4933,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     221,   222,    -1,    -1,    -1,    -1,  2746,    -1,    -1,    -1,
      -1,    -1,  2752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   244,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3541,    -1,    -1,
      -1,    -1,    -1,   193,    -1,  3549,    -1,    -1,   198,    -1,
      -1,    -1,    -1,  2793,    -1,    -1,  1020,  1021,    -1,    -1,
      -1,    -1,    -1,    -1,   285,    -1,    -1,    -1,    -1,  5011,
    3574,   221,   222,    -1,    -1,    -1,    -1,    -1,   299,    -1,
      -1,   302,   392,    -1,    -1,    -1,    -1,    -1,  5030,   494,
      -1,  4829,    -1,    -1,   244,    -1,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4870,    -1,    -1,   285,    -1,    -1,    -1,    -1,
    3644,    -1,  3646,    -1,    -1,    -1,    -1,    -1,    -1,   299,
      -1,    -1,   302,    -1,  4892,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   392,    -1,    -1,  5116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4329,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4964,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3740,    -1,    -1,    -1,
    4355,    -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3003,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,   494,    17,    18,    19,    -1,    -1,    -1,
    3784,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,    35,    -1,    -1,  1259,    -1,    -1,    -1,  5241,
      -1,  5243,    45,    -1,    -1,    -1,    -1,    -1,  3812,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1297,    -1,    78,  3076,    -1,    -1,    -1,
    3080,    -1,    -1,    -1,   494,    -1,    -1,  5085,    -1,    -1,
      -1,  5293,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,  1326,  1327,  1328,    -1,  1330,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,  3880,    -1,    -1,    17,
      18,    19,  4497,    -1,    -1,    -1,    -1,  1351,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,  3902,    -1,
      -1,  5343,    10,    -1,    -1,    13,    -1,    45,    -1,    17,
      18,    19,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
    3924,    -1,    -1,    -1,    -1,   168,    -1,    35,  2543,  4544,
      -1,    -1,    -1,    -1,  4549,    -1,    -1,    45,  2553,    -1,
      78,    -1,    -1,  3183,    52,    -1,    -1,    -1,    -1,    -1,
     193,    -1,    -1,    -1,    -1,   198,    -1,    -1,  3198,    -1,
      -1,    -1,    -1,  3203,    -1,    -1,    -1,  2582,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
      -1,  5219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1454,    -1,    -1,  3233,  1458,  1459,    -1,    -1,    -1,    -1,
      -1,   244,  4006,    -1,    -1,    -1,    -1,    -1,    -1,   147,
      10,    -1,    -1,    13,  2629,  2630,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,   285,    -1,    -1,    45,    -1,    -1,  2663,    -1,
      -1,  4055,    52,    -1,  5292,   193,   299,    -1,    -1,   302,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4080,    -1,    78,    -1,
    1343,    -1,    -1,   221,   222,   193,    -1,    -1,    -1,  4704,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5566,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1398,   244,    -1,  5580,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,    -1,   392,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,   299,    -1,    -1,   302,    -1,    -1,    -1,   168,    -1,
    5612,    -1,    -1,    -1,    -1,    35,  5414,   285,    -1,    -1,
      -1,    -1,  2797,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,   299,    52,   193,   302,    -1,    -1,  2812,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4829,    -1,    -1,    -1,    78,  2834,
      -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4238,    -1,    -1,  1701,  1702,  1703,
      -1,    -1,  3482,    -1,   244,  3485,    -1,  3487,    -1,    -1,
      -1,   494,  3492,    -1,   392,  4870,    -1,    -1,    -1,    -1,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
      -1,  5713,    -1,    -1,    -1,    -1,    -1,  4892,    -1,    -1,
      -1,    -1,    -1,    -1,   392,   285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,
      -1,  3541,   302,    -1,    -1,  2920,  2921,    -1,    -1,  3549,
    5548,    -1,    -1,    -1,    -1,  5553,  5554,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4329,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193,  3574,    -1,    -1,  5779,   198,  5781,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4964,
      -1,  4355,    -1,    -1,    -1,    -1,   494,    -1,    -1,    -1,
     468,   221,   222,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   244,    -1,   494,    -1,    -1,    -1,
      -1,    -1,   392,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,  3644,    -1,  3646,  3022,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,    -1,    -1,    -1,  5667,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,
      -1,    -1,   302,    -1,  1707,    -1,    -1,    -1,  1711,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5906,    -1,    -1,    -1,    -1,    -1,
    5085,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5716,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5933,    -1,  4497,   494,    -1,    -1,    -1,    -1,    -1,
    3740,    -1,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   392,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4544,    -1,    -1,    -1,  3784,  4549,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2030,    -1,    -1,    -1,
      -1,    -1,  3812,    -1,    -1,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,    -1,    -1,    -1,  2049,    -1,  2051,    -1,  2053,
      -1,    -1,  2056,  2057,  2058,    -1,    -1,    -1,    -1,    -1,
    2064,    -1,    -1,  2067,  5219,    -1,    -1,    -1,    -1,  6051,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2082,  2083,
    2084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   494,    -1,  2100,    -1,    -1,    -1,
    3880,    -1,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    -1,  3902,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    -1,    33,    34,    -1,    -1,  5292,    -1,    -1,
      -1,    -1,    -1,    -1,  3924,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4704,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3362,    -1,    -1,
    6192,    -1,    -1,    -1,    -1,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,  2028,  4006,    -1,  3383,    -1,
      -1,    -1,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
    2244,    -1,    -1,    -1,    -1,   145,    -1,  2050,    -1,    -1,
      -1,  2054,    -1,   153,    -1,   155,  6238,    -1,    -1,  5414,
      -1,    -1,   162,    -1,    -1,    -1,  2069,  2070,  2071,    -1,
    2073,    -1,    -1,    -1,  6256,  4055,    -1,    -1,    -1,    -1,
     180,    -1,    -1,    -1,    -1,  4829,    -1,    -1,    -1,  2293,
      -1,    -1,    -1,    23,    -1,    -1,    -1,   197,    28,    -1,
    4080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4870,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,
      -1,    -1,  2346,    -1,    -1,    -1,   246,   247,  4892,    79,
      -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,   266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,   284,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5548,    -1,    -1,    -1,    -1,  5553,  5554,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,
    4964,    -1,    -1,    -1,    -1,    -1,    -1,   157,   328,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     170,    -1,   342,    -1,    -1,    -1,   176,    -1,   348,   349,
      -1,   351,    -1,   183,    -1,    -1,   356,    -1,  4238,   359,
      -1,    -1,   362,    -1,    -1,   365,    -1,    -1,    -1,    -1,
      -1,    -1,   372,   203,    -1,    -1,    -1,    -1,    -1,   379,
     380,    -1,    -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,
      -1,   391,    -1,    -1,    -1,    -1,    -1,  3652,    -1,    -1,
      -1,   401,    -1,    -1,    -1,    -1,    -1,  3662,    -1,    -1,
      -1,    -1,  5667,    -1,    -1,    -1,    -1,   417,    -1,  2523,
    2524,  2525,  2526,  2527,  2528,  2529,  2530,  2531,   258,  2533,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,    -1,
    2544,  5085,  2546,    -1,    -1,    -1,    -1,    -1,   448,  4329,
      -1,    -1,    -1,    -1,   454,    -1,    -1,    -1,    -1,   459,
      -1,  5716,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,
      -1,    -1,   472,    -1,    -1,  4355,    -1,    -1,    -1,    -1,
    2584,    -1,   312,    -1,  2588,    -1,    -1,  2591,    -1,  2593,
      -1,    -1,  2596,   323,    -1,    -1,   496,    -1,    -1,    -1,
      -1,    -1,    -1,   333,   334,    -1,    -1,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   515,    -1,    -1,   518,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   364,    -1,    -1,   367,    -1,    -1,
      -1,   371,    -1,    -1,   374,  2649,  2650,    -1,    -1,    -1,
      -1,   381,    -1,    -1,   384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3823,  3824,
    3825,    -1,    -1,   403,    -1,  5219,    -1,    23,    -1,    -1,
     410,    -1,    28,    -1,    -1,  3840,    -1,   417,    -1,    -1,
     420,    -1,    -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   432,    -1,   434,    -1,    -1,    28,    -1,   439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4497,  3873,  3874,
      66,    -1,   452,  3878,    -1,    -1,    -1,    -1,    -1,  2733,
      -1,    -1,    -1,    79,    80,   465,    -1,  2540,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,  5292,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    -1,    -1,    -1,  4544,    -1,    -1,   113,    -1,  4549,
      -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   137,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   157,    -1,    -1,    -1,    -1,   137,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   170,    -1,    -1,   148,    -1,  3984,
     176,    -1,    -1,  2636,    -1,    -1,   157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2648,    -1,    -1,    -1,   170,
    2653,    -1,    -1,    -1,    -1,   176,    -1,   203,    -1,    -1,
      -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   258,    -1,    -1,   236,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4704,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2969,  2970,  2971,    -1,    -1,
      -1,  2975,    -1,    -1,    -1,    -1,    -1,   323,   299,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,   334,    -1,
      -1,   337,  4147,  4148,  4149,    -1,    -1,    -1,  3002,    -1,
      -1,    -1,   323,    -1,  5548,    -1,    -1,    -1,    -1,  5553,
    5554,    -1,   333,   334,    -1,    -1,   337,    -1,   364,    -1,
      -1,   367,    -1,    -1,    -1,   371,    -1,    -1,   374,    -1,
      -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,   384,    -1,
      -1,    -1,    -1,   364,    -1,    -1,   367,    -1,    -1,  4829,
     371,    -1,    -1,   374,    -1,    -1,    -1,   403,    -1,    -1,
     381,    -1,    -1,   384,   410,    -1,    -1,    -1,    -1,    -1,
      -1,   417,    -1,    -1,   420,    -1,    -1,    -1,   424,    -1,
      -1,    -1,   403,    -1,    -1,    -1,   432,    -1,   434,   410,
    4870,    -1,    -1,   439,   415,    -1,   417,    -1,    -1,   420,
      -1,    -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4892,   434,    -1,    -1,    -1,    -1,   439,   465,
      -1,    -1,    -1,  5667,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   465,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5716,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4964,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3211,    -1,    -1,
      -1,    -1,  3216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3274,    -1,  3276,  3277,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3290,    -1,    -1,  3293,
      -1,  3295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5085,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4474,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3332,    -1,
    3334,    -1,  3336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4538,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3214,    -1,    -1,    -1,    -1,    -1,    -1,  4573,    -1,
      -1,    -1,    -1,    -1,  3428,    -1,    -1,    -1,  3231,  3433,
      -1,    -1,    -1,    -1,    -1,  4590,    -1,  3240,    -1,  5219,
      -1,    -1,    -1,  3246,  3448,  3248,    -1,    -1,    -1,    -1,
    3253,  3254,    -1,  3256,    -1,    -1,    -1,    -1,  3261,  3262,
      -1,  3264,    -1,  3266,    -1,    -1,    -1,  3270,    -1,    -1,
    3273,    -1,    -1,    -1,    -1,  3278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3287,    -1,    -1,    -1,    -1,  3292,
      -1,    -1,    -1,    -1,    -1,    -1,  3299,  3300,  3301,  3302,
      -1,    -1,    -1,    -1,  3307,  3308,    -1,  3310,    -1,  3513,
      -1,    -1,  5292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3329,    -1,  3331,    -1,
      -1,    -1,    -1,    -1,    -1,  3338,  3339,  3340,  3341,  3342,
    3343,  3344,  3345,  3346,  3347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4732,  4733,  4734,
    4735,  3384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5414,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3529,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3769,    -1,    -1,  5548,    -1,
      -1,  3775,    -1,  5553,  5554,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3854,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5667,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5078,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5089,    -1,  5716,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3773,  3774,    -1,    -1,    -1,  3778,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4003,
      -1,    -1,    -1,    -1,  3807,    -1,    -1,    -1,  4012,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4026,    -1,    -1,    -1,  4030,  4031,    -1,    -1,
      -1,    -1,  4036,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4046,    -1,  4048,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4075,  4076,  4077,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4102,    -1,
      -1,  4105,    -1,  4107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4123,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4131,  4132,    -1,
      -1,    -1,    -1,    -1,  4138,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4002,
      -1,    -1,    -1,    -1,    -1,  4008,    -1,    -1,    -1,    -1,
      -1,  4215,  5367,    -1,    -1,    -1,    -1,  5372,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4232,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5391,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4052,
    4053,    -1,    -1,  4056,  4057,  4058,  4059,    -1,    -1,  4062,
    4063,  4064,  4065,  4066,  4067,  4068,  4069,  4070,  4071,  4072,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4095,    -1,    -1,  4098,    -1,  4100,    -1,    -1,
    4103,  4104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4125,  4126,  4127,  4128,    -1,  4130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5530,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4197,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4247,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5634,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5662,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4550,  4551,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4561,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4631,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4647,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4662,    -1,
      -1,    -1,    -1,    -1,  4467,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4701,  4702,    -1,
      -1,    -1,    -1,    -1,  4708,  4709,    -1,  4510,    -1,  4713,
      -1,    -1,    -1,    -1,  4718,    -1,    -1,  4721,  4722,    -1,
      -1,    -1,    -1,    -1,  4728,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4782,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4790,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4810,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4632,
      -1,    -1,    -1,  4636,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4658,  4659,    -1,    -1,    -1,
      -1,  4664,  4665,  4666,  4667,    -1,    -1,    -1,  4671,  4672,
    4673,  4674,  4675,  4676,  4677,  4678,  4679,  4680,  4681,  4682,
    4683,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4707,    -1,    -1,  4710,    -1,  4712,
      -1,  4915,    -1,  4716,    -1,    -1,  4719,  4720,  4922,    -1,
    4723,  4724,    -1,    -1,    -1,    -1,  4729,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4781,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4990,    -1,    -1,    -1,
      -1,    -1,  4795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5148,    -1,    -1,    -1,    -1,    -1,
    5154,  5155,  5156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5179,  5180,    -1,    -1,  5183,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4993,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5080,  5081,    -1,
      -1,    -1,    -1,    -1,    -1,  5088,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5131,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5150,  5151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5169,    -1,  5171,    -1,
      -1,    -1,  5175,  5176,  5177,  5178,    -1,    -1,  5181,  5182,
      -1,    -1,    -1,    -1,  5187,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5221,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5245,    -1,    -1,    -1,    -1,  5451,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5314,    -1,  5316,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5542,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5351,    -1,
      -1,    -1,    -1,    -1,  5558,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5600,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5444,    -1,  5446,  5447,  5448,  5449,  5450,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5463,  5464,  5465,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5477,    -1,    -1,  5480,    -1,    -1,
      -1,  5484,    -1,    -1,    -1,    -1,  5690,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5699,  5700,  5701,    -1,  5502,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5517,    -1,    -1,    -1,    -1,    -1,
      -1,  5725,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5870,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5691,  5893,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5903,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5710,    -1,  5712,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5753,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5765,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5974,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5998,    -1,    -1,  5800,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5866,    -1,    -1,    -1,    -1,    -1,    -1,
    5873,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6114,    -1,    -1,    -1,    -1,  5918,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6017,  6018,    -1,    -1,    -1,    -1,
      -1,  6225,    -1,    -1,    -1,    -1,    -1,    -1,  6031,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6073,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6098,     3,    -1,     5,     6,
      -1,     8,     9,    10,    11,    12,  6109,  6110,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,  6168,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,   134,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,    -1,   295,   296,
      -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,    -1,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
      -1,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,    -1,    -1,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,    -1,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,   494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,
     507,   508,    -1,    -1,    -1,    -1,    -1,    -1,   515,   516,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,    -1,    -1,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,   452,
      -1,   454,   455,   456,   457,   458,   459,   460,    -1,   462,
     463,   464,   465,   466,   467,    -1,    -1,   470,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,   494,    -1,   496,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   506,   507,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   515,   516,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,    -1,   295,   296,    -1,    -1,
     299,   300,   301,    -1,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
      -1,    -1,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,   452,    -1,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,   463,   464,   465,   466,   467,    -1,
      -1,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,   507,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   515,   516,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    -1,
     295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,    -1,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,    -1,    -1,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,   452,    -1,   454,
     455,   456,   457,   458,   459,   460,    -1,   462,   463,   464,
     465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    -1,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   506,   507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     515,   516,     3,    -1,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,   494,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   515,   516,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
      -1,    -1,   246,   247,   248,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,    -1,   283,
     284,    -1,   286,    -1,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,    -1,   308,    -1,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,    -1,    -1,   418,    -1,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,    -1,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,    -1,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   516,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      -1,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,    -1,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,   232,   233,   234,   235,   236,
     237,    -1,    -1,   240,    -1,   242,   243,   244,    -1,   246,
     247,   248,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,    -1,   281,    -1,   283,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,    -1,   295,   296,
      -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,    -1,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,    -1,   322,   323,    -1,   325,    -1,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,    -1,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,    -1,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,   412,    -1,   414,   415,    -1,
      -1,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,    -1,    -1,   431,   432,    -1,   434,    -1,    -1,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,   465,   466,
     467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   490,   491,   492,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   516,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,    -1,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,    -1,   325,    -1,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,    -1,   434,    -1,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,    -1,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
     490,   491,   492,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,   516,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,    -1,    -1,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,   452,
      -1,   454,   455,   456,   457,   458,   459,   460,    -1,   462,
     463,   464,   465,   466,   467,    -1,    -1,   470,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,   494,    -1,   496,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   506,   507,    -1,    -1,    -1,     3,    -1,
       5,     6,   515,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    -1,
     295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,   329,    -1,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
      -1,   426,   427,   428,    -1,    -1,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,   452,    -1,   454,
     455,   456,   457,   458,   459,   460,    -1,   462,   463,   464,
     465,   466,   467,    -1,    -1,   470,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,    -1,   494,
      -1,   496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   506,   507,    -1,    -1,    -1,     3,    -1,     5,     6,
     515,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,    -1,   295,   296,
      -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,    -1,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,   416,
      -1,   418,   419,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,    -1,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,   463,   464,   465,   466,
     467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,   494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,
     507,    -1,    -1,    -1,     3,    -1,     5,     6,   515,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    36,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,    -1,   295,   296,    -1,    -1,
     299,   300,   301,    -1,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
      -1,    -1,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,   452,    -1,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,   463,   464,   465,   466,   467,    -1,
      -1,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,   507,    -1,
      -1,    -1,     3,    -1,     5,     6,   515,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    36,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,   452,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    -1,
       3,    -1,     5,     6,   515,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,    -1,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,    -1,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,   414,   415,   416,    -1,   418,   419,   420,   421,   422,
     423,   424,    -1,   426,   427,   428,    -1,    -1,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,   452,
      -1,   454,   455,   456,   457,   458,   459,   460,    -1,   462,
     463,   464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
      -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   506,   507,    -1,    -1,    -1,    -1,    -1,
     513,   514,   515,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   506,   507,   508,    -1,
      -1,     3,    -1,     5,     6,   515,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    -1,     3,
      -1,     5,     6,   515,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   506,   507,    -1,    -1,    -1,     3,    -1,     5,
       6,   515,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     506,   507,    -1,    -1,    -1,     3,    -1,     5,     6,   515,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,   507,
      -1,    -1,    -1,     3,    -1,     5,     6,   515,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,
      -1,     3,    -1,     5,     6,   515,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    -1,     3,
      -1,     5,     6,   515,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   506,   507,    -1,    -1,    -1,     3,    -1,     5,
       6,   515,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     506,   507,    -1,    -1,    -1,     3,    -1,     5,     6,   515,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,   507,
      -1,    -1,    -1,     3,    -1,     5,     6,   515,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,
      -1,     3,    -1,     5,     6,   515,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    -1,     3,
      -1,     5,     6,   515,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,   446,   447,   448,   449,   450,   451,   452,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   506,   507,    -1,    -1,    -1,     3,    -1,     5,
       6,   515,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     506,   507,    -1,    -1,    -1,     3,    -1,     5,     6,   515,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,   446,   447,
     448,   449,   450,   451,   452,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,   494,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,   507,
      -1,    -1,    -1,     3,    -1,     5,     6,   515,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,
      -1,     3,    -1,     5,     6,   515,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,   446,   447,   448,   449,   450,   451,
     452,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    -1,     3,
      -1,     5,     6,   515,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,   452,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   506,   507,     3,    -1,     5,     6,    -1,     8,
       9,   515,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,    -1,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,    -1,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,    -1,   295,   296,    -1,    -1,
     299,   300,   301,    -1,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
      -1,    -1,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,   451,   452,    -1,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,   463,   464,   465,   466,   467,    -1,
      -1,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   506,   507,     3,
      -1,     5,     6,    -1,     8,     9,   515,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,   452,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,
       8,     9,    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,   515,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,   451,   452,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,   515,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
     452,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,    -1,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,   298,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,   433,   434,   435,
      -1,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,   464,   465,
     466,   467,    -1,    -1,   470,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
     496,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,   298,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   515,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,    -1,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,   452,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   515,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,    -1,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,   451,   452,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
      -1,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,    -1,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
     452,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,    -1,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,    -1,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,    -1,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,   433,   434,   435,
      -1,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,   463,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,   297,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   506,   507,   508,    -1,
      -1,    -1,    -1,    -1,    -1,   515,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,   247,   248,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,    -1,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,    -1,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
      -1,    -1,   496,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   515,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,    -1,   246,   247,
     248,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,    -1,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,    -1,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,    -1,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
      -1,   243,    -1,    -1,   246,   247,   248,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
      -1,   283,   284,    -1,   286,    -1,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,    -1,   308,    -1,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,    -1,   417,   418,    -1,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,    -1,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,    -1,   464,   465,   466,   467,    -1,    -1,   470,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,   496,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,   241,    -1,   243,    -1,    -1,
     246,   247,   248,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,    -1,   283,   284,    -1,
     286,    -1,   288,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,   298,   299,   300,   301,    -1,    -1,   304,   305,
     306,    -1,   308,    -1,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
      -1,   417,   418,    -1,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,   433,   434,   435,
      -1,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,    -1,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   515,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,   241,    -1,   243,
      -1,    -1,   246,   247,   248,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,    -1,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,    -1,   283,
     284,    -1,   286,    -1,   288,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,   306,    -1,   308,    -1,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,    -1,    -1,   418,    -1,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,   433,
     434,   435,    -1,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,   459,   460,    -1,   462,    -1,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   515,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,    -1,   243,    -1,    -1,   246,   247,
     248,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,    -1,   283,   284,    -1,   286,    -1,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,    -1,
     308,    -1,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,    -1,    -1,
     418,    -1,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,    -1,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,    -1,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
      -1,   243,    -1,    -1,   246,   247,   248,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
      -1,   283,   284,    -1,   286,    -1,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,    -1,   308,    -1,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,    -1,    -1,   418,    -1,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,    -1,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,    -1,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,    -1,
      -1,    -1,    -1,   515,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,    -1,   155,   156,   157,   158,    -1,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,    -1,
     183,    -1,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,   232,
     233,   234,   235,   236,   237,   238,   239,   240,    -1,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,    -1,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,    -1,   325,    -1,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
      -1,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   490,   491,   492,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,     5,     6,    -1,    -1,    -1,    10,    11,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,    -1,   183,
      -1,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,   232,   233,
     234,   235,   236,   237,   238,   239,   240,    -1,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
      -1,   325,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,    -1,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   490,   491,   492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    -1,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,    -1,   164,
     165,   166,   167,    -1,   169,   170,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,    -1,   263,   264,
      -1,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    -1,
     295,   296,    -1,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,    -1,    -1,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,    -1,   463,   464,
     465,   466,   467,   468,    -1,   470,    -1,    -1,    -1,    -1,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,    -1,   491,   492,    -1,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,   241,    -1,   243,    -1,    -1,
     246,   247,   248,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,    -1,   283,   284,    -1,
     286,    -1,   288,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
     306,    -1,   308,    -1,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
      -1,    -1,   418,    -1,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,   433,   434,   435,
      -1,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,   459,   460,    -1,   462,    -1,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,    -1,    -1,   240,   241,    -1,   243,    -1,    -1,   246,
     247,   248,    -1,    -1,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,    -1,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,    -1,   283,   284,    -1,   286,
      -1,   288,   289,   290,   291,   292,   293,    -1,   295,   296,
      -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,   306,
      -1,   308,    -1,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,    -1,   322,   323,   324,   325,   326,
     327,   328,   329,    -1,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,    -1,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,    -1,   381,   382,   383,   384,   385,    -1,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
      -1,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,    -1,   414,   415,    -1,
      -1,   418,    -1,   420,   421,   422,   423,   424,    -1,   426,
     427,   428,    -1,    -1,   431,   432,   433,   434,   435,    -1,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,   459,   460,    -1,   462,    -1,   464,   465,   466,
     467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,   241,    -1,   243,    -1,    -1,   246,   247,
     248,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,    -1,   283,   284,    -1,   286,    -1,
     288,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,   306,    -1,
     308,    -1,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,    -1,    -1,
     418,    -1,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,   433,   434,   435,    -1,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,   459,   460,    -1,   462,    -1,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,    -1,
      -1,   240,   241,    -1,   243,    -1,    -1,   246,   247,   248,
      -1,    -1,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,    -1,   283,   284,    -1,   286,    -1,   288,
     289,   290,   291,   292,   293,    -1,   295,   296,    -1,    -1,
     299,   300,   301,    -1,    -1,   304,   305,   306,    -1,   308,
      -1,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
     329,    -1,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,    -1,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,    -1,   381,   382,   383,   384,   385,    -1,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,    -1,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,    -1,   414,   415,    -1,    -1,   418,
      -1,   420,   421,   422,   423,   424,    -1,   426,   427,   428,
      -1,    -1,   431,   432,   433,   434,   435,    -1,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
     459,   460,    -1,   462,    -1,   464,   465,   466,   467,    -1,
      -1,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,    -1,   283,   284,    -1,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,    -1,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,   241,
      -1,   243,    -1,    -1,   246,   247,   248,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
      -1,   283,   284,    -1,   286,    -1,   288,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,   306,    -1,   308,    -1,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,    -1,    -1,   418,    -1,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,   433,   434,   435,    -1,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,    -1,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,    -1,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,    -1,   325,    -1,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,    -1,   434,    -1,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     490,   491,   492,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,   508,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,   156,   157,   158,    -1,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,    -1,
      -1,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
      -1,   242,   243,   244,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,    -1,
     281,    -1,   283,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,    -1,   295,   296,    -1,    -1,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,    -1,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,    -1,   325,    -1,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,   412,    -1,   414,   415,    -1,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,    -1,   434,    -1,    -1,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   490,
     491,   492,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,   508,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,    -1,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,    -1,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,    -1,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,   297,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,    -1,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,   174,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,    -1,   283,   284,    -1,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,    -1,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   506,   507,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,   247,   248,    -1,    -1,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,    -1,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,    -1,   295,   296,    -1,    -1,   299,   300,
     301,    -1,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,    -1,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,    -1,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,    -1,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,    -1,   414,   415,    -1,    -1,   418,   419,   420,
     421,   422,   423,   424,    -1,   426,   427,   428,    -1,    -1,
     431,   432,   433,   434,   435,    -1,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
     451,    -1,    -1,   454,   455,   456,   457,   458,   459,   460,
      -1,   462,   463,   464,   465,   466,   467,    -1,    -1,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,     5,     6,    -1,     8,     9,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,   297,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,   446,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
     180,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,   298,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,   417,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,   417,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,   298,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,   417,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,   298,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,   452,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,   298,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,   298,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,   417,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,    -1,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,    -1,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,   241,    -1,   243,    -1,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,   286,    -1,   288,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,    -1,   308,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,    -1,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
      -1,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,    -1,    -1,   418,    -1,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,   433,   434,   435,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,   459,
     460,    -1,   462,    -1,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,    -1,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,   306,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,    -1,   325,    -1,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,    -1,   434,    -1,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     490,   491,   492,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,    -1,   242,   243,
     244,    -1,   246,   247,   248,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,    -1,   281,    -1,   283,
     284,   285,   286,   287,    -1,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,    -1,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
      -1,   325,    -1,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,    -1,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,    -1,
     434,    -1,    -1,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   490,   491,   492,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,    -1,   242,   243,   244,    -1,   246,   247,
     248,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,    -1,   283,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,    -1,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,    -1,   325,    -1,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,    -1,   414,   415,    -1,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,    -1,   434,    -1,    -1,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   490,   491,   492,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,    -1,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
      -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,    -1,
     242,   243,   244,    -1,   246,   247,   248,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
      -1,   283,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,    -1,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,    -1,   325,    -1,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,    -1,   414,   415,    -1,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,    -1,   434,    -1,    -1,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   490,   491,
     492,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,    -1,    -1,   161,    -1,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,    -1,    -1,    -1,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,    -1,   242,   243,   244,    -1,
     246,   247,   248,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,    -1,   281,    -1,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
      -1,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,    -1,   325,
      -1,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,    -1,   414,   415,
      -1,    -1,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,    -1,   434,    -1,
      -1,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   490,   491,   492,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,    -1,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,    -1,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,    -1,   325,    -1,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,   427,   428,    -1,
      -1,   431,   432,    -1,   434,    -1,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     490,   491,   492,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,   232,   233,
     234,   235,   236,   237,    -1,    -1,   240,    -1,   242,   243,
     244,    -1,   246,   247,   248,    -1,    -1,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,    -1,   281,    -1,   283,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
      -1,   295,   296,    -1,    -1,   299,   300,   301,    -1,    -1,
     304,   305,    -1,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,    -1,   322,   323,
      -1,   325,    -1,   327,   328,   329,    -1,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,    -1,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,    -1,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,   412,    -1,
     414,   415,    -1,    -1,   418,   419,   420,   421,   422,   423,
     424,    -1,   426,   427,   428,    -1,    -1,   431,   432,    -1,
     434,    -1,    -1,   437,   438,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,   451,    -1,    -1,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,   465,   466,   467,    -1,    -1,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   490,   491,   492,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,   232,   233,   234,   235,   236,   237,
      -1,    -1,   240,    -1,   242,   243,   244,    -1,   246,   247,
     248,    -1,    -1,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,    -1,   281,    -1,   283,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,    -1,   295,   296,    -1,
      -1,   299,   300,   301,    -1,    -1,   304,   305,    -1,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,    -1,   325,    -1,   327,
     328,   329,    -1,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,    -1,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,    -1,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,   412,    -1,   414,   415,    -1,    -1,
     418,   419,   420,   421,   422,   423,   424,    -1,   426,   427,
     428,    -1,    -1,   431,   432,    -1,   434,    -1,    -1,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,   451,    -1,    -1,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,   465,   466,   467,
      -1,    -1,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   490,   491,   492,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,    -1,   155,   156,   157,   158,    -1,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
      -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
     232,   233,   234,   235,   236,   237,    -1,    -1,   240,    -1,
     242,   243,   244,    -1,   246,   247,   248,    -1,    -1,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,    -1,   281,
      -1,   283,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,    -1,   295,   296,    -1,    -1,   299,   300,   301,
      -1,    -1,   304,   305,    -1,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,    -1,   325,    -1,   327,   328,   329,    -1,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,    -1,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,    -1,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
     412,    -1,   414,   415,    -1,    -1,   418,   419,   420,   421,
     422,   423,   424,    -1,   426,   427,   428,    -1,    -1,   431,
     432,    -1,   434,    -1,    -1,   437,   438,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,   451,
      -1,    -1,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,    -1,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   490,   491,
     492,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,    -1,   155,
     156,   157,   158,    -1,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,    -1,    -1,    -1,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,   232,   233,   234,   235,
     236,   237,    -1,    -1,   240,    -1,   242,   243,   244,    -1,
     246,   247,   248,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,    -1,   281,    -1,   283,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,    -1,   295,
     296,    -1,    -1,   299,   300,   301,    -1,    -1,   304,   305,
      -1,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,    -1,   325,
      -1,   327,   328,   329,    -1,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,    -1,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
      -1,   387,   388,    -1,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,   412,    -1,   414,   415,
      -1,    -1,   418,   419,   420,   421,   422,   423,   424,    -1,
     426,   427,   428,    -1,    -1,   431,   432,    -1,   434,    -1,
      -1,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,   451,    -1,    -1,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,   465,
     466,   467,    -1,    -1,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   490,   491,   492,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    -1,    54,    -1,    -1,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    -1,
      -1,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,    -1,    -1,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,    -1,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
      -1,   211,   212,   213,   214,    -1,    -1,    -1,    -1,    -1,
     220,   221,   222,   223,   224,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   232,   233,   234,   235,   236,   237,    -1,    -1,
     240,    -1,   242,   243,   244,    -1,   246,   247,   248,    -1,
      -1,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
      -1,   281,    -1,   283,   284,   285,   286,    -1,    -1,   289,
      -1,   291,   292,   293,    -1,   295,   296,    -1,    -1,   299,
     300,   301,    -1,    -1,   304,   305,    -1,   307,   308,   309,
      -1,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,    -1,   325,    -1,   327,   328,   329,
      -1,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,    -1,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,    -1,   387,   388,    -1,
     390,   391,   392,   393,   394,    -1,   396,    -1,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,   412,    -1,   414,   415,    -1,    -1,   418,   419,
     420,   421,   422,   423,   424,    -1,   426,    -1,    -1,    -1,
      -1,   431,   432,    -1,   434,    -1,    -1,   437,   438,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,   451,    -1,    -1,   454,   455,   456,   457,   458,    -1,
      -1,    -1,   462,   463,   464,   465,   466,   467,    -1,    -1,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     490,   491,   492
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    96,    98,   115,   118,   133,   135,   139,   145,
     153,   155,   162,   180,   197,   246,   247,   252,   266,   284,
     328,   342,   348,   349,   351,   356,   362,   365,   372,   379,
     380,   387,   391,   401,   417,   437,   448,   454,   459,   472,
     496,   498,   499,   500,   501,   502,   515,   522,   523,   524,
     525,   530,   531,   537,   538,   540,   541,   542,   543,   545,
     548,   560,   565,   566,   569,   570,   571,   590,   593,   594,
     609,   659,   662,   663,   666,   669,   670,   671,   679,   686,
     688,   689,   692,   695,   696,   700,   709,   713,   714,   715,
     718,   720,   721,   722,   723,   731,   733,   753,   757,   759,
     760,   770,   772,   779,   780,   783,   784,   785,   786,   787,
     796,   798,   800,   803,   807,   808,   818,   819,   824,   829,
     840,   872,   875,   876,   877,   882,   885,   887,   889,   891,
     892,   896,   897,   900,   902,   903,   907,   908,   909,   912,
     913,   914,   915,   916,   923,   925,   926,   927,   928,   934,
     936,   937,   943,   944,   945,   948,   949,   950,   951,   953,
     954,   956,   957,   959,   960,   962,   974,   976,   979,   981,
     982,   991,   993,   998,  1003,  1011,  1015,  1016,  1017,  1018,
    1019,  1020,  1026,  1062,   431,   475,   929,    28,    79,    95,
     113,   119,   137,   148,   157,   170,   176,   183,   203,   236,
     258,   299,   323,   333,   334,   337,   364,   367,   371,   374,
     381,   384,   403,   410,   415,   417,   420,   424,   434,   439,
     452,   465,   685,   929,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    31,    32,    40,    41,    42,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    58,    59,    60,    61,    62,    63,    64,
      67,    68,    69,    70,    71,    73,    74,    75,    76,    77,
      79,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    92,    93,    94,    95,    96,    97,    99,   100,   101,
     102,   106,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   120,   122,   123,   124,   125,   126,   127,   128,   130,
     131,   132,   133,   136,   137,   138,   139,   140,   142,   143,
     144,   146,   147,   148,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   161,   163,   164,   165,   166,   167,
     169,   171,   172,   173,   175,   176,   177,   178,   179,   181,
     182,   184,   185,   186,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   199,   200,   201,   202,   203,   204,
     205,   206,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   218,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     240,   241,   242,   243,   244,   246,   247,   248,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   283,
     284,   285,   286,   288,   289,   290,   291,   292,   293,   295,
     296,   299,   300,   301,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   322,   323,   324,   325,   326,   327,   328,   329,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   381,   382,   383,   384,
     385,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   414,   415,   418,   419,
     420,   421,   422,   423,   424,   426,   427,   428,   431,   432,
     433,   434,   435,   437,   438,   439,   440,   441,   442,   443,
     444,   447,   448,   449,   450,   451,   454,   455,   456,   457,
     458,   459,   460,   462,   463,   464,   465,   466,   467,   470,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
    1124,  1208,  1220,  1221,  1225,  1226,  1227,     3,    29,  1012,
    1205,  1220,  1225,   463,   515,   967,   297,   329,   929,    54,
     515,   601,    23,    41,    66,    79,   113,   119,   137,   148,
     157,   170,   179,   183,   248,   299,   302,   323,   337,   364,
     374,   384,   403,   410,   420,   421,   423,   424,   439,   446,
     449,   452,   610,   668,   775,   830,   841,    29,   328,  1205,
    1012,    29,   322,   382,   421,   423,     6,   235,   883,   884,
    1211,    23,    28,    66,    79,    95,   113,   137,   148,   157,
     170,   176,   183,   203,   258,   299,   312,   323,   334,   337,
     364,   367,   371,   374,   381,   384,   403,   410,   417,   420,
     424,   432,   434,   439,   452,   465,   685,   788,   790,   791,
     929,  1205,    98,   463,   515,   663,   666,   669,   962,   975,
     979,   982,   991,   998,  1003,  1011,  1015,    11,    22,    29,
      49,   165,   172,   174,   198,   237,   273,   331,   350,   506,
     507,   804,   805,  1012,  1210,  1212,    29,    31,    98,   346,
     380,   809,   810,   811,  1220,   170,  1220,  1207,  1211,   417,
    1029,   804,  1220,   431,  1205,   312,   258,   515,   895,   372,
    1220,    29,   385,   427,   431,   552,   561,   562,  1220,   180,
     809,   810,  1220,   329,   929,  1220,   234,    29,   134,  1031,
    1032,    67,    92,   248,   268,   364,   374,   385,   427,   431,
     478,   549,   550,   551,   552,    29,   385,   427,   431,   552,
     431,   298,  1074,  1075,  1203,  1220,  1029,   508,  1220,   175,
     515,   968,   515,   344,  1021,  1022,  1205,  1021,     3,    53,
      55,    56,    69,    70,   116,   117,   138,   166,   215,   216,
     218,   225,   269,   271,   290,   341,   389,   395,   427,   428,
     460,  1097,  1099,  1101,  1103,  1105,  1107,  1108,  1109,  1111,
    1112,  1113,  1115,  1116,  1120,  1221,  1225,  1031,  1032,  1033,
    1216,    12,  1217,  1218,  1220,  1217,  1217,  1016,  1017,  1020,
       0,   518,   515,   967,   149,   217,   303,   445,  1034,  1035,
    1016,  1018,  1019,   124,   213,   260,   451,   519,    35,   933,
     857,  1208,   793,  1220,   793,  1205,   332,   793,   434,  1205,
     112,   417,   845,  1208,  1220,  1227,     3,   105,   109,   386,
    1213,  1214,  1222,  1225,  1226,  1227,    29,   192,  1203,   291,
     465,    10,    17,    18,    19,    74,   161,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   879,   881,  1155,  1156,
    1220,   192,  1205,   845,  1205,    29,  1213,  1214,   845,  1205,
    1205,   192,  1203,  1205,   192,   793,  1205,   356,   387,    29,
     192,  1074,  1205,   377,  1205,   793,    29,   255,  1213,  1214,
     192,  1203,   235,   121,   223,   282,   340,   930,   931,   932,
     515,   513,   517,  1181,  1183,   493,   961,   962,   963,   964,
    1222,  1203,  1205,  1220,    28,    66,    80,    91,   113,   137,
     176,   203,   236,   299,   334,   364,   367,   410,   420,   432,
     439,   788,   789,   790,   791,  1211,   933,   978,   982,   991,
     998,  1003,  1015,  1203,   261,   793,   515,   192,   793,  1205,
     793,   434,   192,  1205,   112,   417,   421,   423,  1213,  1214,
     421,   423,    74,   161,   879,   354,  1205,  1205,  1213,   192,
     526,  1220,   192,  1205,   192,   527,   793,  1205,  1205,   377,
     793,   255,  1213,   344,   381,   417,   465,   258,    95,   203,
      28,    91,   176,   334,   371,   432,   434,   438,   680,    29,
    1205,  1013,   559,  1211,  1222,   884,   261,   192,   857,   858,
     192,   888,   192,  1205,   192,   795,  1097,   434,   112,   417,
     192,   844,   845,   192,  1214,  1215,    87,   465,    74,   161,
     192,   880,   881,    59,   192,   844,   192,  1215,   192,   844,
     192,  1205,   192,  1205,   377,   888,   192,   795,   192,   255,
    1215,   235,   192,   792,   793,   192,  1204,  1205,   192,  1205,
     933,   515,   980,   610,   975,   459,   961,   967,  1212,   805,
     806,    29,   806,  1212,   806,    29,   806,  1212,   806,   806,
     806,  1212,  1210,  1210,  1012,   806,   332,   515,   415,   515,
     636,   636,   636,   297,   429,   519,   636,   374,  1074,  1076,
     519,   924,  1211,   515,   977,    59,   465,   961,   113,   203,
     374,   415,   417,   893,   894,  1220,    48,   492,   223,   517,
     300,   297,   174,   300,  1211,   429,   933,   168,   801,   297,
       5,     8,     9,    10,    12,    37,    53,    55,    56,    65,
      66,    69,    70,    77,    79,   103,   104,   105,   106,   107,
     108,   109,   116,   117,   119,   154,   159,   160,   166,   182,
     184,   215,   216,   218,   225,   226,   227,   228,   229,   230,
     231,   241,   249,   250,   269,   271,   280,   282,   287,   288,
     290,   299,   310,   324,   341,   369,   386,   395,   411,   416,
     427,   428,   433,   435,   436,   446,   452,   460,   480,   481,
     482,   483,   485,   486,   487,   488,   494,   506,   507,   508,
     515,  1016,  1100,  1103,  1106,  1107,  1108,  1110,  1111,  1112,
    1115,  1116,  1120,  1121,  1123,  1124,  1125,  1127,  1151,  1152,
    1153,  1157,  1175,  1180,  1197,  1200,  1201,  1208,  1209,  1210,
    1211,  1220,  1199,  1200,  1211,    29,   567,  1202,  1203,   385,
     549,   119,   558,  1211,   559,  1211,    48,    71,   549,   492,
     396,   931,   300,   174,   429,   505,    48,   492,   223,   932,
     515,  1203,   508,  1183,  1076,   961,   173,   969,  1121,  1160,
    1021,   519,   515,   970,   462,  1114,  1114,  1114,   515,  1102,
    1102,   326,   515,  1104,    69,    70,  1114,  1102,  1099,   496,
     497,   515,  1117,   515,  1117,    37,  1098,   515,   114,   190,
     262,   265,   378,   490,   515,  1118,  1119,   517,   794,  1102,
    1199,  1184,   516,   516,   524,   961,   971,   972,   973,  1203,
      29,   134,  1030,  1030,    59,  1030,   162,   168,   245,   294,
    1038,  1040,  1041,  1056,  1058,  1059,  1060,  1034,  1035,   174,
     219,   219,  1074,  1077,   515,    68,   278,   313,   352,   387,
     515,   855,   313,   348,   352,   387,   794,   313,   352,   387,
       3,    90,   143,   251,   313,   348,   352,   387,   420,   422,
     472,   560,   563,   938,   939,   940,   941,   825,    25,   139,
     313,   352,   387,   456,   576,  1205,    25,   139,   387,   451,
     544,   476,   192,  1074,    62,    97,   158,   195,   240,   278,
     282,   313,   314,   352,   361,   370,   379,   387,   399,   408,
     412,   467,   560,   564,   861,   873,   901,   515,   842,  1183,
     352,   544,   198,   154,    25,    31,    46,    76,   132,   139,
     142,   169,   205,   278,   282,   292,   301,   313,   352,   355,
     356,   387,   456,   572,   574,   575,   703,   901,     5,   506,
     507,   677,  1212,    29,   192,  1203,   793,   793,   515,   878,
     313,   387,   517,   154,   297,   313,   352,   387,   873,   901,
      25,   139,   313,   352,   387,   198,   539,   352,   472,   496,
     532,   539,   313,   352,   387,   873,   901,   297,   313,   352,
     154,    38,    60,   111,   201,   259,   263,   278,   312,   352,
     357,   381,   387,   401,   572,   674,   675,   313,   352,   464,
     703,   711,   154,   313,   352,   387,    25,    90,   132,   139,
     142,   313,   348,   352,   387,   394,   562,   550,   552,   198,
     154,    46,   130,   278,   352,   387,   572,   573,   313,   352,
     356,   387,    88,   131,   316,   422,   297,    25,    31,   139,
     313,   352,   387,   591,   592,   539,   168,   352,   532,   539,
     154,   352,   387,   572,  1205,   243,   121,   298,   477,   519,
     930,    29,   134,   461,   508,   516,   850,  1121,  1161,  1162,
    1221,  1121,  1182,     3,    29,    33,    34,    35,    36,    37,
      38,    39,    43,    57,    65,    66,    72,    78,    80,    91,
      98,   103,   104,   105,   107,   108,   109,   119,   121,   129,
     134,   135,   141,   145,   149,   160,   162,   168,   170,   174,
     180,   183,   187,   198,   207,   217,   219,   238,   239,   245,
     249,   250,   282,   287,   294,   297,   298,   302,   303,   321,
     330,   346,   360,   380,   386,   397,   413,   416,   417,   425,
     429,   430,   436,   445,   446,   452,   453,   461,   468,   469,
     471,   472,   508,  1206,  1223,  1225,  1226,  1227,  1228,  1181,
     516,   519,   160,   297,   436,   556,   559,   677,   965,   453,
     958,   297,   857,   515,   793,  1205,  1097,   845,   291,    74,
     161,   881,   845,   845,   168,  1097,   793,  1205,  1205,   516,
     636,  1205,    72,  1097,   282,   174,   515,   761,   532,    38,
     952,  1205,   282,   532,   476,   192,  1203,   532,   793,   793,
     761,   449,   610,   297,   168,   472,   869,   532,   282,    48,
     546,   282,   439,   710,   282,   970,    90,   313,   687,    88,
     131,   316,   422,    38,   761,   168,   192,   532,   465,   192,
    1203,   192,   664,  1203,  1203,   465,   793,    87,   528,  1208,
     434,  1208,  1208,  1205,   168,  1205,   685,    40,    54,   110,
     212,   278,   376,   154,    63,   358,   519,   529,   154,   515,
     154,   532,   154,   519,   529,   476,   154,   519,   529,   154,
     519,   192,   792,   192,   793,   192,   793,   154,   519,   529,
    1215,   154,   529,   154,   154,   529,   154,   529,   154,    88,
     131,   316,   422,   168,   154,   529,   154,   168,   192,   154,
     519,   529,   154,   519,   529,   154,   297,  1160,   417,   516,
     975,   806,  1012,   806,  1012,   806,  1012,   806,  1012,   806,
    1012,  1012,  1012,   806,  1012,   515,   637,   638,  1220,   637,
      29,   113,   137,   170,   176,   235,   236,   315,   334,   367,
     374,   381,   417,   420,   439,   814,  1202,  1215,   811,  1205,
     198,   519,   994,  1211,  1097,  1164,    38,  1215,   528,   516,
     528,   528,   528,   243,  1220,   168,   814,  1215,   168,   372,
    1220,   559,   297,   515,  1184,   513,  1016,  1165,  1121,  1179,
     515,   515,   168,   515,   515,  1016,   515,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
    1121,   515,   515,   515,   515,   515,   515,   515,   515,   289,
     626,   515,   515,   515,   515,   515,   515,   515,   515,  1121,
    1121,  1121,  1016,  1121,  1160,  1183,  1211,   515,  1211,     3,
      10,    13,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   164,   165,   166,   167,   169,   170,   171,   172,   173,
     175,   176,   177,   178,   179,   181,   182,   184,   185,   186,
     188,   189,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   218,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     263,   264,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     295,   296,   298,   299,   300,   301,   302,   304,   305,   306,
     307,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   463,   464,
     465,   466,   467,   468,   470,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     491,   492,   494,   503,   504,   505,   506,   507,   508,   509,
     510,   511,  1155,  1157,  1159,  1224,  1229,   473,  1138,   309,
    1121,   163,  1139,   219,   519,  1027,   515,  1211,  1183,  1027,
     122,   194,   568,   519,    71,   119,   559,    38,     3,   119,
     248,   557,   677,  1116,  1211,  1211,    93,   136,  1133,   102,
     119,   553,   554,   556,   677,   119,   553,   243,  1203,    94,
     357,   797,   516,   967,    35,    45,    52,    78,   193,   198,
     221,   244,   299,   302,   392,   516,   519,  1022,  1204,    38,
     515,  1160,  1210,  1114,  1114,    37,  1098,   427,   427,  1210,
    1210,   513,   513,  1210,   429,   429,   429,   515,   429,  1210,
    1206,   517,  1102,   174,  1063,    15,   505,  1181,  1219,   516,
     519,   970,  1018,  1018,  1036,  1037,  1121,  1018,   165,   273,
    1047,   232,   278,   340,   390,   451,    29,  1042,  1121,   506,
     507,  1043,  1044,  1121,  1123,  1056,  1057,  1041,  1040,  1038,
    1039,   168,  1059,   292,  1061,  1038,  1056,  1077,   983,  1203,
    1077,    38,  1220,   387,  1160,    68,   429,   429,   374,   198,
     210,   303,   306,   389,   461,   508,   848,   849,   850,   852,
     854,   856,  1097,  1221,   429,   464,   429,   374,   429,   429,
     374,   245,   429,    79,   429,   420,   549,   313,   938,   940,
     505,   942,   168,   180,   198,   362,   826,   827,    72,    91,
     150,   170,   282,   330,   446,   632,   633,    91,   119,   282,
     429,    91,   429,   119,   282,   374,    91,   132,   142,   313,
     352,   758,   374,   693,    28,    66,   137,   176,   299,   334,
     367,   432,   439,   788,   789,  1205,   154,   352,   387,   572,
     297,   677,   379,   240,   429,  1220,   429,   287,   677,   123,
     220,   374,   385,   431,   551,   793,   358,   387,   861,   874,
     127,   516,   843,   848,   429,   452,   420,  1203,    80,   150,
     192,   617,   632,  1220,    80,    91,   898,   318,   297,   369,
     371,   434,    91,   898,    32,   355,   369,   371,   434,   369,
    1203,   169,   205,   292,   793,   515,   429,   429,   191,   515,
     580,    23,   254,   420,   449,   474,   580,    91,   519,   127,
       5,     5,   313,   198,   154,   352,   387,   572,   901,   453,
     453,   279,  1097,   429,   374,   515,   879,  1205,  1203,   429,
     429,   374,   874,   127,   106,   417,   418,   910,   911,  1075,
    1203,  1220,   911,   429,   429,   761,   911,   113,   387,   563,
     429,   534,   563,   429,   429,   374,   874,   127,  1203,   429,
     429,  1203,  1099,   677,    59,   676,   677,   677,   111,   259,
     263,    59,   429,   532,   267,   374,   532,   278,   675,   429,
     429,   287,  1211,   703,   793,   429,   429,   374,   403,   337,
    1211,   337,   429,   337,   429,   337,   761,   761,   420,  1074,
     318,   318,    91,   429,   898,   374,   429,   429,   580,   580,
     793,   793,   793,   793,  1203,    47,   458,    47,    47,   458,
     429,    47,   429,   458,   374,   515,   519,   563,   452,   719,
    1214,   429,   534,   563,  1203,   429,   898,   374,   313,   352,
     340,   353,   383,   555,   930,  1161,  1161,  1162,   516,    15,
      16,   519,  1034,  1035,   514,   520,  1203,   963,  1205,  1203,
     221,  1097,   221,   297,   221,   221,   677,   793,   793,   221,
     221,   221,  1097,   221,   221,   221,   297,   429,   174,   429,
     595,   439,   515,    38,   154,   793,   762,   763,  1223,   938,
    1097,   297,   154,   690,  1205,   282,   318,   515,   533,   775,
     453,   344,   465,  1203,    29,   911,   761,   533,   154,  1214,
      98,   180,   547,   609,   670,   733,   807,   829,   934,   154,
    1211,   711,   712,   154,   297,  1211,  1214,   251,   793,   793,
     793,   793,   146,   339,   515,   719,   282,   533,  1203,   282,
     672,   674,   282,    38,   292,   318,   515,   636,   636,   192,
     667,  1203,   168,   192,   526,  1220,   515,   765,   855,  1205,
     515,   846,   846,    38,  1097,    27,    50,   214,   734,   235,
     472,   474,  1014,   376,   858,   857,  1097,  1205,   515,   795,
    1097,   844,   845,  1215,  1214,   154,   529,   154,   453,   154,
     453,   880,   881,   529,   844,  1215,   844,  1205,  1205,  1097,
     795,  1215,   719,   154,   792,   793,  1204,  1205,  1205,   793,
     516,   192,  1203,   975,  1012,  1012,  1012,  1012,  1012,  1012,
     637,   516,   519,   516,   177,   335,   368,   382,   418,  1204,
     792,   112,   384,   844,  1204,   291,   812,   813,  1220,   844,
     844,  1204,  1202,  1202,  1204,   792,   429,   181,   472,   823,
     149,   245,   716,   717,    23,   152,   369,   390,   995,  1074,
     286,   996,   516,   519,   978,   429,  1203,  1205,  1203,   526,
     809,   810,   174,   823,   810,  1220,    28,    80,   137,   176,
     236,   334,   367,   439,   788,   789,  1160,   514,  1160,  1165,
    1166,   468,  1176,  1177,  1121,  1160,   515,  1210,  1210,     3,
     114,   190,   262,   265,   378,   490,  1167,  1168,  1211,  1160,
    1160,  1121,  1186,   360,  1016,  1017,  1186,  1189,  1196,  1186,
    1121,  1123,  1161,  1189,  1192,  1193,  1121,  1193,  1121,  1186,
    1160,  1210,  1210,  1121,  1121,   879,  1121,  1161,  1163,  1170,
     369,   506,   507,   515,  1122,  1123,  1157,  1171,   516,  1160,
    1121,  1163,  1172,  1121,    57,   174,   239,   430,  1121,  1160,
    1173,   134,   282,  1016,  1160,   267,  1123,  1121,  1131,  1132,
    1133,   267,  1121,  1133,   516,   519,  1210,  1118,  1097,  1121,
    1121,  1121,  1121,  1223,   248,   427,    43,   413,  1185,   793,
    1121,   515,  1016,  1174,   134,   136,   160,   225,   274,   275,
     276,   277,   281,   282,   287,   436,   447,  1169,  1190,  1121,
     515,  1121,   429,    52,   193,   198,   244,   392,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,    29,    36,
     397,  1154,   183,  1139,   369,   515,  1151,   515,   308,  1143,
     179,   248,   417,   421,   423,   449,  1028,  1203,  1201,  1063,
    1161,  1063,  1203,   431,   515,  1211,   519,   516,   191,   191,
     529,   973,   962,   966,  1121,   516,   258,   282,  1023,  1160,
     516,   516,   513,   492,   492,   516,   516,  1210,   514,  1210,
     516,   190,   262,  1119,   262,  1119,  1119,  1210,   265,   516,
    1206,   225,   238,   370,   489,   515,  1016,  1064,  1065,  1066,
    1074,  1080,  1090,  1124,  1126,  1127,  1197,  1220,   469,  1085,
    1216,   973,   971,   519,    39,   129,   453,   838,   369,   370,
     506,   507,  1044,  1046,  1123,   390,   232,   298,   519,     5,
    1045,  1210,  1045,   369,   370,  1046,  1202,   286,   394,   997,
    1057,  1039,   453,   992,   119,   311,   515,   984,  1015,    38,
     453,  1220,   515,   999,  1000,  1001,  1220,   516,  1214,  1205,
    1205,   306,    59,  1221,   516,   850,   852,   849,   852,  1221,
     303,   516,   519,   794,  1214,  1205,  1205,  1214,  1205,  1205,
    1214,   464,  1205,  1205,   119,   556,   677,   364,   452,   809,
     374,   180,   809,   515,  1205,   453,   831,   232,   287,   232,
     453,   626,   658,   192,  1205,   287,  1214,  1205,  1205,  1121,
     287,  1205,  1205,    32,   355,   429,   429,  1205,   429,   694,
     857,   515,  1097,   845,    74,   161,   881,   845,   845,   168,
    1097,   793,  1205,   186,   278,   313,   352,   457,   697,   698,
     699,  1074,   429,   898,   374,   287,   123,   220,  1214,  1205,
     297,  1205,   297,   516,   519,  1213,  1215,  1205,   352,   572,
     192,   617,   282,  1097,  1205,  1210,  1220,  1203,  1205,   243,
    1205,    29,   452,  1205,   192,  1205,   192,  1220,   371,   434,
     371,   434,   243,  1205,    29,   452,  1205,   243,   369,  1203,
      25,   139,   387,   704,   705,   706,   707,  1223,  1214,  1205,
     119,   175,   283,   453,   579,   582,   583,  1223,   261,  1205,
      76,   295,  1205,   575,   297,   429,   420,  1203,   429,   898,
     374,   127,  1205,  1205,   519,   516,   519,  1214,  1205,   904,
     905,  1223,   297,   352,   429,   727,  1214,  1205,  1205,   297,
    1074,   198,   519,   636,   636,  1183,  1214,  1205,  1205,  1213,
       3,    90,   144,   205,   320,   444,   452,   455,   535,  1214,
    1205,  1205,   297,   352,  1214,  1205,   352,   387,   572,   674,
     677,   793,  1205,   677,   793,  1205,   677,  1214,  1205,   387,
    1214,  1205,  1205,  1212,  1204,  1204,  1214,   869,  1205,  1204,
    1205,   352,   387,   572,   573,  1203,  1203,  1205,  1205,  1205,
    1205,  1214,  1205,    25,    31,   139,   313,   352,   387,   313,
     352,   387,   761,   352,   387,   352,   387,   352,   901,  1089,
    1220,   192,   771,  1220,   192,  1220,  1211,  1214,  1205,  1205,
    1211,  1205,   904,    25,   139,   592,   384,  1213,   352,   387,
     572,  1205,  1205,  1205,   429,   429,    85,   443,   340,   519,
    1034,  1034,  1034,  1121,  1121,   461,  1162,   516,  1121,  1182,
     958,   287,   799,  1211,    38,   799,   137,   793,   799,   799,
     221,   453,   453,   799,   799,   799,   235,   799,   799,   799,
     793,   336,   596,   596,   203,   417,   732,  1121,  1097,   793,
     516,   519,   505,   623,  1223,  1205,    63,   174,   374,   464,
     691,   698,   699,   154,   292,   244,   611,   613,   615,   617,
     629,   632,    26,   198,   364,   414,   535,   536,   168,  1205,
     465,  1203,    38,   728,   418,   869,   526,  1220,   546,   610,
     841,  1205,   170,   793,   515,   660,   661,  1126,  1220,   337,
    1211,   761,   761,   761,   761,   515,   761,  1087,  1088,  1089,
     384,   154,   515,   154,   154,   153,  1015,   793,   292,   611,
    1220,   453,   653,   472,   581,   282,    38,   636,  1211,   282,
     297,     3,   766,   767,   761,    27,   516,   847,   848,   853,
      38,   235,   361,   432,   471,   859,   860,   861,   862,   859,
     297,   235,   292,   124,   213,   437,   451,   735,   736,  1205,
     189,   189,   168,   529,    38,   532,   169,   946,   947,   529,
     529,   792,   793,  1205,   793,  1205,   529,   529,   529,   529,
     235,   529,   384,   168,   529,   529,   297,   529,   282,   516,
     638,   198,   198,   198,   198,   198,   476,  1204,   677,   678,
     519,   517,   183,   815,   816,  1214,    59,   820,   821,  1223,
     429,   515,   174,   152,   390,   152,   390,   369,   451,   264,
    1097,  1214,   472,   665,   297,   815,   529,   174,   857,   793,
    1097,   845,   291,   845,   845,  1097,   793,  1205,   516,   514,
     514,   519,  1121,   141,  1177,  1178,    38,   516,  1121,   516,
     516,   516,   174,   516,   516,   493,  1187,  1188,   472,   474,
    1191,  1097,  1188,   516,    21,   287,   519,  1195,   303,  1198,
     520,   458,   516,   516,    21,   287,   519,  1194,  1194,   516,
    1189,   516,   516,   516,   516,   519,   519,   516,   321,   516,
     516,   515,  1122,  1122,  1160,    13,    17,    18,    19,   198,
     221,   299,   503,   504,   505,   506,   507,   508,   509,   510,
     511,  1157,  1122,   516,   516,   168,   174,   392,   516,   516,
      38,  1173,  1160,  1173,  1173,   174,   516,   134,   516,  1223,
     319,  1136,    38,   516,   519,  1121,  1223,   519,  1121,  1184,
    1121,   516,   492,  1122,  1122,   147,  1160,   174,    37,   291,
     373,   458,   134,   136,   160,   281,   287,   436,   447,  1169,
    1190,   281,  1191,   147,   879,  1121,   413,  1185,  1121,  1174,
    1121,   429,   515,  1016,   515,  1143,   515,  1160,   469,   515,
    1144,  1220,   421,   423,   421,   423,  1203,  1029,  1029,  1029,
    1085,  1034,  1085,   931,  1210,  1118,   554,   973,   258,   515,
     516,  1210,  1117,  1117,   514,   514,   516,  1016,  1080,  1090,
     174,   515,  1016,  1065,  1066,    38,  1067,  1068,  1220,   519,
      99,   175,   209,   224,   242,   270,   363,  1071,  1068,    38,
    1067,  1070,  1220,  1068,   496,  1084,  1183,  1121,   183,  1048,
    1037,   299,  1155,  1158,   495,   839,     5,  1210,  1046,   298,
     472,   451,  1043,   253,  1064,   469,  1086,   459,   415,   452,
     985,   986,   987,  1220,   297,   988,  1220,  1065,  1001,  1002,
     519,  1063,   505,  1184,   856,   794,   852,   852,    59,   854,
     510,  1215,  1215,   297,  1204,   300,   297,  1121,   633,  1205,
     515,   515,  1220,   515,   658,   203,   515,   751,   154,   529,
     429,  1214,  1205,   559,  1097,   793,   793,  1097,   681,  1205,
     186,   457,   429,   429,   681,   697,   703,   352,   387,   572,
    1205,  1205,  1205,   211,   287,   157,   848,   312,   387,   429,
     282,   154,   406,   621,   622,   751,   387,    25,   139,   356,
     357,   387,   576,   584,   585,   703,   899,   379,   154,   529,
     154,   529,  1205,  1205,  1205,  1205,   379,   379,   243,   706,
     707,   706,   516,   519,   708,  1211,   203,   516,   519,   505,
     517,  1205,   157,  1214,  1205,   352,   387,   572,  1205,  1205,
    1205,   297,   313,   352,   387,    25,   139,   313,   352,   387,
    1097,   279,  1097,   516,   519,   505,  1203,   429,  1215,   453,
     724,   157,   636,   374,   910,   469,   643,   643,   636,   245,
     320,   287,  1211,   320,  1215,   450,   157,   429,   429,   374,
     403,   869,   869,   869,   312,   387,    91,   429,   898,   374,
     119,   168,   587,   164,   528,   429,   429,   255,   255,   255,
     429,   429,   374,   429,   429,   374,   429,   374,   429,   374,
     429,   127,   529,  1097,   282,  1211,   387,   899,   154,   529,
     429,   429,   516,  1205,   429,   898,   374,   429,  1214,  1205,
     516,   516,   516,  1162,   514,  1097,   793,   221,   799,  1205,
    1205,  1205,   221,   404,   405,   597,  1211,   597,   186,   516,
     516,   174,   761,   763,   279,   299,   506,   507,   677,   764,
     852,  1158,  1211,  1228,    72,    78,    91,   119,   121,   178,
     207,   282,   287,   330,   346,   446,   624,   625,   628,   153,
     468,   532,   559,  1205,   559,   301,   701,  1203,  1203,  1203,
     516,   519,  1215,   183,   364,  1215,  1210,   439,  1203,   636,
       3,   168,   729,   869,    48,   546,   417,   710,   112,   970,
    1121,   174,   519,  1204,   581,   768,   769,  1211,   516,   519,
    1205,   168,   637,  1203,   664,  1203,  1205,   665,   515,   612,
    1203,   516,  1205,   472,   474,   654,   580,    38,   154,  1015,
     653,   429,   154,  1074,   505,   516,   519,   735,   516,   519,
     119,   505,   863,  1211,   559,   417,   851,   852,   168,   868,
      51,   359,   864,   865,   862,   865,   124,   213,   380,   451,
     921,  1205,   292,   297,   302,   186,  1015,  1097,   515,   516,
     519,   529,   453,   529,   453,   529,  1205,  1205,   719,   793,
     154,   374,   374,   374,   374,   374,  1204,   519,   813,  1220,
    1214,   472,   519,   817,  1214,   519,   823,   160,   300,   436,
     822,  1076,   384,   152,   152,   112,   278,   814,   823,  1215,
     221,   221,   221,   221,   677,   221,   221,   221,   221,   221,
    1165,   425,  1121,   145,  1097,   516,  1121,   225,   446,   446,
     516,  1188,  1189,   297,   297,  1186,  1189,    59,  1195,  1186,
    1186,   297,   297,  1193,  1191,  1191,   516,  1169,  1121,  1121,
     516,  1160,   519,  1097,  1122,  1122,  1122,  1122,   134,   136,
     282,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1121,  1121,  1121,  1097,   516,   516,   516,  1160,   516,
     519,    59,  1123,  1137,   516,  1223,  1132,   327,   409,  1135,
     516,   519,   464,  1128,    38,   516,  1211,  1121,    35,    35,
    1121,   516,  1121,   174,   281,  1191,  1121,   516,   147,  1122,
    1122,   147,   147,  1121,  1121,  1035,   516,  1160,   519,  1121,
    1145,  1220,  1029,  1029,  1029,  1029,  1203,  1203,  1203,  1048,
     516,  1048,   516,   978,   514,  1068,  1070,  1068,   515,   484,
    1123,   516,  1220,   515,  1065,   224,   307,  1072,  1065,  1072,
     224,  1071,  1072,   224,   419,  1078,   515,  1220,   515,   304,
      59,   187,  1055,   515,   839,   165,   237,   298,   472,   426,
     102,  1121,   360,   990,   458,   516,   519,  1184,    89,   990,
     297,   516,   519,  1000,  1086,  1121,   516,   510,   856,   439,
     177,   368,   375,   382,   418,   440,   828,   168,   828,   516,
     515,   641,   642,   834,  1126,  1220,   637,   751,   637,   751,
    1205,   637,   121,   207,   278,   282,   752,  1205,  1205,    38,
     453,   453,   235,   794,  1214,  1205,   429,   898,   374,   429,
     211,  1205,    59,   420,  1205,   154,   617,   119,  1220,    86,
     619,   620,   403,   178,   156,   191,   282,   580,   532,   112,
     156,   178,   282,   403,   580,   619,   621,   675,   387,   585,
     439,  1205,  1220,   379,   705,  1205,   583,   764,  1223,  1205,
     312,   387,   429,   898,   374,   429,   157,   429,   429,   374,
     176,   299,   406,   773,   774,   176,   299,   781,   782,   429,
     429,   374,   516,   516,   516,   905,   279,   677,   852,   906,
    1158,  1211,  1228,   352,  1205,   515,   472,   725,  1205,   643,
     106,  1220,   515,   643,  1212,  1211,  1211,  1211,  1205,  1205,
    1205,  1205,  1212,    59,   420,  1205,  1205,  1205,  1205,   459,
    1205,  1205,   168,   168,   354,   168,   192,  1214,  1205,  1205,
    1214,  1205,  1205,  1205,  1205,  1205,  1205,  1205,   297,    78,
     577,   154,    27,    50,   439,  1220,  1205,  1211,   703,  1205,
    1205,  1205,  1205,  1034,   516,   221,   799,   221,   221,   221,
     799,   532,   453,   602,   603,   681,   751,   472,   474,   793,
     515,   793,  1205,  1122,    32,    59,   627,   122,   194,   121,
     287,   232,  1203,   626,   176,   334,   747,   754,   755,  1220,
     690,   515,   318,   515,   612,   630,   206,   648,   615,  1215,
    1215,  1097,   515,   581,    29,   124,   213,   380,   451,   730,
     429,   726,  1214,   192,  1203,   712,   476,   297,   516,  1064,
     661,   869,   516,   519,  1089,   701,   719,   516,   672,    38,
     292,   318,   515,   980,   614,   616,   618,   632,  1220,   318,
     649,   650,   612,   648,   580,   295,   297,   655,  1015,   667,
     665,   581,  1211,  1205,   831,   764,     3,   767,   297,   853,
    1121,  1121,   519,   515,   859,   439,   519,    44,  1121,   429,
     515,   637,  1203,   736,   681,   516,   946,   947,  1205,  1205,
     529,   384,   529,  1204,  1204,  1204,  1204,  1204,   677,   180,
     816,   823,   821,   516,  1205,   112,   174,   529,   823,   287,
     802,  1211,   802,   802,   802,   221,   802,   802,   802,   802,
     802,  1121,   516,   143,   233,   233,   516,   287,   287,   516,
    1036,  1189,   287,   287,  1189,  1189,   516,   516,   174,   516,
    1121,   174,   134,   136,   174,   168,   147,   516,   479,  1130,
    1160,   345,   458,    59,  1137,  1123,   470,   470,   516,  1121,
     278,  1121,   519,  1129,  1099,  1121,  1121,  1121,  1121,    35,
      35,  1121,  1121,   147,   516,   516,   516,  1121,   516,   318,
    1146,  1203,  1203,  1203,  1203,  1055,  1211,  1055,  1211,   516,
    1081,  1082,  1126,   515,  1136,  1067,   515,  1204,  1065,   297,
     453,  1073,  1065,   224,  1065,  1208,  1088,   515,  1088,  1220,
    1030,  1121,   471,  1140,   879,   426,   292,  1200,  1015,   311,
    1015,   987,   297,   515,   989,  1121,   505,  1001,   990,   439,
     516,   429,   809,   174,   751,  1121,   516,   519,   472,    78,
     833,   837,   833,   516,   474,   635,   635,   122,   194,   205,
     121,   455,   529,  1097,  1205,  1205,  1205,  1205,  1205,  1205,
    1205,  1215,  1205,   617,   119,  1220,   701,   119,   586,  1212,
     627,   192,   192,   287,   677,    38,   627,   287,   586,  1097,
     529,   529,   505,    59,   420,  1205,  1205,  1205,  1205,  1205,
    1214,  1205,  1205,  1210,  1210,  1097,   519,  1210,  1210,   519,
    1214,  1205,  1205,   429,  1121,    72,  1121,  1215,  1205,   429,
     429,   174,   198,   472,  1204,  1204,   793,  1204,   154,   157,
     793,  1211,  1211,  1097,   529,   529,   429,   516,   221,   799,
     799,   799,   799,   515,   598,   599,   532,   126,   176,   210,
     176,  1121,   282,   625,   119,    38,   278,   634,   869,   636,
     869,  1208,    35,   153,   198,   702,   706,   292,   611,   587,
     151,   200,   515,   384,   453,   637,    38,  1215,   724,   546,
     282,   515,   170,  1205,   660,  1211,   384,   581,   153,  1015,
     793,   292,   611,   665,   516,   519,   472,   623,    59,   653,
     587,   649,    84,   420,   656,   472,   935,    38,   656,   174,
     297,   515,  1203,  1211,   850,   870,   871,  1221,   865,  1097,
     168,   866,  1203,   174,   429,   890,   347,   737,   208,   682,
     529,   516,   529,   529,  1205,   300,   219,   815,   529,   802,
    1205,   516,   516,   516,  1121,   516,  1122,   174,  1121,  1121,
    1121,   515,   516,   519,   516,  1137,   516,   458,   400,   516,
     202,   278,  1134,  1121,  1121,  1121,   516,    59,  1034,  1140,
    1140,   377,  1024,   516,   519,    38,  1083,   119,  1095,  1096,
    1122,    81,  1204,   516,  1121,   515,  1065,  1073,   515,   516,
    1088,   516,   101,   184,   366,   515,  1049,  1050,  1051,  1052,
    1053,  1054,  1121,  1141,  1142,  1220,  1034,   516,  1012,   985,
      91,   832,   834,   135,   468,  1004,  1005,  1121,   815,   297,
     815,   516,   199,   639,   642,   299,   879,   793,   527,   793,
     346,   309,   516,   516,   516,   429,   387,   996,   623,    38,
     154,   154,   515,   577,   764,  1215,  1205,   429,   515,   845,
     879,   881,   774,   515,   515,   782,  1205,   516,   515,   516,
     387,   996,  1205,  1205,   515,   515,   515,   472,   496,   955,
     354,   955,   955,   168,  1205,   577,  1205,   799,   604,   605,
    1223,    54,   100,   125,   143,   147,   169,   173,   188,   287,
     338,   600,   598,  1211,   845,    38,   886,   886,   516,   191,
     515,   205,   453,   657,   256,   640,   657,   515,   755,   747,
     515,   516,   519,  1203,   516,   384,    29,    83,    86,    92,
     120,   178,   191,   204,   403,   406,   631,   631,  1202,  1205,
    1205,   516,  1015,   725,   154,   112,   701,   174,  1205,    38,
    1205,   665,   612,  1203,   516,   616,   301,  1220,   654,   649,
     653,   124,   139,   327,  1205,    64,    72,   248,  1015,   793,
    1074,   832,   174,   750,   852,   516,   519,   439,   145,   525,
     864,   867,  1085,   398,   398,   516,   272,   296,   738,   739,
     740,   168,   743,   681,   278,   457,   683,   684,  1205,   823,
     168,  1122,  1131,  1160,   278,   491,   202,   516,  1160,   185,
     339,   370,  1147,    58,   128,   111,  1025,  1084,  1081,   515,
    1122,   516,   519,    38,  1091,  1092,  1220,   516,  1204,  1160,
     516,   515,   388,   515,   516,   519,   519,    38,  1039,   458,
    1205,   516,   519,   283,   451,   257,   282,  1005,   817,   828,
     529,   833,   515,   869,   515,   838,   580,  1203,   639,   639,
    1205,   420,   191,  1121,   453,   578,   387,   996,  1205,  1164,
     168,   777,   777,  1164,  1164,  1121,   420,  1160,  1160,   588,
     589,  1222,   792,   793,   792,   793,  1204,   529,   516,   519,
     508,   515,   556,   606,   677,   952,  1211,   952,   282,   287,
     338,   952,   952,  1085,   886,    42,   196,   634,   515,   673,
    1121,   203,   175,   317,   393,   297,   644,   645,   646,   516,
    1208,     6,   756,   706,   612,   648,  1205,   516,   701,   161,
     776,   581,   935,  1203,   476,  1064,   701,  1015,   980,   649,
     612,   648,   623,   515,   655,   653,   654,   370,   370,    72,
     300,    72,   665,   831,   516,  1203,   751,   859,   870,  1097,
     518,   135,   472,   472,   739,   369,   417,   741,   140,   744,
     468,   746,   457,   681,   701,   529,  1121,   516,   516,   458,
      52,   102,   442,  1121,  1148,  1149,  1148,  1148,   516,   165,
     165,   637,  1088,   519,  1096,  1223,   516,   519,   168,  1097,
     516,   516,  1160,   515,  1160,  1050,  1142,  1144,  1057,  1015,
    1085,   834,   387,    35,  1006,   257,   174,   637,   657,   879,
     839,   838,   636,   869,   869,  1205,   673,   516,  1121,   420,
     516,   303,   377,   343,   778,   778,   516,   516,   516,  1205,
     516,   516,   516,   519,  1210,   955,   605,   556,   607,   608,
    1211,  1211,   287,   508,   637,   508,   637,  1211,  1211,   674,
     516,   420,   124,   451,   297,   646,   297,   645,   515,   516,
     519,   587,   384,   701,   793,    38,    38,   515,  1205,   935,
     665,   653,   587,   649,   515,   651,   652,  1126,  1220,   656,
     654,   655,   300,   300,   515,   199,   835,   168,   865,    30,
     214,   922,   176,   176,   952,   369,   402,   745,   515,   153,
    1149,   369,   167,   325,   167,   325,   150,  1150,  1150,  1150,
      59,    59,   387,   516,  1123,  1092,   304,     3,   119,   282,
     287,  1093,  1094,    38,  1069,   353,  1079,   516,  1049,   516,
     999,  1121,   425,  1006,   815,   516,   643,   516,   839,   640,
     657,   657,   996,  1205,   845,    59,   996,   429,   588,   793,
     516,   519,   508,   637,   516,   407,  1205,    63,   278,   358,
     387,   647,   647,   516,     6,   384,  1205,   773,  1015,   701,
     654,   649,   653,  1121,   516,   519,   837,   837,   655,   656,
     832,   515,   626,   140,   283,   515,   917,   919,   923,   982,
     991,   998,  1015,  1026,   845,   845,   742,  1220,  1121,   747,
      35,   102,   183,   278,   426,   637,   637,  1220,  1136,  1122,
    1122,   287,  1094,  1220,   515,   516,  1085,   124,   135,   451,
    1007,  1008,   425,   529,   751,   644,   751,   751,   996,   793,
     515,   608,    24,   119,   287,  1205,   701,   935,   655,   653,
     654,   516,   652,   527,   527,   656,   516,   834,   836,   581,
     369,   918,   919,   920,  1016,  1017,   519,   519,   516,  1208,
    1149,   369,   305,   387,   387,   429,   453,    81,  1121,   283,
     387,   135,   213,  1009,   751,  1160,   636,   636,   701,   656,
     654,   655,   837,   835,   516,   519,   656,   746,   516,   518,
     429,   174,   515,  1220,  1220,   225,  1208,  1209,  1220,  1091,
     516,   999,   283,   119,   311,   459,   515,  1010,   516,   655,
     656,   527,   626,   834,  1085,   153,   920,   398,   398,     5,
     748,   749,  1210,  1211,  1223,   515,   119,   516,   459,   985,
     515,   986,   656,   581,   747,   472,   472,   516,   519,  1161,
    1209,   458,  1160,   516,   656,  1208,   176,   176,   749,  1034,
     453,  1010,   516,   311,  1010,  1085,   515,   845,   845,   516,
    1220,   985,   748,   458,   516,  1010
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   521,   522,   522,   522,   522,   522,   522,   523,   523,
     524,   524,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   525,   525,   525,   525,   525,   526,   526,   527,
     527,   528,   528,   529,   529,   529,   530,   531,   532,   532,
     532,   533,   533,   534,   534,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   536,   536,   536,   536,   536,   536,
     537,   538,   538,   539,   539,   540,   540,   540,   540,   541,
     541,   541,   541,   541,   541,   542,   543,   544,   544,   545,
     545,   545,   545,   546,   546,   547,   547,   547,   547,   547,
     547,   548,   548,   548,   549,   549,   549,   550,   550,   550,
     550,   551,   551,   551,   551,   551,   551,   551,   551,   551,
     551,   551,   552,   552,   553,   553,   554,   554,   555,   555,
     555,   555,   556,   556,   556,   556,   557,   557,   557,   557,
     557,   557,   557,   558,   558,   558,   559,   559,   560,   561,
     561,   561,   561,   562,   562,   563,   563,   564,   564,   565,
     565,   565,   565,   565,   566,   567,   567,   568,   568,   569,
     570,   570,   570,   570,   570,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   571,   571,   571,   571,
     571,   571,   571,   571,   571,   571,   572,   572,   573,   573,
     573,   574,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   576,   576,   577,   577,   578,   578,   579,
     579,   579,   579,   580,   581,   581,   582,   582,   583,   583,
     583,   583,   584,   584,   585,   585,   585,   585,   586,   586,
     587,   587,   587,   587,   588,   589,   589,   590,   591,   591,
     592,   592,   592,   592,   593,   593,   594,   594,   595,   595,
     596,   596,   597,   597,   597,   598,   598,   599,   599,   600,
     600,   600,   600,   600,   600,   600,   600,   600,   600,   600,
     600,   600,   600,   600,   601,   601,   602,   602,   603,   603,
     604,   604,   605,   606,   606,   606,   606,   606,   607,   607,
     608,   609,   609,   609,   609,   609,   609,   610,   610,   610,
     610,   610,   610,   610,   610,   611,   611,   612,   612,   613,
     613,   614,   614,   615,   615,   615,   616,   616,   617,   618,
     618,   619,   619,   620,   620,   621,   621,   622,   622,   623,
     623,   624,   624,   624,   624,   625,   625,   625,   625,   625,
     625,   625,   625,   625,   626,   626,   626,   627,   627,   628,
     628,   628,   628,   629,   630,   630,   630,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   631,   632,   632,   633,
     633,   633,   633,   633,   633,   633,   633,   634,   634,   635,
     635,   636,   636,   637,   637,   638,   639,   639,   640,   640,
     640,   640,   641,   641,   642,   642,   643,   643,   644,   644,
     644,   644,   644,   645,   646,   647,   647,   647,   647,   647,
     648,   648,   649,   649,   650,   651,   651,   652,   652,   652,
     653,   653,   654,   654,   654,   655,   655,   655,   655,   656,
     656,   657,   657,   658,   659,   659,   660,   660,   661,   661,
     661,   662,   662,   663,   663,   664,   665,   665,   665,   666,
     666,   667,   668,   668,   669,   670,   670,   671,   671,   672,
     672,   673,   673,   674,   674,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   676,
     676,   677,   677,   677,   677,   678,   678,   679,   679,   680,
     680,   681,   681,   682,   682,   683,   683,   684,   684,   685,
     685,   686,   687,   687,   688,   688,   689,   689,   690,   690,
     691,   691,   691,   691,   692,   693,   693,   694,   695,   695,
     695,   695,   695,   695,   695,   695,   695,   695,   695,   695,
     695,   696,   697,   697,   697,   697,   698,   698,   699,   699,
     700,   700,   701,   701,   702,   702,   703,   704,   704,   705,
     705,   705,   705,   706,   707,   708,   709,   709,   710,   710,
     711,   711,   712,   712,   713,   713,   713,   714,   714,   714,
     714,   715,   716,   716,   717,   717,   718,   718,   719,   719,
     720,   720,   721,   722,   723,   724,   724,   725,   725,   726,
     726,   727,   727,   728,   728,   729,   729,   730,   730,   730,
     730,   730,   731,   732,   732,   733,   733,   734,   734,   734,
     735,   735,   736,   736,   736,   736,   736,   737,   737,   738,
     738,   739,   740,   740,   741,   741,   742,   743,   743,   744,
     744,   745,   745,   746,   746,   747,   747,   748,   748,   748,
     749,   749,   749,   749,   750,   750,   751,   751,   752,   752,
     752,   752,   752,   752,   753,   753,   754,   754,   755,   756,
     756,   757,   758,   758,   758,   758,   759,   760,   760,   760,
     760,   760,   760,   760,   760,   760,   760,   760,   760,   760,
     760,   760,   760,   761,   762,   762,   763,   763,   764,   764,
     764,   764,   764,   764,   765,   766,   766,   767,   768,   768,
     769,   769,   770,   770,   770,   770,   770,   771,   771,   772,
     773,   773,   774,   774,   774,   774,   774,   775,   775,   776,
     776,   777,   777,   777,   778,   778,   779,   780,   780,   781,
     781,   782,   782,   783,   783,   784,   784,   785,   786,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   788,   788,   788,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   789,   789,   789,   789,   789,   790,
     790,   790,   790,   790,   790,   790,   790,   791,   791,   791,
     792,   792,   793,   793,   794,   794,   795,   795,   796,   797,
     797,   797,   798,   798,   798,   798,   798,   798,   798,   798,
     798,   798,   798,   798,   798,   798,   798,   798,   798,   798,
     799,   799,   800,   800,   800,   800,   800,   800,   800,   800,
     800,   800,   801,   801,   802,   802,   803,   803,   804,   804,
     804,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     804,   804,   804,   804,   805,   805,   806,   806,   807,   808,
     808,   809,   809,   809,   809,   809,   810,   810,   811,   811,
     811,   811,   811,   812,   812,   813,   813,   814,   814,   814,
     814,   814,   814,   814,   814,   814,   814,   814,   814,   814,
     814,   814,   814,   814,   814,   814,   814,   814,   815,   815,
     816,   816,   817,   817,   818,   818,   819,   819,   820,   820,
     821,   822,   822,   822,   823,   823,   824,   825,   825,   826,
     826,   826,   827,   827,   827,   828,   828,   828,   828,   828,
     828,   829,   829,   830,   830,   831,   831,   832,   832,   833,
     833,   834,   834,   834,   835,   835,   836,   836,   837,   837,
     838,   838,   838,   839,   839,   839,   840,   840,   840,   840,
     841,   841,   842,   842,   843,   843,   844,   844,   845,   845,
     845,   845,   846,   846,   847,   847,   848,   848,   848,   848,
     848,   849,   849,   849,   849,   849,   850,   851,   852,   852,
     852,   853,   853,   853,   854,   855,   855,   855,   855,   856,
     856,   857,   858,   858,   859,   859,   860,   860,   861,   861,
     861,   861,   861,   861,   861,   861,   861,   861,   861,   861,
     861,   861,   861,   861,   861,   862,   862,   862,   862,   862,
     863,   863,   864,   865,   865,   865,   866,   866,   867,   867,
     868,   868,   869,   869,   870,   871,   871,   872,   872,   872,
     873,   873,   874,   874,   875,   875,   875,   875,   875,   875,
     876,   876,   877,   877,   878,   878,   878,   878,   879,   879,
     880,   880,   881,   882,   883,   883,   884,   884,   885,   885,
     885,   886,   886,   886,   887,   888,   888,   889,   890,   890,
     890,   890,   891,   892,   892,   892,   893,   893,   894,   894,
     895,   895,   896,   896,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   897,   897,   897,   897,   898,
     898,   899,   899,   900,   900,   900,   900,   900,   900,   901,
     901,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   902,   902,
     902,   902,   902,   902,   902,   902,   902,   902,   903,   904,
     904,   905,   905,   905,   906,   906,   906,   906,   906,   907,
     908,   908,   908,   908,   908,   908,   908,   908,   908,   908,
     908,   908,   908,   908,   908,   908,   908,   908,   908,   908,
     908,   908,   908,   908,   909,   909,   909,   910,   910,   910,
     910,   910,   910,   910,   911,   911,   912,   912,   912,   912,
     913,   914,   914,   914,   914,   914,   914,   914,   914,   914,
     915,   915,   916,   917,   917,   917,   918,   918,   919,   919,
     919,   919,   919,   920,   920,   921,   921,   921,   921,   922,
     922,   922,   923,   924,   924,   925,   926,   926,   927,   927,
     927,   927,   927,   927,   927,   927,   927,   927,   927,   927,
     928,   928,   929,   929,   929,   930,   930,   930,   930,   930,
     931,   931,   931,   932,   932,   933,   933,   933,   934,   934,
     934,   934,   935,   935,   935,   935,   936,   937,   938,   938,
     939,   939,   940,   940,   940,   941,   941,   941,   941,   941,
     941,   941,   942,   942,   943,   943,   943,   943,   944,   945,
     945,   945,   945,   946,   946,   947,   948,   949,   949,   950,
     951,   951,   951,   951,   951,   951,   951,   952,   952,   953,
     954,   954,   954,   954,   954,   954,   955,   955,   956,   957,
     957,   957,   957,   957,   958,   958,   959,   959,   960,   960,
     961,   961,   962,   962,   963,   964,   964,   964,   965,   965,
     965,   966,   966,   967,   967,   968,   968,   969,   969,   970,
     970,   971,   972,   972,   973,   973,   974,   974,   974,   974,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     976,   977,   977,   978,   978,   978,   978,   978,   979,   979,
     979,   980,   980,   981,   981,   981,   981,   982,   983,   983,
     984,   984,   984,   984,   984,   985,   985,   986,   986,   987,
     988,   988,   988,   989,   989,   989,   990,   990,   991,   992,
     992,   993,   994,   994,   995,   995,   995,   995,   995,   995,
     995,   995,   996,   996,   997,   997,   997,   998,   999,   999,
    1000,  1000,  1001,  1002,  1002,  1003,  1004,  1004,  1005,  1005,
    1005,  1005,  1005,  1006,  1006,  1007,  1008,  1009,  1009,  1009,
    1009,  1009,  1010,  1011,  1012,  1013,  1013,  1013,  1013,  1013,
    1013,  1014,  1014,  1014,  1015,  1015,  1016,  1016,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1018,  1018,  1019,  1019,
    1019,  1019,  1019,  1019,  1019,  1020,  1020,  1020,  1021,  1021,
    1022,  1023,  1023,  1023,  1024,  1024,  1024,  1025,  1025,  1025,
    1026,  1026,  1027,  1027,  1028,  1028,  1028,  1028,  1028,  1028,
    1028,  1028,  1028,  1029,  1029,  1030,  1030,  1030,  1031,  1031,
    1032,  1032,  1033,  1033,  1034,  1034,  1035,  1036,  1036,  1037,
    1037,  1038,  1038,  1038,  1038,  1039,  1039,  1040,  1040,  1040,
    1040,  1040,  1040,  1041,  1041,  1042,  1042,  1043,  1044,  1044,
    1044,  1045,  1045,  1046,  1046,  1047,  1047,  1048,  1048,  1049,
    1049,  1050,  1050,  1050,  1050,  1050,  1051,  1052,  1053,  1054,
    1055,  1055,  1056,  1056,  1057,  1057,  1058,  1058,  1059,  1060,
    1060,  1060,  1060,  1061,  1061,  1062,  1062,  1063,  1063,  1064,
    1064,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,  1065,
    1065,  1066,  1066,  1066,  1066,  1066,  1066,  1067,  1067,  1067,
    1067,  1068,  1068,  1069,  1069,  1070,  1070,  1070,  1070,  1070,
    1071,  1071,  1071,  1071,  1072,  1072,  1073,  1073,  1074,  1074,
    1075,  1075,  1075,  1076,  1076,  1077,  1077,  1077,  1078,  1079,
    1079,  1080,  1080,  1081,  1082,  1082,  1083,  1083,  1084,  1084,
    1085,  1085,  1086,  1086,  1086,  1087,  1087,  1088,  1088,  1089,
    1090,  1090,  1091,  1091,  1092,  1092,  1092,  1093,  1093,  1094,
    1094,  1094,  1094,  1095,  1095,  1096,  1096,  1097,  1097,  1097,
    1097,  1097,  1097,  1098,  1098,  1098,  1099,  1099,  1099,  1099,
    1099,  1099,  1099,  1099,  1100,  1100,  1100,  1100,  1100,  1101,
    1101,  1102,  1102,  1103,  1103,  1103,  1103,  1103,  1103,  1103,
    1103,  1103,  1103,  1103,  1104,  1104,  1105,  1105,  1106,  1106,
    1107,  1108,  1109,  1109,  1110,  1110,  1111,  1112,  1113,  1113,
    1113,  1113,  1113,  1113,  1114,  1114,  1115,  1115,  1115,  1115,
    1116,  1117,  1117,  1117,  1118,  1118,  1118,  1118,  1118,  1118,
    1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1119,  1119,
    1120,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1125,  1125,  1125,  1126,  1126,  1126,  1127,  1127,
    1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,
    1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,
    1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,
    1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,
    1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,  1127,
    1127,  1127,  1127,  1127,  1128,  1128,  1129,  1129,  1129,  1129,
    1130,  1131,  1131,  1132,  1132,  1133,  1133,  1134,  1134,  1134,
    1135,  1135,  1135,  1136,  1136,  1136,  1136,  1137,  1137,  1138,
    1138,  1139,  1139,  1140,  1140,  1141,  1141,  1142,  1143,  1143,
    1143,  1144,  1145,  1145,  1146,  1146,  1147,  1147,  1147,  1147,
    1148,  1148,  1149,  1149,  1149,  1149,  1149,  1150,  1150,  1150,
    1150,  1150,  1151,  1151,  1151,  1152,  1152,  1153,  1154,  1154,
    1154,  1155,  1155,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1156,  1156,  1157,  1157,  1158,  1158,  1159,
    1159,  1159,  1159,  1159,  1159,  1160,  1160,  1161,  1161,  1162,
    1162,  1162,  1163,  1163,  1164,  1164,  1165,  1165,  1165,  1166,
    1166,  1167,  1168,  1168,  1168,  1168,  1168,  1168,  1168,  1168,
    1169,  1169,  1169,  1169,  1170,  1170,  1171,  1172,  1172,  1172,
    1172,  1172,  1173,  1173,  1173,  1174,  1174,  1175,  1176,  1176,
    1177,  1178,  1178,  1179,  1179,  1180,  1180,  1181,  1181,  1181,
    1181,  1182,  1182,  1183,  1183,  1184,  1184,  1185,  1185,  1186,
    1187,  1187,  1188,  1188,  1189,  1189,  1190,  1190,  1190,  1190,
    1190,  1191,  1191,  1191,  1191,  1191,  1192,  1192,  1193,  1193,
    1194,  1194,  1194,  1195,  1195,  1195,  1196,  1196,  1197,  1197,
    1198,  1198,  1199,  1199,  1200,  1200,  1201,  1201,  1201,  1201,
    1202,  1202,  1203,  1203,  1204,  1204,  1205,  1206,  1207,  1208,
    1208,  1209,  1209,  1209,  1209,  1209,  1209,  1209,  1209,  1209,
    1209,  1209,  1209,  1209,  1210,  1211,  1212,  1212,  1212,  1213,
    1214,  1214,  1214,  1214,  1215,  1215,  1216,  1217,  1218,  1218,
    1219,  1219,  1220,  1220,  1220,  1221,  1221,  1221,  1222,  1222,
    1222,  1222,  1223,  1223,  1223,  1223,  1223,  1224,  1224,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,  1226,
    1226,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,
    1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,  1227,
    1227,  1227,  1227,  1227,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,  1228,
    1228,  1228,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,  1229,
    1229,  1229,  1229,  1229,  1229,  1229
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       0,     1,     0,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     2,     0,     1,     1,     1,     1,     1,
       1,     2,     3,     3,     2,     5,     1,     3,     3,     3,
       3,     1,     3,     3,     2,     2,     2,     2,     3,     3,
       3,     3,     1,     3,     1,     3,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     3,     5,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     1,
       2,     3,     2,     1,     1,     2,     1,     2,     1,     2,
       3,     4,     3,     2,     4,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     4,     6,     4,     6,    10,
      13,     4,     6,     4,    10,    13,     4,     6,     4,     6,
       5,     7,    11,    14,     5,     7,     1,     3,     4,     4,
       4,     3,     2,     5,     3,     6,     4,     6,     6,     9,
       5,     7,     6,     6,     5,     5,     5,     5,     9,     4,
       5,     7,     6,     4,     8,     4,     2,     4,     3,     6,
       4,     3,     3,     3,     2,     2,     3,     4,     4,     3,
       3,     3,     3,     3,     3,     4,     4,     3,     2,     3,
       2,     2,     3,     4,     3,     2,     2,     3,     4,     4,
       4,     5,     1,     3,     2,     2,     0,     2,     0,     1,
       1,     1,     3,     3,     2,     0,     1,     3,     3,     1,
       5,     3,     1,     2,     1,     3,     2,     3,     1,     1,
       6,     6,    10,     1,     2,     1,     3,     4,     1,     3,
       4,     6,     4,     8,     2,     2,    11,     9,     1,     1,
       1,     0,     1,     1,     1,     1,     3,     2,     0,     1,
       1,     3,     3,     1,     1,     3,     3,     3,     3,     4,
       4,     3,     3,     2,     1,     0,     3,     0,     1,     0,
       1,     3,     2,     1,     1,     1,     3,     0,     1,     3,
       1,    13,    16,    12,    15,    14,    17,     1,     1,     2,
       2,     2,     2,     1,     0,     1,     0,     3,     0,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     6,     2,
       4,     2,     2,     1,     0,     2,     2,     1,     0,     2,
       0,     3,     1,     1,     2,     3,     1,     4,     4,     5,
       2,     5,     7,     5,     2,     3,     0,     1,     2,     1,
       2,     2,     2,     3,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     5,
       4,    10,     3,    10,     4,    10,    11,     2,     0,     2,
       0,     3,     0,     1,     3,     1,     4,     0,     2,     2,
       2,     0,     1,     3,     3,     6,     4,     0,     1,     1,
       2,     2,     0,     3,     3,     2,     1,     1,     3,     3,
       4,     0,     1,     0,     6,     1,     3,     3,     3,     5,
       2,     0,     2,     2,     0,     3,     4,     4,     0,     2,
       0,     4,     0,     3,     8,    11,     1,     3,     1,     1,
       3,     6,     8,     7,    10,     6,     2,     3,     0,     8,
      11,     5,     1,     0,     6,     5,     8,     4,     6,     1,
       0,     3,     0,     1,     2,     2,     2,     1,     2,     3,
       2,     2,     2,     2,     3,     3,     3,     1,     3,     1,
       0,     1,     2,     2,     1,     1,     3,     6,    10,     1,
       0,     1,     2,     2,     0,     2,     2,     1,     0,     1,
       0,     7,     2,     0,     3,     5,     5,     8,     2,     0,
       2,     2,     2,     1,     5,     2,     0,     2,     6,     6,
       6,    10,     6,     6,     6,     9,     9,     6,     6,     9,
       6,     7,     2,     2,     2,     2,     1,     2,     1,     0,
       7,     6,     4,     0,     1,     3,     4,     1,     3,     1,
       2,     2,     2,     2,     1,     1,    10,    13,     2,     0,
       2,     2,     1,     0,     5,     4,     4,    11,    14,    12,
      15,    11,     2,     1,     4,     0,     8,    11,     1,     1,
       7,     9,     8,    10,     8,     4,     0,     5,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     1,     1,     1,
       1,     1,     8,     1,     1,    17,    21,     1,     1,     2,
       1,     3,     1,     1,     1,     3,     1,     2,     0,     1,
       2,     4,     1,     1,     1,     1,     1,     3,     0,     1,
       0,     1,     1,     4,     0,     1,     1,     1,     3,     0,
       1,     1,     1,     1,     2,     0,     0,     2,     2,     1,
       2,     2,     2,     2,    11,    13,     1,     3,     5,     1,
       3,     5,     1,     2,     2,     1,     8,     6,     5,     4,
       4,     3,     7,     8,     6,     6,     6,     6,     6,     4,
       7,     5,     8,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     3,     1,     0,
       1,     3,     7,     9,     9,     8,     6,     3,     0,    13,
       1,     3,     5,     5,     3,     6,     2,     1,     0,     2,
       0,     2,     4,     0,     1,     0,     6,     8,     8,     1,
       3,     5,     5,     7,     9,     7,     9,     5,     6,     6,
       4,     6,     4,     6,     8,     4,     6,     4,     6,     5,
       7,     1,     1,     1,     2,     1,     2,     1,     1,     1,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     2,
       2,     1,     3,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     2,     3,     1,     3,     5,     2,
       2,     0,     6,     6,     6,     6,     6,     6,     6,     6,
       8,     9,     8,     6,     6,     9,     9,     9,     7,    10,
       1,     1,     8,     8,     8,     8,     8,     8,     8,     9,
       8,     8,     2,     0,     1,     1,     2,     2,     1,     2,
       3,     3,     3,     3,     4,     4,     3,     3,     3,     4,
       4,     3,     4,     4,     1,     1,     1,     0,     8,     8,
      11,     1,     1,     2,     4,     5,     1,     3,     2,     2,
       2,     2,     2,     1,     3,     1,     3,     1,     2,     2,
       4,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     5,     5,     5,     5,     5,     1,     3,
       1,     2,     3,     0,     5,     7,     6,     9,     3,     1,
       2,     1,     1,     1,     3,     0,     5,     2,     0,     3,
       3,     3,     7,     7,    10,     1,     1,     1,     1,     1,
       1,    16,    19,     1,     0,     2,     0,     1,     3,     4,
       5,     2,     2,     4,     4,     0,     1,     3,     2,     0,
       1,     1,     0,     2,     2,     0,     9,    12,     7,     7,
       2,     0,     3,     2,     1,     3,     1,     3,     2,     1,
       1,     2,     3,     2,     1,     3,     3,     3,     2,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     4,
       5,     1,     3,     3,     1,     3,     3,     5,     6,     1,
       3,     2,     1,     3,     1,     0,     1,     2,     4,     5,
       1,     1,     1,     1,     3,     3,     2,     2,     1,     2,
       2,     2,     2,     1,     2,     2,     2,     2,     1,     1,
       1,     3,     2,     1,     4,     0,     3,     0,     1,     1,
       3,     5,     2,     0,     2,     1,     3,     5,     5,     5,
       1,     2,     1,     0,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     3,     5,     5,     5,     1,     3,
       1,     3,     2,     2,     1,     2,     1,     2,    11,    10,
      10,     2,     2,     0,     9,     2,     0,    10,    11,    11,
       5,     5,     8,     5,     5,     5,     1,     1,     1,     1,
       3,     0,     5,     5,     6,     6,     6,     6,     6,     8,
       8,     6,     6,     7,     9,     9,     8,    10,     6,     6,
       6,     6,     6,     6,     6,     8,     6,     8,     6,     8,
       7,     9,     6,     8,     7,     9,     8,    10,     8,    10,
       9,    11,     8,    10,     9,    11,     8,     8,     7,     6,
       6,     6,     6,     8,     8,     8,     8,     6,     9,     1,
       0,     2,     0,     8,     8,     8,    10,     9,     8,     1,
       0,     6,     6,     6,     6,     6,     6,     6,     9,     9,
       6,     6,     6,     8,     6,     8,     8,     8,     8,     6,
       8,     6,     8,     7,     9,     7,     9,     6,     7,     1,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     7,
       6,     6,     6,     6,     6,     6,     7,     7,     6,     9,
       9,     6,     6,     6,     6,     6,     6,     8,     8,     8,
       6,     7,     6,     6,     4,     7,     6,     4,     4,     4,
       3,     4,     3,     1,     1,     3,     5,     5,     5,     5,
       8,     5,     5,     6,     7,     7,     7,     4,     4,     5,
       4,     6,    13,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     0,     3,     2,     0,     2,     2,     2,     3,     3,
       3,     3,     2,     3,     2,     5,     4,     3,     3,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     2,
       1,     3,     2,     1,     0,     2,     3,     0,     9,    11,
      12,    14,     3,     4,     4,     0,     2,     5,     1,     0,
       1,     2,     3,     3,     3,     1,     2,     1,     1,     1,
       1,     1,     1,     0,     5,     4,     6,     6,     4,     3,
       5,     7,     9,     1,     3,     1,     5,     4,     4,     6,
       4,     6,     6,     5,     7,     9,     6,     1,     0,     6,
      11,    11,    11,    13,     9,    11,     1,     1,    10,     6,
       4,     4,     2,     5,     2,     0,     6,     5,     3,     5,
       1,     3,     1,     1,     2,     1,     1,     1,     1,     1,
       0,     1,     0,     1,     0,     1,     0,     1,     0,     3,
       0,     2,     1,     3,     1,     0,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     3,     0,     1,     1,     1,     1,     1,     3,     9,
      12,     3,     0,     2,     3,     2,     3,     7,     1,     3,
       1,     4,     4,     7,     2,     1,     1,     1,     3,     2,
       8,     5,     0,     4,     3,     0,     2,     0,     7,     2,
       0,     5,     3,     0,     2,     2,     2,     3,     1,     3,
       1,     2,     1,     0,     1,     2,     0,     8,     1,     3,
       3,     5,     2,     1,     3,     9,     1,     2,     5,     5,
       6,     6,     7,     2,     0,     3,     1,     2,     5,     5,
       8,     3,     4,     7,     1,     0,     3,     2,     2,     2,
       2,     0,     2,     2,     1,     1,     3,     3,     1,     2,
       4,     4,     2,     3,     5,     5,     1,     1,     9,     9,
       1,     2,     4,     4,     4,     2,     2,     3,     1,     3,
       9,     1,     2,     0,     7,     7,     0,    10,     6,     0,
       1,     0,     2,     0,     3,     3,     4,     4,     4,     4,
       3,     2,     1,     1,     0,     1,     1,     0,     1,     5,
       1,     0,     1,     1,     1,     0,     3,     1,     3,     4,
       3,     2,     2,     1,     1,     1,     0,     2,     4,     5,
       6,     4,     5,     2,     3,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     4,     0,     1,
       3,     1,     1,     1,     1,     1,     2,     4,     4,     5,
       2,     0,     1,     3,     1,     0,     1,     2,     3,     2,
       4,     2,     3,     2,     0,     4,     5,     2,     0,     1,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     1,
       4,     3,     4,     5,     4,     5,     4,     5,     2,     4,
       1,     1,     0,     2,     0,     1,     4,     5,     4,     0,
       2,     2,     2,     1,     1,     0,     5,     2,     1,     1,
       2,     2,     4,     1,     3,     1,     2,     3,     6,     4,
       0,     2,     6,     2,     1,     3,     4,     0,     2,     0,
       2,     0,     2,     4,     0,     1,     0,     1,     3,     3,
       7,    12,     1,     3,     2,     3,     3,     1,     2,     2,
       2,     2,     1,     1,     3,     3,     2,     2,     3,     5,
       6,     2,     3,     3,     4,     0,     1,     1,     1,     1,
       1,     2,     4,     1,     1,     1,     1,     1,     1,     2,
       3,     3,     0,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     1,     3,     0,     1,     1,     1,     1,
       5,     2,     1,     1,     1,     1,     4,     1,     2,     2,
       1,     3,     3,     2,     1,     0,     5,     2,     5,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     0,     1,     4,
       1,     1,     3,     3,     5,     3,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     3,     2,     2,     3,     5,     4,     6,
       3,     5,     4,     6,     4,     6,     5,     7,     3,     2,
       4,     2,     3,     3,     4,     3,     4,     3,     4,     5,
       6,     6,     7,     6,     7,     3,     4,     4,     6,     3,
       3,     4,     3,     4,     4,     5,     4,     5,     1,     1,
       3,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     5,     6,     3,
       4,     1,     1,     2,     4,     1,     1,     1,     2,     2,
       2,     2,     1,     1,     4,     3,     5,     6,     8,     6,
       6,     4,     4,     3,     1,     1,     1,     1,     5,     1,
       1,     4,     1,     4,     1,     4,     1,     4,     1,     1,
       1,     1,     1,     1,     1,     6,     4,     4,     6,     4,
       4,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     5,     7,     7,     9,     5,     4,
       6,     5,     7,     7,     8,     4,     7,     4,     6,     6,
       4,     5,     4,     5,     2,     3,     3,     3,     4,     0,
       4,     1,     3,     3,     1,     1,     1,     1,     2,     0,
       2,     2,     0,     2,     3,     3,     4,     2,     2,     5,
       0,     5,     0,     2,     0,     1,     3,     3,     2,     2,
       0,     6,     1,     0,     3,     0,     3,     3,     3,     0,
       1,     4,     2,     2,     2,     2,     2,     3,     2,     2,
       3,     0,     4,     3,     5,     4,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     1,     4,     1,
       4,     1,     2,     1,     2,     1,     3,     1,     3,     1,
       3,     3,     1,     0,     1,     3,     3,     3,     2,     1,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     7,     5,     3,     5,     5,     3,
       3,     5,     3,     2,     1,     1,     3,     5,     1,     2,
       4,     2,     0,     1,     0,     1,     2,     2,     2,     3,
       5,     1,     0,     1,     2,     0,     2,     1,     0,     2,
       4,     2,     1,     0,     3,     0,     1,     2,     2,     2,
       2,     3,     2,     3,     2,     0,     1,     3,     3,     3,
       3,     3,     0,     3,     3,     0,     1,     3,     7,     7,
       3,     0,     1,     0,     1,     3,     3,     2,     1,     1,
       1,     3,     1,     2,     1,     3,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     6,     2,     3,
       5,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     3,    10,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 902 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 28819 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 907 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 28827 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 911 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 28836 "gram.c" /* yacc.c:1646  */
    break;

  case 5:
#line 916 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28848 "gram.c" /* yacc.c:1646  */
    break;

  case 6:
#line 924 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28860 "gram.c" /* yacc.c:1646  */
    break;

  case 7:
#line 932 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 28872 "gram.c" /* yacc.c:1646  */
    break;

  case 8:
#line 952 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 28888 "gram.c" /* yacc.c:1646  */
    break;

  case 9:
#line 964 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 28899 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1107 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28905 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1114 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28911 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1115 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28917 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1119 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28923 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28929 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1124 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 28935 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1125 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 28941 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1129 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 28947 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1130 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 28953 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1131 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 28959 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1141 "gram.y" /* yacc.c:1646  */
    {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 28970 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1157 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 28983 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1179 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 28989 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1180 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28995 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1184 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29001 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1185 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29007 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1190 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 29016 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 29024 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1199 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29038 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1209 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 29050 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1217 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 29058 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1221 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 29066 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1225 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29074 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1230 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29082 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1234 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 29131 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1281 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 29137 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1284 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 29145 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1288 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29153 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1292 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29161 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1296 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 29169 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1300 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 29177 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1314 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29190 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1333 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 29203 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1342 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 29216 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1353 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29222 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1354 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29228 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1359 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29241 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1368 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29254 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1377 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29267 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1386 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29280 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1408 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29292 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1416 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29304 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1424 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29316 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1432 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29328 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1440 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29340 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1448 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29352 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1466 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29365 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1485 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 29379 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1496 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 29385 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1497 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 29391 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1509 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 29406 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1520 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 29421 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1531 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 29441 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1547 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 29461 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1566 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 29471 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1572 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29477 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1600 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 29488 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1607 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 29499 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1614 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 29510 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1624 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29523 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1633 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29536 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1646 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29549 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1655 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 29562 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1664 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29574 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1672 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29586 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1682 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 29592 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1684 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 29604 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1693 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 29620 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1705 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 29632 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1713 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29645 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1722 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 29661 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1734 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29674 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1743 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29687 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1752 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29699 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1760 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29712 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1770 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 29725 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1780 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29731 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1782 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 29737 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1785 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29743 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1786 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29749 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1790 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 29755 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1792 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 29761 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1795 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 29767 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1796 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 29773 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1797 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 29779 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1798 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 29785 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1802 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 29791 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1803 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 29797 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1804 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 29803 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1810 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29809 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1823 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29817 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1827 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 29825 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1831 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const	   *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 29846 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1848 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 29858 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1855 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 29864 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1856 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29870 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1857 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29876 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1861 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29882 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1862 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29888 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1863 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29894 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1867 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29900 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1868 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29906 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1872 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 29912 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1876 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29918 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1878 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 29930 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1886 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 29942 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1894 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 29954 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1905 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 29966 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1913 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 29977 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1923 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29983 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1924 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 29989 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1929 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 29995 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1930 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 30001 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1936 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30012 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1943 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 30023 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1950 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 30034 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1957 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 30045 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1964 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 30056 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1975 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30068 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1985 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30074 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1986 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30080 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1990 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30086 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1991 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30092 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2000 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 30102 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2016 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 30113 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2023 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 30124 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2030 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 30135 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2037 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 30146 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2044 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 30157 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2064 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30171 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2074 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30185 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2084 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30199 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2094 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30213 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2104 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30229 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2116 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30245 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2128 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30259 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2138 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30273 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2148 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30287 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2158 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30303 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2170 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30319 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2182 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30333 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2192 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30347 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2202 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30361 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2212 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30375 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2222 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30389 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2232 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30403 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2242 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30419 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2254 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30435 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2266 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30449 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2276 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30463 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2288 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30469 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2289 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30475 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2295 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30492 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2309 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30509 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2322 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 30525 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2338 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 30542 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2355 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30555 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2365 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30568 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2375 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30581 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2385 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30594 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2395 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30607 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2405 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30619 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2414 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 30631 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2423 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetExpression;
					n->name = (yyvsp[-6].str);
					n->def = (yyvsp[-1].node);
					(yyval.node) = (Node *) n;
				}
#line 30644 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2433 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 30656 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2442 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30669 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2452 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30682 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2462 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30701 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2478 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30714 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2488 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30727 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2498 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 30740 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2508 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 30753 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2518 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 30773 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2535 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30786 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2545 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30799 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2555 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30812 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2565 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30826 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2576 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30840 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2590 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 30859 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2606 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30872 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2616 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 30884 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2625 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 30903 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2641 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30915 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2650 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30929 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2661 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30943 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2672 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 30954 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2680 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30966 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2689 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30978 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2698 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 30989 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2706 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 31000 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2714 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31012 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2723 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31024 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2732 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31036 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2741 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 31047 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2749 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 31058 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2757 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31070 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2766 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 31081 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2774 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 31092 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2782 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31104 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2791 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31116 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2800 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31128 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2809 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31140 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2818 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 31152 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2827 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 31164 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2836 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 31178 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2847 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 31189 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2855 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 31201 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2864 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31213 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2873 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31225 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2882 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31237 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2891 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31249 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2900 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31261 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2909 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31272 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2917 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31283 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2925 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31294 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2933 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31305 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2940 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31317 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2950 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31323 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2951 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31329 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2956 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31342 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2964 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31348 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2968 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31354 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2969 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31360 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2974 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31372 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2982 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31384 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2990 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31396 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2998 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31408 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3008 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31414 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31420 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31426 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3016 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31432 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3017 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 31438 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3023 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 31446 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3027 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 31454 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3031 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 31463 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3036 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 31471 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3043 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31477 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31483 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3050 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 31491 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3054 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 31499 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3058 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 31514 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3069 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 31522 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3075 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 31528 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3076 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31534 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3082 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 31589 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3135 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 31604 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3148 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 31620 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3162 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 31633 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3174 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 31641 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3181 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 31649 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3185 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 31657 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3199 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 31671 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3211 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31677 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3212 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31683 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3218 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 31696 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3228 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31710 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3239 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31724 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3250 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 31744 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3277 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31755 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3284 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31766 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3320 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 31804 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3354 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 31828 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3376 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31834 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3377 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31840 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3381 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31846 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3382 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31852 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3391 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31858 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3392 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31864 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3393 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31870 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3396 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31876 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3397 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31882 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3402 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31888 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3403 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31894 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3408 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 31902 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3412 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 31910 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3416 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31918 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3420 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31926 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3424 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 31934 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3428 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 31942 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3432 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31950 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3436 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31958 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3440 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31966 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3444 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 31974 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3448 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 31982 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3452 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) makeNode(A_Star), (yylsp[-3]));
				}
#line 31990 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3456 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31998 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3460 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 32006 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3464 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32014 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3473 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 32022 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3476 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 32028 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32036 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3484 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 32042 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3495 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 32050 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3499 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 32058 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3506 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 32066 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3512 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 32072 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3513 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 32078 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3514 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 32084 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3515 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 32090 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3516 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32096 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3521 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32104 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3525 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32112 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3532 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 32118 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3546 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32140 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3566 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32162 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3586 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32185 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3607 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32208 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3628 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32231 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3649 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32254 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3680 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32260 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3681 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32266 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3682 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32272 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3683 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32278 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3685 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 32289 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3692 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 32300 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3698 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 32306 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3699 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 32312 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3703 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32318 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3704 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32324 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32330 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32336 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3714 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32344 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3718 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32352 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32360 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32368 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3735 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32374 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3736 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32380 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3737 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32386 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3741 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32392 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3742 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32398 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3746 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->storage_name = (yyvsp[-3].str);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32424 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3770 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32447 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3789 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 32470 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3810 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32476 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3811 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 32482 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3815 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32488 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3816 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32494 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3820 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32500 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3821 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 32506 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3825 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32512 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3826 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32518 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3830 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 32524 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3831 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32530 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3836 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 32542 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3843 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32548 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3844 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32554 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3846 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32572 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3878 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-2]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32587 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3889 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 32599 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3897 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32616 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3910 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32632 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3922 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32649 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3935 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32663 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3945 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 32677 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3955 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 32705 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3979 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32726 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3998 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32732 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3999 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32738 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 4000 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32744 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 4004 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 32750 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 4005 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 32756 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 4025 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 32768 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 4033 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32780 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 4041 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32792 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 4049 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32804 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 4061 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 32817 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 4072 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 32823 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 4073 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 32829 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 4074 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 32835 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 4078 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 32841 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 4079 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 32847 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 4080 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 32853 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 4081 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 32859 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 4082 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 32865 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 4083 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 32871 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 4084 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 32877 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 4085 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 32883 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 4086 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 32889 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 4087 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 32895 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 4097 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 32907 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 4104 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32913 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 4109 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 32931 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 4123 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-3]);
					n->keys = list_make1(makeString((yyvsp[-1].str)));
					/* no NOT VALID support yet */
					processCASbits((yyvsp[0].ival), (yylsp[0]), "NOT NULL",
								   NULL, NULL, NULL,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 32949 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 4138 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-9]);
					n->nulls_not_distinct = !(yyvsp[-8].boolean);
					n->keys = (yyvsp[-6].list);
					n->without_overlaps = (yyvsp[-5].boolean);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32971 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 4156 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 32991 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4173 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-9]);
					n->keys = (yyvsp[-6].list);
					n->without_overlaps = (yyvsp[-5].boolean);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33012 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4190 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33032 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4208 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33054 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4227 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 33078 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4248 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 33084 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4249 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 33090 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4253 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33096 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4254 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33102 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4258 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33108 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4259 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33114 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4263 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33120 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4264 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33126 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4268 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 33134 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4273 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33140 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33146 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4278 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 33154 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4282 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 33166 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4290 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 33174 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4294 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 33182 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4300 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 33188 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4302 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 33194 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4306 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 33202 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4311 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 33210 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4317 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33216 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4318 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33222 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4323 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 33236 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4333 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 33250 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4343 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 33262 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4351 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 33274 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4359 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 33290 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4373 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 33304 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4385 "gram.y" /* yacc.c:1646  */
    {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 33312 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4392 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33324 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4400 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33336 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4408 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33348 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4416 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 33360 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4424 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 33372 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4433 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33378 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4434 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33384 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4438 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 33390 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4439 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 33396 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4443 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = parsePartitionStrategy((yyvsp[-3].str));
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 33410 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4454 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 33416 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4455 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 33422 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4459 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 33437 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4470 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 33452 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4481 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 33467 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4494 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33473 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4495 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33479 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4500 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33485 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33491 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4502 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33497 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4505 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 33503 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4506 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 33509 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4507 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 33515 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4508 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 33521 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4511 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33527 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4512 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33533 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4515 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33539 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4516 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33545 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4519 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33551 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4541 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33567 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4554 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33583 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4574 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 33589 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4575 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 33595 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4579 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 33605 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4585 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 33615 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4591 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 33625 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4608 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 33638 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4617 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 33651 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4639 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33669 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4653 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33687 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33703 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4685 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33709 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4686 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33715 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4687 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33721 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4700 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33739 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4714 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 33757 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4731 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 33773 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4744 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 33779 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4745 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 33785 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4758 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 33798 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4779 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33813 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4790 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33828 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4804 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33841 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4813 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33854 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4824 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33860 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4825 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33866 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4828 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33872 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4829 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33878 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4832 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33884 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4833 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33890 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4837 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 33898 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4841 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33906 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4845 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 33914 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4849 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 33922 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4853 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33930 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33938 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4861 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 33946 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4865 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 33954 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4869 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 33962 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4873 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33970 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4877 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 33979 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4882 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33987 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4886 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33995 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4890 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34003 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4900 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 34009 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4901 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 34015 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4903 "gram.y" /* yacc.c:1646  */
    {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 34026 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4909 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 34032 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4912 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34038 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4913 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34044 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4926 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 34064 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4943 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34080 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4957 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34086 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4958 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34092 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4966 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34098 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4967 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 34104 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4971 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34110 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4972 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34116 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4976 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34122 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4977 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34128 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4981 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34134 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4982 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34140 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4998 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34154 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 5009 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 34160 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 5010 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 34166 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 5024 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34178 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 5032 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34190 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 5050 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34203 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 5059 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34216 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 5071 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34222 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 5073 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34228 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 5078 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34236 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 5082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34244 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 5086 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 34255 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 5093 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 34263 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 5105 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34275 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 5116 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34281 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 5118 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34287 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 5123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34295 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 5136 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 34309 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 5146 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34323 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 5156 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34337 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 5166 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 34351 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 5176 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34365 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 5186 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34379 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 5196 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34393 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 5206 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 34407 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 5216 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 34421 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 5226 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34435 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 5236 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34449 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 5246 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 34463 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 5256 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34477 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 5275 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34490 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 5286 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 34496 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 5287 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 34502 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 5288 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 34508 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5289 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 34514 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5293 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34520 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5294 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34526 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5298 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34532 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5299 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34538 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5310 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34551 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5319 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 34564 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5331 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34570 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5332 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34576 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5337 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34584 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5341 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34592 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5348 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34598 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34606 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5357 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34614 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5364 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 34622 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5368 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 34631 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5373 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 34640 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5378 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 34648 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5385 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 34656 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5391 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34662 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5396 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34668 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5408 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34684 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5421 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34700 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5435 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34706 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5436 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34712 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5441 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34718 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5442 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34724 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5446 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34730 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5447 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34736 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5458 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34750 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5468 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 34763 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5477 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34775 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5497 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34798 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5518 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34821 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5539 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34845 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5561 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34869 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5594 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 34885 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5608 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 34891 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5609 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 34897 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5614 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 34909 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5622 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 34920 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5638 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34934 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5648 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34948 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5660 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 34954 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5661 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 34960 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5674 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34973 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5683 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34986 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5701 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34999 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5728 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35016 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5745 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35031 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5758 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35037 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5759 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35043 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5763 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35049 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5764 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35055 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5768 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35061 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5769 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 35067 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5773 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35073 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5774 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 35079 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5779 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 35097 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5792 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35103 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5796 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35109 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5797 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 35115 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5801 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 35121 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5802 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 35127 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5803 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 35133 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5804 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 35139 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5805 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 35145 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5816 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 35158 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5827 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 35164 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5828 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 35170 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5842 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 35195 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5866 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 35225 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5894 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 35231 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5895 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 35237 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5896 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 35243 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5901 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35249 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5903 "gram.y" /* yacc.c:1646  */
    {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 35272 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5925 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 35278 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5927 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 35284 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5929 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 35290 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5931 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 35296 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 35302 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35308 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5938 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35314 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5942 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35320 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5943 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 35326 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5948 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 35339 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5959 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35345 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5960 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35351 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5964 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35357 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5973 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35363 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5977 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35369 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5982 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 35377 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5986 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 35389 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 6001 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35395 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 6002 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35401 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 6006 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35407 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 6007 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35413 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 6016 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35419 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 6017 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35425 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 6018 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35431 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 6023 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 35439 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 6026 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35445 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 6027 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35451 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 6028 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35457 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 6032 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 35463 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 6033 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 35469 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 6038 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35475 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 6040 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 35503 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 6066 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 35509 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 6067 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 35515 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 6068 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 35521 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 6069 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 35527 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 6070 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 35533 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 6071 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 35539 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 6086 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35553 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 6098 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 35567 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 6111 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35573 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 6113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35579 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 6118 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 35585 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 6123 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35591 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 6125 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35597 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 6130 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 35609 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 6140 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 35615 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 6141 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 35621 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 6142 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 35627 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 6143 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 35633 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 6155 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 35645 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 6174 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35661 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 6186 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35678 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 6199 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35693 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 6210 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35708 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 6221 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 35724 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 6233 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35737 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 6242 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 35749 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 6250 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35761 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 6258 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35775 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 6268 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35789 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 6278 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35803 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 6288 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35817 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 6298 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35831 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 6308 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35846 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 6319 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 35860 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 6329 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35875 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 6341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35881 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 6344 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35887 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 6345 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35893 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6349 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35901 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 35909 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6359 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 35915 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6360 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 35921 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6361 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 35927 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6362 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 35933 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6363 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35939 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6364 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 35945 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6367 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35951 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6370 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 35957 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6371 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 35963 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6380 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 35971 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35977 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6387 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35983 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35989 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6393 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35995 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6404 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36011 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6416 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36027 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6428 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36043 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6440 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 36059 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6452 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * The following problems must be solved before this can be
				 * implemented:
				 *
				 * - There must be no instance of the target value in
				 *   any table.
				 *
				 * - The value must not appear in any catalog metadata,
				 *   such as stored view expressions or column defaults.
				 *
				 * - The value must not appear in any non-leaf page of a
				 *   btree (and similar issues with other index types).
				 *   This is problematic because a value could persist
				 *   there long after it's gone from user-visible data.
				 *
				 * - Concurrent sessions must not be able to insert the
				 *   value while the preceding conditions are being checked.
				 *
				 * - Possibly more...
				 */
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("dropping an enum value is not implemented"),
						 parser_errposition((yylsp[-2]))));
			}
#line 36090 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6480 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36096 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6481 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36102 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6499 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36118 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6513 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36124 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36130 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6519 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36147 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6533 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36161 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6543 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 36174 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6552 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 36188 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6562 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36200 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6571 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36206 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6572 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36212 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6575 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36218 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6576 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36224 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6579 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36230 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6580 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36236 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6581 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36242 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6585 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 36260 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6598 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36266 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6604 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36278 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6615 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36292 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6625 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36306 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6637 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36312 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6638 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36318 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6643 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36331 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6652 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36344 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6665 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36359 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6676 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36374 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6690 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36389 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6701 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36404 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6724 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36416 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6735 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 36428 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6754 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36443 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6765 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36458 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6776 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36473 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6787 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36488 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6798 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36503 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6809 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36518 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6820 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36533 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6831 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36548 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6842 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36563 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6853 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36578 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6864 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 36593 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6875 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 36608 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6889 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 36614 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6890 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 36620 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6891 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 36626 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6892 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 36632 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6893 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 36638 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6894 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 36644 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6895 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 36650 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6896 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 36656 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6897 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 36662 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6898 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 36668 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6899 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 36674 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6900 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 36680 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6901 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 36686 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6911 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 36692 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6912 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 36698 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6913 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 36704 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6914 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 36710 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6915 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 36716 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6919 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 36722 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6920 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 36728 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6921 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 36734 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6922 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 36740 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6923 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 36746 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6924 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 36752 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6925 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 36758 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6926 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 36764 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6931 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 36770 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6932 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 36776 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6933 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 36782 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 36788 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6938 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 36794 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6941 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36800 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6942 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36806 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6946 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36812 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36818 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 36824 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 36830 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6965 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36843 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6976 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36849 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6977 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36855 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6978 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36861 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6989 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36874 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6998 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36887 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 7007 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36900 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 7016 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36913 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 7025 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36926 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 7034 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36939 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 7043 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36952 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 7052 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36965 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 7061 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36978 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 7070 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36996 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 7084 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37009 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 7093 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37022 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 7102 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37035 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 7111 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37048 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 7120 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37061 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 7129 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37074 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 7138 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37087 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 7147 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37100 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 7158 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37106 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 7159 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37112 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 7175 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37126 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 7186 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37140 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 7197 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37154 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 7208 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37168 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 7219 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37182 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 7230 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37196 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 7241 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37210 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 7252 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37224 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 7263 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37238 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 7274 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37252 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 7285 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37258 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 7286 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37264 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 7289 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37270 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 7290 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37276 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 7301 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 37287 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 7308 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 37298 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 7317 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37311 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 7326 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37324 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 7335 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37337 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 7344 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37350 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 7353 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37363 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 7362 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 37376 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 7371 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37389 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 7380 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37402 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 7389 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37415 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 7398 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37428 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7407 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37441 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7416 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37454 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7425 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37467 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7434 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37480 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7443 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37493 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7452 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37506 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7479 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 37524 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7497 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37543 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7513 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37562 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7540 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37568 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7542 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37574 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7544 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37580 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 7546 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37592 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 7554 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 37604 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7563 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 37610 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7564 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 37616 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7568 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37628 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7576 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37640 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7584 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37652 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7592 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 37663 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7599 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 37675 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7610 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 37683 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7614 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 37691 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7621 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = (yyvsp[0].str);
			}
#line 37699 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7625 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 37707 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7636 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37720 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7645 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37733 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7654 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37746 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7663 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37759 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7672 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37772 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7681 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37785 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7690 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37798 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7699 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37811 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7708 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37824 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7717 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37837 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7726 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37850 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7735 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37863 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7744 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37875 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7752 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37888 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7761 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37901 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7770 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37914 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7779 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37927 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7788 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37940 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7797 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37953 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7806 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37966 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7815 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 37979 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7827 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 37985 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7828 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 37991 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7832 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37997 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7833 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38003 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7838 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38009 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7839 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38015 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7850 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-3].list);
					n->grantee_roles = (yyvsp[-1].list);
					n->opt = NIL;
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38030 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7861 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-5].list);
					n->grantee_roles = (yyvsp[-3].list);
					n->opt = (yyvsp[-1].list);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38045 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7875 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->opt = NIL;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38061 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7887 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					DefElem *opt;

					opt = makeDefElem(pstrdup((yyvsp[-7].str)),
									  (Node *) makeBoolean(false), (yylsp[-7]));
					n->is_grant = false;
					n->opt = list_make1(opt);
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38080 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7904 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38086 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7905 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38092 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7910 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem(pstrdup((yyvsp[-1].str)), (yyvsp[0].node), (yylsp[-1]));
			}
#line 38100 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7916 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 38106 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7917 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 38112 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7918 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(false); }
#line 38118 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7921 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38124 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7922 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 38130 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7933 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38142 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7943 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38148 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7944 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38154 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7949 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38162 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7953 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38170 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7957 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38178 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7969 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 38195 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7983 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38213 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7998 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38231 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 8014 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 38237 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 8015 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 38243 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 8016 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 38249 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 8017 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 38255 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 8018 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 38261 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 8019 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 38267 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 8034 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 38301 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 8066 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 38335 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 8098 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38341 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 8099 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38347 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 8103 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 38353 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 8104 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 38359 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 8107 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 38365 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 8108 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 38371 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 8114 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 38387 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 8126 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 38403 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 8145 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 38412 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 8150 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 38421 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 8155 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 38430 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 8161 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38436 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 8162 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38442 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 8165 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 38448 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 8166 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 38454 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 8169 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38460 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 8170 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38466 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 8174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 38472 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 8175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 38478 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 8176 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 38484 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 8179 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 38490 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 8180 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 38496 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 8181 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 38502 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 8199 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38519 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 8213 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38537 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 8228 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38554 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 8242 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38571 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 8257 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38577 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 8258 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38583 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 8261 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38589 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 8262 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38595 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 8266 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38601 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 8267 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38607 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 8271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38613 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 8273 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38619 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 8278 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 38632 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 8292 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38644 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 8300 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38656 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 8308 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 38669 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 8323 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38675 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 8324 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38681 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 8328 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38687 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 8330 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38693 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 8345 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38707 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 8355 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38721 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 8365 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38735 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 8375 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38749 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 8385 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 38763 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 8397 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 38769 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 8398 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 38775 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 8399 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38781 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 8400 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 38787 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 8401 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 38793 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 8412 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 38805 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 8426 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 38811 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 8428 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38821 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 8434 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 38832 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 8444 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38840 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 8448 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38849 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 8453 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 38858 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 8461 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 38873 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 8503 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 38881 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 8507 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 38889 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 8511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 38897 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 8515 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 38906 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 8522 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 38912 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 8523 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 38918 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 8528 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 38931 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 8539 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 38937 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 8541 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 38943 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 8546 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38949 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 8551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38955 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 8552 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38961 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 8560 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 38969 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 8564 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 38977 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8568 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 38985 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8572 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 38993 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 39001 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8580 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 39009 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8584 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 39017 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 8588 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 39025 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 8592 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 39033 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8596 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 39041 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8600 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39049 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8604 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 39057 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8608 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 39065 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8612 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 39073 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8616 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39081 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8620 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 39090 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8625 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39098 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8632 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39106 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8636 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39114 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8640 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39122 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8644 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39130 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8648 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 39138 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39144 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8655 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 39152 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8661 "gram.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 39163 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 39171 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8675 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 39185 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8685 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 39193 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8692 "gram.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 39205 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8700 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 39213 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8711 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 39219 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8712 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 39225 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8716 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39231 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8717 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39237 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8721 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39251 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8734 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 39259 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8738 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 39267 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8753 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39280 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8762 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39293 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8771 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39306 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8783 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39312 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8784 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39318 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8808 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39333 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8819 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39348 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8830 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39363 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8841 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39378 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8852 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39393 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8863 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39408 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8877 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39423 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8888 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39438 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8902 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39453 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8913 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39468 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8927 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 39480 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 39486 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 39492 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8939 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 39498 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8944 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39504 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8946 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 39510 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8950 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 39516 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 39522 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8957 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 39534 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8976 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 39545 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8985 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39551 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8986 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39557 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8991 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 39565 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8995 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39573 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 9008 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 39588 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 9020 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 39603 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 9032 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 39618 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 9044 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 39624 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 9045 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 39630 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 9046 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 39636 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 9051 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39651 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 9063 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39657 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 9064 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39663 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 9075 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 39678 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 9088 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 39686 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 9092 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 39694 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 9096 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 39702 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 9100 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 39710 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 9107 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 39724 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 9129 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39741 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 9142 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = REINDEX_OBJECT_SCHEMA;
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39758 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 9155 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 39775 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 9169 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 39781 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 9170 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 39787 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 9173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 39793 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 9174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 39799 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 9177 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39805 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 9178 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 39811 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 9189 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 39825 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 9199 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 39839 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 9217 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39853 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 9227 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39867 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 9237 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39881 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 9247 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39895 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 9257 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39909 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 9267 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39923 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 9277 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39937 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 9287 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39951 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 9297 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39965 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 9307 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39979 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 9317 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 39993 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 9327 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40007 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 9337 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40022 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 9348 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40037 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 9359 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40051 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 9369 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40065 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 9379 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40079 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 9389 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40093 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 9399 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40107 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 9409 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40121 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 9419 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40136 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 9430 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40151 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 9441 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40166 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 9452 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40181 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 9463 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40196 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 9474 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40211 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9485 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40226 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9496 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40241 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9507 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40256 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9518 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40271 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9529 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40286 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9540 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40301 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 9551 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40317 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 9563 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40333 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9575 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40349 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9587 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40365 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9599 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40381 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9611 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40397 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9623 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40412 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9634 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40427 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9645 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40443 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9657 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40459 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9669 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40474 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 9680 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40489 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 9691 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 40502 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9700 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40516 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9710 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40530 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9720 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40544 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9730 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40558 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9740 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40572 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9750 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40586 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9760 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40600 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9770 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40614 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9780 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40628 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9790 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40645 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9808 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 40651 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9809 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 40657 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9820 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40671 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9830 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40685 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9840 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40699 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9850 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40714 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9861 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40728 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9871 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40742 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9882 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40748 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9883 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 40754 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9894 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40768 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9904 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40782 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9914 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40796 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9924 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40810 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9934 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40824 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9944 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40838 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9954 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40852 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9964 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40866 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9974 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40880 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9984 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40894 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9994 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40908 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 10004 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40922 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 10014 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40936 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 10024 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40950 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 10034 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40964 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 10044 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40978 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 10054 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40992 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 10064 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41006 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 10074 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41020 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 10084 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41034 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 10094 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41048 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 10104 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41062 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 10114 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41076 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 10124 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41090 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 10134 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41104 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 10144 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41118 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 10154 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41132 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 10173 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41144 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 10182 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41150 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 10183 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 41156 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 10187 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 41162 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 10189 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 41168 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 10191 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0])); }
#line 41174 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 10196 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 41180 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 10197 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 41186 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 10198 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 41192 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 10199 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 41198 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 10200 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 41204 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 10213 "gram.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41216 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 10229 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41229 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 10238 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41242 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 10247 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41255 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 10256 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41268 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 10265 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41281 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 10274 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41294 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 10283 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41307 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 10292 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41320 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 10301 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41333 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 10310 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41346 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 10319 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41359 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 10328 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41372 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 10337 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41385 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 10346 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41398 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 10355 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41411 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 10364 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41424 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 10373 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41437 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 10382 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41450 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 10391 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41463 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 10400 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41476 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 10409 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41489 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 10418 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41502 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 10427 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41515 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 10436 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41528 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 10464 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41540 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 10472 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 41553 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 10481 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 41567 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 10507 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 41580 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 10516 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41591 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 10523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41601 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 10529 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 41632 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 10556 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 41646 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 10567 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 41659 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 10576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 41669 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 10584 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 41675 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 10586 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 41681 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 10608 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41693 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 10616 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 41707 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 10626 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 41721 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 10636 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 41735 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 10655 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41749 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 10674 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41763 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 10684 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 41777 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 10694 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41791 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 10704 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41806 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 10715 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41821 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 10726 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41836 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 10737 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 41851 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 10748 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 41866 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 10759 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41880 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10777 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 41893 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10786 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 41906 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10805 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41923 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10820 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41929 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10821 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41935 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10822 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41941 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10828 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 41951 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10834 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 41961 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10850 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41967 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10851 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 41973 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10854 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 41979 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10855 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 41985 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 10856 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 41991 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 10857 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 41997 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 10861 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42003 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 10862 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42009 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 10863 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42015 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10876 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42027 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10886 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42033 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10887 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 42039 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10891 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42050 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10901 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42061 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10908 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42072 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10928 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 42086 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10938 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 42099 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10947 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 42113 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10957 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 42127 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10967 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42140 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10976 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42153 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10985 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42166 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10994 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42179 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 11003 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42192 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 11012 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42205 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 11021 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42218 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 11030 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 42231 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 11042 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 42244 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 11051 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 42258 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 11069 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 42265 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 11072 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 42272 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 11075 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 42279 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 11078 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 42286 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 11081 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 42293 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 11088 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42299 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 11090 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 42305 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 11092 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42311 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 11098 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42317 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 11102 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42323 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 11103 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42329 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 11104 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42335 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 11118 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42352 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 11132 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42369 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 11146 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 42391 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 11165 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 42413 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 11185 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 42419 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 11186 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 42425 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 11187 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 42431 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 11188 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 42437 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 11199 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42448 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 11216 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42460 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 11226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42466 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 11227 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42472 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 11231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42478 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 11232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42484 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 11237 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node), (yylsp[-2]));
				}
#line 42492 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 11241 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 42500 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 11245 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 42508 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 11262 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42514 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 11263 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 42520 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 11264 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42526 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 11265 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42532 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 11266 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42538 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 11267 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42544 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 11268 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42550 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 11288 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 42562 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 11296 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 42574 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 11304 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 42587 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 11313 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 42598 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 11323 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42610 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 11341 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42623 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 11350 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42636 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 11359 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42649 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 11368 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42662 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 11380 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 42670 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 11384 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 42678 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 11395 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 42686 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 11407 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 42697 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 11425 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42708 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 11432 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 42719 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 11449 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 42733 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 11463 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42746 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 11473 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42758 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 11482 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42770 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 11491 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 42783 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 11501 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42798 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 11513 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42813 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 11525 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42826 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 11548 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42838 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 11559 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 42854 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 11571 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 42870 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 11583 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 42886 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 11595 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 42902 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 11607 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42916 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 11617 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42930 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 11646 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 42945 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 11669 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 42958 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 11678 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 42971 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 11688 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 42986 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 11700 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 43001 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 11712 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43016 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 11725 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43022 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 11726 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 43028 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 11739 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 43053 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 11760 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 43066 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 11771 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 43082 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 11783 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 43095 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 11795 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 43103 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 11799 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 43111 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 11811 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43119 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 11817 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43125 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 11818 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 43131 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 11819 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "format"; }
#line 43137 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 11823 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 43143 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 11824 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 43149 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 11825 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43155 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 11829 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43161 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 11830 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43167 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 11834 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43173 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 11835 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43179 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 11838 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43185 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 11839 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43191 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 11842 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43197 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 11843 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43203 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 11847 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43209 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 11848 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43215 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 11853 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 43223 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 11860 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43229 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 11862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43235 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 11866 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43241 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11867 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43247 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11881 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 43259 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11889 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43274 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 11900 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43286 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 11908 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 43298 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 11938 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43311 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 11948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43317 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 11949 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43323 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11968 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43335 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 11977 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 43356 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 11995 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 43377 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 12013 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43383 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 12014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43389 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 12025 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 43402 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 12034 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 43415 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 12043 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 43428 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 12052 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 43441 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 12072 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 43453 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 12089 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 43461 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 12093 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 43470 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 12101 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43480 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 12107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43491 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 12114 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43501 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 12120 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43512 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 12127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 43522 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 12135 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 43528 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 12136 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 43534 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 12141 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43540 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 12143 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 43546 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 12148 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43558 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 12159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 43571 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 12169 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 43584 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 12178 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 43592 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 12185 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 43604 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 12194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 43616 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 12202 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 43624 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 12208 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43630 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 12209 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43636 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 12222 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 43651 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 12235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43657 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 12236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43663 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 12248 "gram.y" /* yacc.c:1646  */
    {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 43676 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 12258 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 43682 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 12259 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 43688 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 12262 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 43694 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 12263 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 43700 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 12264 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 43706 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 12265 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 43712 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 12266 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 43718 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 12267 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 43724 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 12268 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 43730 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 12269 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 43736 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 12272 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43742 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 12273 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43748 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 12277 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 43754 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 12278 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 43760 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 12279 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 43766 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 12295 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 43782 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 12309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43788 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 12310 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 43794 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 12315 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 43803 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 12320 "gram.y" /* yacc.c:1646  */
    {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 43828 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 12344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43840 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 12354 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43846 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 12355 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 43852 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 12371 "gram.y" /* yacc.c:1646  */
    {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-8].with);
					m->relation = (yyvsp[-5].range);
					m->sourceRelation = (yyvsp[-3].node);
					m->joinCondition = (yyvsp[-1].node);
					m->mergeWhenClauses = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 43868 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 12385 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43874 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 12386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 43880 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 12391 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43891 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 12398 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43902 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 12405 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = false;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 43913 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 12412 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = true;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 43927 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 12422 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = false;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 43941 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 12434 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43947 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 12435 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43953 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 12440 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 43967 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 12453 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 43981 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 12466 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 43994 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 12475 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44007 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 12484 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44020 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 12493 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44033 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 12502 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 44046 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 12514 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 44054 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 12526 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44068 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 12537 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44074 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 12540 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44080 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 12541 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 44086 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 12542 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 44092 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 12543 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 44098 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 12544 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 44104 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 12545 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 44110 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 12548 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44116 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 12549 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 44122 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 12550 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44128 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 12603 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44134 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 12604 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44140 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 12619 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44146 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 12621 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44157 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 12628 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44169 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 12636 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44181 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 12644 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 44193 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 12652 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44205 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 12660 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44217 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 12668 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44229 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 12678 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44235 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 12679 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44241 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 12714 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44259 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 12730 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44278 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 12744 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44284 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 12746 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 44307 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 12765 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44315 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 12769 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44323 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 12773 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44331 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 12788 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44342 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 12795 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44353 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 12802 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 44364 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 12811 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44370 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 12812 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44376 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 12816 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 44393 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 12831 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 44399 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 12832 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 44405 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 12833 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 44411 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 12838 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 44425 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 12848 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 44439 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 12858 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 44447 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 12865 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 44463 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 12877 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 44479 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 12889 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 44487 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 12895 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 44493 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 12896 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 44499 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 12901 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 44514 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 12912 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 44520 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12921 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44529 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12926 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44538 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 12931 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44547 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 12936 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44556 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12941 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44568 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12949 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44580 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 12957 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 44589 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 12962 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44598 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 12967 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44607 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 12978 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 44613 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 12979 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 44619 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 12980 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 44625 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 12987 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 44631 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 12988 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44637 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 12997 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44643 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 12998 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44649 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 13002 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44655 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 13003 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44661 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 13007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44667 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 13011 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 44673 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 13012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 44679 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 13016 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 44692 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 13025 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 44705 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 13038 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 44714 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 13043 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 44723 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 13048 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 44731 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 13052 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44744 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 13063 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 44750 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 13064 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 44756 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 13069 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44769 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 13078 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 44782 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 13094 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44795 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 13103 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44808 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 13112 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 44821 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 13121 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 44834 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 13133 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44840 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 13136 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44846 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 13140 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44852 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 13142 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 44861 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 13149 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44867 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 13169 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44873 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 13171 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44879 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 13173 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44885 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 13177 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 44891 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 13178 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 44897 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 13182 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44903 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 13183 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44909 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 13186 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44915 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 13187 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44921 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 13213 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 44933 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 13221 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 44945 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 13231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44951 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 13232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 44957 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 13236 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44963 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 13237 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44969 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 13238 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44975 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 13239 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44981 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 13240 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44987 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 13245 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 44995 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 13258 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45003 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 13265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45011 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 13272 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 45019 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 13278 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45025 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 13279 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45031 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 13283 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45037 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 13284 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45043 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 13288 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45049 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 13289 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45055 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 13293 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45061 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 13294 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 45067 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 13299 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 45080 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 13310 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 45086 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 13311 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 45092 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 13312 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 45098 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 13313 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 45104 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 13317 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45110 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 13318 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45116 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 13329 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45127 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 13336 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45138 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 13354 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45144 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 13355 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45150 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 13359 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45156 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 13360 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45162 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 13367 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 45171 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 13372 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 45184 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 13381 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45196 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 13389 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45209 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 13398 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45220 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 13405 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45232 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 13413 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45245 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 13422 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45258 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 13431 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 45266 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 13435 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 45275 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 13461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 45283 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 13465 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 45301 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 13479 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 45326 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 13500 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 45352 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 13522 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45369 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 13535 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45387 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 13552 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45397 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 13558 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45406 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 13563 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45416 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 13569 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45425 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 13575 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 45431 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 13576 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 45437 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 13587 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 45447 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 13592 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 45453 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 13601 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 45461 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 13605 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 45469 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 13609 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45480 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 13616 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45491 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 13623 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 45499 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 13628 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 45505 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 13629 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 45511 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 13630 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 45517 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 13631 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 45523 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 13652 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 45531 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 13656 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45539 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 13664 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 45550 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 13671 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45558 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 13678 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 45569 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 13685 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 45580 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 13692 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 45591 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 13702 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 45597 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 13703 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 45603 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 13717 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45611 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 13721 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 45623 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 13729 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45635 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 13743 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 45650 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 13756 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 45656 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 13757 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45662 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 13773 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 45677 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 13784 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 45692 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 13797 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 45698 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 13801 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 45704 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 13802 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 45710 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 13805 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45716 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 13806 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45722 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 13809 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45728 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 13810 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45734 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 13815 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45740 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 13816 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45746 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 13821 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45752 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13823 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 45765 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13831 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45771 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13836 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45777 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45783 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13842 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 45791 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13846 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 45799 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13852 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 45822 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13877 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 45837 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13889 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 45852 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13901 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45858 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13902 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45864 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13907 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 45882 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13921 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 45943 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13978 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 45958 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13992 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 45964 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13994 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 45970 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 13999 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 45976 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 14001 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 45982 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 14003 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 45988 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 14005 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 45994 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 14010 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46000 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 14012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 46006 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 14017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 46018 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 14025 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46030 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 14045 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 46039 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 14050 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 46049 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 14057 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 46058 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 14062 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 46068 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 14068 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 46077 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 14073 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 46087 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 14082 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 46093 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 14084 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 46099 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 14086 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 46105 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 14090 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46111 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 14091 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46117 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 14092 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46123 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 14093 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46129 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 14094 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46135 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 14096 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 46144 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 14101 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46154 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 14106 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46160 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 14121 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46166 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 14122 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46172 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 14123 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46178 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 14124 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46184 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 14125 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46190 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 14137 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46200 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 14143 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 46210 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 14150 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46216 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 14151 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46222 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 14158 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46231 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 14163 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46240 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 14168 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46249 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 14173 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46258 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 14178 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46267 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 14183 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46276 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 14188 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46285 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 14193 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46295 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 14199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46305 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 14205 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46315 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 14211 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46324 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 14218 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 46349 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 14239 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 46357 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 14249 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46365 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 14253 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46373 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 14261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46381 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 14265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46390 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 14273 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46403 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 14285 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46421 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 14306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46429 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 14310 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46437 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 14316 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46445 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 14320 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46460 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 14333 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 46470 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 14341 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46482 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 14351 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46488 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 14353 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46494 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 14355 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 46500 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 14357 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46506 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 14359 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46512 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 14361 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46518 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 14365 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 46524 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 14366 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46530 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 14374 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46543 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 14383 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46555 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 14391 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46568 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 14400 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46580 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 14411 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46589 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 14418 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 46595 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 14419 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46601 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 14420 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46607 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 14425 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 46613 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 14427 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 46619 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 14429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 46625 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 14431 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 46631 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 14433 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 46637 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 14435 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46643 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 14437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 46652 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 14442 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 46661 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 14447 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 46671 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 14453 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46683 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 14461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 46692 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 14466 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46703 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 14473 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 46713 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 14479 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46719 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 14484 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 46727 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 14488 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46736 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 14496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("json");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46745 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 14530 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46751 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 14532 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 46757 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 14534 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 46770 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 14543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 46781 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 14550 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   -1);
				}
#line 46792 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 14566 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46798 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 14568 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 46804 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 14570 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46810 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 14572 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46816 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 14574 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46822 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 14576 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46828 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 14578 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46834 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 14580 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46840 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 14582 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46846 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 14584 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46852 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 14586 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46858 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 14588 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46864 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 14590 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46870 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 14592 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46876 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 14595 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46882 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 14597 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 46888 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 14600 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46894 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 14602 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 46900 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 14604 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 46906 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 14606 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 46912 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 14609 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 46921 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 14614 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46934 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 14623 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 46943 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 14628 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 46956 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 14637 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 46965 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 14642 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 46978 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 14651 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 46987 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 14656 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47000 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 14666 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 47013 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 14675 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47026 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 14684 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47039 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 14693 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 47052 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 14712 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47065 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 14721 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47078 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 14730 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47091 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 14739 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47104 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 14748 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 47125 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 14765 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47138 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 14774 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47151 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 14783 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47164 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 14792 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47177 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 14801 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47190 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14810 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47203 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14819 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47211 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14823 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47219 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14827 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47231 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14835 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47243 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14843 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47255 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14851 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47267 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14859 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 47292 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14880 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 47319 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14903 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47335 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14915 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 47346 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14922 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 47366 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14938 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47375 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14943 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47385 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14949 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 47396 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14956 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 47407 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14963 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47419 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14971 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 47431 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14980 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 47441 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14998 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 47451 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 15015 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47470 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 15041 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47476 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 15043 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 47482 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 15045 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47488 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 15047 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47494 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 15049 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47500 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 15051 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47506 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 15053 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47512 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 15055 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47518 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 15057 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47524 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 15059 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47530 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 15061 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47536 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 15063 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47542 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 15065 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47548 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 15067 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47554 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 15069 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47560 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 15071 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47566 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 15073 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47572 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 15075 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47578 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 15077 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47586 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 15081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47594 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 15085 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47603 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 15090 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47613 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 15105 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47619 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 15106 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47625 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 15108 "gram.y" /* yacc.c:1646  */
    {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 47646 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 15125 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 47663 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 15138 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47669 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 15140 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47675 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 15142 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47691 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 15154 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 47720 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 15179 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47736 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 15191 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47752 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 15203 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47764 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 15211 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47779 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 15222 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 47794 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 15233 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 47806 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 15243 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 47816 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 15249 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47829 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 15258 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47843 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 15268 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 47857 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 15278 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 47874 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 15291 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 47888 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 15301 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 47911 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 15332 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 47951 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 15368 "gram.y" /* yacc.c:1646  */
    {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 47965 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 15378 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47971 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 15388 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47977 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 15389 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47983 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 15390 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47989 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 15398 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48000 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 15405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 48008 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 15409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 48016 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 15413 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48024 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 15417 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 48032 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 15421 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48040 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 15425 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 48048 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 15429 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48056 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 15433 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 48064 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 15437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48072 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 15441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 48080 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 15445 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 48088 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 15449 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 48096 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 15453 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("system_user"),
											   NIL,
											   COERCE_SQL_SYNTAX,
											   (yylsp[0]));
				}
#line 48107 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 15460 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 48115 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 15464 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 48123 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 15468 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 48131 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 15472 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 48137 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 15474 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48148 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 15481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48159 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 15488 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 48170 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 15495 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48181 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 15502 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 48196 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 15513 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48214 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 15527 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48228 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 15537 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 48243 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 15548 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 48263 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 15564 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48277 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 15574 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48288 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 15581 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48299 "gram.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 15588 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48310 "gram.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 15595 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 48318 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 15599 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 48330 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 15607 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 48343 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 15616 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 48356 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 15625 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48364 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 15629 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 48372 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 15633 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 48380 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 15637 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 48388 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 15641 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 48396 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 15645 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48409 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 15654 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 48417 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 15658 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 48431 "gram.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 15668 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 48439 "gram.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 15672 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48447 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 15676 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48456 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 15681 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-5].ival);
					n->expr = (yyvsp[-4].node);
					n->typeName = (yyvsp[-2].typnam);
					n->indent = (yyvsp[-1].boolean);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 48471 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 15692 "gram.y" /* yacc.c:1646  */
    {
					/* Support for legacy (non-standard) json_object() */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("json_object"),
											   (yyvsp[-1].list), COERCE_EXPLICIT_CALL, (yylsp[-3]));
				}
#line 48481 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 15701 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-4].list);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48496 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 15712 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 48511 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 15727 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48525 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 15742 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-3].node);
					n->format = (JsonFormat *) (yyvsp[-2].node);
					n->absent_on_null = true;	/* XXX */
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48540 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 15755 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 48554 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 15765 "gram.y" /* yacc.c:1646  */
    {
					JsonParseExpr *n = makeNode(JsonParseExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->unique_keys = (yyvsp[-1].boolean);
					n->output = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 48568 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 15775 "gram.y" /* yacc.c:1646  */
    {
					JsonScalarExpr *n = makeNode(JsonScalarExpr);

					n->expr = (Expr *) (yyvsp[-1].node);
					n->output = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 48581 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 15784 "gram.y" /* yacc.c:1646  */
    {
					JsonSerializeExpr *n = makeNode(JsonSerializeExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 48594 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 15799 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48600 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 15801 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 48606 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 15805 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 48612 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 15807 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 48618 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 15809 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 48624 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 15811 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 48630 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 15814 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48636 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 15817 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48642 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 15818 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48648 "gram.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 15822 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48660 "gram.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 15830 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 48672 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 15839 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 48678 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 15840 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 48684 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 15843 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 48690 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 15844 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48696 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 15845 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48702 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 15848 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 48708 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 15849 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48714 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 15850 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48720 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 15856 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48728 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 15860 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 48736 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 15864 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 48744 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 15868 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 48752 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 15883 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48758 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 15884 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48764 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 15888 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 48770 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 15889 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48776 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 15897 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48782 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 15898 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48788 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 15902 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 48794 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 15904 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 48800 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 15909 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 48811 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 15918 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 48817 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 15920 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 48835 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 15934 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 48841 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 15939 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 48860 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 15965 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48866 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 15966 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 48872 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 15969 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48878 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 15970 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48884 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 15979 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48896 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 15987 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48908 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 15995 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 48920 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 16003 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 48933 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 16014 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 48955 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 16032 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 48997 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 16078 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49010 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 16087 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49023 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 16096 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49036 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 16105 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49049 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 16114 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49062 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 16125 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 49068 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 16126 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 49074 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 16127 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 49080 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 16128 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 49086 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 16129 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 49092 "gram.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 16143 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49098 "gram.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 16144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49104 "gram.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 16145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49110 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 16148 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49116 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 16149 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49122 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 16152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49128 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 16155 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 49134 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 16156 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 49140 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 16157 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 49146 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 16160 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49152 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 16161 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49158 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 16164 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 49164 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 16165 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 49170 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 16166 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 49176 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 16167 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 49182 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 16168 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 49188 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 16169 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 49194 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 16170 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 49200 "gram.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 16171 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 49206 "gram.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 16172 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 49212 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 16173 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 49218 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 16174 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 49224 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 16175 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 49230 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 16179 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49236 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 16181 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49242 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 16186 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49248 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 16188 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49254 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 16193 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49260 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 16195 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49266 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 16197 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 49272 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 16199 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 49278 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 16201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 49284 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 16203 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 49290 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 16215 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49298 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 16219 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49306 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 16226 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49314 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 16230 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49322 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 16236 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49330 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 16240 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49344 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 16250 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49358 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 16261 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49364 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 16262 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49370 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 16265 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 49376 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 16266 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 49382 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 16270 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49390 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 16274 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49398 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 16278 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 49406 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 16283 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49412 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 16284 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 49418 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 16290 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 49426 "gram.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 16299 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49432 "gram.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 16300 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 49438 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 16301 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 49444 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 16302 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 49450 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 16303 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 49456 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 16304 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 49462 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 16305 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 49468 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 16306 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49474 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 16310 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 49480 "gram.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 16311 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 49486 "gram.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 16312 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 49492 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 16313 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 49498 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 16319 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49507 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 16324 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49516 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 16332 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 49522 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 16354 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49530 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 16358 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 49539 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 16363 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49554 "gram.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 16374 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 49575 "gram.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 16391 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49583 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 16396 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 49589 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 16397 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49595 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 16398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49601 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 16402 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 49613 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 16409 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 49619 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 16420 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 49634 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 16434 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49640 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 16435 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49646 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 16440 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 49659 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 16451 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49665 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 16452 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49671 "gram.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 16455 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49677 "gram.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 16456 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49683 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 16460 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 49691 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 16464 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 49699 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 16471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 49707 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 16475 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 49715 "gram.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 16479 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 49728 "gram.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 16488 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 49741 "gram.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 16499 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49747 "gram.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 16500 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49753 "gram.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 16504 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49759 "gram.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 16505 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49765 "gram.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 16509 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49771 "gram.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 16510 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49777 "gram.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 16520 "gram.y" /* yacc.c:1646  */
    {
				/* formatted_expr will be set during parse-analysis. */
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), NULL,
												castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 49787 "gram.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 16529 "gram.y" /* yacc.c:1646  */
    {
					int		encoding;

					if (!pg_strcasecmp((yyvsp[0].str), "utf8"))
						encoding = JS_ENC_UTF8;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf16"))
						encoding = JS_ENC_UTF16;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf32"))
						encoding = JS_ENC_UTF32;
					else
						ereport(ERROR,
								errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								errmsg("unrecognized JSON encoding: %s", (yyvsp[0].str)));

					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, encoding, (yylsp[-3]));
				}
#line 49808 "gram.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 16546 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, JS_ENC_DEFAULT, (yylsp[-1]));
				}
#line 49816 "gram.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 16553 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49824 "gram.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 16557 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 49832 "gram.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 16564 "gram.y" /* yacc.c:1646  */
    {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 49845 "gram.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 16572 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49851 "gram.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 16586 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 49857 "gram.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 16587 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 49863 "gram.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 16588 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ARRAY; }
#line 49869 "gram.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 16589 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_OBJECT; }
#line 49875 "gram.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 16590 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_SCALAR; }
#line 49881 "gram.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 16599 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49887 "gram.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 16600 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49893 "gram.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 16601 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49899 "gram.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 16602 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49905 "gram.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 16603 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49911 "gram.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 16608 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49917 "gram.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 16610 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 49923 "gram.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 16620 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 49929 "gram.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 16623 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 49935 "gram.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 16628 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49941 "gram.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 16629 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49947 "gram.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 16630 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49953 "gram.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 16634 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49959 "gram.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 16635 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49965 "gram.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 16636 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49971 "gram.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 16640 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49977 "gram.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 16641 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 49983 "gram.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 16651 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50000 "gram.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 16669 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50016 "gram.c" /* yacc.c:1646  */
    break;

  case 2330:
#line 16683 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 50022 "gram.c" /* yacc.c:1646  */
    break;

  case 2331:
#line 16684 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50028 "gram.c" /* yacc.c:1646  */
    break;

  case 2332:
#line 16693 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 50034 "gram.c" /* yacc.c:1646  */
    break;

  case 2333:
#line 16694 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50040 "gram.c" /* yacc.c:1646  */
    break;

  case 2334:
#line 16698 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 50046 "gram.c" /* yacc.c:1646  */
    break;

  case 2335:
#line 16699 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 50052 "gram.c" /* yacc.c:1646  */
    break;

  case 2336:
#line 16703 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 50064 "gram.c" /* yacc.c:1646  */
    break;

  case 2337:
#line 16711 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 50076 "gram.c" /* yacc.c:1646  */
    break;

  case 2338:
#line 16719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 50088 "gram.c" /* yacc.c:1646  */
    break;

  case 2339:
#line 16727 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 50105 "gram.c" /* yacc.c:1646  */
    break;

  case 2340:
#line 16749 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 50111 "gram.c" /* yacc.c:1646  */
    break;

  case 2341:
#line 16750 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 50117 "gram.c" /* yacc.c:1646  */
    break;

  case 2342:
#line 16762 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 50125 "gram.c" /* yacc.c:1646  */
    break;

  case 2343:
#line 16766 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 50133 "gram.c" /* yacc.c:1646  */
    break;

  case 2344:
#line 16772 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50139 "gram.c" /* yacc.c:1646  */
    break;

  case 2345:
#line 16774 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 50145 "gram.c" /* yacc.c:1646  */
    break;

  case 2346:
#line 16778 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50151 "gram.c" /* yacc.c:1646  */
    break;

  case 2347:
#line 16780 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50157 "gram.c" /* yacc.c:1646  */
    break;

  case 2348:
#line 16782 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50163 "gram.c" /* yacc.c:1646  */
    break;

  case 2349:
#line 16793 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50169 "gram.c" /* yacc.c:1646  */
    break;

  case 2350:
#line 16795 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 50178 "gram.c" /* yacc.c:1646  */
    break;

  case 2351:
#line 16806 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 50186 "gram.c" /* yacc.c:1646  */
    break;

  case 2352:
#line 16810 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50194 "gram.c" /* yacc.c:1646  */
    break;

  case 2353:
#line 16814 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50202 "gram.c" /* yacc.c:1646  */
    break;

  case 2354:
#line 16818 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50210 "gram.c" /* yacc.c:1646  */
    break;

  case 2355:
#line 16822 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50223 "gram.c" /* yacc.c:1646  */
    break;

  case 2356:
#line 16831 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50235 "gram.c" /* yacc.c:1646  */
    break;

  case 2357:
#line 16839 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50271 "gram.c" /* yacc.c:1646  */
    break;

  case 2358:
#line 16871 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 50279 "gram.c" /* yacc.c:1646  */
    break;

  case 2359:
#line 16875 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 50290 "gram.c" /* yacc.c:1646  */
    break;

  case 2360:
#line 16882 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50302 "gram.c" /* yacc.c:1646  */
    break;

  case 2361:
#line 16890 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 50310 "gram.c" /* yacc.c:1646  */
    break;

  case 2362:
#line 16894 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 50318 "gram.c" /* yacc.c:1646  */
    break;

  case 2363:
#line 16898 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 50326 "gram.c" /* yacc.c:1646  */
    break;

  case 2364:
#line 16903 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 50332 "gram.c" /* yacc.c:1646  */
    break;

  case 2365:
#line 16904 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50338 "gram.c" /* yacc.c:1646  */
    break;

  case 2366:
#line 16906 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 50344 "gram.c" /* yacc.c:1646  */
    break;

  case 2367:
#line 16907 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 50350 "gram.c" /* yacc.c:1646  */
    break;

  case 2368:
#line 16908 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 50356 "gram.c" /* yacc.c:1646  */
    break;

  case 2369:
#line 16913 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 50399 "gram.c" /* yacc.c:1646  */
    break;

  case 2370:
#line 16954 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 50431 "gram.c" /* yacc.c:1646  */
    break;

  case 2371:
#line 16982 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 50439 "gram.c" /* yacc.c:1646  */
    break;

  case 2372:
#line 16986 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 50447 "gram.c" /* yacc.c:1646  */
    break;

  case 2373:
#line 16990 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 50455 "gram.c" /* yacc.c:1646  */
    break;

  case 2374:
#line 16996 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 50461 "gram.c" /* yacc.c:1646  */
    break;

  case 2375:
#line 16998 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 50467 "gram.c" /* yacc.c:1646  */
    break;

  case 2376:
#line 17015 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 50498 "gram.c" /* yacc.c:1646  */
    break;

  case 2377:
#line 17048 "gram.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50513 "gram.c" /* yacc.c:1646  */
    break;

  case 2378:
#line 17060 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50519 "gram.c" /* yacc.c:1646  */
    break;

  case 2379:
#line 17061 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 50525 "gram.c" /* yacc.c:1646  */
    break;

  case 2382:
#line 17082 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50531 "gram.c" /* yacc.c:1646  */
    break;

  case 2383:
#line 17083 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50537 "gram.c" /* yacc.c:1646  */
    break;

  case 2384:
#line 17084 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50543 "gram.c" /* yacc.c:1646  */
    break;

  case 2385:
#line 17089 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50549 "gram.c" /* yacc.c:1646  */
    break;

  case 2386:
#line 17090 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50555 "gram.c" /* yacc.c:1646  */
    break;

  case 2387:
#line 17091 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50561 "gram.c" /* yacc.c:1646  */
    break;

  case 2388:
#line 17096 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50567 "gram.c" /* yacc.c:1646  */
    break;

  case 2389:
#line 17097 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50573 "gram.c" /* yacc.c:1646  */
    break;

  case 2390:
#line 17098 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50579 "gram.c" /* yacc.c:1646  */
    break;

  case 2391:
#line 17099 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50585 "gram.c" /* yacc.c:1646  */
    break;

  case 2392:
#line 17105 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50591 "gram.c" /* yacc.c:1646  */
    break;

  case 2393:
#line 17106 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50597 "gram.c" /* yacc.c:1646  */
    break;

  case 2394:
#line 17107 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50603 "gram.c" /* yacc.c:1646  */
    break;

  case 2395:
#line 17108 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50609 "gram.c" /* yacc.c:1646  */
    break;

  case 2396:
#line 17109 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50615 "gram.c" /* yacc.c:1646  */
    break;

  case 2397:
#line 17115 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50621 "gram.c" /* yacc.c:1646  */
    break;

  case 2398:
#line 17116 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50627 "gram.c" /* yacc.c:1646  */
    break;


#line 50631 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 18092 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.sval.type = T_String;
	n->val.sval.sval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node	   *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

   return (Node *) n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBoolAConst(bool state, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.boolval.type = T_Boolean;
	n->val.boolval.boolval = state;
	n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->val.bsval.type = T_BitString;
	n->val.bsval.bsval = str;
	n->location = location;

   return (Node *) n;
}

static Node *
makeNullAConst(int location)
{
	A_Const	   *n = makeNode(A_Const);

	n->isnull = true;
	n->location = location;

	return (Node *) n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node	   *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					errcode(ERRCODE_SYNTAX_ERROR),
					errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Parse a user-supplied partition strategy string into parse node
 * PartitionStrategy representation, or die trying.
 */
static PartitionStrategy
parsePartitionStrategy(char *strategy)
{
	if (pg_strcasecmp(strategy, "list") == 0)
		return PARTITION_STRATEGY_LIST;
	else if (pg_strcasecmp(strategy, "range") == 0)
		return PARTITION_STRATEGY_RANGE;
	else if (pg_strcasecmp(strategy, "hash") == 0)
		return PARTITION_STRATEGY_HASH;

	ereport(ERROR,
			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
			 errmsg("unrecognized partitioning strategy \"%s\"",
					strategy)));
	return PARTITION_STRATEGY_LIST;		/* keep compiler quiet */

}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				errcode(ERRCODE_SYNTAX_ERROR),
				errmsg("invalid publication object list"),
				errdetail("One of TABLE or TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				parser_errposition(pubobj->location));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid table name"),
						parser_errposition(pubobj->location));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("WHERE clause not allowed for schema"),
						parser_errposition(pubobj->location));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("column specification not allowed for schema"),
						parser_errposition(pubobj->location));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						errcode(ERRCODE_SYNTAX_ERROR),
						errmsg("invalid schema name"),
						parser_errposition(pubobj->location));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
